{$N-}
unit Affiche;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Printers, ExtCtrls, Graphes, GrapheTa, GrapheCo,
  GrapheRe, Buttons, ArretImp, Menus, Options, UDate, FicheTpo;

const

  naPlan=0;
  naCoupe=1;
  naPerspective=2;
  naTableau=3;

type
  TAfficheur = class(TForm)
    PopupMenu1: TPopupMenu;
    Edition1: TMenuItem;
    Tableau1: TMenuItem;
    Plan1: TMenuItem;
    Coupe1: TMenuItem;
    Perspective1: TMenuItem;
    Barre_Verticale: TScrollBar;
    Barre_Horizontale: TScrollBar;
    N1: TMenuItem;
    Imprimer1: TMenuItem;
    N2: TMenuItem;
    Proprits1: TMenuItem;
    N3: TMenuItem;
    Isoler1: TMenuItem;
    Dformationmax1: TMenuItem;
    Fiche1: TMenuItem;
    Lieu1: TMenuItem;
    Rseau1: TMenuItem;
    Cavit1: TMenuItem;
    Systme1: TMenuItem;
    ColorDialog1: TColorDialog;
    Couleur1: TMenuItem;
    Galerie1: TMenuItem;
    Fiche2: TMenuItem;
    Lieu2: TMenuItem;
    Rseau2: TMenuItem;
    Cavit2: TMenuItem;
    Systeme1: TMenuItem;
    Ecran1: TMenuItem;
    N9: TMenuItem;
    Timer1: TTimer;
    Deplacement: TTimer;
    Debut_3D: TTimer;
    DelaiHint: TTimer;
    CaTourne: TTimer;
    Exclure1: TMenuItem;
    Fiche3: TMenuItem;
    Lieu3: TMenuItem;
    Rseau3: TMenuItem;
    Cavit3: TMenuItem;
    Systme2: TMenuItem;
    PanelFond: TPanel;
    Image2: TImage;
    Support_OpenGL: TPanel;
    SaveDialogSVG: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Boite_EchelleChange(Sender: TObject);
    procedure Boite_RapportChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Barre_HorizontaleChange(Sender: TObject);
    procedure Barre_VerticaleChange(Sender: TObject);
    procedure Nouvelle1Click(Sender: TObject);
    procedure Continuer1Click(Sender: TObject);
    procedure Boite_EchelleKeyPress(Sender: TObject; var Key: Char);
    procedure Boite_EchelleExit(Sender: TObject);
    procedure Inverser1Click(Sender: TObject);
    procedure Retirer1Click(Sender: TObject);
    procedure Plan1Click(Sender: TObject);
    procedure Coupe1Click(Sender: TObject);
    procedure Perspective1Click(Sender: TObject);
    procedure Edition1Click(Sender: TObject);
    procedure Dcaler1Click(Sender: TObject);
    procedure Racrocher1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Proprits1Click(Sender: TObject);
    procedure Dformationmax1Click(Sender: TObject);
    procedure Lieu1Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Galerie1Click(Sender: TObject);
    procedure Lieu2Click(Sender: TObject);
    procedure Rotationplane1Click(Sender: TObject);
    procedure Rotation1Click(Sender: TObject);
    procedure Echelle2Click(Sender: TObject);
    procedure Pourcent1Click(Sender: TObject);
    procedure Pourcent2Click(Sender: TObject);
    procedure Ecran1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Support_OpenGLMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Support_OpenGLMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure Support_OpenGLMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DeplacementTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Debut_3DTimer(Sender: TObject);
    procedure DelaiHintTimer(Sender: TObject);
    procedure CaTourneTimer(Sender: TObject);
    procedure Fiche3Click(Sender: TObject);
    procedure Lieu3Click(Sender: TObject);
    procedure Rseau3Click(Sender: TObject);
    procedure Cavit3Click(Sender: TObject);
    procedure Systme2Click(Sender: TObject);
    procedure Image2DblClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    Contenu : TGraphique;
    Reduction : reel;
    PixelX_Max, PixelY_Max, Fraction_Verticale, Fraction_Horizontale, Zoom_Gauche,
    Zoom_Haut, Zoom_Droite, Zoom_Bas : longint;
    D_X, D_Y, O_X, O_Y, Vitesse :integer;
    Click_Fiche,Click_Galerie,Click_Visee : integer;
    Enfonce, Clicke, Echelle_Perso, Interdit : boolean;
    SIncrement : string; // mmorisation de l'angle lors des rotations automatiques
    HintPerso :   THintWindow;
    HintChaine, Status : string;
    rHint : TRect;
    F : Textfile; // fichier bidon pour Construit_Scene OpenGL
    procedure Nature(Na : shortInt);
    procedure Impression(Debut,Fin, Nombre  : integer; Marge : TMarge);
    procedure Mise_A_Jour;
    procedure Grosse_Mise_A_Jour;
    procedure Activation(N_Fiche, N_Galerie, N_Visee : smallInt);
    function Etat : smallInt;
    procedure Debut_Couleur(var Une_Fiche : TFiche;var Une_Galerie : Tgalerie);
    procedure Bascule;
    procedure StopHint;
    procedure ExportSvg;
  end;

var
  Afficheur: TAfficheur;

implementation

{$R *.DFM}
uses Unit1, Arrets, Tourne, Outils3D, couleurs, svg;

procedure TAfficheur.FormCreate(Sender: TObject);
var
  BitMap : TBitMap;
begin
  Interdit:=false;
  Reduction:=1;
  BitMap:=TBitMap.Create;
  BitMap.Width:=Image2.Width; BitMap.Height:=Image2.Height;
  Image2.Picture.Graphic := Bitmap;
  Clicke:=false;
  Echelle_Perso:=false;
  SIncrement:='10';
  FormResize(Sender);
end;

procedure TAfficheur.Nature(Na : shortInt);
var
  RX, Ry : single;
begin
  case Na of
    naPlan : begin
      Contenu:=TPlan.Create;
      Caption:='Plan';
      try
        Icon.LoadFromFile(Form1.Repertoire+'TOPO.ICO');
      except
      end;
      (Contenu as TPlan).Definitif(Form1.Les_Options_Plan.Rotation);
      HelpContext:=9;
    end;
    naPerspective : begin
//      Timer1.Enabled:=true;
      Contenu:=TPerspective.Create;
      Caption:='Perspective';
      try
        Icon.LoadFromFile(Form1.Repertoire+'RELIEF.ICO');
      except
      end;
      (Contenu as TPerspective).Definitif(Form1.Les_Options_Relief.Rotation_Horizontale,
                                      Form1.Les_Options_Relief.Rotation_Verticale);
      with Outils_3D do begin
        OpenGL.Checked:=false;
        Stereo.Checked:=false;
        if Form1.Y_3D=0 then begin
          Top:=Form1.Height-Height-10;
          if form1.Barredtat1.Checked then Top:=Top-Form1.StatusBar.Height;
        end
        else Top:=Form1.Y_3D;
        if Form1.X_3D=0 then Left:=(Form1.Width-Width) div 2
        else Left:=Form1.X_3D;
      end;
      HelpContext:=11;
    end;
    naCoupe: begin
      try
        Icon.LoadFromFile(Form1.Repertoire+'COUPE.ICO');
      except
      end;
      Contenu:=TCoupe.Create;
      Caption:='Coupe';
      HelpContext:=10;
    end;
    naTableau : begin
      Contenu:=TTableau.Create;
      Caption:='Tableau';
      try
        Icon.LoadFromFile(Form1.Repertoire+'TABLEAU.ICO');
      except
      end;
      Contenu.Echelle:=0;
      HelpContext:=12;
    end;
  end;
  Contenu.Gabarit(PixelX_Max, PixelY_Max,PixelsPerInch/25.4,Reduction,Image2);
  if not (Na=naTableau) then begin
    if (PixelX_Max>1) or (PixelX_Max>1) then begin
      RX:=PixelX_Max/(ClientWidth-18);
      RY:=PixelY_Max/(ClientHeight-18);
      if RX>RY then Contenu.Echelle:=round(Contenu.Echelle*RX*1.1)
      else Contenu.Echelle:=round(Contenu.Echelle*RY*1.1);
    end;
  end;
  FormActivate(self);
  Mise_A_Jour;
end;

procedure TAfficheur.Mise_A_Jour;
begin
  if Contenu<>nil then begin
    if not Support_OpenGl.Visible then begin
      if Clicke then begin
        Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
        if Active then Form1.StatusBar.Panels[1].Text:=Status;
      end;
      Clicke:=false;
      if not Form1.Massif.Finition then Form1.Massif.Detailler;
      if ((Contenu is TCoupe) or (Contenu is TTableau)) and
      not Form1.Massif.Finition_Coupe
                                 then Form1.Massif.Detailler_Coupe;
      Contenu.Gabarit(PixelX_Max, PixelY_Max,PixelsPerInch/25.4,Reduction,Image2);
      if PixelX_Max<10 then PixelX_Max:=10;
      if PixelY_Max<10 then PixelY_Max:=10;
      if PixelX_Max>ClientWidth-18 then with Barre_Horizontale do begin
        Image2.Left:=0;
        Image2.Width:=self.ClientWidth-18;
        Enabled:=true;
        if PixelX_Max>32000 then Fraction_Horizontale:=PixelX_Max div 32000 +1
                            else Fraction_Horizontale:=1;
        Max:=(PixelX_Max-Image2.Width) div Fraction_Horizontale;
        Barre_Horizontale.SmallChange:=Image2.Width div (10*Fraction_Horizontale);
        Barre_Horizontale.LargeChange:=round(Image2.Width*0.95/Fraction_Horizontale);
        Image2.Picture.Graphic.Width:=Image2.Width;
      end
      else begin
        Barre_Horizontale.Enabled:=false;
        Barre_Horizontale.Position:=0;
        Image2.Width:=PixelX_Max;
        Image2.Picture.Graphic.Width:=PixelX_Max;
        Image2.Left:=(ClientWidth-18-PixelX_Max) div 2;
      end;
      if PixelY_Max>ClientHeight-18 then with Barre_Verticale do begin
        Image2.Top:=0;
        Image2.Height:=self.ClientHeight-18;
        Enabled:=true;
        if PixelY_Max>32000 then Fraction_Verticale:=PixelY_Max div 32000 +1
                            else Fraction_Verticale:=1;
        Max:=(PixelY_Max-Image2.Height) div Fraction_Verticale;
        Barre_Verticale.SmallChange:=Image2.Height div (10*Fraction_Verticale);
        Barre_Verticale.LargeChange:=round(Image2.Height*0.95/Fraction_Verticale);
        Image2.Picture.Graphic.Height:=Image2.Height;
      end
      else begin
        Barre_Verticale.Enabled:=false;
        Barre_Verticale.Position:=0;
        Image2.Height:=PixelY_Max;
        Image2.Picture.Graphic.Height:=PixelY_Max;
        Image2.Top:=(ClientHeight-18-PixelY_Max) div 2;
      end;
      if not Interdit then
      Contenu.Dessine(Barre_Horizontale.Position*Fraction_Horizontale,Barre_Verticale.Position*Fraction_Verticale
             ,PixelsPerInch/25.4,Reduction,Image2, Etat);
      Status:='';
      if (Contenu is TPlan) and Form1.Rotation.Down then Status:=IntToStr(round((Contenu as TPlan).Rotation_Horizontale))+' '+tuAngle[deg];
      if (Contenu is TPerspective) and Form1.Rotation.Down then
         Status:=IntToStr(round((Contenu as TPerspective).Rotation_Horizontale))+' '+tuAngle[deg]+'  '+
            IntToStr(-round((Contenu as TPerspective).Elevation))+' '+tuAngle[deg];
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end
    else with (Contenu as TPerspective) do begin
      Scene.Free; Scene:=nil;
      Debut_3D.Enabled:=true;
    end;
  end;
end;

function TAfficheur.Etat : smallInt;
var
  Resultat : smallInt;
begin
  Resultat:=etNoir;
  if Form1.Contrainte.Down then Resultat:=etContrainte;
  if Form1.Couleur.Down then Resultat:=etCouleur;
  if Form1.Rotation.Down then Resultat:=etRotation;
  Etat:=resultat;
end;

procedure TAfficheur.FormResize(Sender: TObject);
begin
  if Support_OpenGL.Visible then begin
    if Contenu<>nil then with (Contenu as TPerspective) do begin
      Scene.UpDateArea(Support_OpenGl.Width,Support_OpenGl.Height);
      Redessine_Scene;  
    end;
  end;
  if (ClientWidth>20) and (ClientHeight>65) then begin
    Barre_Horizontale.Top:=ClientHeight-18;
    Barre_Horizontale.Width:=ClientWidth-18;
    Barre_Verticale.Left:=ClientWidth-18;
    Barre_Verticale.Height:=ClientHeight-18;
    PanelFond.Width:=Barre_Verticale.Left;
    PanelFond.Height:=Barre_Horizontale.Top;
    Barre_Horizontale.SmallChange:=Image2.Width div 10;
    Barre_Horizontale.LargeChange:=round(Image2.Width*0.95);
    Barre_Verticale.SmallChange:=Image2.Height div 10;
    Barre_Verticale.LargeChange:=round(Image2.Height*0.95);
    if not Support_OpenGL.Visible then Mise_A_Jour;
  end;
end;

procedure TAfficheur.Impression(Debut,Fin, Nombre : integer;Marge : TMarge);
var
  I, J, PageX_Max, PageY_Max : integer;
  Premier : boolean;
  Rectangle : TRect;
  Rapport : single;

  procedure Fait_Les_Marges;
  var
    R : reel;
    K : integer;
    S : string;
  begin
    if not (Contenu is TTableau) then begin

      R:=Printer.PageWidth/GetDeviceCaps(Printer.Handle,HorzSize);
      Printer.Canvas.Pen.Color:=clBlack;
      Printer.Canvas.Pen.Width:=round(Marge.Epaisseur/10*R);
      Printer.Canvas.MoveTo(round(Marge.Gauche*R),round(Marge.Haut*R));
      Printer.Canvas.LineTo(round((Marge.Gauche+Marge.Longueur)*R),round(Marge.Haut*R));
      Printer.Canvas.MoveTo(round(Marge.Gauche*R),round(Marge.Haut*R));
      Printer.Canvas.LineTo(round(Marge.Gauche*R),round((Marge.Haut+Marge.Longueur)*R));
      Printer.Canvas.MoveTo(round(Marge.Gauche*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.LineTo(round((Marge.Gauche+Marge.Longueur)*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.MoveTo(round(Marge.Gauche*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.LineTo(round(Marge.Gauche*R),Printer.PageHeight-round((Marge.Bas+Marge.Longueur)*R));
      Printer.Canvas.MoveTo(Printer.PageWidth-round(Marge.Droite*R),round(Marge.Haut*R));
      Printer.Canvas.LineTo(Printer.PageWidth-round((Marge.Droite+Marge.Longueur)*R),round(Marge.Haut*R));
      Printer.Canvas.MoveTo(Printer.PageWidth-round(Marge.Droite*R),round(Marge.Haut*R));
      Printer.Canvas.LineTo(Printer.PageWidth-round(Marge.Droite*R),round((Marge.Haut+Marge.Longueur)*R));
      Printer.Canvas.MoveTo(Printer.PageWidth-round(Marge.Droite*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.LineTo(Printer.PageWidth-round((Marge.Droite+Marge.Longueur)*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.MoveTo(Printer.PageWidth-round(Marge.Droite*R),Printer.PageHeight-round(Marge.Bas*R));
      Printer.Canvas.LineTo(Printer.PageWidth-round(Marge.Droite*R),Printer.PageHeight-round((Marge.Bas+Marge.Longueur)*R));
    end;
    Printer.Canvas.Font:=Marge.Police;
    for K:=1 to 3 do if Marge.Afficher[K] then begin
      case K of
        1 : S:=La_Date;
        2 : S:='Page '+IntTostr(I+1);
        3 : S:=Form1.Massif.Fichier;
      end;
      case Marge.Angle[K] of
        anHautGauche : Printer.Canvas.TextOut(0,0,S);
        anHautDroit  : Printer.Canvas.TextOut(Printer.PageWidth-Printer.Canvas.TextWidth(S),0,S);
        anBasGauche  : Printer.Canvas.TextOut(0,Printer.PageHeight-Printer.Canvas.TextHeight(S),S);
        anBasDroit   : Printer.Canvas.TextOut(Printer.PageWidth-Printer.Canvas.TextWidth(S),
              Printer.PageHeight-Printer.Canvas.TextHeight(S),S);
      end;
    end;
  end;

begin
  if Support_OpenGL.Visible then begin
    Outils_3D.Visible:=false;
    (Contenu as TPerspective).Redessine_Scene;
    Printer.BeginDoc;
    Rectangle:=Support_OpenGL.clientrect;
    if printer.PageWidth/Rectangle.Right>printer.PageHeight/Rectangle.Bottom then
      Rapport:=printer.PageHeight/Rectangle.Bottom*0.99
    else
      Rapport:=printer.PageWidth/Rectangle.Right*0.99;
    Rectangle.Right:=trunc(Rectangle.Right*Rapport);
    Rectangle.Bottom:=trunc(Rectangle.Bottom*Rapport);
    I:=(printer.PageWidth-Rectangle.Right) div 2;
    Rectangle.Left:=I; Rectangle.Right:=Rectangle.Right+I;
    I:=(printer.PageHeight-Rectangle.Bottom) div 2;
    Rectangle.Top:=I; Rectangle.Bottom:=Rectangle.Bottom+I;
    printer.Canvas.CopyRect(Rectangle, canvas, Support_OpenGL.clientrect);
    Outils_3D.Visible:=true;
    printer.EndDoc;
  end
  else begin
    Screen.Cursor:=crHourGlass;
    Contenu.Gabarit_Imprimante(PageX_Max,PageY_Max,
       Marge.Gauche+Marge.Droite,Marge.Haut+Marge.Bas);
    if Debut=0 then begin
      Debut:=1;
      Fin:=PageX_Max*PageY_Max;
    end;
    Evolution:=TEvolution.Create(self);
    Evolution.Gauge1.Progress:=0;
    Evolution.Show;
    Application.ProcessMessages;
    Printer.BeginDoc;
    Application.ProcessMessages;
    Printer.Title:='Plan topographique';
    Application.ProcessMessages;
    Premier:=true;
    for J:=1 to Nombre do for I:=Debut-1 to Fin-1 do if Evolution.Visible then begin
      if not Premier and Evolution.Visible then Printer.NewPage;
      Premier:=false;
      Contenu.Imprime(I mod PageX_Max,I div PageX_Max,Marge.Gauche,Marge.Haut,Etat,Printer.Canvas,1);
      Fait_Les_Marges;
      Application.ProcessMessages;
      Application.ProcessMessages;
      Evolution.Gauge1.Progress:=round(((J-1)/Nombre+(I-Debut+1)/(Fin-Debut+1)/Nombre)*100);
    end;
    if Evolution.Visible then Evolution.Close
                         else Printer.Abort;
    Printer.EndDoc;
    Screen.Cursor:=crDefault;
    Evolution.Free;
  end;
end;

procedure TAfficheur.Boite_EchelleChange(Sender: TObject);
var
  Nouvelle : integer;
  Centre_X, Centre_Y : reel;
begin
  if not Echelle_Perso then begin
    try
      Nouvelle:=StrToInt(Form1.Boite_Echelle.Text);
      if Nouvelle<100 then Abort;
      Contenu.Echelle:=Nouvelle;
      if Barre_Horizontale.Enabled then Centre_X:=(Barre_Horizontale.Position*Fraction_Horizontale+Image2.Width/2)/PixelX_Max
                                   else Centre_X:=0.5;
      if Barre_Verticale.Enabled then Centre_Y:=(Barre_Verticale.Position*Fraction_Verticale+Image2.Height/2)/PixelY_Max
                                   else Centre_Y:=0.5;
      Interdit:=true;
      Mise_A_Jour;
      if Barre_Horizontale.Enabled then Barre_Horizontale.Position:=
                              round((Centre_X*PixelX_Max-Image2.Width/2)/Fraction_Horizontale);
      if Barre_Verticale.Enabled then Barre_Verticale.Position:=
                              round((Centre_Y*PixelY_Max-Image2.Height/2)/Fraction_Verticale);
{      if Barre_Horizontale.Enabled or Barre_Verticale.Enabled then
          Contenu.Dessine(Barre_Horizontale.Position*Fraction_Horizontale,Barre_Verticale.Position*Fraction_Verticale
           ,PixelsPerInch/25.4,Reduction,Image2, Etat); }
      Interdit:=false;
      Mise_A_Jour;
      Form1.Boite_Echelle.SetFocus;
    except
      Form1.Boite_Echelle.Text:=IntToStr(Contenu.Echelle);
    end;
  end;
end;

procedure TAfficheur.Boite_RapportChange(Sender: TObject);
var
  DuRelief : boolean;
  Centre_X, Centre_Y : reel;
begin
  DuRelief:=Clicke;
  case Form1.Boite_Rapport.ItemIndex of
    0 : reduction:=0.1;
    1 : reduction:=0.25;
    2 : reduction:=0.5;
    3 : reduction:=1;
    4 : reduction:=2;
    5 : reduction:=4;
  end;
  if (Contenu is TTableau) then Form1.Massif.Gabarit_Tableau:=false;
  if Barre_Horizontale.Enabled then Centre_X:=(Barre_Horizontale.Position*Fraction_Horizontale+Image2.Width/2)/PixelX_Max
                               else Centre_X:=0.5;
  if Barre_Verticale.Enabled then Centre_Y:=(Barre_Verticale.Position*Fraction_Verticale+Image2.Height/2)/PixelY_Max
                               else Centre_Y:=0.5;
  Interdit:=true;
  Mise_A_Jour;
  if Barre_Horizontale.Enabled then Barre_Horizontale.Position:=
                          round((Centre_X*PixelX_Max-Image2.Width/2)/Fraction_Horizontale);
  if Barre_Verticale.Enabled then Barre_Verticale.Position:=
                          round((Centre_Y*PixelY_Max-Image2.Height/2)/Fraction_Verticale);
{  if Barre_Horizontale.Enabled or Barre_Verticale.Enabled then
      Contenu.Dessine(Barre_Horizontale.Position*Fraction_Horizontale,Barre_Verticale.Position*Fraction_Verticale
       ,PixelsPerInch/25.4,Reduction,Image2, Etat); }
  Interdit:=false;
  Mise_A_Jour;
  if DuRelief then begin
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Clicke:=DuRelief;
end;

procedure TAfficheur.FormActivate(Sender: TObject);
begin
  if Contenu<>nil then begin
    Form1.Boite_Echelle.Text:=IntToStr(Contenu.Echelle);
    Form1.Boite_Rapport.Text:=IntToStr(round(Reduction*100))+'%';
  end;
  Form1.Massif.Calculer_Coupe;
  Form1.Imprimer1.Enabled:=true;
  Form1.Bouton_Imprimer.Enabled:=true;
  Form1.Apercu1.Enabled:=true;
  Form1.Bouton_Apercu.Enabled:=true;
  Form1.StatusBar.Panels[1].Text:=Status;
  Form1.Vue1.Enabled:=true;
  if Contenu is TPlan then begin
    Form1.Rotation.Enabled:=true;
    Form1.Zoom.Enabled:=true;
    Form1.Couleur.Enabled:=true;
    Form1.Boite_Echelle.Enabled:=true;
    Form1.Trier1.Enabled:=false;
  end;
  if Contenu is TPerspective then begin
    Outils_3D.Visible:=true;
    Form1.Rotation.Enabled:=not Support_OpenGL.Visible;
    Form1.Zoom.Enabled:=not Support_OpenGL.Visible;
    Form1.Couleur.Enabled:=true;
    Form1.Boite_Echelle.Enabled:=true;
    Form1.Trier1.Enabled:=false;
    if Support_OpenGL.Visible then with (Contenu as Tperspective) do Redessine_Scene;
  end;
  if Contenu is TCoupe then begin
    Form1.Rotation.Enabled:=false;
    Form1.Rotation.Down:=false;
    Form1.Zoom.Enabled:=true;
    Form1.Couleur.Enabled:=true;
    Form1.Boite_Echelle.Enabled:=true;
    Form1.Trier1.Enabled:=false;
  end;
  if Contenu is TTableau then begin
    Form1.Rotation.Enabled:=false;
    Form1.Rotation.Down:=false;
    Form1.Zoom.Enabled:=false;
    Form1.Zoom.Down:=false;
    Form1.Couleur.Enabled:=true;
    Form1.Boite_Echelle.Enabled:=false;
    Form1.Trier1.Enabled:=true;
  end;
  Form1.Etat_Menu;
end;

procedure TAfficheur.PopupMenu1Popup(Sender: TObject);
var
  Une_Fiche : TFiche;
begin
  StopHint;
  Edition1.Visible:=Clicke;

  N9.Visible:=Clicke;
  Fiche1.Visible:=Clicke;
  Lieu1.Visible:=Clicke;
  Rseau1.Visible:=Clicke;
  Cavit1.Visible:=Clicke;
  Systme1.Visible:=Clicke;

  Couleur1.Visible:=Clicke;
  N1.Visible:=Clicke;
  Dformationmax1.Visible:=(Etat<>etRotation) and not Form1.Zoom.Down and not (Contenu is TTableau);
  Plan1.Visible:=(Form1.LePlan<>nil) and Clicke and not (Contenu is TPlan);
  Perspective1.Visible:=(Form1.LaPerspective<>nil) and Clicke and
    not (Contenu is TPerspective) and not(Form1.LaPerspective.Support_OpenGL.Visible);
  Tableau1.Visible:=(Form1.LeTableau <>nil) and Clicke and not (Contenu is TTableau);
  if (Form1.LaCoupe<>nil) and Clicke and not (Contenu is TCoupe) then begin
    Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
    Coupe1.Visible:=TGalerie(Une_Fiche.Liste_Galerie[Click_Galerie]).En_Coupe;
  end
  else Coupe1.Visible:=false;
  N3.Visible:=Isoler1.Visible or Dformationmax1.Visible;
end;

procedure TAfficheur.FormDestroy(Sender: TObject);
begin
  StopHint;
  if Contenu is TPerspective then begin
    Outils_3D.OpenGL.Checked:=false;
    Outils_3D.Visible:=false;
    Form1.X_3D:=Outils_3D.left;
    Form1.Y_3D:=Outils_3D.top;
  end;
  Contenu.Free; Contenu:=nil;
end;

procedure TAfficheur.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Form1.Rotation.Down then begin
    if (Contenu is TPerspective) then begin
      O_X:=X+Image2.Left; O_Y:=Y+Image2.Top; Enfonce:=true;
      Screen.Cursor:=crCroix;
    end
    else if (Contenu is TPlan) then begin
      O_X:=X+Image2.Left; O_Y:=Y+Image2.Top; Enfonce:=true;
      Screen.Cursor:=crCroix;
    end;
  end
  else if Form1.Zoom.Down then begin
    Zoom_Gauche:=X; Zoom_Haut:=Y; Enfonce:=true;
    Zoom_Droite:=X; Zoom_Bas:=Y;
    with Image2.Canvas do begin
      Pen.Color:=clBlack; Pen.Style:=psDash; Pen.Mode:=pmNot;
      Rectangle(X,Y,X,Y);
    end;
  end
  else if not (Contenu is TTableau) then begin
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    if not Form1.Massif.Finition then Form1.Massif.Detailler;
    if (Contenu is TCoupe) and not Form1.Massif.Finition_Coupe then Form1.Massif.Detailler_Coupe;
    Contenu.Trouve(X+Barre_Horizontale.Position*Fraction_Horizontale, Y+Barre_Verticale.Position*Fraction_Verticale,
                                         Click_Fiche,Click_Galerie,Click_Visee);
    if Click_Visee<>0 then begin
      Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
      Clicke:=true;
    end;
  end
  else begin
    O_X:=X+Barre_Horizontale.Position*Fraction_Horizontale;
    O_Y:=Y+Barre_Verticale.Position*Fraction_Verticale;
  end;
end;


procedure TAfficheur.Image2MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  N_Fiche, N_Galerie, N_Visee : integer;
  Distance, Lechelle, Signe, Angle, CX, CY : reel;
  S : string;

  Point : TPoint;

begin
  if Form1.Rotation.Down then begin
    if (Contenu is TPerspective) and Enfonce then begin
      S:=(Contenu as TPerspective).Essai((O_X-X-Image2.Left)/3,(O_Y-Y-Image2.Top)/3);
      Mise_A_Jour;
      Status:=S;
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    if (Contenu is TPlan) and Enfonce then begin
      CX:=Barre_Verticale.Left/2;
      CY:=Barre_Horizontale.Top/2;
      Angle:=(O_X-CX)*(Y+Image2.Top-CY)-(O_Y-CY)*(X+Image2.Left-CX);
      Angle:=Angle/sqrt(sqr(O_X-CX)+sqr(O_Y-CY))/sqrt(sqr(Y+Image2.Top-CY)+sqr(X+Image2.Left-CX));
      Angle:=ArcTan (Angle/sqrt (1-sqr (Angle)));
      if (O_X-CX)*(X+Image2.Left-CX)+(Y+Image2.Top-CY)*(O_Y-CY)<0 then begin
        if Angle>=0 then Angle:=Pi-Angle
        else Angle:=-Pi-Angle;
      end;
      S:=(Contenu as TPlan).Essai(Angle*180);
      Mise_A_Jour;
      Status:=S;
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
  end;
  if Form1.Zoom.Down and Enfonce then begin
    with Image2.Canvas do begin
      Pen.Color:=clBlack; Pen.Style:=psDash; Pen.Mode:=pmNot;
      Brush.Style:=bsClear;
      Rectangle(Zoom_Gauche,Zoom_Haut,Zoom_Droite,Zoom_Bas);
      if (X-Zoom_Gauche)*(Y-Zoom_Haut)>0 then Signe:=1 else Signe:=-1;
      if abs(X-Zoom_Gauche)>abs(Barre_Horizontale.Width/Barre_Verticale.Height*(Y-Zoom_Haut)) then begin
        Zoom_Droite:=X; Zoom_Bas:=Zoom_Haut+round(Barre_Verticale.Height/Barre_Horizontale.Width*(X-Zoom_Gauche)*Signe);
      end
      else begin
        Zoom_Bas:=Y; Zoom_Droite:=Zoom_Gauche+round(Barre_Horizontale.Width/Barre_Verticale.Height*(Y-Zoom_Haut)*Signe);
      end;
      Rectangle(Zoom_Gauche,Zoom_Haut,Zoom_Droite,Zoom_Bas);
      Lechelle:=StrToFloat(Form1.Boite_Echelle.Text);
      Lechelle:=Lechelle*abs(Zoom_Gauche-Zoom_Droite)/Barre_Horizontale.Width;
      Status:='Echelle 1/'+IntTostr(round(Lechelle));
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
  end;
  if not Form1.Bulle.Aucun and not Enfonce then begin
    Distance:=Contenu.Trouve(X+Barre_Horizontale.Position*Fraction_Horizontale, Y+Barre_Verticale.Position*Fraction_Verticale,
                                         N_Fiche,N_Galerie,N_Visee);
    if (N_Visee<>0) and (Distance<5) then begin
      S:=Contenu.Bulle(N_Fiche,N_Galerie,N_Visee);
      if (HintPerso=nil) or (S<>HintChaine) then begin
        StopHint;
        if S<>'' then begin
          HintPerso := THintWindow.Create( Self );
          Point.X:=X;
          Point.Y:=Y;
          Point:=Image2.ClientToScreen(Point);
          rHint.top    :=  Point.Y-20;
          rHint.bottom    :=  rHint.top+HintPerso.Canvas.TextHeight(S)+2;
          rHint.left   :=  Point.X;
          rHint.right := rHint.left+HintPerso.Canvas.TextWidth(S+'  ');
          DelaiHint.Enabled:=true;
          HintChaine:=S;
        end;
      end;
    end
    else StopHint;
  end;
end;

procedure TAfficheur.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Centre_X, Centre_Y, Lechelle, Une_Marge, CX, CY, Angle : reel;
  Visee_Clique : boolean;
begin
  if Form1.Rotation.Down then begin
    if (Contenu is TPerspective) and Enfonce then begin
      (Contenu as TPerspective).Definitif((O_X-X-Image2.Left)/3,(O_Y-Y-Image2.Top)/3);
      Mise_A_Jour;
      Screen.Cursor:=crDefault;
      Enfonce:=false;
    end;
    if (Contenu is TPlan) and Enfonce then begin
      CX:=Barre_Verticale.Left/2;
      CY:=Barre_Horizontale.Top/2;
      Angle:=(O_X-CX)*(Y+Image2.Top-CY)-(O_Y-CY)*(X+Image2.Left-CX);
      Angle:=Angle/sqrt(sqr(O_X-CX)+sqr(O_Y-CY))/sqrt(sqr(Y+Image2.Top-CY)+sqr(X+Image2.Left-CX));
      Angle:=ArcTan (Angle/sqrt (1-sqr (Angle)));
      if (O_X-CX)*(X+Image2.Left-CX)+(Y+Image2.Top-CY)*(O_Y-CY)<0 then begin
        if Angle>=0 then Angle:=Pi-Angle
        else Angle:=-Pi-Angle;
      end;
      (Contenu as TPlan).Definitif(Angle*180);
      Mise_A_Jour;
      Screen.Cursor:=crDefault;
      Enfonce:=false;
    end;
  end;
  if Form1.Zoom.Down and Enfonce then begin
    Form1.Zoom.Down:=false;
    Visee_Clique:=Clicke;
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    with Image2.Canvas do begin
      Pen.Color:=clBlack; Pen.Style:=psDash; Pen.Mode:=pmNot;
      Brush.Style:=bsClear;
      Rectangle(Zoom_Gauche,Zoom_Haut,Zoom_Droite,Zoom_Bas);
    end;
    Enfonce:=false;
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
    Lechelle:=StrToFloat(Form1.Boite_Echelle.Text);
    Lechelle:=Lechelle*abs(Zoom_Gauche-Zoom_Droite)/Barre_Horizontale.Width;
    if (abs(Zoom_Gauche-Zoom_Droite)>=10) and (Lechelle>99) then begin
      Contenu.Echelle:=round(Lechelle);
      Form1.Boite_Echelle.Text:=IntTostr(round(Lechelle));
      Une_Marge:=10*PixelsPerInch/25.4*Reduction;
      if Barre_Horizontale.Enabled then
          Centre_X:=(Barre_Horizontale.Position*Fraction_Horizontale+(Zoom_Gauche+Zoom_Droite)/2-Une_Marge)
                    /(PixelX_Max-2*Une_Marge)
                                   else Centre_X:=((Zoom_Gauche+Zoom_Droite)/2-Une_Marge)/(PixelX_Max-2*Une_Marge);
      if Barre_Verticale.Enabled then
           Centre_Y:=(Barre_Verticale.Position*Fraction_Verticale+(Zoom_Haut+Zoom_Bas)/2-Une_Marge)/(PixelY_Max-2*Une_Marge)
                                   else Centre_Y:=((Zoom_Haut+Zoom_Bas)/2-Une_Marge)/(PixelY_Max-2*Une_Marge);
      Interdit:=true;
      Mise_A_Jour;
      if Barre_Horizontale.Enabled then
        Barre_Horizontale.Position:=round((Centre_X*(PixelX_Max-2*Une_Marge)+Une_Marge-Barre_Horizontale.Width/2)/
               Fraction_Horizontale);
      if Barre_Verticale.Enabled then Barre_Verticale.Position:=
                              round((Centre_Y*(PixelY_Max-2*Une_Marge)+Une_Marge-Barre_Verticale.Height/2)/Fraction_Verticale);
      Interdit:=false;
      Mise_A_Jour;
    end;
    if Visee_Clique then begin
      Clicke:=true;
      Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
  end;
end;

procedure TAfficheur.Barre_HorizontaleChange(Sender: TObject);
var
  DuRelief : boolean;
begin
  DuRelief:=Clicke;
  Mise_A_Jour;
  if DuRelief then begin
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Clicke:=DuRelief;
end;

procedure TAfficheur.Barre_VerticaleChange(Sender: TObject);
var
  DuRelief : boolean;
begin
  DuRelief:=Clicke;
  Mise_A_Jour;
  if DuRelief then begin
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Clicke:=DuRelief;
end;

procedure TAfficheur.Nouvelle1Click(Sender: TObject);
begin
  if (Contenu is TCoupe) then begin
    if (Contenu as TCoupe).Nouvelle_Branche then begin
      Mise_A_Jour;
      Form1.Massif.Sauvegarde:=false;
      Form1.Massif.Detecteur_Erreur_Coupe;
    end;
  end;
end;

procedure TAfficheur.Continuer1Click(Sender: TObject);
var
  N_F, N_G : integer;
  A_Fond : boolean;
begin
  if (Contenu is TCoupe) then begin
    N_F:=Click_Fiche;
    N_G:=Click_Galerie;
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,N_F,N_G,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=false;
    if (Contenu as TCoupe).Continuer(N_F,N_G) then begin
      A_Fond:=Barre_Horizontale.Enabled and (Barre_Horizontale.Position=Barre_Horizontale.Max);
      Mise_A_Jour;
      if A_Fond then Barre_Horizontale.Position:=Barre_Horizontale.Max;
      Form1.Massif.Sauvegarde:=false;
      Status:=Contenu.Met_En_Relief(true,N_F,N_G,1,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
      Click_Fiche:=N_F;
      Click_Galerie:=N_G;
      Click_Visee:=1;
      Form1.Massif.Detecteur_Erreur_Coupe;
    end
    else begin
      Status:=Contenu.Met_En_Relief(true,N_F,N_G,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=true;
  end;
end;

procedure TAfficheur.Boite_EchelleKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #13) and (Key <> #8)
      then Key := #0;
  Echelle_Perso:=(Key<>#13);
  if Key=#13 then begin
    Boite_EchelleChange(Sender);
    Key:=#0;
  end;
end;

procedure TAfficheur.Boite_EchelleExit(Sender: TObject);
begin
  if Echelle_Perso then begin
    Echelle_Perso:=false;
    Boite_EchelleChange(Sender);
  end;
end;

procedure TAfficheur.Inverser1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
begin
  if (Contenu is TCoupe) then begin
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=false;
    Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
    (Contenu as TCoupe).Inverser(Une_Fiche.Ordre,Click_Galerie);
    Form1.Massif.Calculer_Coupe;
    Mise_A_Jour;
    Form1.Massif.Sauvegarde:=false;
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
    Clicke:=true;
    Form1.Massif.Detecteur_Erreur_Coupe;
  end;
end;

procedure TAfficheur.Retirer1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
begin
  if (Contenu is TCoupe) then begin
    if MessageDlg('Cette galerie et son(ses) aval(s) vont tre retirs de la coupe',
    mtConfirmation,[mbOk,mbCancel],0)=mrOk then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
      Clicke:=false;
      Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
      Form1.Massif.Retirer_coupe(Une_Fiche.Ordre,Click_Galerie,true);
      Form1.Massif.Calculer_Coupe;
      Mise_A_Jour;
      Form1.Massif.Sauvegarde:=false;
      Form1.Massif.Detecteur_Erreur_Coupe;
    end;
  end;
end;

procedure TAfficheur.Activation(N_Fiche, N_Galerie, N_Visee : smallInt);
begin
  if Clicke then begin
    Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Mise_A_Jour;
  Click_Fiche:=N_Fiche;
  Click_Galerie:=N_Galerie;
  Click_Visee:=N_Visee;
  Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
  if Active then Form1.StatusBar.Panels[1].Text:=Status;
  Clicke:=true;
end;

procedure TAfficheur.Plan1Click(Sender: TObject);
begin
  Form1.Bascule('Plan',Click_Fiche,Click_Galerie,Click_Visee);
end;

procedure TAfficheur.Coupe1Click(Sender: TObject);
begin
  Form1.Bascule('Coupe',Click_Fiche,Click_Galerie,Click_Visee);
end;

procedure TAfficheur.Perspective1Click(Sender: TObject);
begin
  Form1.Bascule('Relief',Click_Fiche,Click_Galerie,Click_Visee);
end;

procedure TAfficheur.Edition1Click(Sender: TObject);
begin
  if Clicke then Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
   if Active then Form1.StatusBar.Panels[1].Text:=Status;
  Clicke:=false;
  Form1.Appel_Exterieur(Click_Fiche,Click_Galerie); 
end;

procedure TAfficheur.Dcaler1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
begin
  if (Contenu is TCoupe) then begin
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=false;
    Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
    if (Contenu as TCoupe).Decaler(Une_Fiche.Ordre,Click_Galerie) then begin
      Form1.Massif.Calculer_Coupe;
      Mise_A_Jour;
      Form1.Massif.Sauvegarde:=false;
    end;
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
    Clicke:=true;
    Form1.Massif.Detecteur_Erreur_Coupe;
  end;
end;

procedure TAfficheur.Racrocher1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
begin
  if (Contenu is TCoupe) then begin
    if Clicke then begin
      Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=false;
    Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
    if (Contenu as TCoupe).Raccrocher(Une_Fiche.Ordre,Click_Galerie) then begin
      Form1.Massif.Calculer_Coupe;
      Mise_A_Jour;
      Form1.Massif.Sauvegarde:=false;
    end;
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
    Clicke:=true;
    Form1.Massif.Detecteur_Erreur_Coupe;
  end;
end;

procedure TAfficheur.Imprimer1Click(Sender: TObject);
begin
  Form1.Imprimer1Click(Sender);
end;

procedure TAfficheur.Proprits1Click(Sender: TObject);
begin
  if (Contenu is TPlan) then begin
    if Form1.Les_Options_Plan.Editer then Mise_A_Jour;
  end;
  if (Contenu is TPerspective) then begin
    if Form1.Les_Options_Relief.Editer then Mise_A_Jour;
  end;
  if (Contenu is TTableau) then begin
    if Form1.Les_Options_Tableau.Editer then Mise_A_Jour;
  end;
  if (Contenu is TCoupe) then begin
    if Form1.Les_Options_Coupe.Editer then Mise_A_Jour;
  end;
end;

procedure TAfficheur.Dformationmax1Click(Sender: TObject);
begin
  if Clicke then begin
    Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Clicke:=false;
  if Contenu.Mauvais_Rebouclage(Click_Fiche, Click_Galerie, Click_Visee) then begin
    Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
    Clicke:=true;
  end;
end;

procedure TAfficheur.Lieu1Click(Sender: TObject);
// isoler ou exclure fiche, lieu, reseau, cavite ou systeme
var
  Une_Fiche, L_autre : TFiche;
  LeLieu : TEco;
  I : integer;
  Nouvelle : TList;
begin
  Grosse_Mise_A_Jour;
  Une_Fiche:=Form1.Massif.Liste_Courante[Click_Fiche];
  Nouvelle:=TList.Create;
  if Sender=Fiche1 then
    Nouvelle.Add(Une_Fiche)
  else begin
    if (Sender=Lieu1) or (Sender=Lieu3) then LeLieu:=Une_Fiche.Lieu
    else if (Sender=Rseau1) or (Sender=Rseau3) then LeLieu:=Une_Fiche.Reseau
    else if (Sender=Cavit1) or (Sender=Cavit3) then LeLieu:=Une_Fiche.Cavite
    else if (Sender=Systme1) or (Sender=Systme2) then LeLieu:=Une_Fiche.Systeme
    else if Sender=Fiche3 then L_autre:=Une_Fiche
    else assert(false,'Sender non trouv dans Lieu1');
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      Une_Fiche:=Form1.Massif.Liste_Courante[I];
      if ((Sender=Lieu1) and Une_Fiche.Lieu.Identique(LeLieu)) or
         ((Sender=Rseau1) and Une_Fiche.Reseau.Identique(LeLieu)) or
         ((Sender=Cavit1) and Une_Fiche.Cavite.Identique(LeLieu)) or
         ((Sender=Systme1) and Une_Fiche.Systeme.Identique(LeLieu))
        then Nouvelle.Add(Une_Fiche);                // isoler
      if ((Sender=Lieu3) and not Une_Fiche.Lieu.Identique(LeLieu)) or
         ((Sender=Rseau3) and not Une_Fiche.Reseau.Identique(LeLieu)) or
         ((Sender=Cavit3) and not Une_Fiche.Cavite.Identique(LeLieu)) or
         ((Sender=Systme2) and not Une_Fiche.Systeme.Identique(LeLieu)) or
         ((Sender=Fiche3) and (Une_Fiche<>L_Autre))
        then Nouvelle.Add(Une_Fiche);                //exclure
    end;
  end;
  with Form1 do begin
    if Massif.Existe_Selection then begin
      Massif.Selection.Free; Massif.Selection:=nil;
    end;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.FormDeactivate(Sender: TObject);
begin
  StopHint;
end;

procedure TAfficheur.Debut_Couleur(var Une_Fiche : TFiche;var Une_Galerie : Tgalerie);
begin
  with Form1 do begin
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
    Une_Galerie:=Une_Fiche.Liste_Galerie[Click_Galerie];
    ColorDialog1.Color:=Une_Galerie.Couleur;
  end;
end;


procedure TAfficheur.Galerie1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
begin
  with Form1 do begin
    Debut_Couleur(Une_Fiche,Une_Galerie);
    if ColorDialog1.Execute then begin
      Une_Galerie.Couleur:=ColorDialog1.Color;
      Grosse_Mise_A_Jour;
    end;
  end;
end;

procedure TAfficheur.Lieu2Click(Sender: TObject);
// choix de la couleur par le menu contextuel
var
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
  I, J : integer;
  LeLieu : TEco;
begin
  Debut_Couleur(Une_Fiche,Une_Galerie);
  if ColorDialog1.Execute then begin
    if Sender=Fiche2 then begin
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        Une_Galerie.Couleur:=ColorDialog1.Color;
      end;
    end
    else begin
      if Sender=Lieu2 then LeLieu:=Une_Fiche.Lieu
      else if Sender=Rseau2 then LeLieu:=Une_Fiche.Reseau
      else if Sender=Cavit2 then LeLieu:=Une_Fiche.Cavite
      else if Sender=Systeme1 then LeLieu:=Une_Fiche.Systeme
      else assert(false,'Sender non trouv dans Lieu2');
      for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
        Une_Fiche:=Form1.Massif.Liste_Courante[I];
        if ((Sender=Lieu2) and Une_Fiche.Lieu.Identique(LeLieu)) or
           ((Sender=Rseau2) and Une_Fiche.Reseau.Identique(LeLieu)) or
           ((Sender=Cavit2) and Une_Fiche.Cavite.Identique(LeLieu)) or
           ((Sender=Systeme1) and Une_Fiche.Systeme.Identique(LeLieu))
         then begin
          for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
            Une_Galerie:=Une_Fiche.Liste_Galerie[J];
            Une_Galerie.Couleur:=ColorDialog1.Color;
          end;
        end;
      end;
    end;
    Grosse_Mise_A_Jour;
  end;
end;

procedure TAfficheur.Grosse_Mise_A_Jour;
begin
  with Form1 do begin
    if LePlan<>nil then LePlan.Mise_A_Jour;
    if LaCoupe<>nil then LaCoupe.Mise_A_Jour;
    if LeTableau<>nil then LeTableau.Mise_A_Jour;
    if LaPerspective<>nil then LaPerspective.Mise_A_Jour;
  end;
end;

procedure TAfficheur.Rotationplane1Click(Sender: TObject);
var
  S : string;
  Increment : reel;
begin
  S:=SIncrement;
  if InputQuery('Rotation','Pas en degr',S) then begin
    try
      Increment:=StrToFloat(S);
    except
      ShowMessage(Format('%s n''est pas une valeur numrique correcte.',[S]));
      Abort;
    end;
    SIncrement:=S;
    Arret.Show;
    Outils_3D.Enabled:=false;
    if not Support_OpenGL.Visible then begin
      repeat
        (Contenu as TPerspective).Definitif(Increment,0);
        Mise_A_Jour;
        Application.ProcessMessages;
        Refresh;
      until not Arret.Visible;
      (Contenu as TPerspective).Definitif(-Increment,0);
      Mise_A_Jour;
      Refresh;
      Outils_3D.Enabled:=true;
    end
    else begin
      CaTourne.Tag:=round(Increment*1000);
      CaTourne.Enabled:=true;
    end;
  end;
end;

procedure TAfficheur.Rotation1Click(Sender: TObject);
var
  S : string;
  Increment, IncrementV, VInf, VSup : reel;
begin
  if (Contenu is TPlan) then begin
    S:=SIncrement;
    if InputQuery('Rotation','Pas en degr',S) then begin
      try
        Increment:=StrToFloat(S);
      except
        ShowMessage(Format('%s n''est pas une valeur numrique correcte.',[S]));
        Abort;
      end;
      SIncrement:=S;
      Arret.Show;
      repeat
        (Contenu as TPlan).Definitif(Increment);
        Mise_A_Jour;
        Refresh;
        Application.ProcessMessages;
      until not Arret.Visible;
      (Contenu as TPlan).Definitif(-Increment);
      Mise_A_Jour;
      Refresh;
    end;
  end
  else begin
    LaRotation:=TLaRotation.Create(self);
    if LaRotation.ShowModal=mrOk then begin
      Increment:=StrToFloatE(LaRotation.PasH.Text);
      IncrementV:=-StrToFloatE(LaRotation.PasV.Text);
      VInf:=StrToFloatE(LaRotation.MinV.Text);
      VSup:=StrToFloatE(LaRotation.MaxV.Text);
      Arret.Show;
      repeat
        if (-(Contenu as TPerspective).Elevation>VSup) or
           (-(Contenu as TPerspective).Elevation<VInf) then IncrementV:=-IncrementV;
        (Contenu as TPerspective).Definitif(Increment,IncrementV);
        Mise_A_Jour;
        Refresh;
        Application.ProcessMessages;
      until not Arret.Visible;
      (Contenu as TPerspective).Definitif(-Increment,-IncrementV);
      Mise_A_Jour;
      Refresh;
    end;
    LaRotation.Free;
  end;
end;

procedure TAfficheur.Echelle2Click(Sender: TObject);
var
  S : string;
  N : integer;
  Centre_X, Centre_Y : reel;
begin
  S:=InputBox('Echelle','Nouvelle chelle (1/n, n>=100)',Form1.Boite_Echelle.Text);
  try
    N:=StrToInt(S);
    if N<100 then Abort;
    Form1.Boite_Echelle.Text:=S;
    Contenu.Echelle:=N;
    if Barre_Horizontale.Enabled then Centre_X:=(Barre_Horizontale.Position*Fraction_Horizontale+Image2.Width/2)/PixelX_Max
                                 else Centre_X:=0.5;
    if Barre_Verticale.Enabled then Centre_Y:=(Barre_Verticale.Position*Fraction_Verticale+Image2.Height/2)/PixelY_Max
                                 else Centre_Y:=0.5;
    Mise_A_Jour;
    if Barre_Horizontale.Enabled then Barre_Horizontale.Position:=
                            round((Centre_X*PixelX_Max-Image2.Width/2)/Fraction_Horizontale);
    if Barre_Verticale.Enabled then Barre_Verticale.Position:=
                            round((Centre_Y*PixelY_Max-Image2.Height/2)/Fraction_Verticale);
    if Barre_Horizontale.Enabled or Barre_Verticale.Enabled then
        Contenu.Dessine(Barre_Horizontale.Position*Fraction_Horizontale,Barre_Verticale.Position*Fraction_Verticale
         ,PixelsPerInch/25.4,Reduction,Image2, Etat);
  except
  end;
end;

procedure TAfficheur.Pourcent1Click(Sender: TObject);
var
  DuRelief : boolean;
  Centre_X, Centre_Y : reel;
  S : string;
  N : integer;
begin
  DuRelief:=Clicke;
  S:=Form1.Boite_Rapport.Text;
  S:=copy(S,1,length(S)-1);
  S:=InputBox('Pourcentage','Nouveau pourcentage ',S);
  try
    N:=StrToInt(S);
    if N<=0 then Abort;
    Form1.Boite_Rapport.Text:=S+'%';
    Reduction:=N/100;
    if (Contenu is TTableau) then Form1.Massif.Gabarit_Tableau:=false;
    if Barre_Horizontale.Enabled then Centre_X:=(Barre_Horizontale.Position*Fraction_Horizontale+Image2.Width/2)/PixelX_Max
                                 else Centre_X:=0.5;
    if Barre_Verticale.Enabled then Centre_Y:=(Barre_Verticale.Position*Fraction_Verticale+Image2.Height/2)/PixelY_Max
                                 else Centre_Y:=0.5;
    Mise_A_Jour;
    if Barre_Horizontale.Enabled then Barre_Horizontale.Position:=
                            round((Centre_X*PixelX_Max-Image2.Width/2)/Fraction_Horizontale);
    if Barre_Verticale.Enabled then Barre_Verticale.Position:=
                            round((Centre_Y*PixelY_Max-Image2.Height/2)/Fraction_Verticale);
    if Barre_Horizontale.Enabled or Barre_Verticale.Enabled then
        Contenu.Dessine(Barre_Horizontale.Position*Fraction_Horizontale,Barre_Verticale.Position*Fraction_Verticale
         ,PixelsPerInch/25.4,Reduction,Image2, Etat);
    if DuRelief then begin
      Status:=Contenu.Met_En_Relief(true,Click_Fiche,Click_Galerie,Click_Visee,Etat);
      if Active then Form1.StatusBar.Panels[1].Text:=Status;
    end;
    Clicke:=DuRelief;
  except
  end;
end;

procedure TAfficheur.Pourcent2Click(Sender: TObject);
begin
  Pourcent1Click(Sender);
end;

procedure TAfficheur.Ecran1Click(Sender: TObject);
var
  Distance : longint;
begin
  Distance:=(sqr(longint(Barre_Horizontale.Width))+sqr(longint(Barre_Verticale.Height)))div 4;
  if Clicke then begin
    Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
    if Active then Form1.StatusBar.Panels[1].Text:=Status;
  end;
  Clicke:=false;
  Contenu.Isoler(Barre_Horizontale.Width div 2+Barre_Horizontale.Position*Fraction_Horizontale,
                 Barre_Verticale.Height div 2+Barre_Verticale.Position*Fraction_Verticale,
                 Distance);
  Mise_A_Jour;
  if Form1.Massif.Existe_Selection then begin
    Form1.Rcuprer1.Enabled:=true;
    Form1.StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Bascule;
begin
  if Contenu is TPerspective then with Contenu as TPerspective do begin
    StopHint;
    if not Outils_3D.OpenGL.Checked then begin
      Scene.Free; Scene:=nil;
      Support_OpenGL.Visible:=false;
      Image2.Visible:=true;
      PanelFond.Visible:=true;
      Barre_Verticale.Visible:=true;
      Barre_Horizontale.Visible:=true;
      Form1.Rotation.Enabled:=true;
      Form1.Zoom.Enabled:=true;
    end
    else begin
      if Clicke then begin
        Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
        if Active then Form1.StatusBar.Panels[1].Text:=Status;
      end;
      Clicke:=false;
      Form1.Rotation.Enabled:=false;
      Form1.Zoom.Enabled:=false;
      Image2.Visible:=false;
      PanelFond.Visible:=false;
      Barre_Verticale.Visible:=false;
      Barre_Horizontale.Visible:=false;
      Support_OpenGL.Visible:=true;
      Support_OpenGL.Align:=alClient;
      Scene.Free; Scene:=nil;
      Debut_3D.Enabled:=true;
    end;
  end;
  Vitesse:=1;
end;

procedure TAfficheur.Timer1Timer(Sender: TObject);
begin
  if not Active and (Contenu is TPerspective) then Outils_3D.Visible:=false;
  if Active and (Contenu is TPerspective) then Outils_3D.Visible:=true;
  Form1.Etat_Menu;
end;

procedure TAfficheur.Support_OpenGLMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Enfonce:=true;
  Deplacement.Enabled:=true;
  Timer1.Enabled:=false;
  O_X:=X; D_X:=0;
  O_Y:=Y; D_Y:=0;
  if Outils_3D.Rotation.Down then Screen.Cursor:=crTourne;
  if Outils_3D.Translation.Down then Screen.Cursor:=crTranslate;
  if Outils_3D.Lateral.Down then Screen.Cursor:=crLateral;
end;

procedure TAfficheur.Support_OpenGLMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if Enfonce then with (Contenu as Tperspective) do begin
    if Outils_3D.Rotation.Down then begin
      Screen.Cursor:=crTourne;
      Vue_Azimuth:=Vue_Azimuth+(X-O_X-D_X)/10;
      Vue_Pente:=Vue_Pente-(Y-O_Y-D_Y)/10;
      if Vue_Azimuth>360 then Vue_Azimuth:=Vue_Azimuth-360;
      if Vue_Azimuth<0 then Vue_Azimuth:=Vue_Azimuth+360;
    end;
    D_X:=X-O_X;
    D_Y:=Y-O_Y;
  end;
end;

procedure TAfficheur.Support_OpenGLMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Enfonce:=false;
  Deplacement.Enabled:=false;
  Timer1.Enabled:=true;
  Screen.Cursor:=crDefault;
  Form1.StatusBar.Panels[1].Text:='';
end;

procedure TAfficheur.DeplacementTimer(Sender: TObject);
begin
  with (Contenu as Tperspective) do begin
    if Outils_3D.Translation.Down then begin
      Vue_Position.Z:=Vue_Position.Z+D_Y/100*Vitesse*cos(Vue_Azimuth/180*PI);
      Vue_Position.X:=Vue_Position.X-D_Y/100*Vitesse*sin(Vue_Azimuth/180*PI);
      Vue_Azimuth:=Vue_Azimuth+D_X/100;
      if Vue_Azimuth>360 then Vue_Azimuth:=Vue_Azimuth-360;
      if Vue_Azimuth<0 then Vue_Azimuth:=Vue_Azimuth+360;
      Screen.Cursor:=crTranslate;
    end;
    if Outils_3D.Lateral.Down then begin
      Vue_Position.Y:=Vue_Position.Y-D_Y/100*Vitesse;
      Vue_Position.X:=Vue_Position.X+D_X/100*Vitesse*cos(Vue_Azimuth/180*PI);
      Vue_Position.Z:=Vue_Position.Z+D_X/100*Vitesse*sin(Vue_Azimuth/180*PI);
      Screen.Cursor:=crLateral;
    end;
    Redessine_Scene;
    Form1.StatusBar.Panels[1].Text:='X = '+IntToStr(round(Vue_Position.X+Centre_X))+
                                    '  Y = '+IntToStr(round(-Vue_Position.Z+Centre_Y))+
                                    '  Z = '+IntToStr(round(Vue_Position.Y+Centre_Z))+
                                    '  Az = '+IntToStr(round(Vue_Azimuth))+
                                    '  P = '+IntToStr(round(Vue_Pente));
  end;
end;

procedure TAfficheur.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Support_OpenGL.Visible then begin
    if ssShift in Shift then Vitesse:=10 else Vitesse:=1;
    Outils_3D.FormKeyDown(Sender,Key,Shift);
  end;
end;

procedure TAfficheur.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Support_OpenGL.Visible then begin
    if ssShift in Shift then Vitesse:=10 else Vitesse:=1;
    Outils_3D.FormKeyUp(Sender,Key,Shift);
  end;
end;

procedure TAfficheur.Debut_3DTimer(Sender: TObject);
begin
  Debut_3D.Enabled:=false;
  (Contenu as TPerspective).Construit_Scene(Support_OpenGL,Etat,F);
end;

procedure TAfficheur.DelaiHintTimer(Sender: TObject);
begin
  DelaiHint.Enabled:=false;
  HintPerso.ActivateHint( rHint, HintChaine);
  HintPerso.Refresh;
end;

procedure TAfficheur.StopHint;
begin
  DelaiHint.Enabled:=false;
  if HintPerso<>nil then begin
    HintPerso.ReleaseHandle;
    HintPerso.Free; HintPerso:=nil;
  end;
end;

procedure TAfficheur.CaTourneTimer(Sender: TObject);
var
  Teta, X0, Z0 : single;
begin
  if Arret.Visible then begin
    with (Contenu as TPerspective) do begin
      Teta:=CaTourne.Tag/1000;
      Vue_Azimuth:=Vue_Azimuth+Teta;
      if Vue_Azimuth>360 then Vue_Azimuth:=Vue_Azimuth-360;
      if Vue_Azimuth<0 then Vue_Azimuth:=Vue_Azimuth+360;
      with Vue_Position do begin
        Teta:=Teta/180*PI;
        X0:=X; Z0:=Z;
        X:=X0*cos(Teta)-Z0*sin(Teta);
        Z:=X0*sin(Teta)+Z0*cos(Teta);
      end;
      Redessine_Scene;
    end;
  end
  else begin
    CaTourne.Enabled:=false;
    Outils_3D.Enabled:=true;
  end;
end;

procedure TAfficheur.Fiche3Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  Nouvelle : TList;
  I : integer;
begin
  with Form1 do begin
    Grosse_Mise_A_Jour;
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
{    Massif.Trier; }
    Nouvelle:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      if TFiche(Form1.Massif.Liste_Courante[I])<>Une_Fiche then Nouvelle.Add(Form1.Massif.Liste_Courante[I]);
    end;
    if Massif.Existe_Selection then Massif.Selection.Free;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Lieu3Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  LeLieu : TEco;
  I : integer;
  Nouvelle : TList;
begin
  with Form1 do begin
    Grosse_Mise_A_Jour;
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
{    Massif.Trier; }
    LeLieu:=Une_Fiche.Lieu;
    Nouvelle:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      if not TFiche(Form1.Massif.Liste_Courante[I]).Lieu.Identique(LeLieu) then Nouvelle.Add(Form1.Massif.Liste_Courante[I]);
    end;
    if Massif.Existe_Selection then Massif.Selection.Free;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Rseau3Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  LeReseau : TEco;
  I : integer;
  Nouvelle : TList;
begin
  with Form1 do begin
    Grosse_Mise_A_Jour;
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
{    Massif.Trier; }
    LeReseau:=Une_Fiche.Reseau;
    Nouvelle:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      if not TFiche(Form1.Massif.Liste_Courante[I]).Reseau.Identique(LeReseau) then Nouvelle.Add(Form1.Massif.Liste_Courante[I]);
    end;
    if Massif.Existe_Selection then Massif.Selection.Free;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Cavit3Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  LaCavite: TEco;
  I : integer;
  Nouvelle : TList;
begin
  with Form1 do begin
    Grosse_Mise_A_Jour;
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
{    Massif.Trier; }
    LaCavite:=Une_Fiche.Cavite;
    Nouvelle:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      if not TFiche(Form1.Massif.Liste_Courante[I]).Cavite.Identique(LaCavite) then Nouvelle.Add(Form1.Massif.Liste_Courante[I]);
    end;
    if Massif.Existe_Selection then Massif.Selection.Free;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Systme2Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  LeSysteme: TEco;
  I : integer;
  Nouvelle : TList;
begin
  with Form1 do begin
    Grosse_Mise_A_Jour;
    Une_Fiche:=Massif.Liste_Courante[Click_Fiche];
{    Massif.Trier; }
    LeSysteme:=Une_Fiche.Systeme;
    Nouvelle:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do begin
      if not TFiche(Form1.Massif.Liste_Courante[I]).Systeme.Identique(LeSysteme) then Nouvelle.Add(Form1.Massif.Liste_Courante[I]);
    end;
    if Massif.Existe_Selection then Massif.Selection.Free;
    Massif.Selection:=Nouvelle;
    Massif.Existe_Selection:=true;
    Massif.Gabarit_Tableau:=false;
    Massif.Liste_Courante:=Massif.Selection;
    Mise_A_Jour;
    Rcuprer1.Enabled:=true;
    StatusBar.Panels[0].Text:='Slection';
  end;
end;

procedure TAfficheur.Image2DblClick(Sender: TObject);
begin
  if Contenu is TTableau then begin
    Screen.Cursor:=crHourGlass;
    (Contenu as TTableau).Ajuste(O_X,PixelsPerInch/25.4,Reduction);
    Mise_A_Jour;
    Screen.Cursor:=crDefault;
  end;
end;

procedure TAfficheur.FormClick(Sender: TObject);
begin
  Mise_A_Jour;
end;

procedure TAfficheur.ExportSvg;
begin
  if Contenu is TProjection then
  begin
    if (SaveDialogSvg.Execute) and (Dlg_svg.ShowModal=mrOk) then
    begin
      if not FileExists(SaveDialogSvg.FileName) or
        (MessageDlg(Format('Le fichier %s existe dj.'+#13+'Ecrire par dessus?',[SaveDialogSvg.FileName]),
        mtWarning,[mbYes,mbNo],0)=mrYes) then begin
        Screen.Cursor:=crHourGlass;
        (Contenu as TProjection).Export_Svg(SaveDialogSvg.FileName,
            Dlg_Svg.CheckBoxIllustrator.Checked,not Dlg_Svg.CheckBoxToutes.Checked);
        Screen.Cursor:=crDefault;
        ShowMessage('Exportation termine');
      end;
    end;
  end;
end;

end.
