{$N-}
unit Cadrerec;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, FicheTpo, Mask, ComCtrls;

type
  TBaseRecherche = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Systeme: TEdit;
    Label2: TLabel;
    Cavite: TEdit;
    Label3: TLabel;
    Reseau: TEdit;
    Label4: TLabel;
    Lieu: TEdit;
    Date_apres: TMaskEdit;
    Date_Avant: TMaskEdit;
    Label6: TLabel;
    Topographe: TEdit;
    Label9: TLabel;
    DuTexte: TEdit;
    GroupBox1: TGroupBox;
    Point_Topo: TEdit;
    Indice: TEdit;
    Label8: TLabel;
    Nom: TLabel;
    Date_tout: TRadioButton;
    Date_exacte: TRadioButton;
    Date_interval: TRadioButton;
    Date_le: TMaskEdit;
    Label5: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure IndiceKeyPress(Sender: TObject; var Key: Char);
    procedure Date_toutClick(Sender: TObject);
    procedure Date_exacteClick(Sender: TObject);
    procedure Date_intervalClick(Sender: TObject);
    procedure Maj_Date;
    procedure Date_toutExit(Sender: TObject);
  private
    { Private-dclarations }
  public
    La_Liste, La_Solution : TList;
    Champ_Indice_Point : integer;
    Champ_Systeme, Champ_Cavite, Champ_Reseau, Champ_Lieu,
                                           Champ_Point_Topo : TNom;
    Point_Propose : string;
    Champ_Topographe : String;
    procedure Initialise(var Une_Liste, Resultat : TList; Un_Point,S1, S2, S3, S4 : string);
    function Compare(Une_Fiche : TFiche) : boolean;
    procedure Majuscule;
    { Public-dclarations }
  end;

var
  BaseRecherche: TBaseRecherche;

implementation

{$R *.DFM}
procedure TBaseRecherche.Initialise(var Une_Liste, Resultat : TList; Un_Point ,S1, S2, S3, S4 : string);
begin
  La_Liste:=Une_Liste;
  La_Solution:=Resultat;
  Point_Propose:=Un_Point;
  Point_Topo.Text:=Un_Point;
  Indice.Text:='';
  Systeme.Text:=S1;
  Cavite.Text:=S2;
  Reseau.Text:=S3;
  Lieu.Text:=S4;
  PageControl1.ActivePage:=TabSheet1;
  Date_Tout.Checked:=true;
  Maj_Date;
  Topographe.Text:='';
  DuTexte.Text:='';
  Date_Le.Text:='  /  /  ';
  Date_Avant.Text:='  /  /  ';
  Date_Apres.Text:='  /  /  ';
end;

procedure TBaseRecherche.Majuscule;
begin
  Champ_Systeme:=UpperCase(Systeme.Text);
  Champ_Cavite:=UpperCase(Cavite.Text);
  Champ_Reseau:=UpperCase(Reseau.Text);
  Champ_Lieu:=UpperCase(Lieu.Text);
  Champ_Topographe:=UpperCase(Topographe.Text);
  Champ_Point_Topo:=UpperCase(Point_Topo.Text);
  try
    Champ_Indice_Point:=StrToInt(Indice.Text);
  except
    Champ_Indice_Point:=-1;
  end;
end;

function TBaseRecherche.Compare(Une_Fiche : TFiche) : boolean;

  function Chaine_Jour(S : string; Borne_sup : boolean) : integer;
  var
    Prime : String;
    I : integer;
  begin
    result:=0;
    Prime:=S[1]+S[2];
    if Prime<>'  ' then try
      result:=StrToInt(Prime);
    except
    end
    else if Borne_Sup then result:=31;
    Prime:=S[4]+S[5];
    if Prime<>'  ' then try
      result:=result+32*StrToInt(Prime);
    except
    end
    else if Borne_Sup then result:=result+384;
    Prime:=S[7]+S[8];
    if Prime<>'  ' then begin
      try
        I:=StrToInt(Prime);
      except
      end;
      if I<50 then I:=I+100;
      result:=result+I*400;
    end;
  end;

var
  Accepte, Trouve : boolean;
  DAvant, DApres, DRef, I, J : integer;
  Ptt_Text, Prime : String;
begin
  Accepte:=true;
  with Une_Fiche do begin
    Systeme.UpString(Ptt_Text);
    Ptt_Text:=Copy(Ptt_text,1,length(Champ_Systeme));
    if (Champ_Systeme<>'') and (Champ_Systeme<>Ptt_Text) then Accepte:=false;
    Cavite.UpString(Ptt_Text);
    Ptt_Text:=Copy(Ptt_text,1,length(Champ_Cavite));
    if (Champ_Cavite<>'') and (Champ_Cavite<>Ptt_Text) then Accepte:=false;
    Reseau.UpString(Ptt_Text);
    Ptt_Text:=Copy(Ptt_text,1,length(Champ_Reseau));
    if (Champ_Reseau<>'') and (Champ_Reseau<>Ptt_Text) then Accepte:=false;
    Lieu.UpString(Ptt_Text);
    Ptt_Text:=Copy(Ptt_text,1,length(Champ_Lieu));
    if (Champ_Lieu<>'') and (Champ_Lieu<>Ptt_Text) then Accepte:=false;

    Dref:=Chaine_Jour(Date,false);
    if Date_interval.Checked then begin
      DAvant:=Chaine_Jour(Date_Avant.Text,true);
      if DAvant<Dref then Accepte:=false;
      DApres:=Chaine_Jour(Date_Apres.Text,false);
      if DApres>Dref then Accepte:=false;
    end;
    if Date_Exacte.Checked then begin
      DAvant:=Chaine_Jour(Date_Le.Text,false);
      if DAvant>Dref then Accepte:=false;
      DApres:=Chaine_Jour(Date_Le.Text,true);
      if DApres<Dref then Accepte:=false;
    end;

    if Champ_Point_Topo<>'' then begin
      Trouve:=false;
      for I:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[I]) do begin
        Depart.Nom.UpString(Ptt_Text);
        Arrivee.Nom.UpString(Prime);
        if Champ_Indice_Point>=0 then begin
          if (Champ_Point_Topo=Ptt_Text) and (Champ_Indice_Point=Depart.Indice) then Trouve:=true;
          if (Champ_Point_Topo=Prime)  and (Champ_Indice_Point=Arrivee.Indice) then Trouve:=true;
        end
        else begin
          if Champ_Point_Topo=Ptt_Text then Trouve:=true;
          if Champ_Point_Topo=Prime then Trouve:=true;
        end;
      end;
      if not Trouve then Accepte:=false;
    end;

    if Champ_Topographe<>'' then begin
      Trouve:=false;
      for I:=0 to Topographes.Count-1 do with TEco(Topographes[I]) do begin
        UpString(Ptt_Text);
        Ptt_Text:=Copy(Ptt_text,1,length(Champ_Topographe));
        if Champ_Topographe=Ptt_Text then Trouve:=true;
      end;
      if not Trouve then Accepte:=false;
    end;
    if DuTexte.Text<>'' then begin
      Trouve:=false;
      Prime:=UpperCase(DuTexte.Text);
      Systeme.UpString(Ptt_Text);
      if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
      Cavite.UpString(Ptt_Text);
      if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
      Reseau.UpString(Ptt_Text);
      if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
      Lieu.UpString(Ptt_Text);
      if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
      for I:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[I]) do begin
        Depart.Nom.UpString(Ptt_Text);
        if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
        Arrivee.Nom.UpString(Ptt_Text);
        if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
        Information.UpString(Ptt_Text);
        if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
        for J:=1 to Nb_Visee do begin
          Visees[J].Commentaires.UpString(Ptt_Text);
          if Pos(Prime,Ptt_Text)<>0 then Trouve:=true;
        end;
      end;
      if not Trouve then Accepte:=false;
    end;
  end;
  Compare:=Accepte;
end;

procedure TBaseRecherche.BitBtn1Click(Sender: TObject);
var
  I : SmallInt;
  Ptt_Fiche : TFiche;
begin
  Majuscule;
  if Point_Topo.Text<>Point_Propose then Point_Propose:='';
  for I:=0 to La_Liste.Count-1 do begin
    Ptt_Fiche:=La_Liste[I];
    if Compare(Ptt_Fiche) then La_Solution.Add(Ptt_Fiche);
  end;
  if La_Solution.Count=0 then begin
    ShowMessage('Il n''y a pas de fiche correspondante');
    ModalResult:=mrNone;
  end;
end;

procedure TBaseRecherche.BitBtn2Click(Sender: TObject);
var
  I : SmallInt;
  Ptt_Fiche : TFiche;
begin
  Majuscule;
  Point_Propose:='';
  for I:=0 to La_Liste.Count-1 do begin
    Ptt_Fiche:=La_Liste[I];
    if not Compare(Ptt_Fiche) then La_Solution.Add(Ptt_Fiche);
  end;
  if La_Solution.Count=0 then begin
    ShowMessage('Il n''y a pas de fiche correspondante');
    ModalResult:=mrNone;
  end;
end;

procedure TBaseRecherche.IndiceKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8)
      then Key := #0;
end;

procedure TBaseRecherche.Date_toutClick(Sender: TObject);
begin
  if Date_Tout.Checked then begin
    Date_Exacte.Checked:=false;
    Date_Interval.Checked:=false;
  end;
  Maj_Date;
end;

procedure TBaseRecherche.Date_exacteClick(Sender: TObject);
begin
  if Date_Exacte.Checked then begin
    Date_Tout.Checked:=false;
    Date_Interval.Checked:=false;
  end;
  Maj_Date;
end;

procedure TBaseRecherche.Date_intervalClick(Sender: TObject);
begin
  if Date_Interval.Checked then begin
    Date_Tout.Checked:=false;
    Date_Exacte.Checked:=false;
  end;
  Maj_Date;
end;

procedure TBaseRecherche.Maj_Date;
begin;
  Date_Avant.Enabled:=Date_Interval.Checked;
  Date_Apres.Enabled:=Date_Interval.Checked;
  Date_Le.Enabled:=Date_Exacte.Checked;
end;

procedure TBaseRecherche.Date_toutExit(Sender: TObject);
begin
  Maj_Date;
end;

end.
