unit CThread;

interface

uses
  Classes, Calcul, Fichetpo;

type
  TThreadCalcul = class(TThread)
  private
    { Dclarations prives }
  protected
    procedure Execute; override;
  public
    Calculateur : TCalculateur;
    constructor Create(Un_Massif : TMassif);
    destructor Destroy; override;
  end;

implementation


{ TThreadCalcul }

constructor TThreadCalcul.Create(Un_Massif : TMassif);
begin
  Un_Massif.Trier;
  Calculateur:=TCalculateur.Create;
  Calculateur.Initialise(Un_Massif.Liste_Fiche,Un_Massif.Liste_Reference,moBoucle);
  FreeOnTerminate:=true;
  inherited Create(False);
  Priority:=tpLowest;
//  Priority:=tpHighest;
end;

destructor TThreadCalcul.Destroy;
begin
  Calculateur.Free;
  inherited Destroy;
end;

procedure TThreadCalcul.Execute;
begin
  Calcul_En_Cours:=true;
  Calcul_Arrete:=false;
  with Calculateur do
  if Atteint(Silencieux) then begin
    if not Calcul_Arrete then Reduction(Silencieux);
    if not Calcul_Arrete then La_Totale(Silencieux) else Utilise:=false;
    if not Calcul_Arrete then Fission;
  end;
end;

end.
