unit ExportPlt;

interface

uses SysUtils, FicheTpo;

  procedure ExportToPlt(FMassif : TMassif; FFileName : TFileName);

implementation

uses Classes;

// Sauve un massif au format HPGL
// A faire: sauvegarde des largeurs/hauteurs, noms de Survey,Shots correctes

procedure ExportToPlt(FMassif : TMassif; FFileName : TFileName);
var
  l: TStringList;
  OldCave: string;
  f, g : integer;
  i,j,k: integer;
  pMin,    pMax, pt: TPoint3D;
  pExtMin, pExtMax:  TPoint3D;
  dev:        double;
  lw, rw, th, bh: double;  // largeurs gauche, droite, haut bas
  dd,mm,yy: integer;
  s: string;
  bFirst,bNewSurvey: boolean;
  Les_Fiches : TList;
begin

  l := TStringList.Create;
  try
    l.Add('Z xmin xmax ymin ymax zmin zmax');  // Il faudra mettre  jour cette line  la fin

    // Gnre les galeries
    with FMassif do begin
      if Existe_Selection then Les_Fiches:=Selection
                          else Les_Fiches:=Liste_Fiche;
      with Les_Fiches do begin
        g := 0;
        f := Count;

        bFirst  := true;
        OldCave := '';
        for i:=0 to Count-1 do with TFiche(Items[i]) do begin
          // Save Section
          if Cavite.AsString <> OldCave then begin
            if Cavite.AsString <> '' then l.Add( format('S%s', [Copy(Cavite.AsString,1,8)]) );
            OldCave := Cavite.AsString;
          end;

          // Save Survey
          s := Date;
          try dd:=StrToInt(Copy(s,1,2)) except dd:=31; end;
          try mm:=StrToInt(Copy(s,4,2)) except mm:=12; end;
          try yy:=StrToInt(Copy(s,7,2)) except yy:=00; end;
          if yy>30 then yy:=yy+1900 else yy:=yy+2000;
          s := format('T%d', [i]);
          l.Add(format('N%s D %d %d %d C%s', [s, mm, dd, yy, Lieu.AsString]));
          bNewSurvey := true;

          with Liste_Galerie do begin
            g := g + Count;

            for j:=0 to Count-1 do with TGalerie(Items[j]) do begin
              s := Information.AsString;

              // Save Move (First point)
              l.Add(format('M %.2f %.2f %.2f S%s P %.1f %.1f %.1f %.1f', [Depart.x, Depart.y, Depart.z, Depart.Nom.AsString, 999.0,999.0,999.0,999.0]));

              if bFirst then begin
                bFirst := false;
                with pMin do begin
                  x := Depart.x;
                  y := Depart.y;
                  z := Depart.z;
                end;
                pMax := pMin;
              end;

              if bNewSurvey then begin
                bNewSurvey := false;
                with pExtMin do begin
                  x := Depart.x;
                  y := Depart.y;
                  z := Depart.z;
                end;
                pExtMax   := pExtMin;
              end;


              for k:=1 to Nb_Visee do with Coordonnees^[k] {pt} do begin
                if x<pMin.X then pMin.X:=x;
                if y<pMin.y then pMin.y:=y;
                if z<pMin.z then pMin.z:=z;
                if x>pMax.X then pMax.X:=x;
                if y>pMax.y then pMax.y:=y;
                if z>pMax.z then pMax.z:=z;

                if x<pExtMin.X then pExtMin.X:=x;
                if y<pExtMin.y then pExtMin.y:=y;
                if z<pExtMin.z then pExtMin.z:=z;
                if x>pExtMax.X then pExtMax.X:=x;
                if y>pExtMax.y then pExtMax.y:=y;
                if z>pExtMax.z then pExtMax.z:=z;

                // Save Draw (Next point)
                s := format('%d.%d', [j, k]); // "Nom" de la vise
                with Visees[k] do begin
                  try lw:=StrToFLoat(LargeurGauche); except lw:=999; end;
                  try rw:=StrToFLoat(LargeurDroite); except rw:=999; end;
                  try th:=StrToFLoat(HauteurSup);    except th:=999; end;
                  try bh:=StrToFLoat(HauteurInf);    except bh:=999; end;
                end;
                l.Add(format('D %.2f %.2f %.2f S%s P %.1f %.1f %.1f %.1f', [x, y, z, s, lw,rw,th,bh]));
              end;
            end;
          end;

          // Save eXtension (of Survey)
          l.Add(format('X %.2f %.2f %.2f %.2f %.2f %.2f', [pExtMin.x, pExtMax.x, pExtMin.y, pExtMax.y, pExtMin.z, pExtMax.z]));
        end;
      end;

      l.Strings[0] := format('Z %.2f %.2f %.2f %.2f %.2f %.2f', [pMin.x, pMax.x, pMin.y, pMax.y, pMin.z, pMax.z]);
    end;

    l.SaveToFile(FFileName);
  finally
    l.Free;
  end;
end;

end.
