unit Grapheta;

interface

uses Graphes, Fichetpo, Classes, ExtCtrls, Printers, Windows,
     SysUtils, Options, Forms, Dialogs, Graphics, Controls;

type

  TTableau= class (TGraphique)
    DX, DY, DZ : double;
    constructor Create;
    procedure Dessine(Pixel_X, Pixel_Y : longint; Resolution, Rapport : double; Canevas : TImage; Etat : smallInt); override;
    procedure Imprime(Page_X, Page_Y, Sup_X, Sup_Y : integer; Etat : smallInt;
                              Fond : TCanvas; Reduc : double); override;
    procedure Gabarit(var Pixel_Hori, Pixel_Verti : longint; Resolution, Rapport : double; Canevas : TImage); override;
    procedure Gabarit_Imprimante(var Page_X, Page_Y : integer; MargeX, MargeY : integer); override;
    function Trouve(X, Y : longint;var N_Fiche, N_Galerie, N_Visee : integer) : double; override;
    procedure Isoler(X, Y, Rayon2 : longint); override;
    function Met_En_Relief(Nouveau : boolean; N_Fiche, N_Galerie, N_Visee : integer; Etat : smallInt) : string; override;
    function Bulle(N_Fiche, N_Galerie, N_Visee : integer) : string; override;
    procedure La_Liste(var Une_Liste : TList);
    procedure Ajuste(X : integer; Resolution,Rapport : double);
  end;

implementation

uses Unit1, Couleurs;

{********************** TTableau ****************************************}

const
  hjAvant=0;
  hjPendant=1;
  hjApres=2;
  hjTermine=3;

constructor TTableau.Create;
begin
  inherited Create;
end;

procedure TTableau.La_Liste(var Une_Liste : TList);
var
  I, J : integer;

  function Superieur : boolean;
  var
    FicheJ, FicheI : TFiche;
    DI, DJ : integer;
    SI, SJ : string;
  begin
    FicheJ:=Une_Liste[J];
    FicheI:=Form1.Massif.Liste_Courante[I];
    if Form1.Date1.Checked then begin
      DI:=Date2Jour(FicheI.Date);
      DJ:=Date2Jour(FicheJ.Date);
      Superieur:=DJ<DI;
    end
    else begin
      FicheI.Systeme.UpString(SI);
      FicheJ.Systeme.Upstring(SJ);
      if SI=SJ then begin
        FicheI.Cavite.UpString(SI);
        FicheJ.Cavite.Upstring(SJ);
        if SI=SJ then begin
          FicheI.Reseau.UpString(SI);
          FicheJ.Reseau.Upstring(SJ);
          if SI=SJ then begin
            FicheI.Lieu.UpString(SI);
            FicheJ.Lieu.Upstring(SJ);
            Superieur:=(SJ<SI);
          end
          else Superieur:=(SJ<SI);
        end
        else Superieur:=(SJ<SI);
      end
      else Superieur:=(SJ<SI);
    end;
  end;

begin
  if Form1.Ordredesaisie1.Checked then Une_Liste:=Form1.Massif.Liste_Courante
  else begin
    for I:=0 to Form1.Massif.Liste_Courante.count-1 do begin
      J:=0;
      while (J<Une_Liste.Count) and Superieur do inc(J);
      if J=Une_Liste.Count then Une_Liste.Add(Form1.Massif.Liste_Courante[I])
      else Une_Liste.Insert(J,Form1.Massif.Liste_Courante[I]);
    end;
  end;
end;

procedure TTableau.Dessine(Pixel_X, Pixel_Y : longint; Resolution, Rapport : double; Canevas : TImage; Etat : smallInt);
var
  I, J, K, L, M, Type_Brut, Type_Net, Type_Premiere, Hauteur_Fenetre, Hors_Jeu : integer;
  Long , X0, Y0, Z0, X1, Y1, Z1, H1,
  Eps, Plus, Cumul_Brut, Cumul_Net, Cumul_Premiere, Contrainte_Max : double;
  MM_Gauche, MM_Haut, Largeur_Totale, Toz, Precedent_Brut, Precedent_Net, Precedent_Premiere,
    Base_Entete : longint;
  Contenu, Suplement, Report, Info : string;
  Centrage, Chgt_Direction, Chgt_Galerie, Chgt_Equipe, Premier_Entete : boolean;
  Une_Fiche, Precedente_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Les_Fiches : TList;
  Precedent_Point : TPointTopo;
  Un_Topographe : TEco;
  Hors_Plan : TBitMap;

  procedure Sequence(var Origine, Surplus : string);
  var
    Indice : integer;
    Test : string;
  begin
    Origine:=' '+Origine;
    if Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution*Rapport>Le_Caneva.TextWidth(Origine) then Report:=''
    else begin
      Indice:=length(Origine);
      repeat
        dec(Indice);
        Test:=Copy(Origine,1,Indice);
      until (Indice=0) or ((Origine[Indice]=' ') and
            (Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution*Rapport>Le_Caneva.TextWidth(Test)));
      case Indice of
        0 : begin
          Indice:=length(Origine);
          repeat
            dec(Indice);
            Test:=Copy(Origine,1,Indice);
          until Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution>Canevas.Canvas.TextWidth(Test);
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice);
        end;
        1 : begin
          Surplus:='';
          Origine:=Copy(Origine,Indice+1,length(Origine)-Indice);
        end;
        else begin
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice-1);
        end;
      end;
    end;
  end;

  procedure Sommet_Colonne;
  var L : integer;
  begin
    if (MM_Haut*Rapport*Resolution-PixelY>0) and (MM_Haut*Rapport*Resolution-PixelY<3000) then begin
      Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
      Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
      MM_Gauche:=0;
      for L:=1 to 13 do begin
        M:=1;
        while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
        Centrage:=true;
        if Form1.Les_Options_Tableau.Afficher[M] then begin
          Contenu:=Form1.Les_Options_Tableau.Entete[M,1];
          Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Rapport*Resolution-Le_Caneva.TextWidth(Contenu))/2;
          Le_Caneva.TextOut(round(Plus+MM_Gauche*Rapport*Resolution-PixelX),
                                   round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
          inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
          if Form1.Les_Options_Tableau.Dedoubler[M] then begin
            Contenu:=Form1.Les_Options_Tableau.Entete[M,2];
            Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Rapport*Resolution-Le_Caneva.TextWidth(Contenu))/2;
            Le_Caneva.TextOut(round(Plus+MM_Gauche*Rapport*Resolution-PixelX),
                                     round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
            inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
          end;
        end;
      end;
      Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Rapport*Resolution/10);
      Le_Caneva.MoveTo(-PixelX,round(MM_Haut*Rapport*Resolution-PixelY));

      Le_Caneva.LineTo(round(Largeur_Totale*Rapport*Resolution-PixelX),
                              round(MM_Haut*Rapport*Resolution-PixelY));
    end;
    inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
  end;

  procedure Remonter(Le_Quel : integer);
  var
    L : integer;
    La_Haut : longint;
  begin
    if not Premier_Entete and ((Hors_Jeu=hjPendant) or (Hors_Jeu=hjApres))then with Form1.Les_Options_Tableau do begin
      La_Haut:=round(Base_Entete*Rapport*Resolution-PixelY);
      if La_Haut<0 then La_Haut:=-1;
      if So_Afficher[7,Le_Quel] then begin
        Le_Caneva.Font:=So_police[7,Type_Brut];
        Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
        Contenu:=So_Intitule[7,Type_Brut]+' '+FloatTostrF(Cumul_Brut,ffGeneral,5,2);
        if LA_Haut>=0 then Le_Caneva.TextOut(round(So_X[7,Type_Brut]*Rapport*Resolution-PixelX),
                                 round((Precedent_Brut+So_Y[7,Type_Brut])*Rapport*Resolution-PixelY),
                                 Contenu);
      end;
      if So_Afficher[8,Le_Quel] then begin
        Le_Caneva.Font:=So_police[8,Type_Net];
        Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
        Contenu:=So_Intitule[8,Type_Net]+' '+FloatTostrF(Cumul_Net,ffGeneral,5,2);
        if LA_Haut>=0 then Le_Caneva.TextOut(round(So_X[8,Type_Net]*Rapport*Resolution-PixelX),
                                 round((Precedent_Net+So_Y[8,Type_Net])*Rapport*Resolution-PixelY),Contenu);
      end;
      if So_Afficher[11,Le_Quel] then begin
        Le_Caneva.Font:=So_police[11,Type_Premiere];
        Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
        Contenu:=So_Intitule[11,Type_Premiere]+' '+FloatTostrF(Cumul_Premiere,ffGeneral,5,2);
        if LA_Haut>=0 then Le_Caneva.TextOut(round(So_X[11,Type_Premiere]*Rapport*Resolution-PixelX),
                                 round((Precedent_Premiere+So_Y[11,Type_Premiere])*Rapport*Resolution-PixelY),Contenu);
      end;
      Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Rapport*Resolution/10);
      Le_Caneva.MoveTo(-PixelX,La_Haut);
      Le_Caneva.LineTo(-PixelX,round(MM_Haut*Rapport*Resolution-PixelY));
      MM_Gauche:=0;
      Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Rapport*Resolution/10);
      for L:=1 to 13 do begin
        M:=1;
        while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
        if Form1.Les_Options_Tableau.Afficher[M] then begin
          inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
          Le_Caneva.MoveTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                                  La_Haut);
          Le_Caneva.LineTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                                  round(MM_Haut*Rapport*Resolution-PixelY));
          if Form1.Les_Options_Tableau.Dedoubler[M] then begin
            inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
            Le_Caneva.MoveTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                                    La_HAut);
            Le_Caneva.LineTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                                    round(MM_Haut*Rapport*Resolution-PixelY));
          end;
        end;
      end;
      Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Rapport*Resolution/10);
      Le_Caneva.MoveTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                              La_Haut);
      Le_Caneva.LineTo(round(MM_Gauche*Rapport*Resolution-PixelX),
                              round(MM_Haut*Rapport*Resolution-PixelY));

    end;
    if (Le_Quel=0) and (Hors_Jeu=hjApres) then Hors_Jeu:=hjTermine;
  end;

  procedure EnTete(Le_Quel : integer);
  var
    I, J : integer;
  begin
    Remonter(Le_Quel);
    Premier_Entete:=false;
    for I:=1 to 11 do with Form1.Les_Options_Tableau do begin
      if So_Afficher[I,Le_Quel] then begin
        Chgt_Direction:=true;
        Le_Caneva.Font:=So_police[I,Le_Quel];
        Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
        Contenu:=So_Intitule[I,Le_Quel];
        case I of
          1 : Suplement:=Une_Fiche.date;
          2 : Une_Fiche.Systeme.Lit(Suplement);
          3 : Une_Fiche.Cavite.Lit(Suplement);
          4 : Une_Fiche.Reseau.Lit(Suplement);
          5 : Une_Fiche.Lieu.Lit(Suplement);
          6 : Suplement:=FloatTostrF(Une_Fiche.Declinaison,ffGeneral,3,2)+
                tuAngle[Une_Fiche.Unite_Decli];
          7 : begin
            Suplement:=''; {Dev brut}
            Cumul_Brut:=0;
            Precedent_Brut:=MM_Haut;
            Type_Brut:=Le_Quel;
          end;
          8 : begin
            Suplement:=''; {Dev net}
            Cumul_Net:=0;
            Precedent_Net:=MM_Haut;
            Type_Net:=Le_Quel;
          end;
          9 : begin
            MM_Gauche:=round(So_X[I,Le_Quel]*Resolution*Rapport-PixelX)+Le_Caneva.TextWidth(Contenu+' ');

            for J:=0 to Une_Fiche.Topographes.Count-1 do begin
              Un_Topographe:=Une_Fiche.Topographes[J];
              Un_Topographe.Lit(Suplement);
              if Hors_Jeu=hjPendant then Le_Caneva.TextOut(MM_Gauche,
                  round((MM_Haut+J*Form1.Les_Options_Tableau.Hauteur+So_Y[I,Le_Quel])*Rapport*Resolution-PixelY),Suplement);
            end;
            Suplement:=''; {explorateur}
          end;
          10 : Une_Fiche.Temps.Lit(Suplement);
          11 : begin
            Suplement:=''; {Dev Premiere}
            Cumul_Premiere:=0;
            Precedent_Premiere:=MM_Haut;
            Type_Premiere:=Le_Quel;
          end;
        end;
        Contenu:=Contenu+' '+Suplement;
        if Hors_Jeu=hjPendant then Le_Caneva.TextOut(round(So_X[I,Le_Quel]*Rapport*Resolution-PixelX),
                                 round((MM_Haut+So_Y[I,Le_Quel])*Rapport*Resolution-PixelY),Contenu);
      end;
    end;
    inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[Le_Quel]);
    Base_Entete:=MM_Haut;
    if Form1.Les_Options_Tableau.So_Rappel[Le_Quel] and
           ((Hors_Jeu=hjPendant) or (Hors_Jeu=hjAvant)) then Sommet_Colonne;
  end;

begin
  Premier_Entete:=true;
  PixelX:=Pixel_X; PixelY:=Pixel_Y;

  Hors_Plan:=TBitMap.Create;
  Hors_Plan.Width:=Canevas.Width;
  Hors_Plan.Height:=Canevas.Height;
  Le_Caneva:=Hors_Plan.Canvas;

  Le_Caneva.Pen.Color:=clWhite; Le_Caneva.Brush.Color:=clWhite;
  //  Le_Caneva.Rectangle(0,0,Le_Caneva.Width,Le_Caneva.Height);
  La_Resolution:=Resolution;
  Hauteur_Fenetre:=Form1.LeTableau.Height;
  Form1.Massif.Trier;
  Les_Fiches:=TList.Create;
  La_Liste(Les_Fiches);
  if Affichable then begin
    Largeur_Totale:=0;
    Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
    Le_Caneva.Brush.Style:=bsClear;
    Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
    Eps:=(Form1.Les_Options_Tableau.Hauteur*Rapport*Resolution-Le_Caneva.TextHeight('P'))/2;
    for I:=1 to 13 do if Form1.Les_Options_Tableau.Afficher[I] then begin
      inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
      if Form1.Les_Options_Tableau.Dedoubler[I] then inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
    end;
    Chgt_Direction:=true; Chgt_Galerie:=true; Chgt_Equipe:=true;
    Le_Caneva.Pen.Color:=clBlack;
    MM_Haut:=0;
    Hors_Jeu:=hjAvant;
    if Etat=etContrainte then Contrainte_Max:=Contrainte_Maximum(Les_Fiches);
    for I:=0 to les_Fiches.Count-1 do if not (Hors_Jeu=hjTermine) then begin
      Une_Fiche:=Les_Fiches[I];
      if (Hors_Jeu=hjAvant) and (PixelY<Une_Fiche.Base_Tableau*Rapport*Resolution+0.1) then Hors_Jeu:=hjPendant;
      if Hors_Jeu<>hjTermine then begin
        if (Hors_Jeu=hjPendant) and
        (PixelY+Hauteur_Fenetre<Une_Fiche.Sommet_Tableau*Rapport*Resolution) then Hors_Jeu:=hjApres;
        MM_Haut:=Une_Fiche.Sommet_Tableau;
        if not Chgt_Equipe then begin
          Chgt_Equipe:=not Une_Fiche.Meme_Equipe(Precedente_Fiche);
          Chgt_Galerie:=not Une_Fiche.Meme_Lieu(Precedente_Fiche);
        end;
        if Chgt_Equipe then begin
          {En_tte gnral }
          EnTete(0);
        end
        else if Chgt_Galerie then begin
          {En_tte restreint }
          EnTete(1);
        end;
        Cumul_Premiere:=Cumul_Premiere+Une_Fiche.Premiere;
        Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
        Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
        for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
          Une_Galerie:=Une_Fiche.Liste_Galerie[J];
          if Une_Galerie.Approximation then with Une_Galerie do begin
            if Hors_Jeu=hjPendant then begin
              X0:=Depart.X-DX; Y0:=Depart.Y-DY; Z0:=Depart.Z-DZ;
              if not Chgt_Direction then Chgt_Direction:=not Une_Galerie.Depart.Identique(Precedent_Point);
              if Chgt_Direction then begin
                Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Rapport*Resolution/10);
                Le_Caneva.MoveTo(-PixelX,round(MM_Haut*Rapport*Resolution-PixelY));
                Le_Caneva.LineTo(round(Largeur_Totale*Rapport*Resolution-PixelX),
                                        round(MM_Haut*Rapport*Resolution-PixelY));
                if (Une_Galerie.Nb_Visee>0) and (Une_Galerie.Visees[1].Longueur=0) then begin
                  if not Une_Galerie.Depart.Terminus then begin
                    Une_Galerie.Depart.Nom.Lit(Suplement);
                    Suplement:=Suplement+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
    (*1*)                Suplement:='du point '+Suplement+'. ';
                    Le_Caneva.Font:=Form1.Les_Options_Tableau.Relief;
                    Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
                    case Etat of
                      etContrainte : Le_Caneva.Font.Color:=
                       Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                      etNoir : Le_Caneva.Font.Color:=clBlack;
                      etCouleur :  Le_Caneva.Font.Color:=Couleur;
                    end;
                  end
                  else Suplement:='';
                  Une_Galerie.Information.Lit(Info);
                  if Info<>'' then Suplement:=Suplement+Info+' ';
                end
                else begin
                  MM_Gauche:=0;
                  Report:='';
                  if not Une_Galerie.Depart.Terminus then begin
                    Le_Caneva.Font:=Form1.Les_Options_Tableau.Relief;
                    Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
                    case Etat of
                      etContrainte : Le_Caneva.Font.Color:=
                       Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                      etNoir : Le_Caneva.Font.Color:=clBlack;
                      etCouleur :  Le_Caneva.Font.Color:=Couleur;
                    end;
                  end;
                  for L:=1 to 13 do begin
                    M:=1;
                    while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
                    Centrage:=true;
                    case M of
                      coLongueur : Contenu:='';
                      coAzimuth : Contenu:='';
                      coPente : Contenu:='';
                      coLargeur : Contenu:='';
                      coHauteur : Contenu:='';
                      coX : str(X0:6:2,Contenu);
                      coY : str(Y0:6:2,Contenu);
                      coZ : str(Z0:6:2,Contenu);
                      coDevH : if Une_Galerie.En_Coupe then
                        if Une_Galerie.Accrochage_Debut then str(Une_Galerie.Decal_Hori:6:2,Contenu)
                                                        else str(Une_Galerie.Fin_Hori:6:2,Contenu)
                        else Contenu:='X';
                      coObservation : begin
                        Centrage:=false;
                        if not Une_Galerie.Depart.Terminus then begin
                          Une_Galerie.Depart.Nom.Lit(Contenu);
                          Contenu:=Contenu+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                          Contenu:='du point '+Contenu+'. ';
                        end
                        else Contenu:='';
                        Une_Galerie.Information.Lit(Info);
                        if Info<>'' then Contenu:=Contenu+Info+' ';
                        Sequence(Contenu,Report);
                        Toz:=MM_Gauche;
                      end;
                      coDlt : Contenu:='';
                      coLH : Contenu:='';
                      coDZ : Contenu:='';
                    end;
                    if Form1.Les_Options_Tableau.Afficher[M] then begin
                      if Centrage
                        then Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Rapport*Resolution-
                                Le_Caneva.TextWidth(Contenu))/2
                        else Plus:=0;
                      Le_Caneva.TextOut(round(Plus+MM_Gauche*Rapport*Resolution-PixelX),
                                               round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
                      inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                      if Form1.Les_Options_Tableau.Dedoubler[M] then inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                    end;
                  end;
                  if Report<>'' then begin
                    repeat
                      Contenu:=Report;
                      Sequence(Contenu,Report);
                      inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                      Le_Caneva.TextOut(round(Toz*Rapport*Resolution-PixelX),
                                               round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
                    until Report='';
                  end;
                  inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                  Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
                  Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
                  case Etat of
                    etContrainte : Le_Caneva.Font.Color:=
                     Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                    etNoir : Le_Caneva.Font.Color:=clBlack;
                    etCouleur :  Le_Caneva.Font.Color:=Couleur;
                  end;
                  Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Rapport*Resolution/10);
                  Le_Caneva.MoveTo(-PixelX,round(MM_Haut*Rapport*Resolution-PixelY));
                  Le_Caneva.LineTo(round(Largeur_Totale*Rapport*Resolution-PixelX),
                                          round(MM_Haut*Rapport*Resolution-PixelY));
                  Suplement:='';
                end;
              end
              else begin
                Une_Galerie.Information.Lit(Suplement);
                if Suplement<>'' then Suplement:=Suplement+'. ';
              end;
            end;
            for K:=1 to Une_Galerie.Nb_Visee do begin
              if Visees[K].ULong=cm then Long:=Visees[K].Longueur/100 else Long:=Visees[K].Longueur;
              Cumul_Brut:=Cumul_Brut+Long;
              if Visees[K].Correction_Dlt then Cumul_Net:=Cumul_Net+Visees[K].Longueur_Dlt
                                          else Cumul_Net:=Cumul_Net+Long;
              if Hors_Jeu=hjPendant then begin
                X1:=Coordonnees^[K].X-DX;
                Y1:=Coordonnees^[K].Y-DY;
                Z1:=Coordonnees^[K].Z-DZ;
                H1:=Coordonnees^[K].LH;
                MM_Gauche:=0;
                if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
                  Le_Caneva.Font:=Form1.Les_Options_Tableau.Relief;
                  Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
                  case Etat of
                    etContrainte : Le_Caneva.Font.Color:=
                     Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                    etNoir : Le_Caneva.Font.Color:=clBlack;
                    etCouleur :  Le_Caneva.Font.Color:=Couleur;
                  end;
                end;
                for L:=1 to 13 do begin
                  M:=1;
                  while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
                  case M of
                    coLongueur : begin
                      Centrage:=true;
                      if Visees[K].ULong=cm then str(Une_Galerie.Visees[K].Longueur/100:2:2,Contenu)
                                            else str(Une_Galerie.Visees[K].Longueur:2:2,Contenu);
                      if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                    end;
                    coDZ : begin
                      Centrage:=true;
                      if K=1 then str((Coordonnees^[1].Z-Une_Galerie.Depart.Z):2:2,Contenu)
                      else str((Coordonnees^[K].Z-Coordonnees^[K-1].Z):2:2,Contenu);
                    end;
                    coLH : begin
                      Centrage:=true;
                      if K=1 then str(sqrt(sqr(Visees[1].X)+sqr(Visees[1].Y)):2:2,Contenu)
                      else str(sqrt(sqr(Visees[K].X-Visees[K-1].X)+
                                    sqr(Visees[K].Y-Visees[K-1].Y)):2:2,Contenu);
                    end;
                    coAzimuth : begin
                      Centrage:=true;
                      str(Une_Galerie.Visees[K].Azimuth:3:0,Contenu);
                      if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                    end;
                    coPente : begin
                      Centrage:=true;
                      str(Une_Galerie.Visees[K].Pente:3:1,Contenu);
                      if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                    end;
                    coLargeur : begin
                      Centrage:=true;
                      Contenu:=Une_Galerie.Visees[K].LargeurGauche;
                      if Form1.Les_Options_Tableau.Dedoubler[coLargeur] then Info:=Une_Galerie.Visees[K].LargeurDroite
                      else if Une_Galerie.Visees[K].LargeurDroite<>'' then
                        Contenu:=Contenu+'/'+Une_Galerie.Visees[K].LargeurDroite;
                    end;
                    coHauteur : begin
                      Centrage:=true;
                      Contenu:=Une_Galerie.Visees[K].HauteurSup;
                      if Form1.Les_Options_Tableau.Dedoubler[coHauteur] then Info:=Une_Galerie.Visees[K].HauteurInf
                      else if Une_Galerie.Visees[K].HauteurInf<>'' then
                        Contenu:=Contenu+'/'+Une_Galerie.Visees[K].HauteurInf;
                    end;
                    coX : begin
                      Centrage:=true;
                      str(X1:6:2,Contenu);
                    end;
                    coY : begin
                      Centrage:=true;
                      str(Y1:6:2,Contenu);
                    end;
                    coZ : begin
                      Centrage:=true;
                      str(Z1:6:2,Contenu);
                    end;
                    coDevH : begin
                      Centrage:=true;
                      if Une_Galerie.En_Coupe then str(H1:6:2,Contenu)
                      else Contenu:='X';
                    end;
                    coObservation : begin
                      Centrage:=false;
                      Une_Galerie.Visees[K].Commentaires.Lit(Contenu);
                      {if Une_Galerie.Visees[K].Longueur=0 then }Contenu:=Suplement+Contenu;
                      if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
                        Une_Galerie.Arrivee.Nom.Lit(Suplement);
                        Suplement:=Suplement+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
                        Contenu:=Contenu+' Point '+Suplement;
                      end;
                      Sequence(Contenu,Report);
                      Toz:=MM_Gauche;
                      Suplement:='';
                    end;
                    coDlt : begin
                      Centrage:=true;
                      if Une_Galerie.Visees[K].Correction_Dlt then
                          str(Une_Galerie.Visees[K].Longueur_Dlt:2:2,Contenu)
                          else if Une_Galerie.Visees[K].ULong=cm then
                            str(Une_Galerie.Visees[K].Longueur/100:2:2,Contenu)
                          else str(Une_Galerie.Visees[K].Longueur:2:2,Contenu);
                    end;
                  end;
                  if Form1.Les_Options_Tableau.Afficher[M] then begin
                    if Centrage
                      then Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Rapport*Resolution-
                                                      Le_Caneva.TextWidth(Contenu))/2
                      else Plus:=0;
                    Le_Caneva.TextOut(round(Plus+MM_Gauche*Rapport*Resolution-PixelX),
                                             round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
                    inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                    if Form1.Les_Options_Tableau.Dedoubler[M] then begin
                      Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Rapport*Resolution-Le_Caneva.TextWidth(Info))/2;
                      Le_Caneva.TextOut(round(Plus+MM_Gauche*Rapport*Resolution-PixelX),
                                               round(Eps+MM_Haut*Rapport*Resolution-PixelY),Info);
                      inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                    end;
                  end;
                end;
                if Report<>'' then begin
                  repeat
                    Contenu:=Report;
                    Sequence(Contenu,Report);
                    inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                    Le_Caneva.TextOut(round(Toz*Rapport*Resolution-PixelX),
                                             round(Eps+MM_Haut*Rapport*Resolution-PixelY),Contenu);
                  until Report='';
                end;
                inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur+Une_Galerie.Visees[K].Schema*10);
                Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
                Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
                case Etat of
                  etContrainte : Le_Caneva.Font.Color:=
                   Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                  etNoir : Le_Caneva.Font.Color:=clBlack;
                  etCouleur :  Le_Caneva.Font.Color:=Couleur;
                end;
                Le_Caneva.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Rapport*Resolution/10);
                Le_Caneva.MoveTo(-PixelX,round(MM_Haut*Rapport*Resolution-PixelY));
                Le_Caneva.LineTo(round(Largeur_Totale*Rapport*Resolution-PixelX),
                                        round(MM_Haut*Rapport*Resolution-PixelY));
              end;
            end;
            Chgt_Direction:=false;
            Precedent_Point:=Une_Galerie.Arrivee;
          end;
        end;
      end;
      Chgt_Galerie:=false; Chgt_Equipe:=false;
      Precedente_Fiche:=Une_Fiche;
    end;
    if Hors_Jeu<>hjTermine then Remonter(0);
  end;

  Le_Caneva:=Canevas.Canvas;
  Le_Caneva.CopyMode:=cmSrcCopy;
  Le_Caneva.Draw(0,0,Hors_Plan);
  Hors_Plan.Free;
end;

procedure TTableau.Imprime(Page_X, Page_Y, Sup_X, Sup_Y : integer; Etat : smallInt; Fond : TCanvas; Reduc : double);
var
  I, J, K, L, M, Type_Brut, Type_Net, Type_Premiere : integer;
  Long , X0, Y0, Z0, X1, Y1, Z1, H1,
  Eps, Plus, Cumul_Brut, Cumul_Net, Cumul_Premiere, Contrainte_Max : double;
  MM_Gauche, MM_Haut, Largeur_Totale, Toz, Precedent_Brut, Precedent_Net, Precedent_Premiere,
    Base_Entete, Hauteur_Page : longint;
  Contenu, Suplement, Report, Info : string;
  Centrage, Chgt_Direction, Chgt_Galerie, Chgt_Equipe, Premier_Entete : boolean;
  Une_Fiche, Precedente_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Les_Fiches : TList;
  Precedent_Point : TPointTopo;
  Un_Topographe : TEco;


  procedure MoveTo(X,Y : double);
  begin
   if (Y<=Hauteur_Page*(Page_Y+1)) and (Y>=Hauteur_Page*Page_Y) then
    Support.MoveTo(round(((X+Sup_X)*Resolution_Imprimante-Page_X*Printer.PageWidth)*Correction),
          round((Y+Sup_Y-Hauteur_Page*Page_Y)*Resolution_Imprimante*Correction));
  end;
  procedure LineTo(X,Y : double);
  begin
   if (Y<=Hauteur_Page*(Page_Y+1)) and (Y>=Hauteur_Page*Page_Y) then
    Support.LineTo(round(((X+Sup_X)*Resolution_Imprimante-Page_X*Printer.PageWidth)*Correction),
          round((Y+Sup_Y-Hauteur_Page*Page_Y)*Resolution_Imprimante*Correction));
  end;
  procedure TextOut(X,Y : double; S : string);
  begin
   if (Y<=Hauteur_Page*(Page_Y+1)-1) and (Y>=Hauteur_Page*Page_Y-1) then
    Support.TextOut(round(((X+Sup_X)*Resolution_Imprimante-Page_X*Printer.PageWidth)*Correction),
          round((Y+Sup_Y-Hauteur_Page*Page_Y)*Resolution_Imprimante*Correction),S);
  end;

  procedure Descend(MM : integer);
  var
    L : integer;
  begin
    if MM_Haut div Hauteur_Page<(MM_Haut+MM) div Hauteur_Page then begin
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
      MoveTo(0,Base_Entete);
      LineTo(0,MM_Haut);
      MM_Gauche:=0;
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Resolution_Imprimante/10*Correction);
      for L:=1 to 13 do begin
        M:=1;
        while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
        if Form1.Les_Options_Tableau.Afficher[M] then begin
          inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
          MoveTo(MM_Gauche,Base_Entete);
          LineTo(MM_Gauche,MM_Haut);
          if Form1.Les_Options_Tableau.Dedoubler[M] then begin
            inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
            MoveTo(MM_Gauche,Base_Entete);
            LineTo(MM_Gauche,MM_Haut);
          end;
        end;
      end;
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
      MoveTo(MM_Gauche,Base_Entete);
      LineTo(MM_Gauche,MM_Haut);
      MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
      Base_Entete:=MM_Haut;
    end;
  end;

  procedure Sequence(var Origine, Surplus : string);
  var
    Indice : integer;
    Test : string;
  begin
    if Correction=1 then Application.ProcessMessages;
    Origine:=' '+Origine;
    if Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Origine) then Report:=''
    else begin
      Indice:=length(Origine);
      repeat
        dec(Indice);
        Test:=Copy(Origine,1,Indice);
      until (Indice=0) or ((Origine[Indice]=' ') and
            (Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Test)));
      case Indice of
        0 : begin
          Indice:=length(Origine);
          repeat
            dec(Indice);
            Test:=Copy(Origine,1,Indice);
          until Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Test);
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice);
        end;
        1 : begin
          Surplus:='';
          Origine:=Copy(Origine,Indice+1,length(Origine)-Indice);
        end;
        else begin
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice-1);
        end;
      end;
    end;
  end;

  procedure Sommet_Colonne;
  var L : integer;
  begin
    Descend(Form1.Les_Options_Tableau.Hauteur);
    Support.Font:=Form1.Les_Options_Tableau.police;
    if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
         Resolution_Imprimante/Form1.PixelsPerInch*25.4);
    Printer.Canvas.Font:=Form1.Les_Options_Tableau.police;
    MM_Gauche:=0;
    for L:=1 to 13 do begin
      M:=1;
      while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
      Centrage:=true;
      if Form1.Les_Options_Tableau.Afficher[M] then begin
        Contenu:=Form1.Les_Options_Tableau.Entete[M,1];
        Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Resolution_Imprimante-Printer.Canvas.TextWidth(Contenu))/2;
        TextOut(MM_Gauche+Plus/Resolution_Imprimante,MM_Haut+Eps/Resolution_Imprimante,Contenu);
        inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
        if Form1.Les_Options_Tableau.Dedoubler[M] then begin
          Contenu:=Form1.Les_Options_Tableau.Entete[M,2];
          Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Resolution_Imprimante-Printer.Canvas.TextWidth(Contenu))/2;
          TextOut(MM_Gauche+Plus/Resolution_Imprimante,MM_Haut+Eps/Resolution_Imprimante,Contenu);
          inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
        end;
      end;
    end;
    Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
    MoveTo(0,MM_Haut);
    LineTo(Largeur_Totale,MM_Haut);
    inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
  end;

  procedure Remonter(Le_Quel : integer);
  var
    L : integer;
  begin
    if not Premier_Entete then with Form1.Les_Options_Tableau do begin
      if So_Afficher[7,Le_Quel] then begin
        Support.Font:=So_police[7,Type_Brut];
        if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
             Resolution_Imprimante/Form1.PixelsPerInch*25.4);
        Contenu:=So_Intitule[7,Type_Brut];
        str(Cumul_Brut:3:2,Suplement);
        Contenu:=Contenu+' '+Suplement;
        TextOut(So_X[7,Type_Brut],Precedent_Brut+So_Y[7,Type_Brut],Contenu);
      end;
      if So_Afficher[8,Le_Quel] then begin
        Support.Font:=So_police[8,Type_Net];
        if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
             Resolution_Imprimante/Form1.PixelsPerInch*25.4);
        Contenu:=So_Intitule[8,Type_Net];
        str(Cumul_Net:3:2,Suplement);
        Contenu:=Contenu+' '+Suplement;
        TextOut(So_X[8,Type_Net],Precedent_Net+So_Y[8,Type_Net],Contenu);
      end;
      if So_Afficher[11,Le_Quel] then begin
        Support.Font:=So_police[11,Type_Premiere];
        if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
             Resolution_Imprimante/Form1.PixelsPerInch*25.4);
        Contenu:=So_Intitule[11,Type_Premiere];
        str(Cumul_Premiere:3:2,Suplement);
        Contenu:=Contenu+' '+Suplement;
        TextOut(So_X[11,Type_Premiere],Precedent_Premiere+So_Y[11,Type_Premiere],Contenu);
      end;
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
      MoveTo(0,Base_Entete);
      LineTo(0,MM_Haut);
      MM_Gauche:=0;
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Resolution_Imprimante/10*Correction);
      for L:=1 to 13 do begin
        M:=1;
        while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
        if Form1.Les_Options_Tableau.Afficher[M] then begin
          inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
          MoveTo(MM_Gauche,Base_Entete);
          LineTo(MM_Gauche,MM_Haut);
          if Form1.Les_Options_Tableau.Dedoubler[M] then begin
            inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
            MoveTo(MM_Gauche,Base_Entete);
            LineTo(MM_Gauche,MM_Haut);
          end;
        end;
      end;
      Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
      MoveTo(MM_Gauche,Base_Entete);
      LineTo(MM_Gauche,MM_Haut);
    end;
  end;

  procedure EnTete(Le_Quel : integer);
  var
    I, J : integer;
  begin
    Remonter(Le_Quel);
    Premier_Entete:=false;
    Descend(Form1.Les_Options_Tableau.So_Hauteur[Le_Quel]);
    for I:=1 to 11 do with Form1.Les_Options_Tableau do begin
      if So_Afficher[I,Le_Quel] then begin
        Chgt_Direction:=true;
        Support.Font:=So_police[I,Le_Quel]; Printer.Canvas.Font:=So_police[I,Le_Quel];
        if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
             Resolution_Imprimante/Form1.PixelsPerInch*25.4);
        Contenu:=So_Intitule[I,Le_Quel];
        case I of
          1 : Suplement:=Une_Fiche.date;
          2 : Une_Fiche.Systeme.Lit(Suplement);
          3 : Une_Fiche.Cavite.Lit(Suplement);
          4 : Une_Fiche.Reseau.Lit(Suplement);
          5 : Une_Fiche.Lieu.Lit(Suplement);
          6 : begin
            str(Une_Fiche.Declinaison:1:2,Suplement);
            Suplement:=Suplement+tuAngle[Une_Fiche.Unite_Decli];
          end;
          7 : begin
            Suplement:=''; {Dev brut}
            Cumul_Brut:=0;
            Precedent_Brut:=MM_Haut;
            Type_Brut:=Le_Quel;
          end;
          8 : begin
            Suplement:=''; {Dev net}
            Cumul_Net:=0;
            Precedent_Net:=MM_Haut;
            Type_Net:=Le_Quel;
          end;
          9 : begin
            MM_Gauche:=round((So_X[I,Le_Quel]+Sup_X)*Resolution_Imprimante-Page_X*Printer.PageWidth)+
                        Printer.Canvas.TextWidth(Contenu+' ');
            MM_Gauche:=So_X[I,Le_Quel];
                        Printer.Canvas.TextWidth(Contenu+' ');

            for J:=0 to Une_Fiche.Topographes.Count-1 do begin
              Un_Topographe:=Une_Fiche.Topographes[J];
              Un_Topographe.Lit(Suplement);
              TextOut(So_X[I,Le_Quel]+Printer.Canvas.TextWidth(Contenu+' ')/Resolution_Imprimante,
                  MM_Haut+J*Form1.Les_Options_Tableau.Hauteur+So_Y[I,Le_Quel], Suplement);
            end;
            Suplement:=''; {explorateur}
          end;
          10 : Une_Fiche.Temps.Lit(Suplement);
          11 : begin
            Suplement:=''; {Dev Premiere}
            Cumul_Premiere:=0;
            Precedent_Premiere:=MM_Haut;
            Type_Premiere:=Le_Quel;
          end;
        end;
        Contenu:=Contenu+' '+Suplement;
        TextOut(So_X[I,Le_Quel],MM_Haut+So_Y[I,Le_Quel],Contenu);
      end;
    end;
    inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[Le_Quel]);
    Base_Entete:=MM_Haut;
    if Form1.Les_Options_Tableau.So_Rappel[Le_Quel] then Sommet_Colonne;
  end;

begin

  Support:=Fond; Correction:=Reduc;

  Premier_Entete:=true;
  Support.Pen.Color:=clWhite; Support.Brush.Color:=clWhite;
  Support.Brush.Style:=bsClear;
  Hauteur_Page:=GetDeviceCaps(Printer.Handle,VertSize)-MY;
  Form1.Massif.Trier;
  Les_Fiches:=TList.Create;
  La_Liste(Les_Fiches);
  if Affichable then begin
    Largeur_Totale:=0;
    Eps:=(Form1.Les_Options_Tableau.Hauteur*Resolution_Imprimante-Printer.Canvas.TextHeight('P'))/2;
    for I:=1 to 13 do if Form1.Les_Options_Tableau.Afficher[I] then begin
      inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
      if Form1.Les_Options_Tableau.Dedoubler[I] then inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
    end;
    Chgt_Direction:=true; Chgt_Galerie:=true; Chgt_Equipe:=true;
    Support.Pen.Color:=clBlack;
    MM_Haut:=0;
    if Etat=etContrainte then Contrainte_Max:=Contrainte_Maximum(Les_Fiches);
    for I:=0 to les_Fiches.Count-1 do begin
      Une_Fiche:=Les_Fiches[I];
      if not Chgt_Equipe then begin
        Chgt_Equipe:=not Une_Fiche.Meme_Equipe(Precedente_Fiche);
        Chgt_Galerie:=not Une_Fiche.Meme_Lieu(Precedente_Fiche);
      end;
      if Chgt_Equipe then begin
        {En_tte gnral }
        EnTete(0);
      end
      else if Chgt_Galerie then begin
        {En_tte restreint }
        EnTete(1);
      end;
      Cumul_Premiere:=Cumul_Premiere+Une_Fiche.Premiere;
      Support.Font:=Form1.Les_Options_Tableau.police;
      if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
           Resolution_Imprimante/Form1.PixelsPerInch*25.4);
      Printer.Canvas.Font:=Form1.Les_Options_Tableau.police;
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        if Une_Galerie.Approximation then with Une_Galerie do begin
          X0:=Depart.X-DX; Y0:=Depart.Y-DY; Z0:=Depart.Z-DZ;
          if not Chgt_Direction then Chgt_Direction:=not Une_Galerie.Depart.Identique(Precedent_Point);
          if Chgt_Direction then begin
            Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Direction*Resolution_Imprimante/10*Correction);
            MoveTo(0,MM_Haut);
            LineTo(Largeur_Totale,MM_Haut);
            if (Une_Galerie.Nb_Visee>0) and (Une_Galerie.Visees[1].Longueur=0) then begin
              if not Une_Galerie.Depart.Terminus then begin
                Une_Galerie.Depart.Nom.Lit(Suplement);
                Suplement:=Suplement+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                Suplement:='du point '+Suplement+'. ';
                Support.Font:=Form1.Les_Options_Tableau.Relief;
                if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
                     Resolution_Imprimante/Form1.PixelsPerInch*25.4);
                Printer.Canvas.Font:=Form1.Les_Options_Tableau.Relief;
                case Etat of
                  etContrainte : Support.Font.Color:=
                   Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                  etNoir : Support.Font.Color:=clBlack;
                  etCouleur :  Support.Font.Color:=Couleur;
                end;
              end
              else Suplement:='';
              Une_Galerie.Information.Lit(Info);
              if Info<>'' then Suplement:=Suplement+Info+' ';
            end
            else begin
              Descend(Form1.Les_Options_Tableau.Hauteur);
              MM_Gauche:=0;
              Report:='';
              if not Une_Galerie.Depart.Terminus then begin
                Support.Font:=Form1.Les_Options_Tableau.Relief;
                if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
                     Resolution_Imprimante/Form1.PixelsPerInch*25.4);
                Printer.Canvas.Font:=Form1.Les_Options_Tableau.Relief;
              end;
              case Etat of
                etContrainte : Support.Font.Color:=
                 Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                etNoir : Support.Font.Color:=clBlack;
                etCouleur :  Support.Font.Color:=Couleur;
              end;
              for L:=1 to 13 do begin
                M:=1;
                while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
                Centrage:=true;
                case M of
                  coLongueur : Contenu:='';
                  coDZ : Contenu:='';
                  coAzimuth : Contenu:='';
                  coPente : Contenu:='';
                  coLargeur : Contenu:='';
                  coHauteur : Contenu:='';
                  coX : str(X0:6:2,Contenu);
                  coY : str(Y0:6:2,Contenu);
                  coZ : str(Z0:6:2,Contenu);
                  coDevH : if Une_Galerie.En_Coupe then
                    if Une_Galerie.Accrochage_Debut then str(Une_Galerie.Decal_Hori:6:2,Contenu)
                                                     else str(Une_Galerie.Fin_Hori:6:2,Contenu)
                    else Contenu:='X';
                  coObservation : begin
                    Centrage:=false;
                    if not Une_Galerie.Depart.Terminus then begin
                      Une_Galerie.Depart.Nom.Lit(Contenu);
                      Contenu:=Contenu+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                      Contenu:='du point '+Contenu+'. ';
                    end
                    else Contenu:='';
                    Une_Galerie.Information.Lit(Info);
                    if Info<>'' then Contenu:=Contenu+Info+' ';
                    Sequence(Contenu,Report);
                    Toz:=MM_Gauche;
                  end;
                  coDlt : Contenu:='';
                end;
                if Form1.Les_Options_Tableau.Afficher[M] then begin
                  if Centrage
                    then Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Resolution_Imprimante-Printer.Canvas.TextWidth(Contenu))/2
                    else Plus:=0;
                  TextOut(MM_Gauche+Plus/Resolution_Imprimante,MM_Haut+Eps/Resolution_Imprimante,Contenu);
                  inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                  if Form1.Les_Options_Tableau.Dedoubler[M] then inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                end;
              end;
              inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
              if Report<>'' then begin
                repeat
                  Descend(Form1.Les_Options_Tableau.Hauteur);
                  Contenu:=Report;
                  Sequence(Contenu,Report);
                  TextOut(Toz,MM_Haut+Eps/Resolution_Imprimante,Contenu);
                  inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                until Report='';
              end;
              Support.Font:=Form1.Les_Options_Tableau.police;
              if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
                   Resolution_Imprimante/Form1.PixelsPerInch*25.4);
              Printer.Canvas.Font:=Form1.Les_Options_Tableau.police;
              Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Resolution_Imprimante/10*Correction);
              case Etat of
                etContrainte : Support.Font.Color:=
                 Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
                etNoir : Support.Font.Color:=clBlack;
                etCouleur :  Support.Font.Color:=Couleur;
              end;
              MoveTo(0,MM_Haut);
              LineTo(Largeur_Totale,MM_Haut);
              Suplement:='';
            end;
          end
          else begin
            Une_Galerie.Information.Lit(Suplement);
            if Suplement<>'' then Suplement:=Suplement+'. ';
          end;
          for K:=1 to Une_Galerie.Nb_Visee do begin
            if Visees[K].ULong=cm then Long:=Visees[K].Longueur/100 else Long:=Visees[K].Longueur;
            Cumul_Brut:=Cumul_Brut+Long;
            if Visees[K].Correction_Dlt then Cumul_Net:=Cumul_Net+Visees[K].Longueur_Dlt
                                        else Cumul_Net:=Cumul_Net+Long;
            X1:=Coordonnees^[K].X-DX;
            Y1:=Coordonnees^[K].Y-DY;
            Z1:=Coordonnees^[K].Z-DZ;
            H1:=Coordonnees^[K].LH;
            Descend(Form1.Les_Options_Tableau.Hauteur);
            MM_Gauche:=0;
            if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
              Support.Font:=Form1.Les_Options_Tableau.Relief;
              if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
                   Resolution_Imprimante/Form1.PixelsPerInch*25.4);
              Printer.Canvas.Font:=Form1.Les_Options_Tableau.Relief;
            end;
            case Etat of
              etContrainte : Support.Font.Color:=
               Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
              etNoir : Support.Font.Color:=clBlack;
              etCouleur :  Support.Font.Color:=Couleur;
            end;
            for L:=1 to 13 do begin
              M:=1;
              while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
              case M of
                coLongueur : begin
                  Centrage:=true;
                  if Visees[K].ULong=cm then str(Une_Galerie.Visees[K].Longueur/100:2:2,Contenu)
                                        else str(Une_Galerie.Visees[K].Longueur:2:2,Contenu);
                  if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                end;
                coDZ : begin
                  Centrage:=true;
                  if K=1 then str((Coordonnees^[1].Z-Une_Galerie.Depart.Z):2:2,Contenu)
                  else str((Coordonnees^[K].Z-Coordonnees^[K-1].Z):2:2,Contenu);
                end;
                coLH : begin
                  Centrage:=true;
                  if K=1 then str(sqrt(sqr(Visees[1].X)+sqr(Visees[1].Y)):2:2,Contenu)
                  else str(sqrt(sqr(Visees[K].X-Visees[K-1].X)+
                                sqr(Visees[K].Y-Visees[K-1].Y)):2:2,Contenu);
                end;
                coAzimuth : begin
                  Centrage:=true;
                  str(Une_Galerie.Visees[K].Azimuth:3:0,Contenu);
                  if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                end;
                coPente : begin
                  Centrage:=true;
                  str(Une_Galerie.Visees[K].Pente:3:1,Contenu);
                  if Une_Galerie.Visees[K].Longueur=0 then Contenu:='';
                end;
                coLargeur : begin
                  Centrage:=true;
                  Contenu:=Une_Galerie.Visees[K].LargeurGauche;
                  if Form1.Les_Options_Tableau.Dedoubler[coLargeur] then Info:=Une_Galerie.Visees[K].LargeurDroite
                  else if Une_Galerie.Visees[K].LargeurDroite<>'' then
                    Contenu:=Contenu+'/'+Une_Galerie.Visees[K].LargeurDroite;
                end;
                coHauteur : begin
                  Centrage:=true;
                  Contenu:=Une_Galerie.Visees[K].HauteurSup;
                  if Form1.Les_Options_Tableau.Dedoubler[coHauteur] then Info:=Une_Galerie.Visees[K].HauteurInf
                  else if Une_Galerie.Visees[K].HauteurInf<>'' then
                    Contenu:=Contenu+'/'+Une_Galerie.Visees[K].HauteurInf;
                end;
                coX : begin
                  Centrage:=true;
                  str(X1:6:2,Contenu);
                end;
                coY : begin
                  Centrage:=true;
                  str(Y1:6:2,Contenu);
                end;
                coZ : begin
                  Centrage:=true;
                  str(Z1:6:2,Contenu);
                end;
                coDevH : begin
                  Centrage:=true;
                  if Une_Galerie.En_Coupe then str(H1:6:2,Contenu)
                  else Contenu:='X';
                end;
                coObservation : begin
                  Centrage:=false;
                  Une_Galerie.Visees[K].Commentaires.Lit(Contenu);
                  {if Une_Galerie.Visees[K].Longueur=0 then }Contenu:=Suplement+Contenu;
                  if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
                    Une_Galerie.Arrivee.Nom.Lit(Suplement);
                    Suplement:=Suplement+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
                    Contenu:=Contenu+' Point '+Suplement;
                  end;
                  Sequence(Contenu,Report);
                  Toz:=MM_Gauche;
                  Suplement:='';
                end;
                coDlt : begin
                  Centrage:=true;
                  if Une_Galerie.Visees[K].Correction_Dlt then
                      str(Une_Galerie.Visees[K].Longueur_Dlt:2:2,Contenu)
                        else if Une_Galerie.Visees[K].ULong=cm then
                          str(Une_Galerie.Visees[K].Longueur/100:2:2,Contenu)
                        else str(Une_Galerie.Visees[K].Longueur:2:2,Contenu);
                end;
              end;
              if Form1.Les_Options_Tableau.Afficher[M] then begin
                if Centrage
                  then Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Resolution_Imprimante-Printer.Canvas.TextWidth(Contenu))/2
                  else Plus:=0;
                TextOut(MM_Gauche+Plus/Resolution_Imprimante,MM_Haut+Eps/Resolution_Imprimante,Contenu);
                inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                if Form1.Les_Options_Tableau.Dedoubler[M] then begin
                  Plus:=(Form1.Les_Options_Tableau.Largeur[M]*Resolution_Imprimante-Printer.Canvas.TextWidth(Info))/2;
                  TextOut(MM_Gauche+Plus/Resolution_Imprimante,MM_Haut+Eps/Resolution_Imprimante,Info);
                  inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
                end;
              end;
            end;
            inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
            if Report<>'' then begin
              repeat
                Descend(Form1.Les_Options_Tableau.Hauteur);
                Contenu:=Report;
                Sequence(Contenu,Report);
                TextOut(Toz,MM_Haut+Eps/Resolution_Imprimante,Contenu);
                inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
              until Report='';
            end;
            Support.Font:=Form1.Les_Options_Tableau.police;
            if Correction<>1 then Support.Font.Height:=round(Support.Font.Height*Correction*
                 Resolution_Imprimante/Form1.PixelsPerInch*25.4);
            Printer.Canvas.Font:=Form1.Les_Options_Tableau.police;
            case Etat of
              etContrainte : Support.Font.Color:=
               Degrade[round(sqrt(sqr(Contrainte_Plan)+sqr(Contrainte_Z))/Contrainte_Max*60)];
              etNoir : Support.Font.Color:=clBlack;
              etCouleur :  Support.Font.Color:=Couleur;
            end;
            Descend(Une_Galerie.Visees[K].Schema*10);
            inc(MM_Haut,Une_Galerie.Visees[K].Schema*10);
            Support.Pen.Width:=round(Form1.Les_Options_Tableau.Epaisseur_Visee*Resolution_Imprimante/10*Correction);
            MoveTo(0,MM_Haut);
            LineTo(Largeur_Totale,MM_Haut);
          end;
          Chgt_Direction:=false;
          Precedent_Point:=Une_Galerie.Arrivee;
        end;
      end;
      Chgt_Galerie:=false; Chgt_Equipe:=false;
      Precedente_Fiche:=Une_Fiche;
    end;
    Remonter(0);
  end;
end;


procedure TTableau.Gabarit(var Pixel_Hori, Pixel_Verti : longint; Resolution, Rapport : double; Canevas : TImage);
var
  Largeur_Totale : integer;
  I, J, K : integer;
  MM_Haut : longint;
  Contenu, Suplement, Report, Info : string;
  Chgt_Direction, Chgt_Galerie, Chgt_Equipe, Concordance : boolean;
  Une_Fiche, Precedente_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Les_Fiches : TList;
  Precedent_Point : TPointTopo;


  procedure Sequence(var Origine, Surplus : string);
  var
    Indice : integer;
    Test : string;
  begin
    Origine:=' '+Origine;
    if Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution>Canevas.Canvas.TextWidth(Origine) then Report:=''
    else begin
      Indice:=length(Origine);
      repeat
        dec(Indice);
        Test:=Copy(Origine,1,Indice);
      until (Indice=0) or ((Origine[Indice]=' ') and
            (Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution>Canevas.Canvas.TextWidth(Test)));
      case Indice of
        0 : begin
          Indice:=length(Origine);
          repeat
            dec(Indice);
            Test:=Copy(Origine,1,Indice);
          until Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution>Canevas.Canvas.TextWidth(Test);
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice);
        end;
        1 : begin
          Surplus:='';
          Origine:=Copy(Origine,Indice+1,length(Origine)-Indice);
        end;
        else begin
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice-1);
        end;
      end;
    end;
  end;

begin


  Concordance:=false;
  Largeur_Totale:=0;
  for I:=1 to 13 do if Form1.Les_Options_Tableau.Afficher[I] then begin
    inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
    if Form1.Les_Options_Tableau.Dedoubler[I] then inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
  end;
  Pixel_Hori:=round(Largeur_Totale*Resolution*Rapport);
  Affichable:=true;
  La_Resolution:=Resolution;
  Form1.Massif.Trier;
  Les_Fiches:=TList.Create;
  La_Liste(Les_Fiches);
  if Form1.Massif.Gabarit_Tableau then begin
    Une_Fiche:=Les_Fiches[Les_Fiches.Count-1];
    MM_Haut:=Une_Fiche.Base_Tableau;
  end
  else begin
    if Affichable then begin
      Chgt_Direction:=true; Chgt_Galerie:=true; Chgt_Equipe:=true;
      Canevas.Canvas.Font:=Form1.Les_Options_Tableau.police;
      MM_Haut:=0;
      for I:=0 to les_Fiches.Count-1 do begin
        Une_Fiche:=Les_Fiches[I];
        Une_Fiche.Sommet_Tableau:=MM_Haut;
        if not Chgt_Equipe then begin
          Chgt_Equipe:=not Une_Fiche.Meme_Equipe(Precedente_Fiche);
          Chgt_Galerie:=not Une_Fiche.Meme_Lieu(Precedente_Fiche);
        end;
        if Chgt_Equipe then begin
          inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[0]);
          if Form1.Les_Options_Tableau.So_Rappel[0] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
          for J:=1 to 11 do if Form1.Les_Options_Tableau.So_Afficher[J,0] then Chgt_Direction:=true;
        end
        else if Chgt_Galerie then begin
          inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[1]);
          if Form1.Les_Options_Tableau.So_Rappel[1] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
          for J:=1 to 11 do if Form1.Les_Options_Tableau.So_Afficher[J,1] then Chgt_Direction:=true;
        end;
        Canevas.Canvas.Font:=Form1.Les_Options_Tableau.police;
        for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
          Une_Galerie:=Une_Fiche.Liste_Galerie[J];
          if Une_Galerie.Approximation then with Une_Galerie do begin
            if not Concordance and Une_Galerie.Depart.Identique(Form1.les_Options_Tableau.Point)
                    then with Form1.les_Options_Tableau.Point do begin
              X:=Une_Galerie.Depart.X; Y:=Une_Galerie.Depart.Y; Z:=Une_Galerie.Depart.Z;
              Concordance:=true;
            end;
            if not Concordance and Une_Galerie.Arrivee.Identique(Form1.les_Options_Tableau.Point)
                    then with Form1.les_Options_Tableau.Point do begin
              X:=Une_Galerie.Arrivee.X; Y:=Une_Galerie.Arrivee.Y; Z:=Une_Galerie.Arrivee.Z;
              Concordance:=true;
            end;
            if not Chgt_Direction then Chgt_Direction:=not Une_Galerie.Depart.Identique(Precedent_Point);
            if Chgt_Direction then begin
              if (Une_Galerie.Nb_Visee>0) and (Une_Galerie.Visees[1].Longueur=0) then begin
                if not Une_Galerie.Depart.Terminus then begin
                  Une_Galerie.Depart.Nom.Lit(Suplement);
                  Suplement:=Suplement+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                  Suplement:='du point '+Suplement+'. ';
                  Canevas.Canvas.Font:=Form1.Les_Options_Tableau.relief;
                end
                else Suplement:='';
                Une_Galerie.Information.Lit(Info);
                if Info<>'' then Suplement:=Suplement+Info+' ';
              end
              else begin
                Suplement:='';
                if not Une_Galerie.Depart.Terminus then begin
                  Canevas.Canvas.Font:=Form1.Les_Options_Tableau.relief;
                  Une_Galerie.Depart.Nom.Lit(Contenu);
                  Contenu:=Contenu+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                  Contenu:='du point '+Contenu+'. ';
                end
                else Contenu:='';
                Une_Galerie.Information.Lit(Info);
                if Info<>'' then Contenu:=Contenu+Info+' ';
                Sequence(Contenu,Report);
                if Report<>'' then begin
                  repeat
                    Contenu:=Report;
                    Sequence(Contenu,Report);
                    inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                  until Report='';
                end;
                inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                Canevas.Canvas.Font:=Form1.Les_Options_Tableau.police;
                Suplement:='';
              end;
            end
            else begin
              Une_Galerie.Information.Lit(Suplement);
              if Suplement<>'' then Suplement:=Suplement+'. ';
            end;
            for K:=1 to Une_Galerie.Nb_Visee do begin
              Une_Galerie.Visees[K].Commentaires.Lit(Contenu);
              Contenu:=Suplement+Contenu;
              if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
                Canevas.Canvas.Font:=Form1.Les_Options_Tableau.relief;
                Une_Galerie.Arrivee.Nom.Lit(Suplement);
                Suplement:=Suplement+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
                Contenu:=Contenu+' Point '+Suplement;
              end;
              Sequence(Contenu,Report);
              Suplement:='';
              if Report<>'' then begin
                repeat
                  Contenu:=Report;
                  Sequence(Contenu,Report);
                  inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                until Report='';
              end;
              inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur+Une_Galerie.Visees[K].Schema*10);
              Canevas.Canvas.Font:=Form1.Les_Options_Tableau.police;
            end;
            Chgt_Direction:=false;
            Precedent_Point:=Une_Galerie.Arrivee;
          end;
        end;
        Chgt_Galerie:=false; Chgt_Equipe:=false;
        Precedente_Fiche:=Une_Fiche;
        Une_Fiche.Base_Tableau:=MM_Haut;
      end;
    end
    else begin
      Pixel_Hori:=1;
      MM_Haut:=5;
    end;
    if Concordance then begin
      if Form1.Les_Options_Tableau.BloqueXY then begin
        DX:=Form1.Les_Options_Tableau.Point.X;
        DY:=Form1.Les_Options_Tableau.Point.Y;
      end
      else begin
        DX:=0; DY:=0;
      end;
      if Form1.Les_Options_Tableau.BloqueZ then DZ:=Form1.Les_Options_Tableau.Point.Z
                                           else DZ:=0;
    end;
  end;
  Form1.Massif.Gabarit_Tableau:=true;
  Pixel_Verti:=round(MM_Haut*Resolution*Rapport);
end;

procedure TTableau.Gabarit_Imprimante(var Page_X, Page_Y : integer; MargeX, MargeY : integer);
var
  Largeur_Totale : integer;
  I, J, K : integer;
  MM_Haut, Hauteur_Page : longint;
  Contenu, Suplement, Report, Info : string;
  Chgt_Direction, Chgt_Galerie, Chgt_Equipe : boolean;
  Une_Fiche, Precedente_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Les_Fiches : TList;
  Precedent_Point : TPointTopo;

  procedure Sequence(var Origine, Surplus : string);
  var
    Indice : integer;
    Test : string;
  begin
    Origine:=' '+Origine;
    if Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Origine) then Report:=''
    else begin
      Indice:=length(Origine);
      repeat
        dec(Indice);
        Test:=Copy(Origine,1,Indice);
      until (Indice=0) or ((Origine[Indice]=' ') and
            (Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Test)));
      case Indice of
        0 : begin
          Indice:=length(Origine);
          repeat
            dec(Indice);
            Test:=Copy(Origine,1,Indice);
          until Form1.Les_Options_Tableau.Largeur[coObservation]*Resolution_Imprimante>Printer.Canvas.TextWidth(Test);
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice);
        end;
        1 : begin
          Surplus:='';
          Origine:=Copy(Origine,Indice+1,length(Origine)-Indice);
        end;
        else begin
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice-1);
        end;
      end;
    end;
  end;

begin
  Resolution_Imprimante:=Printer.PageHeight/GetDeviceCaps(Printer.Handle,VertSize);
  Hauteur_Page:=GetDeviceCaps(Printer.Handle,VertSize)-MY;
  Largeur_Totale:=0;
  for I:=1 to 13 do if Form1.Les_Options_Tableau.Afficher[I] then begin
    inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
    if Form1.Les_Options_Tableau.Dedoubler[I] then inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[I]);
  end;
  Affichable:=true;

  Form1.Massif.Trier;
  Les_Fiches:=TList.Create;
  La_Liste(Les_Fiches);
  if Affichable then begin
    Chgt_Direction:=true; Chgt_Galerie:=true; Chgt_Equipe:=true;
    MM_Haut:=0; 
    for I:=0 to les_Fiches.Count-1 do begin
      Une_Fiche:=Les_Fiches[I];
      if not Chgt_Equipe then begin
        Chgt_Equipe:=not Une_Fiche.Meme_Equipe(Precedente_Fiche);
        Chgt_Galerie:=not Une_Fiche.Meme_Lieu(Precedente_Fiche);
      end;
      if Chgt_Equipe then begin
        if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.So_Hauteur[0]) div Hauteur_Page then
                              MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
        inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[0]);
        if Form1.Les_Options_Tableau.So_Rappel[0] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
        for J:=1 to 11 do if Form1.Les_Options_Tableau.So_Afficher[J,0] then Chgt_Direction:=true;
      end
      else if Chgt_Galerie then begin
        if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.So_Hauteur[1]) div Hauteur_Page then
                              MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
        inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[1]);
        if Form1.Les_Options_Tableau.So_Rappel[1] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
        for J:=1 to 11 do if Form1.Les_Options_Tableau.So_Afficher[J,1] then Chgt_Direction:=true;
      end;
      Printer.Canvas.Font:=Form1.Les_Options_Tableau.police;

      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        if Une_Galerie.Approximation then with Une_Galerie do begin
          if not Chgt_Direction then Chgt_Direction:=not Une_Galerie.Depart.Identique(Precedent_Point);
          if Chgt_Direction then begin
            if (Une_Galerie.Nb_Visee>0) and (Une_Galerie.Visees[1].Longueur=0) then begin
              if not Une_Galerie.Depart.Terminus then begin
                Une_Galerie.Depart.Nom.Lit(Suplement);
                Suplement:=Suplement+'('+IntToStr(Une_Galerie.depart.Indice)+')';
                Suplement:='du point '+Suplement+'. ';
              end
              else Suplement:='';
              Une_Galerie.Information.Lit(Info);
              if Info<>'' then Suplement:=Suplement+Info+' ';
            end
            else begin
              if not Une_Galerie.Depart.Terminus then begin
                Une_Galerie.Depart.Nom.Lit(Contenu);
                Contenu:=Contenu+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                Contenu:='du point '+Contenu+'. ';
              end
              else Contenu:='';
              Une_Galerie.Information.Lit(Info);
              if Info<>'' then Contenu:=Contenu+Info+' ';
              Sequence(Contenu,Report);
              if Report<>'' then begin
                repeat
                  Contenu:=Report;
                  Sequence(Contenu,Report);
                  if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.Hauteur) div Hauteur_Page then
                              MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
                  inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                until Report='';
              end;
              Suplement:='';
              inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
              if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.Hauteur) div Hauteur_Page then
                          MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
            end;
          end
          else begin
            Une_Galerie.Information.Lit(Suplement);
            if Suplement<>'' then Suplement:=Suplement+'. ';
          end;
          for K:=1 to Une_Galerie.Nb_Visee do begin
            Une_Galerie.Visees[K].Commentaires.Lit(Contenu);
            Contenu:=Suplement+Contenu;
            if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
              Une_Galerie.Arrivee.Nom.Lit(Suplement);
              Suplement:=Suplement+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
              Contenu:=Contenu+' Point '+Suplement;
            end;
            Sequence(Contenu,Report);
            Suplement:='';
            if Report<>'' then begin
              repeat
                Contenu:=Report;
                Sequence(Contenu,Report);
                if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.Hauteur) div Hauteur_Page then
                            MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
                inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
              until Report='';
            end;
             if MM_Haut div Hauteur_Page<(MM_Haut+Form1.Les_Options_Tableau.Hauteur+Une_Galerie.Visees[K].Schema*10)
                 div Hauteur_Page then MM_Haut:=(MM_Haut div Hauteur_Page +1)*Hauteur_Page;
            inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur+Une_Galerie.Visees[K].Schema*10);
          end;
          Chgt_Direction:=false;
          Precedent_Point:=Une_Galerie.Arrivee;
        end;
      end;
      Chgt_Galerie:=false; Chgt_Equipe:=false;
      Precedente_Fiche:=Une_Fiche;
    end;
  end;
  Page_X:=trunc(Largeur_Totale/(GetDeviceCaps(Printer.Handle,HorzSize)-MargeX))+1;
  Page_Y:=trunc(MM_Haut/(GetDeviceCaps(Printer.Handle,VertSize)-MargeY))+1;
  MX:=MargeX;
  MY:=MargeY;
end;

function TTableau.Trouve(X, Y : longint;var N_Fiche, N_Galerie, N_Visee : integer) : double;
var
//  Largeur_Totale : integer;
  I, J, K{, L, M}: integer;
  MM_Haut : longint;
  Contenu, Suplement, Report, Info : string;
  Chgt_Direction, Chgt_Galerie, Chgt_Equipe, Depasse : boolean;
  Une_Fiche, Precedente_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Les_Fiches : TList;
  Precedent_Point : TPointTopo;


  procedure Sequence(var Origine, Surplus : string);
  var
    Indice : integer;
    Test : string;
  begin
  Origine:=' '+Origine;
  if (Origine=' ') or (Form1.Les_Options_Tableau.Largeur[coObservation]*La_Resolution>
         Le_Caneva.TextWidth(Origine)) then Report:=''
    else begin
      Indice:=length(Origine);
      repeat
        dec(Indice);
        Test:=Copy(Origine,1,Indice);
      until (Indice=0) or ((Origine[Indice]=' ') and
            (Form1.Les_Options_Tableau.Largeur[coObservation]*La_Resolution>Le_Caneva.TextWidth(Test)));
      case Indice of
        0 : begin
          Indice:=length(Origine);
          repeat
            dec(Indice);
            Test:=Copy(Origine,1,Indice);
          until Form1.Les_Options_Tableau.Largeur[coObservation]*La_Resolution>Le_Caneva.TextWidth(Test);
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice);
        end;
        1 : begin
          Surplus:='';
          Origine:=Copy(Origine,Indice+1,length(Origine)-Indice);
        end;
        else begin
          Surplus:=Copy(Origine,Indice+1,length(Origine)-Indice);
          Origine:=Copy(Test,1,Indice-1);
        end;
      end;
    end;
  end;

begin
  Depasse:=false;

  Form1.Massif.Trier;
  Les_Fiches:=TList.Create;
  La_Liste(Les_Fiches);
  if Affichable then begin
    Chgt_Direction:=true; Chgt_Galerie:=true; Chgt_Equipe:=true;
    MM_Haut:=0;
    for I:=0 to les_Fiches.Count-1 do begin
      Une_Fiche:=Les_Fiches[I];
      if not Chgt_Equipe then begin
        Chgt_Equipe:=not Une_Fiche.Meme_Equipe(Precedente_Fiche);
        Chgt_Galerie:=not Une_Fiche.Meme_Lieu(Precedente_Fiche);
      end;
      if Chgt_Equipe then begin
        inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[0]);
        if not Depasse and (MM_Haut*La_Resolution>Y) then begin
          N_Fiche:=I;
          N_Galerie:=0;
          N_Visee:=1;
          Depasse:=true;
        end;
        if Form1.Les_Options_Tableau.So_Rappel[0] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
      end
      else if Chgt_Galerie then begin
        inc(MM_Haut,Form1.Les_Options_Tableau.So_Hauteur[1]);
        if not Depasse and (MM_Haut*La_Resolution>Y) then begin
          N_Fiche:=I;
          N_Galerie:=0;
          N_Visee:=1;
          Depasse:=true;
        end;
        if Form1.Les_Options_Tableau.So_Rappel[1] then inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
      end;
      Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        if Une_Galerie.Approximation then with Une_Galerie do begin
          if not Chgt_Direction then Chgt_Direction:=not Une_Galerie.Depart.Identique(Precedent_Point);
          if Chgt_Direction then begin
            if (Une_Galerie.Nb_Visee>0) and (Une_Galerie.Visees[1].Longueur=0) then begin
              if not Une_Galerie.Depart.Terminus then begin
                Une_Galerie.Depart.Nom.Lit(Suplement);
                Suplement:=Suplement+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                Suplement:='du point '+Suplement+'. ';
              end
              else Suplement:='';
              Une_Galerie.Information.Lit(Info);
              if Info<>'' then Suplement:=Suplement+Info+' ';
            end
            else begin
              if not Une_Galerie.Depart.Terminus then begin
                Une_Galerie.Depart.Nom.Lit(Contenu);
                Contenu:=Contenu+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
                Contenu:='du point '+Contenu+'. ';
              end
              else Contenu:='';
              Une_Galerie.Information.Lit(Info);
              if Info<>'' then Contenu:=Contenu+Info+' ';
              Sequence(Contenu,Report);
              if Report<>'' then begin
                repeat
                  Contenu:=Report;
                  Sequence(Contenu,Report);
                  inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                  if not Depasse and (MM_Haut*La_Resolution>Y) then begin
                    N_Fiche:=I;
                    N_Galerie:=J;
                    N_Visee:=1;
                    Depasse:=true;
                  end;
                until Report='';
              end;
              inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
              if not Depasse and (MM_Haut*La_Resolution>Y) then begin
                N_Fiche:=I;
                N_Galerie:=J;
                N_Visee:=1;
                Depasse:=true;
              end;
              Suplement:='';
            end;
          end
          else begin
            Une_Galerie.Information.Lit(Suplement);
            if Suplement<>'' then Suplement:=Suplement+'. ';
          end;
          for K:=1 to Une_Galerie.Nb_Visee do begin
            Une_Galerie.Visees[K].Commentaires.Lit(Contenu);
            Contenu:=Suplement+Contenu;
            if (K=Une_Galerie.Nb_Visee) and (not Une_Galerie.Arrivee.Terminus) then begin
              Une_Galerie.Arrivee.Nom.Lit(Suplement);
              Suplement:=Suplement+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
              Contenu:=Contenu+' Point '+Suplement;
            end;
            Sequence(Contenu,Report);
            Suplement:='';
            if Report<>'' then begin
              repeat
                Contenu:=Report;
                Sequence(Contenu,Report);
                inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur);
                if not Depasse and (MM_Haut*La_Resolution>Y) then begin
                  N_Fiche:=I;
                  N_Galerie:=J;
                  N_Visee:=K;
                  Depasse:=true;
                end;
              until Report='';
            end;
            inc(MM_Haut,Form1.Les_Options_Tableau.Hauteur+Une_Galerie.Visees[K].Schema*10);
            if not Depasse and (MM_Haut*La_Resolution>Y) then begin
              N_Fiche:=I;
              N_Galerie:=J;
              N_Visee:=K;
              Depasse:=true;
            end;
          end;
          Chgt_Direction:=false;
          Precedent_Point:=Une_Galerie.Arrivee;
        end;
      end;
      Chgt_Galerie:=false; Chgt_Equipe:=false;
      Precedente_Fiche:=Une_Fiche;
    end;
  end;
 Trouve:=1e6; 
end;

function TTableau.Met_En_Relief(Nouveau : boolean; N_Fiche, N_Galerie, N_Visee : integer;Etat : smallInt) : string;
begin
  Met_En_Relief:='';
end;

function TTableau.Bulle(N_Fiche, N_Galerie, N_Visee : integer) : string;
begin

end;

procedure TTableau.Isoler;
begin
end;

procedure TTableau.Ajuste(X : integer;Resolution,Rapport : double);
var
  I, J, K, L, M, Colonne, MM, MM_Gauche, Page_X, Largeur_Totale : integer;
  Contenu, Info : string;
  X1, Y1, Z1, H1 : double;
begin
  with Form1.Les_Marges do MX:=Gauche+Droite;
  MM_Gauche:=0;
  MM:=round(X/Resolution/Rapport);
  for L:=1 to 13 do begin
    M:=1;
    while L<>Form1.Les_Options_Tableau.Rang[M] do inc(M);
    if Form1.Les_Options_Tableau.Afficher[M] then begin
      if (MM>=MM_Gauche) and (MM<MM_Gauche+Form1.Les_Options_Tableau.Largeur[M]) then begin
        Colonne:=M;
      end;
      inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
      if Form1.Les_Options_Tableau.Dedoubler[M] then begin
        if (MM>=MM_Gauche) and (MM<MM_Gauche+Form1.Les_Options_Tableau.Largeur[M]) then begin
          Colonne:=M;
        end;
        inc(MM_Gauche,Form1.Les_Options_Tableau.Largeur[M]);
      end;
    end;
  end;
  if Colonne=coObservation then begin
    Largeur_Totale:=0;
    for L:=1 to 13 do if (L<>coObservation) and Form1.Les_Options_Tableau.Afficher[L] then begin
      inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[L]);
      if Form1.Les_Options_Tableau.Dedoubler[L] then inc(Largeur_Totale,Form1.Les_Options_Tableau.Largeur[L]);
    end;
    Page_X:=trunc(Largeur_Totale/(GetDeviceCaps(Printer.Handle,HorzSize)-MX))+1;
    Form1.Les_Options_Tableau.Largeur[coObservation]:=
                    Page_X*(GetDeviceCaps(Printer.Handle,HorzSize)-MX)-Largeur_Totale-1;
  end
  else begin
    Largeur_Totale:=0;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
      for J:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[J]) do if Approximation then begin
        for K:=1 to Nb_Visee do begin
          X1:=Coordonnees^[K].X-DX;
          Y1:=Coordonnees^[K].Y-DY;
          Z1:=Coordonnees^[K].Z-DZ;
          H1:=Coordonnees^[K].LH;
          case Colonne of
            coLongueur : begin
              if Visees[K].ULong=cm then str(Visees[K].Longueur/100:2:2,Contenu)
                                    else str(Visees[K].Longueur:2:2,Contenu);
              if Visees[K].Longueur=0 then Contenu:='';
            end;
            coDZ : begin
              if K=1 then str((Coordonnees^[1].Z-Depart.Z):2:2,Contenu)
              else str((Coordonnees^[K].Z-Coordonnees^[K-1].Z):2:2,Contenu);
            end;
            coLH : begin
              if K=1 then str(sqrt(sqr(Visees[1].X)+sqr(Visees[1].Y)):2:2,Contenu)
              else str(sqrt(sqr(Visees[K].X-Visees[K-1].X)+
                            sqr(Visees[K].Y-Visees[K-1].Y)):2:2,Contenu);
            end;
            coAzimuth : begin
              str(Visees[K].Azimuth:3:0,Contenu);
              if Visees[K].Longueur=0 then Contenu:='';
            end;
            coPente : begin
              str(Visees[K].Pente:3:1,Contenu);
              if Visees[K].Longueur=0 then Contenu:='';
            end;
            coLargeur : begin
              Contenu:=Visees[K].LargeurGauche;
              if Form1.Les_Options_Tableau.Dedoubler[coLargeur] then Info:=Visees[K].LargeurDroite
              else if Visees[K].LargeurDroite<>'' then
                Contenu:=Contenu+'/'+Visees[K].LargeurDroite;
            end;
            coHauteur : begin
              Contenu:=Visees[K].HauteurSup;
              if Form1.Les_Options_Tableau.Dedoubler[coHauteur] then Info:=Visees[K].HauteurInf
              else if Visees[K].HauteurInf<>'' then
                Contenu:=Contenu+'/'+Visees[K].HauteurInf;
            end;
            coX : str(X1:6:2,Contenu);
            coY : str(Y1:6:2,Contenu);
            coZ : str(Z1:6:2,Contenu);
            coDevH : if En_Coupe then str(H1:6:2,Contenu) else Contenu:='X';
            coDlt : begin
              if Visees[K].Correction_Dlt then
                  str(Visees[K].Longueur_Dlt:2:2,Contenu)
                  else if Visees[K].ULong=cm then
                    str(Visees[K].Longueur/100:2:2,Contenu)
                  else str(Visees[K].Longueur:2:2,Contenu);
            end;
          end;
          Le_Caneva.Font:=Form1.Les_Options_Tableau.police;
          Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
          if Largeur_Totale<Le_Caneva.TextWidth(Contenu) then Largeur_Totale:=Le_Caneva.TextWidth(Contenu);
          if Form1.Les_Options_Tableau.Dedoubler[Colonne] and (Largeur_Totale<Le_Caneva.TextWidth(Info)) then Largeur_Totale:=Le_Caneva.TextWidth(Info);
          Le_Caneva.Font:=Form1.Les_Options_Tableau.Relief;
          Le_Caneva.Font.Height:=round(Le_Caneva.Font.Height*Rapport);
          if Largeur_Totale<Le_Caneva.TextWidth(Contenu) then Largeur_Totale:=Le_Caneva.TextWidth(Contenu);
          if Form1.Les_Options_Tableau.Dedoubler[Colonne] and (Largeur_Totale<Le_Caneva.TextWidth(Info)) then Largeur_Totale:=Le_Caneva.TextWidth(Info);
        end;
      end;
    end;
    Form1.Les_Options_Tableau.Largeur[Colonne]:=round(Largeur_Totale/Rapport/Resolution)+3;
  end;
  Form1.Massif.Gabarit_Tableau:=false;
end;

end.
