{$N-}
unit Informat;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, FicheTpo, Dialogs, SysUtils;

type
  TInformations = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Info: TEdit;
    Deformation: TEdit;
    Label3: TLabel;
    Topofil: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DeformationKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure InfoChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Modifie : boolean;
    procedure Charge(Du_Text : TEco; Epsilon, Le_Topofil : reel);
    procedure Decharge(var Du_Text : TEco;var Epsilon, Le_Topofil : reel);
  end;

var
  Informations: TInformations;

implementation

{$R *.DFM}

procedure TInformations.OKBtnClick(Sender: TObject);
begin
  try
    if StrToFloat(Deformation.Text)<=0 then Abort;
    try
      if StrToFloat(Topofil.Text)<=0 then Abort;
    except
      ModalResult:=mrNone;
      MessageDlg('La correction du Topofil doit tre numrique et positive (et proche de 1)'+
            #13+'exemple'+' 1.002',mtWarning,[mbOk],0);
      Topofil.SetFocus;
    end;
  except
    ModalResult:=mrNone;
    MessageDlg('La dformation doit tre numrique et positive'+#13+'exemple'+' 2.5',mtWarning,[mbOk],0);
    Deformation.SetFocus;
  end;
end;

procedure TInformations.Charge(Du_Text : TEco; Epsilon, Le_Topofil : reel);
var
  S : string;
begin
  Du_Text.Lit(S);
  Info.Text:=S;
  Deformation.Text:=FloatTostrF(Epsilon,ffGeneral,3,1);
  Topofil.Text:=FloatTostrF(Le_Topofil,ffGeneral,5,3);
end;

procedure TInformations.Decharge(var Du_Text : TEco;var Epsilon, Le_Topofil : reel);
var
  S : string;
begin
  S:=Info.Text;
  Du_Text.Ecrit(S);
  Epsilon:=StrToFloat(Deformation.Text);
  Le_Topofil:=StrToFloat(Topofil.Text);
end;

procedure TInformations.FormCreate(Sender: TObject);
begin
  PixelsPerInch:=Screen.PixelsPerInch;
end;

procedure TInformations.FormActivate(Sender: TObject);
begin
  Info.SetFocus;
end;

procedure TInformations.DeformationKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') then Key := #0;
end;

procedure TInformations.FormShow(Sender: TObject);
begin
  Modifie:=false;
end;

procedure TInformations.InfoChange(Sender: TObject);
begin
  Modifie:=true;
end;

end.
