{ Form Template - Source and Destination Choices Lists }
unit Multiple;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Fichetpo, Visuel, ExtCtrls, Messages;

type
  TRechMulti = class(TForm)
    SrcList: TListBox;
    DstList: TListBox;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    Details: TPanel;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure FormResize(Sender: TObject);
    procedure SrcListMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DstListMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Souri_Colonne, Souri_Ligne : longint;
    procedure Preparation(Le_Contenu : TList);
  end;

var
  RechMulti: TRechMulti;

implementation

{$R *.DFM}

procedure TRechMulti.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TRechMulti.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TRechMulti.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TRechMulti.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TRechMulti.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TRechMulti.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TRechMulti.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TRechMulti.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TRechMulti.Preparation(Le_Contenu : TList);
var
  I : integer;
  S, Ptt_Text : string;
begin
  IncludeBtn.Enabled:=true;
  IncAllBtn.Enabled:=true;
  ExcludeBtn.Enabled:=false;
  ExAllBtn.Enabled:=false;
  SrcList.Clear;
  DstList.Clear;
  Details.Caption:='';
  for I:=0 to Le_Contenu.Count-1 do with TFiche(Le_Contenu[I]) do begin
    Systeme.Lit(S);
    Cavite.Lit(Ptt_Text);  S:=S+'/'+Ptt_Text;
    Reseau.Lit(Ptt_Text);  S:=S+'/'+Ptt_Text;
    Lieu.Lit(Ptt_Text);    S:=S+'/'+Ptt_Text;
    SrcList.Items.AddObject(S,Le_Contenu[I]);
  end;
end;

procedure TRechMulti.FormResize(Sender: TObject);
begin
  OkBtn.Top:=ClientHeight-57;
  CancelBtn.Top:=ClientHeight-57;
  SrcList.Height:=ClientHeight-88;
  DstList.Height:=ClientHeight-88;

  DstList.Left:=ClientWidth div 2 +20;
  DstLabel.Left:=ClientWidth div 2 +20;
  DstList.Width:=ClientWidth div 2 -28;
  SrcList.Width:=ClientWidth div 2 -28;
  IncludeBtn.Left:=(ClientWidth - IncludeBtn.Width) div 2;
  IncAllBtn.Left:=(ClientWidth - IncAllBtn.Width) div 2;
  ExcludeBtn.Left:=(ClientWidth - ExcludeBtn.Width) div 2;
  ExAllBtn.Left:=(ClientWidth - ExAllBtn.Width) div 2;

  SrcList.Repaint;
  DstList.Repaint;
end;

procedure TRechMulti.SrcListMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  Nvlle_Ligne : longint;
  J : smallInt;
  S, Ptt_Text : string;
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  Nvlle_Ligne:= SrcList.ItemAtPos(APoint, true);

  if (Nvlle_Ligne>=0) and ((Nvlle_Ligne<>Souri_Ligne) or (Souri_Colonne<>1)) then begin
    if Nvlle_Ligne>=SrcList.Items.Count then Ptt_Text:=''
    else with TFiche(SrcList.Items.Objects[Nvlle_Ligne]) do begin
      Ptt_Text:=Date+' -> ';
      for J:=0 to Topographes.Count-1 do begin
        TEco(Topographes[J]).Lit(S);
        Ptt_Text:=Ptt_Text+S+' ';
      end;
    end;
    Details.Caption:=Ptt_Text;
  end;
  Souri_Ligne:=Nvlle_Ligne;
  Souri_Colonne:=1;
end;

procedure TRechMulti.DstListMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  Nvlle_Ligne : longint;
  J : smallInt;
  S, Ptt_Text : string;
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  Nvlle_Ligne:= DstList.ItemAtPos(APoint, true);
  if (Nvlle_Ligne>=0) and ((Nvlle_Ligne<>Souri_Ligne) or (Souri_Colonne<>2)) then begin
    if Nvlle_Ligne>=DstList.Items.Count then Ptt_Text:=''
    else with TFiche(DstList.Items.Objects[Nvlle_Ligne]) do begin
      Ptt_Text:=Date+' -> ';
      for J:=0 to Topographes.Count-1 do begin
        TEco(Topographes[J]).Lit(S);
        Ptt_Text:=Ptt_Text+S+' ';
      end;
    end;
    Details.Caption:=Ptt_Text;
  end;

  Souri_Ligne:=Nvlle_Ligne;
  Souri_Colonne:=2;
end;

procedure TRechMulti.FormShow(Sender: TObject);
var
  ScrollWidth, Largeur : SmallInt;
  I : integer;
begin
  ScrollWidth:=0;
  SrcList.Canvas.Font:=SrcList.Font;
  for I:=0 to SrcList.Items.Count-1 do begin
    Largeur:=SrcList.Canvas.TextWidth(SrcList.Items[I]);
    if Largeur>ScrollWidth then ScrollWidth:=Largeur;
  end;
  inc(ScrollWidth,3);
  PostMessage( SrcList.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);
  PostMessage( DstList.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);
end;

end.

