{$N-}
unit Options;

interface

uses Graphics, Controls, SysUtils, FicheTpo, Dialogs, Buttons, BufferedFile, Classes, Forms;

const

  coLongueur = 1;
  coAzimuth  = 2;
  coPente    = 3;
  coLargeur  = 4;
  coHauteur  = 5;
  coX        = 6;
  coY        = 7;
  coZ        = 8;
  coDevH     = 9;
  coObservation = 10;
  coDlt      = 11;
  coLH       = 12;
  coDZ       = 13;

  anHautGauche = 1;
  anHautDroit  = 2;
  anBasGauche  = 3;
  anBasDroit   = 4;

type

  TOptions_Tableau = class
    Entete : array[1..13,1..2] of string[25];
    Separateur : array[1..13] of char;
    Rang, Largeur : array[1..13] of smallInt;
    Afficher, Dedoubler : array[1..13] of boolean;
    So_Afficher : array[1..11,0..1] of boolean;
    So_Intitule : array[1..11,0..1] of string[25];
    So_X, So_Y : array[1..11,0..1] of smallInt;
    So_Police : array[1..11,0..1] of TFont;
    So_Hauteur : array[0..1] of SmallInt;
    So_Rappel: array[0..1] of boolean;
    Hauteur, Epaisseur_Visee, Epaisseur_Direction : smallInt;
    Police, Relief : TFont;
    Point : TPointTopo;
    BloqueXY, BloqueZ : boolean;
    constructor Create;
    destructor Destroy; override;
    function Editer : boolean;
    procedure Sauve(Destination : TFileName);
    procedure Loade(Destination : TFileName);
  end;

  TOptions_Plan = class
    Nord_Affiche, Echelle_Affiche, Habit_Affiche, Quadri_Affiche, NG,
    Blocage_Origine, Debut, Fin : boolean;
    Texte_Nord : string[25];
    Nord_X, Nord_Y, Echelle_X, Echelle_Y, Origine_X, Origine_Y, Rotation : reel;
    Nord_Epaisseur, Nord_Longueur, Echelle_Epaisseur, Echelle_Longueur, Echelle_Largeur,
    Echelle_Sub, Visee_Epaisseur, Pourcent, Diametre, Habit_Epaisseur, Carrefour,
    Quadri_Pas, Quadri_Epaisseur, Quadri_Longueur, Epaisseur_Largeur, Type_Largeur : smallInt;
    Nord_Police, Echelle_Police,  Station_Police : TFont;
    constructor Create;
    destructor Destroy; override;
    function Editer : boolean;
    procedure Sauve(Destination : TFileName);
    procedure Loade(Destination : TFileName);
  end;

  TOptions_Relief = class
    Nord_Affiche, Repere_Affiche, Rectangle_Affiche, NG, Inverse_X,
    Inverse_Y, Inverse_Z : boolean;
    Texte_Nord : string[25];
    Nord_X, Nord_Y, Nord_Z, Repere_X, Repere_Y, Repere_Z, Rotation_Horizontale,
    Rotation_Verticale : reel;
    Nord_Epaisseur, Nord_Longueur, Repere_Epaisseur, Repere_Longueur, Repere_Largeur,
    Repere_Sub, Visee_Epaisseur, Pourcent, Diametre, Carrefour,
    Rectangle_Epaisseur : smallInt;
    Nord_Police, Repere_Police,  Station_Police : TFont;
    Galerie_Couleur, Cylindre_Couleur, Fond_Couleur, Rectangle_Couleur : TColor;
    Diametre_Mini : single;
    Nb_Faces : integer;
    Les_Cylindres, squelette : boolean;

    constructor Create;
    destructor Destroy; override;
    function Editer : boolean;
    procedure Sauve(Destination : TFileName);
    procedure Loade(Destination : TFileName);
  end;

  TVerticale = record
     Xdev, Decal : reel;
     ZMin, ZMax : smallInt;
     Gauche : boolean;
     Nom : string[10];
     Point : string[50];
     Indice : smallInt;
   end;

  TOptions_Coupe = class
    Horizontale_Affiche, Habit_Affiche, Blocage_Origine : boolean;
    Horizontale_X, Horizontale_Z, Origine_X, Origine_Z : reel;
    Horizontale_Epaisseur, Horizontale_Longueur, Horizontale_Largeur, Horizontale_Pas,
    Verticale_Epaisseur, Verticale_Largeur, Verticale_Pas, Nb_Verticale,
    Visee_Epaisseur, Pourcent, Diametre, Carrefour, Habit_Epaisseur,
    Epaisseur_Hauteur, Type_Hauteur : smallInt;
    Horizontale_Police, Verticale_Police,  Station_Police : TFont;
    Verticale : array[1..50] of TVerticale;
    constructor Create;
    destructor Destroy; override;
    function Editer : boolean;
    procedure Sauve(Destination : TFileName);
    procedure Loade(Destination : TFileName);
  end;

  TMarge = class
    Gauche, Droite, Haut, Bas, Longueur, Epaisseur : SmallInt;
    Angle : array[1..3] of shortInt;
    Afficher : array[1..3] of boolean;
    Police : TFont;
    constructor Create;
    destructor Destroy; override;
    function Editer : boolean;
    procedure Sauve(Destination : TFileName);
    procedure Loade(Destination : TFileName); 
  end;

  TBulle = record
    Aucun, Coordonnees, Visee, Info, Largeur, Hauteur, Deformation : boolean;
  end;

procedure Colorier(Bouton : TBitBtn; Couleur : TColor);

implementation

uses Opt_Tabl, Marges, Opt_Plan, Unit1, Graphes, Opt_Reli, GrapheRE, Opt_Coup;

procedure Colorier(Bouton : TBitBtn; Couleur : TColor);
var
  MonBitMap : TBitMap;
begin
  MonBitMap:=TBitMap.Create;
  with MonBitMap do begin
    Height:=16; Width:=16;
    Canvas.Pen.Color:=clGray;
    Canvas.rectangle(0,0,15,15);
    Canvas.Pen.Color:=clBlack;
    Canvas.Brush.Color:=Couleur;
    Canvas.rectangle(1,1,14,14);
  end;
  Bouton.Glyph:=MonBitMap;
end;

procedure Enregistrer_Font(var F : TFileBufferStream; La_Font : TFont);
var
  J : integer;
  Col : Tcolor;
  Pit : TFontPitch;
  Sty : TFontStyles;
  FCharset : TFontCharset;
  S : shortstring;
begin
  if (abs(La_Font.Height)>100) and
     (MessageDlg('Perte de police. Rinitialisation ?',mtWarning,[mbOk,MbNo],0)=mrOk) then begin
    La_Font.Free; La_Font:=TFont.Create;
    La_Font.Height:=-11;
    La_Font.Color:=clBlack;
    La_Font.Name := 'Times New Roman';
  end;
  with La_Font do begin
    FCharset:=Charset;
    F.write(FCharset,sizeOf(FCharset));
    Col:=Color;
    F.write(Col,sizeOf(Col));
    J:=Height;
    F.write(J,sizeOf(J));

    J:=length(Name);
    F.write(J,sizeOf(J));
    S:=Name;
    for J:=1 to length(Name) do
      F.write(S[J],1);

    Pit:=Pitch;
    F.write(Pit,sizeOf(Pit));
    J:=PixelsPerInch;
    F.write(J,sizeOf(J));
    J:=size;
    F.write(J,sizeOf(J));
    Sty:=Style;
    F.write(Sty,sizeOf(Sty));
  end;
end;

procedure Lire_Font(var F : TFileBufferStream;La_Font : TFont);
var
  I, J : integer;
  Col : Tcolor;
  Pit : TFontPitch;
  Sty : TFontStyles;
  FCharSet : TFontCharset;
  S : shortString;
  C : char;
begin
  with La_Font do begin
    F.Read(FCharset,sizeOf(FCharset));
    Charset:=FCharset;
    F.Read(Col,sizeOf(Col));
    Color:=Col;
    F.Read(J,sizeOf(J));
    Height:=J;

    F.Read(J,sizeOf(J));
    S:='';
    for I:=1 to J do begin
      F.Read(C,1); S:=S+C;
    end;
    Name:=S;

    F.Read(Pit,sizeOf(Pit));
    Pitch:=Pit;
    F.Read(J,sizeOf(J));
    PixelsPerInch:=J;
    F.Read(J,sizeOf(J));
    size:=J;
    F.Read(Sty,sizeOf(Sty));
    Style:=Sty;
  end;
end;

(**************************** TOptions_Tableau *******************************)


constructor TOptions_Tableau.Create;
var
  I, J : integer;
begin
  inherited Create;
  Epaisseur_Visee:=5; Epaisseur_Direction:=10;
  for I:=1 to 13 do begin
    Rang[I]:=I;
    Largeur[I]:=20;
    Afficher[I]:=true;
    Dedoubler[I]:=false;
    Separateur[I]:='/';
  end;
  Largeur[10]:=60;
  Entete[1,1]:='L';
  Entete[2,1]:='Az';
  Entete[3,1]:='P';
  Entete[4,1]:='l';
  Entete[5,1]:='h';
  Entete[6,1]:='X';
  Entete[7,1]:='Y';
  Entete[8,1]:='Z';
  Entete[9,1]:='Dev H';
  Entete[10,1]:='Commentaires';
  Entete[11,1]:='Dev';
  Entete[12,1]:='Long H';
  Entete[13,1]:='Delta Z';
  Hauteur:=8;
  Police:=TFont.Create;
  with police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Relief:=TFont.Create;
  with Relief do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  for J:=0 to 1 do begin
    for I:=1 to 11 do begin
      So_Afficher[I,J]:=false;
      So_Intitule[I,J]:='';
      So_X[I,J]:=0;
      So_Y[I,J]:=0;
      So_Police[I,J]:=TFont.create;
      with So_Police[I,J] do begin
        Height:=-11;
        Color:=clBlack;
        Name := 'Times New Roman';
      end;
    end;
    So_Hauteur[J]:=50;
    So_Rappel[J]:=true;
  end;
  Point:=TPointTopo.Create;
  BloqueXY:=false; BloqueZ:=false;
end;

destructor TOptions_Tableau.Destroy;
var
  I, J : integer;
begin
  Police.Free;
  Relief.Free;
  for J:=0 to 1 do begin
    for I:=1 to 11 do So_Police[I,J].Free;
  end;
  Point.Free;
  inherited Destroy;
end;

function TOptions_Tableau.Editer : boolean;
var
  I, J : shortInt;
begin
  Opt_Tableau:=TOpt_Tableau.Create(Application);
  Opt_Tableau.Rempli(self);
  if Opt_Tableau.ShowModal=mrOk then begin
    for I:=1 to 13 do begin
      Rang[Opt_Tableau.Ordre[I-1]]:=I;
      Largeur[I]:=Opt_Tableau.Larg[I];
      Separateur[I]:=Opt_Tableau.Separat[I];
      Afficher[I]:=Opt_Tableau.Affich[I];
      Dedoubler[I]:=Opt_Tableau.Dedoubl[I];
      Entete[I,1]:=Opt_Tableau.EnteteA[I];
      Entete[I,2]:=Opt_Tableau.EnteteB[I];
    end;
    Police.Assign(Opt_Tableau.Font_Standart);
    Relief.Assign(Opt_Tableau.Font_Relief);
    Epaisseur_Visee:=StrToIntE(Opt_Tableau.Ptt_Trait.Text);
    Epaisseur_direction:=StrToIntE(Opt_Tableau.Gros_Trait.Text);
    Hauteur:=StrToIntE(Opt_Tableau.Hauteur_Ligne.Text);
    for J:=0 to 1 do begin
      for I:=1 to 11 do begin
        So_Afficher[I,J]:=Opt_Tableau.So_Afficher[I,J];
        So_Intitule[I,J]:=Opt_Tableau.So_Intitule[I,J];
        So_X[I,J]:=Opt_Tableau.So_X[I,J];
        So_Y[I,J]:=Opt_Tableau.So_Y[I,J];
        So_Police[I,J].Assign(Opt_Tableau.So_Police[I,J]);
      end;
      So_Hauteur[J]:=Opt_Tableau.So_Hauteur[J];
      So_Rappel[J]:=Opt_Tableau.So_Rappel[J];
    end;
    BloqueXY:=Opt_Tableau.EnPlan.Checked;
    BloqueZ:=Opt_Tableau.EnAltitude.Checked;
    Point.Indice:=StrToIntE(Opt_Tableau.Indice.Text);
    Point.Nom.Ecrit(Opt_Tableau.Point_Topo.Text);


    Editer:=true;
    if Form1.Massif<>nil then Form1.Massif.Gabarit_Tableau:=false;
  end
  else Editer:=false;
  Opt_Tableau.Free;
end;

procedure TOptions_Tableau.Sauve(Destination : TFileName);
var
  F : TFileBufferStream;
  I, K : integer;
begin
  F:=TFileBufferStream.Create(Destination,fmCreate);
  F.write(Entete,sizeOf(Entete));
  F.write(Separateur,sizeOf(Separateur));
  F.write(Rang,sizeOf(Rang));
  F.write(Largeur,sizeOf(Largeur));
  F.write(Afficher,sizeOf(Afficher));
  F.write(Dedoubler,sizeOf(Dedoubler));
  F.write(So_Afficher,sizeOf(So_Afficher));
  F.write(So_Intitule,sizeOf(So_Intitule));
  F.write(So_X,sizeOf(So_X));
  F.write(So_Y,sizeOf(So_Y));
  for I:=1 to 11 do for K:=0 to 1 do Enregistrer_Font(F,So_Police[I,K]);
  F.write(So_Hauteur,sizeOf(So_Hauteur));
  F.write(So_Rappel,sizeOf(So_Rappel));
  F.write(Hauteur,sizeOf(Hauteur));
  F.write(Epaisseur_Visee,sizeOf(Epaisseur_Visee));
  F.write(Epaisseur_Direction,sizeOf(Epaisseur_Direction));
  Enregistrer_Font(F,Police);
  Enregistrer_Font(F,Relief);
  F.write(BloqueXY,sizeOf(BloqueXY));
  F.write(BloqueZ,sizeOf(BloqueZ));
  Point.Sauve(F);
  F.Free;
end;

procedure TOptions_Tableau.Loade(Destination : TFileName);
var
  F : TFileBufferStream;
  I, K : integer;
begin
  if FileExists(Destination) then begin
    F:=TFileBufferStream.Create(Destination,fmOpenRead);
    F.Read(Entete,sizeOf(Entete));
    F.Read(Separateur,sizeOf(Separateur));
    F.Read(Rang,sizeOf(Rang));
    F.Read(Largeur,sizeOf(Largeur));
    F.Read(Afficher,sizeOf(Afficher));
    F.Read(Dedoubler,sizeOf(Dedoubler));
    F.Read(So_Afficher,sizeOf(So_Afficher));
    F.Read(So_Intitule,sizeOf(So_Intitule));
    F.Read(So_X,sizeOf(So_X));
    F.Read(So_Y,sizeOf(So_Y));
    for I:=1 to 11 do for K:=0 to 1 do Lire_Font(F,So_Police[I,K]);
    F.Read(So_Hauteur,sizeOf(So_Hauteur));
    F.Read(So_Rappel,sizeOf(So_Rappel));
    F.Read(Hauteur,sizeOf(Hauteur));
    F.Read(Epaisseur_Visee,sizeOf(Epaisseur_Visee));
    F.Read(Epaisseur_Direction,sizeOf(Epaisseur_Direction));
    Lire_Font(F,Police);
    Lire_Font(F,Relief);
    if not F.Eof then begin
      F.Read(BloqueXY,sizeOf(BloqueXY));
      F.Read(BloqueZ,sizeOf(BloqueZ));
      Point.Loade(F);
    end;
    F.Free;
  end;
end;


(************************  TOptions_Plan **********************************)


constructor TOptions_Plan.Create;
begin
  inherited Create;
  Nord_Affiche:=true;
  Echelle_Affiche:=true;
  Habit_Affiche:=true;
  NG:=true;
  Debut:=false;
  Fin:=true;
  Type_Largeur:=0;
  Epaisseur_Largeur:=1;
  Texte_Nord:='N.G.';
  Nord_X:=0; Nord_Y:=0;
  Echelle_X:=0;
  Echelle_Y:=0;
  Nord_Epaisseur:=2; Nord_Longueur:=10;
  Echelle_Epaisseur:=2; Echelle_Longueur:=10; Echelle_Largeur:=2;
  Echelle_Sub:=5;
  Visee_Epaisseur:=2;
  Pourcent:=100;
  Diametre:=1;
  Habit_Epaisseur:=5;
  Carrefour:=0;
  Rotation:=0;
  Blocage_Origine:=false;
  Origine_X:=0; Origine_Y:=0;
  Nord_Police:=TFont.Create;
  with Nord_police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Echelle_Police:=TFont.Create;
  with Echelle_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Station_Police:=TFont.Create;
  with Station_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
end;

destructor TOptions_Plan.destroy;
begin
  Nord_Police.Free;
  Echelle_Police.Free;
  Station_Police.Free;
  inherited destroy;
end;

function TOptions_Plan.Editer : boolean;
begin
  Opti_Plan:=TOpti_Plan.Create(application);
  if Form1.LePlan<>nil then Rotation:=TPlan(Form1.LePlan.Contenu).Rotation_Horizontale;
  Opti_Plan.Rempli(self);
  if Opti_Plan.ShowModal=mrOk then begin
    Nord_Police.Assign(Opti_Plan.Font_Nord);
    Echelle_Police.Assign(Opti_Plan.Font_Echelle);
    Station_Police.Assign(Opti_Plan.Font_Station);
    Nord_Affiche:=Opti_Plan.Affiche_Nord.Checked;
    Echelle_Affiche:=Opti_Plan.Affiche_Echelle.Checked;
    Habit_Affiche:=Opti_Plan.Afficher_Habillage.Checked;
    Quadri_Affiche:=Opti_Plan.Affiche_Quadri.Checked;
    NG:=(Opti_Plan.Representation.ItemIndex=1);
    Texte_Nord:=Opti_Plan.Texte_Nord.Text;
    Nord_X:=StrToFloatE(Opti_Plan.X_Nord.Text);
    Nord_Y:=StrToFloatE(Opti_Plan.Y_Nord.Text);
    Echelle_X:=StrToFloatE(Opti_Plan.X_Echelle.Text);
    Echelle_Y:=StrToFloatE(Opti_Plan.Y_Echelle.Text);
    Nord_Epaisseur:=StrToIntE(Opti_Plan.Epaisseur_Nord.Text);
    Nord_Longueur:=StrToIntE(Opti_Plan.Long_Nord.Text);
    Echelle_Epaisseur:=StrToIntE(Opti_Plan.Epaisseur_Echelle.Text);
    Echelle_Longueur:=StrToIntE(Opti_Plan.Long_Echelle.Text);
    Echelle_Largeur:=StrToIntE(Opti_Plan.Largeur_Echelle.Text);
    Echelle_Sub:=StrToIntE(Opti_Plan.Subdivision.Text);
    Visee_Epaisseur:=StrToIntE(Opti_Plan.Epaisseur_Visee.Text);
    Pourcent:=StrToIntE(Opti_Plan.Pourcentage.Text);
    Diametre:=StrToIntE(Opti_Plan.Diametre.Text);
    Habit_Epaisseur:=StrToIntE(Opti_Plan.Epaisseur_Habit.Text);
    Carrefour:=Opti_Plan.Texte_Station.ItemIndex;
    Quadri_Pas:=StrToIntE(Opti_Plan.Pas.Text);
    Quadri_Epaisseur:=StrToIntE(Opti_Plan.Epaisseur_Quadri.Text);
    Quadri_Longueur:=StrToIntE(Opti_Plan.Longueur_Quadri.Text);
    Rotation:=StrToFloatE(Opti_Plan.Angle.Text);
    if Form1.LePlan<>nil then with TPlan(Form1.LePlan.Contenu) do begin
      Rotation_Horizontale:=Rotation;
      Definitif(0);
    end;
    Blocage_Origine:=Opti_Plan.Origine.Checked;
    Origine_X:=StrToFloatE(Opti_Plan.X_Origine.Text);
    Origine_Y:=StrToFloatE(Opti_Plan.Y_Origine.Text);
    Type_Largeur:=Opti_Plan.Representation_Largeur.ItemIndex;
    Debut:=Opti_Plan.AuDebut.Checked;
    Fin:=Opti_Plan.ALaFin.Checked;
    Epaisseur_Largeur:=StrToIntE(Opti_Plan.Epaisseur_Largeur.Text);

    Editer:=true;
  end
  else Editer:=false;
  Opti_Plan.Free;
end;

procedure TOptions_Plan.Sauve(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  F:=TFileBufferStream.Create(Destination,fmCreate);
  F.write(Nord_Affiche,sizeOf(Nord_Affiche));
  F.write(Echelle_Affiche,sizeOf(Echelle_Affiche));
  F.write(Habit_Affiche,sizeOf(Habit_Affiche));
  F.write(Quadri_Affiche,sizeOf(Quadri_Affiche));
  F.write(NG,sizeOf(NG));
  F.write(Texte_Nord,sizeOf(Texte_Nord));
  F.write(Nord_X,sizeOf(Nord_X));
  F.write(Nord_Y,sizeOf(Nord_Y));
  F.write(Echelle_X,sizeOf(Echelle_X));
  F.write(Echelle_Y,sizeOf(Echelle_Y));
  F.write(Nord_Epaisseur,sizeOf(Nord_Epaisseur));
  F.write(Nord_Longueur,sizeOf(Nord_Longueur));
  F.write(Echelle_Epaisseur,sizeOf(Echelle_Epaisseur));
  F.write(Echelle_Longueur,sizeOf(Echelle_Longueur));
  F.write(Echelle_Largeur,sizeOf(Echelle_Largeur));
  F.write(Echelle_Sub,sizeOf(Echelle_Sub));
  F.write(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
  F.write(Pourcent,sizeOf(Pourcent));
  F.write(Diametre,sizeOf(Diametre));
  F.write(Habit_Epaisseur,sizeOf(Habit_Epaisseur));
  F.write(Carrefour,sizeOf(Carrefour));
  F.write(Quadri_Pas,sizeOf(Quadri_Pas));
  F.write(Quadri_Epaisseur,sizeOf(Quadri_Epaisseur));
  F.write(Quadri_Longueur,sizeOf(Quadri_Longueur));
  Enregistrer_Font(F,Nord_Police);
  Enregistrer_Font(F,Echelle_Police);
  Enregistrer_Font(F,Station_Police);
  F.write(Rotation,sizeOf(Rotation));
  F.write(Blocage_Origine,sizeOf(Blocage_Origine));
  F.write(Origine_X,sizeOf(Origine_X));
  F.write(Origine_Y,sizeOf(Origine_Y));
  F.write(Type_Largeur,sizeOf(Type_Largeur));
  F.write(Debut,sizeOf(Debut));
  F.write(Fin,sizeOf(Fin));
  F.write(Epaisseur_Largeur,sizeOf(Epaisseur_Largeur));
  F.Free;
end;

procedure TOptions_Plan.Loade(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  if FileExists(Destination) then begin
    F:=TFileBufferStream.Create(Destination,fmOpenRead);
    F.Read(Nord_Affiche,sizeOf(Nord_Affiche));
    F.Read(Echelle_Affiche,sizeOf(Echelle_Affiche));
    F.Read(Habit_Affiche,sizeOf(Habit_Affiche));
    F.Read(Quadri_Affiche,sizeOf(Quadri_Affiche));
    F.Read(NG,sizeOf(NG));
    F.Read(Texte_Nord,sizeOf(Texte_Nord));
    F.Read(Nord_X,sizeOf(Nord_X));
    F.Read(Nord_Y,sizeOf(Nord_Y));
    F.Read(Echelle_X,sizeOf(Echelle_X));
    F.Read(Echelle_Y,sizeOf(Echelle_Y));
    F.Read(Nord_Epaisseur,sizeOf(Nord_Epaisseur));
    F.Read(Nord_Longueur,sizeOf(Nord_Longueur));
    F.Read(Echelle_Epaisseur,sizeOf(Echelle_Epaisseur));
    F.Read(Echelle_Longueur,sizeOf(Echelle_Longueur));
    F.Read(Echelle_Largeur,sizeOf(Echelle_Largeur));
    F.Read(Echelle_Sub,sizeOf(Echelle_Sub));
    F.Read(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
    F.Read(Pourcent,sizeOf(Pourcent));
    F.Read(Diametre,sizeOf(Diametre));
    F.Read(Habit_Epaisseur,sizeOf(Habit_Epaisseur));
    F.Read(Carrefour,sizeOf(Carrefour));
    F.Read(Quadri_Pas,sizeOf(Quadri_Pas));
    F.Read(Quadri_Epaisseur,sizeOf(Quadri_Epaisseur));
    F.Read(Quadri_Longueur,sizeOf(Quadri_Longueur));
    Lire_Font(F,Nord_Police);
    Lire_Font(F,Echelle_Police);
    Lire_Font(F,Station_Police);
    F.Read(Rotation,sizeOf(Rotation));
    F.Read(Blocage_Origine,sizeOf(Blocage_Origine));
    F.Read(Origine_X,sizeOf(Origine_X));
    F.Read(Origine_Y,sizeOf(Origine_Y));
    F.Read(Type_Largeur,sizeOf(Type_Largeur));
    F.Read(Debut,sizeOf(Debut));
    F.Read(Fin,sizeOf(Fin));
    F.Read(Epaisseur_Largeur,sizeOf(Epaisseur_Largeur));
    F.Free;
  end;
end;

(************************  TOptions_Relief **********************************)

destructor TOptions_Relief.Destroy;
begin
  Nord_Police.Free;
  Repere_Police.Free;
  Station_Police.Free;
  inherited Destroy;
end;

constructor TOptions_Relief.Create;
begin
  inherited Create;
  Nord_Affiche:=true;
  NG:=true;
  Texte_Nord:='N.G.';
  Nord_X:=0; Nord_Y:=0; Nord_Z:=0;
  Repere_X:=0;
  Repere_Y:=0;
  Repere_Z:=0;
  Nord_Epaisseur:=2; Nord_Longueur:=10;
  Repere_Epaisseur:=2; Repere_Longueur:=10; Repere_Largeur:=2;
  Repere_Sub:=5;
  Visee_Epaisseur:=2;
  Pourcent:=100;
  Diametre:=1;
  Carrefour:=0;
  Rotation_Horizontale:=0;
  Rotation_Verticale:=0;
  Rectangle_Couleur:=clBlack;
  Rectangle_Epaisseur:=1;
  Rectangle_Affiche:=true;
  Nord_Police:=TFont.Create;
  with Nord_police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Repere_Police:=TFont.Create;
  with Repere_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Station_Police:=TFont.Create;
  with Station_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Diametre_Mini:=0.5;
  Nb_Faces:=10;
  Galerie_Couleur:=clDkGray;
  Cylindre_Couleur:=clDkGray;
  Fond_Couleur:=clBlack;
  Les_Cylindres:=false;
  squelette:=false;
end;


function TOptions_Relief.Editer : boolean;
begin
  if Form1.LaPerspective<>nil then begin
    Rotation_Horizontale:=TPerspective(Form1.LaPerspective.Contenu).Rotation_Horizontale;
    Rotation_Verticale:=TPerspective(Form1.LaPerspective.Contenu).Elevation;
  end;
  Opti_Relief:=TOpti_Relief.Create(application);
  Opti_Relief.Rempli(self);
  if Opti_Relief.ShowModal=mrOk then begin
    Nord_Police.Assign(Opti_Relief.Font_Nord);
    Repere_Police.Assign(Opti_Relief.Font_Repere);
    Station_Police.Assign(Opti_Relief.Font_Station);
    Nord_Affiche:=Opti_Relief.Affiche_Nord.Checked;
    Repere_Affiche:=Opti_Relief.Affiche_Echelle.Checked;
    Rectangle_Affiche:=Opti_Relief.Affiche_Quadri.Checked;
    NG:=(Opti_Relief.Representation.ItemIndex=1);
    Texte_Nord:=Opti_Relief.Texte_Nord.Text;
    Nord_X:=StrToFloatE(Opti_Relief.X_Nord.Text);
    Nord_Y:=StrToFloatE(Opti_Relief.Y_Nord.Text);
    Nord_Z:=StrToFloatE(Opti_Relief.Z_Nord.Text);
    Repere_X:=StrToFloatE(Opti_Relief.X_Echelle.Text);
    Repere_Y:=StrToFloatE(Opti_Relief.Y_Echelle.Text);
    Repere_Z:=StrToFloatE(Opti_Relief.Z_Echelle.Text);
    Nord_Epaisseur:=StrToIntE(Opti_Relief.Epaisseur_Nord.Text);
    Nord_Longueur:=StrToIntE(Opti_Relief.Long_Nord.Text);
    Repere_Epaisseur:=StrToIntE(Opti_Relief.Epaisseur_Echelle.Text);
    Repere_Longueur:=StrToIntE(Opti_Relief.Long_Echelle.Text);
    Repere_Largeur:=StrToIntE(Opti_Relief.Largeur_Echelle.Text);
    Repere_Sub:=StrToIntE(Opti_Relief.Subdivision.Text);
    Inverse_X:=Opti_Relief.X_Inverse.Checked;
    Inverse_Y:=Opti_Relief.Y_Inverse.Checked;
    Inverse_Z:=Opti_Relief.Z_Inverse.Checked;
    Visee_Epaisseur:=StrToIntE(Opti_Relief.Epaisseur_Visee.Text);
    Pourcent:=StrToIntE(Opti_Relief.Pourcentage.Text);
    Diametre:=StrToIntE(Opti_Relief.Diametre.Text);
    Carrefour:=Opti_Relief.Texte_Station.ItemIndex;
    Rectangle_Epaisseur:=StrToIntE(Opti_Relief.Epaisseur_Quadri.Text);
    Rotation_Horizontale:=StrToFloatE(Opti_Relief.Angle_Horizontal.Text);
    Rotation_Verticale:=StrToFloatE(Opti_Relief.Angle_Vertical.Text);
    Rectangle_Couleur:=Opti_Relief.La_Couleur;

    Diametre_Mini:=StrToFloatE(Opti_Relief.Largeur_3D.Text);
    Nb_Faces:=StrToIntE(Opti_Relief.N_Face.Text);
    Galerie_Couleur:=Opti_Relief.Couleur_Galerie;
    Cylindre_Couleur:=Opti_Relief.Couleur_Cylindre;
    Fond_Couleur:=Opti_Relief.Couleur_Fond;
    Les_Cylindres:=Opti_Relief.Cylindre.Checked;
    Squelette:=Opti_Relief.Filaire.Checked;

    if Form1.LaPerspective<>nil then begin
      TPerspective(Form1.LaPerspective.Contenu).Rotation_Horizontale:=Rotation_Horizontale;
      TPerspective(Form1.LaPerspective.Contenu).Elevation:=Rotation_Verticale;
      TPerspective(Form1.LaPerspective.Contenu).Definitif(0,0);
    end;
    Editer:=true;
  end
  else Editer:=false;
  Opti_Relief.Free;
end;

procedure TOptions_Relief.Sauve(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  F:=TFileBufferStream.Create(Destination,fmCreate);
  F.write(Nord_Affiche,sizeOf(Nord_Affiche));
  F.write(Repere_Affiche,sizeOf(Repere_Affiche));
  F.write(Rectangle_Affiche,sizeOf(Rectangle_Affiche));
  F.write(NG,sizeOf(NG));
  F.write(Inverse_X,sizeOf(Inverse_X));
  F.write(Inverse_Y,sizeOf(Inverse_Y));
  F.write(Inverse_Z,sizeOf(Inverse_Z));
  F.write(Texte_Nord,sizeOf(Texte_Nord));
  F.write(Nord_X,sizeOf(Nord_X));
  F.write(Nord_Y,sizeOf(Nord_Y));
  F.write(Nord_Z,sizeOf(Nord_Z));
  F.write(Repere_X,sizeOf(Repere_X));
  F.write(Repere_Y,sizeOf(Repere_Y));
  F.write(Repere_Z,sizeOf(Repere_Z));
  F.write(Nord_Epaisseur,sizeOf(Nord_Epaisseur));
  F.write(Nord_Longueur,sizeOf(Nord_Longueur));
  F.write(Repere_Epaisseur,sizeOf(Repere_Epaisseur));
  F.write(Repere_Longueur,sizeOf(Repere_Longueur));
  F.write(Repere_Largeur,sizeOf(Repere_Largeur));
  F.write(Repere_Sub,sizeOf(Repere_Sub));
  F.write(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
  F.write(Pourcent,sizeOf(Pourcent));
  F.write(Diametre,sizeOf(Diametre));
  F.write(Carrefour,sizeOf(Carrefour));
  F.write(Rectangle_Epaisseur,sizeOf(Rectangle_Epaisseur));
  F.write(Rectangle_Couleur,sizeOf(Rectangle_Couleur));
  Enregistrer_Font(F,Nord_Police);
  Enregistrer_Font(F,Repere_Police);
  Enregistrer_Font(F,Station_Police);
  F.write(Rotation_Horizontale,sizeOf(Rotation_Horizontale));
  F.write(Rotation_Verticale,sizeOf(Rotation_Verticale));
  F.write(Diametre_Mini,sizeOf(Diametre_Mini));
  F.write(Nb_Faces,sizeOf(Nb_Faces));
  F.write(Galerie_Couleur,sizeOf(Galerie_Couleur));
  F.write(Cylindre_Couleur,sizeOf(Cylindre_Couleur));
  F.write(Fond_Couleur,sizeOf(Fond_Couleur));
  F.write(Les_Cylindres,sizeOf(Les_Cylindres));
  F.write(squelette,sizeOf(squelette));
  F.Free;
end;

procedure TOptions_Relief.Loade(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  if FileExists(Destination) then begin
    F:=TFileBufferStream.Create(Destination,fmOpenRead);
    F.Read(Nord_Affiche,sizeOf(Nord_Affiche));
    F.Read(Repere_Affiche,sizeOf(Repere_Affiche));
    F.Read(Rectangle_Affiche,sizeOf(Rectangle_Affiche));
    F.Read(NG,sizeOf(NG));
    F.Read(Inverse_X,sizeOf(Inverse_X));
    F.Read(Inverse_Y,sizeOf(Inverse_Y));
    F.Read(Inverse_Z,sizeOf(Inverse_Z));
    F.Read(Texte_Nord,sizeOf(Texte_Nord));
    F.Read(Nord_X,sizeOf(Nord_X));
    F.Read(Nord_Y,sizeOf(Nord_Y));
    F.Read(Nord_Z,sizeOf(Nord_Z));
    F.Read(Repere_X,sizeOf(Repere_X));
    F.Read(Repere_Y,sizeOf(Repere_Y));
    F.Read(Repere_Z,sizeOf(Repere_Z));
    F.Read(Nord_Epaisseur,sizeOf(Nord_Epaisseur));
    F.Read(Nord_Longueur,sizeOf(Nord_Longueur));
    F.Read(Repere_Epaisseur,sizeOf(Repere_Epaisseur));
    F.Read(Repere_Longueur,sizeOf(Repere_Longueur));
    F.Read(Repere_Largeur,sizeOf(Repere_Largeur));
    F.Read(Repere_Sub,sizeOf(Repere_Sub));
    F.Read(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
    F.Read(Pourcent,sizeOf(Pourcent));
    F.Read(Diametre,sizeOf(Diametre));
    F.Read(Carrefour,sizeOf(Carrefour));
    F.Read(Rectangle_Epaisseur,sizeOf(Rectangle_Epaisseur));
    F.Read(Rectangle_Couleur,sizeOf(Rectangle_Couleur));
    Lire_Font(F,Nord_Police);
    Lire_Font(F,Repere_Police);
    Lire_Font(F,Station_Police);
    F.Read(Rotation_Horizontale,sizeOf(Rotation_Horizontale));
    F.Read(Rotation_Verticale,sizeOf(Rotation_Verticale));
    F.Read(Diametre_Mini,sizeOf(Diametre_Mini));
    F.Read(Nb_Faces,sizeOf(Nb_Faces));
    F.Read(Galerie_Couleur,sizeOf(Galerie_Couleur));
    F.Read(Cylindre_Couleur,sizeOf(Cylindre_Couleur));
    F.Read(Fond_Couleur,sizeOf(Fond_Couleur));
    F.Read(Les_Cylindres,sizeOf(Les_Cylindres));
    if not F.EOF then F.Read(squelette,sizeOf(squelette));
    F.Free;
  end;
end;

(************************  TOptions_Coupe **********************************)

destructor TOptions_Coupe.Destroy;
begin
  Horizontale_Police.Free;
  Verticale_Police.Free;
  Station_Police.Free;
  inherited Destroy;
end;

constructor TOptions_Coupe.Create;
begin
  inherited Create;
  Horizontale_Affiche:=false;
  Habit_Affiche:=false;
  Horizontale_X:=0;
  Horizontale_Z:=0;
  Horizontale_Epaisseur:=1;
  Horizontale_Longueur:=100;
  Horizontale_Largeur:=2;
  Horizontale_Pas:=20;
  Verticale_Epaisseur:=1;
  Verticale_Largeur:=2;
  Verticale_Pas:=10;
  Nb_Verticale:=0;
  Visee_Epaisseur:=1;
  Pourcent:=100;
  Diametre:=0;
  Carrefour:=0;
  Blocage_Origine:=true;
  Origine_X:=0; Origine_Z:=0;
  Type_Hauteur:=0;
  Epaisseur_Hauteur:=2;
  Horizontale_Police:=TFont.Create;
  with Horizontale_police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Verticale_Police:=TFont.Create;
  with Verticale_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
  Station_Police:=TFont.Create;
  with Station_Police do begin
    Height:=-11;
    Color:=clBlack;
    Name := 'Times New Roman';
  end;
end;


function TOptions_Coupe.Editer : boolean;
var
  I : integer;
begin
  Opti_Coupe:=TOpti_Coupe.Create(application);
  Opti_Coupe.Rempli(self);
  if Opti_Coupe.ShowModal=mrOk then begin
    Horizontale_Police.Assign(Opti_Coupe.Font_Horizontale);
    Verticale_Police.Assign(Opti_Coupe.Font_Verticale);
    Station_Police.Assign(Opti_Coupe.Font_Station);

    Horizontale_Affiche:=Opti_Coupe.Affiche_Horizontale.Checked;
    Habit_Affiche:=Opti_Coupe.Afficher_Habillage.Checked;
    Horizontale_X:=StrToFloatE(Opti_Coupe.X_Horizontale.Text);
    Horizontale_Z:=StrToFloatE(Opti_Coupe.Z_Horizontale.Text);
    Horizontale_Epaisseur:=StrToIntE(Opti_Coupe.Epaisseur_Horizontale.Text);
    Horizontale_Largeur:=StrToIntE(Opti_Coupe.Largeur_Horizontale.Text);
    Horizontale_Longueur:=StrToIntE(Opti_Coupe.Long_Horizontale.Text);
    Horizontale_Pas:=StrToIntE(Opti_Coupe.Pas_Horizontale.Text);
    Verticale_Epaisseur:=StrToIntE(Opti_Coupe.Epaisseur_Verticale.Text);
    Verticale_Largeur:=StrToIntE(Opti_Coupe.Largeur_Verticale.Text);
    Verticale_Pas:=StrToIntE(Opti_Coupe.Pas_Verticale.Text);
    Visee_Epaisseur:=StrToIntE(Opti_Coupe.Epaisseur_Visee.Text);
    Pourcent:=StrToIntE(Opti_Coupe.Pourcentage.Text);
    Diametre:=StrToIntE(Opti_Coupe.Diametre.Text);
    Habit_Epaisseur:=StrToIntE(Opti_Coupe.Epaisseur_Habit.Text);
    Carrefour:=Opti_Coupe.Texte_Station.ItemIndex;
    Blocage_Origine:=Opti_Coupe.Origine.Checked;
    Origine_X:=StrToFloatE(Opti_Coupe.X_Origine.Text);
    Origine_Z:=StrToFloatE(Opti_Coupe.Z_Origine.Text);
    Type_Hauteur:=Opti_Coupe.Representation_Hauteur.ItemIndex;
    Epaisseur_Hauteur:=StrToIntE(Opti_Coupe.Epaisseur_Hauteur.Text);

    Nb_Verticale:=Opti_Coupe.Nb_Verticales;
    for I:=1 to Nb_Verticale do if Opti_Coupe.ListBox1.ItemIndex<>I-1 then begin
      Verticale[I]:=Opti_Coupe.Les_Verticales[I];
    end
    else begin
      Verticale[I].Nom:=Opti_Coupe.ListBox1.Items[I-1];
      Verticale[I].XDev:=StrToFloatE(Opti_Coupe.X_Verticale.text);
      Verticale[I].ZMin:=StrToIntE(Opti_Coupe.ZMin_Verticale.text);
      Verticale[I].ZMax:=StrToIntE(Opti_Coupe.ZMax_Verticale.text);
      Verticale[I].Decal:=StrToFloatE(Opti_Coupe.Decal_Verticale.text);
      Verticale[I].Gauche:=Opti_Coupe.Gauche_Verticale.Checked;
      Verticale[I].Point:=Opti_Coupe.Nom_Verticale.Text;
      Verticale[I].Indice:=StrToIntE(Opti_Coupe.Indice_Verticale.text);
    end;
    Editer:=true;
  end
  else Editer:=false;
  Opti_Coupe.Free;
end;

procedure TOptions_Coupe.Sauve(Destination : TFileName);
var
  F : TFileBufferStream;
  I : integer;
begin
  F:=TFileBufferStream.Create(Destination,fmCreate);
  F.write(Horizontale_Affiche,sizeOf(Horizontale_Affiche));
  F.write(Habit_Affiche,sizeOf(Habit_Affiche));
  F.write(Horizontale_X,sizeOf(Horizontale_X));
  F.write(Horizontale_Z,sizeOf(Horizontale_Z));
  F.write(Horizontale_Epaisseur,sizeOf(Horizontale_Epaisseur));
  F.write(Horizontale_Longueur,sizeOf(Horizontale_Longueur));
  F.write(Horizontale_Largeur,sizeOf(Horizontale_Largeur));
  F.write(Horizontale_Pas,sizeOf(Horizontale_Pas));
  F.write(Verticale_Epaisseur,sizeOf(Verticale_Epaisseur));
  F.write(Verticale_Largeur,sizeOf(Verticale_Largeur));
  F.write(Verticale_Pas,sizeOf(Verticale_Pas));
  F.write(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
  F.write(Pourcent,sizeOf(Pourcent));
  F.write(Diametre,sizeOf(Diametre));
  F.write(Carrefour,sizeOf(Carrefour));
  F.write(Nb_Verticale,sizeOf(Nb_Verticale));
  for I:=1 to Nb_Verticale do F.write(Verticale[I],sizeOf(Verticale[I]));
  Enregistrer_Font(F,Horizontale_Police);
  Enregistrer_Font(F,Verticale_Police);
  Enregistrer_Font(F,Station_Police);
  F.write(Blocage_Origine,sizeOf(Blocage_Origine));
  F.write(Origine_X,sizeOf(Origine_X));
  F.write(Origine_Z,sizeOf(Origine_Z));
  F.write(Habit_Epaisseur,sizeOf(Habit_Epaisseur));
  F.write(Type_Hauteur,sizeOf(Type_Hauteur));
  F.write(Epaisseur_Hauteur,sizeOf(Epaisseur_Hauteur));
  F.Free;
end;

procedure TOptions_Coupe.Loade(Destination : TFileName);
var
  F : TFileBufferStream;
  I : integer;
begin
  if FileExists(Destination) then begin
    F:=TFileBufferStream.Create(Destination,fmOpenRead);
    F.Read(Horizontale_Affiche,sizeOf(Horizontale_Affiche));
    F.Read(Habit_Affiche,sizeOf(Habit_Affiche));
    F.Read(Horizontale_X,sizeOf(Horizontale_X));
    F.Read(Horizontale_Z,sizeOf(Horizontale_Z));
    F.Read(Horizontale_Epaisseur,sizeOf(Horizontale_Epaisseur));
    F.Read(Horizontale_Longueur,sizeOf(Horizontale_Longueur));
    F.Read(Horizontale_Largeur,sizeOf(Horizontale_Largeur));
    F.Read(Horizontale_Pas,sizeOf(Horizontale_Pas));
    F.Read(Verticale_Epaisseur,sizeOf(Verticale_Epaisseur));
    F.Read(Verticale_Largeur,sizeOf(Verticale_Largeur));
    F.Read(Verticale_Pas,sizeOf(Verticale_Pas));
    F.Read(Visee_Epaisseur,sizeOf(Visee_Epaisseur));
    F.Read(Pourcent,sizeOf(Pourcent));
    F.Read(Diametre,sizeOf(Diametre));
    F.Read(Carrefour,sizeOf(Carrefour));
    F.Read(Nb_Verticale,sizeOf(Nb_Verticale));
    for I:=1 to Nb_Verticale do F.Read(Verticale[I],sizeOf(Verticale[I]));
    Lire_Font(F,Horizontale_Police);
    Lire_Font(F,Verticale_Police);
    Lire_Font(F,Station_Police);
    F.Read(Blocage_Origine,sizeOf(Blocage_Origine));
    F.Read(Origine_X,sizeOf(Origine_X));
    F.Read(Origine_Z,sizeOf(Origine_Z));
    F.Read(Habit_Epaisseur,sizeOf(Habit_Epaisseur));
    F.Read(Type_Hauteur,sizeOf(Type_Hauteur));
    F.Read(Epaisseur_Hauteur,sizeOf(Epaisseur_Hauteur));
    F.Free;
  end;
end;

{************************************************************}
{*                         TMarge                           *}
{************************************************************}

destructor TMarge.Destroy;
begin
  Police.Free;
  inherited Destroy;
end;
  
constructor TMarge.Create;
begin
  Gauche:=10; Droite:=10; Haut:=10; Bas:=10;
  Longueur:=30; Epaisseur:=1;
  Angle[1]:=anHautGauche;
  Angle[2]:=anBasGauche;
  Angle[3]:=anBasDroit;
  Afficher[1]:=true;
  Afficher[2]:=true;
  Afficher[3]:=true;
  Police:=TFont.Create;
  with police do begin
    Height:=-12;
    Color:=clBlack;
    Name := 'Arial';
  end;
end;

function TMarge.Editer : boolean;
begin
  Def_Marge:=TDef_Marge.Create(Application);
  Def_Marge.Rempli(self);
  if Def_Marge.ShowModal=mrOk then begin
    Police.Assign(Def_Marge.Font_Standart);
    Gauche:=StrToIntE(Def_Marge.EGauche.Text);
    Droite:=StrToIntE(Def_Marge.EDroite.Text);
    Haut:=StrToIntE(Def_Marge.EHaut.Text);
    Bas:=StrToIntE(Def_Marge.EBas.Text);
    longueur:=StrToIntE(Def_Marge.ELongueur.Text);
    Epaisseur:=StrToIntE(Def_Marge.EEpaisseur.Text);

    Afficher[1]:=Def_Marge.F_Afficher.Checked;
    Afficher[2]:=Def_Marge.P_Afficher.Checked;
    Afficher[3]:=Def_Marge.D_Afficher.Checked;
    Angle[1]:=Def_Marge.C_Fichier.ItemIndex+1;
    Angle[2]:=Def_Marge.C_Page.ItemIndex+1;
    Angle[3]:=Def_Marge.C_Date.ItemIndex+1;
  end;
  Def_Marge.Free;
end;

procedure TMarge.Sauve(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  F:=TFileBufferStream.Create(Destination,fmCreate);
  F.write(Gauche,sizeOf(Gauche));
  F.write(Droite,sizeOf(Droite));
  F.write(Haut,sizeOf(Haut));
  F.write(Bas,sizeOf(Bas));
  F.write(Longueur,sizeOf(Longueur));
  F.write(Angle,sizeOf(Angle));
  F.write(Afficher,sizeOf(Afficher));
  Enregistrer_Font(F,Police);
  F.write(Epaisseur,sizeOf(Epaisseur));
  F.Free;
end;

procedure TMarge.Loade(Destination : TFileName);
var
  F : TFileBufferStream;
begin
  if FileExists(Destination) then begin
    F:=TFileBufferStream.Create(Destination,fmOpenRead);
    F.Read(Gauche,sizeOf(Gauche));
    F.Read(Droite,sizeOf(Droite));
    F.Read(Haut,sizeOf(Haut));
    F.Read(Bas,sizeOf(Bas));
    F.Read(longueur,sizeOf(Longueur));
    F.Read(Angle,sizeOf(Angle));
    F.Read(Afficher,sizeOf(Afficher));
    Lire_Font(F,Police);
    if not F.Eof then F.Read(Epaisseur,sizeOf(Epaisseur));
    F.Free;
  end;
end;



end.
