unit Opt_reli;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons, SysUtils,
  StdCtrls, Dialogs, ExtCtrls, Options, TabNotBk, ComCtrls;

type
  TOpti_Relief = class(TForm)
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    Affiche_Nord: TCheckBox;
    Representation: TRadioGroup;
    Label1: TLabel;
    X_Nord: TEdit;
    Label2: TLabel;
    Y_Nord: TEdit;
    Label21: TLabel;
    Z_Nord: TEdit;
    Label4: TLabel;
    Epaisseur_Nord: TEdit;
    Label3: TLabel;
    Long_Nord: TEdit;
    Label5: TLabel;
    Texte_Nord: TEdit;
    Police_Nord: TButton;
    Affiche_Echelle: TCheckBox;
    Label9: TLabel;
    Epaisseur_Echelle: TEdit;
    Label8: TLabel;
    Long_Echelle: TEdit;
    Label10: TLabel;
    Largeur_Echelle: TEdit;
    Label11: TLabel;
    Subdivision: TEdit;
    Label6: TLabel;
    X_Echelle: TEdit;
    X_Inverse: TCheckBox;
    Label7: TLabel;
    Y_Echelle: TEdit;
    Y_Inverse: TCheckBox;
    Label22: TLabel;
    Z_Echelle: TEdit;
    Z_Inverse: TCheckBox;
    Police_Echelle: TButton;
    Label16: TLabel;
    Angle_Horizontal: TEdit;
    Label20: TLabel;
    Label17: TLabel;
    Angle_Vertical: TEdit;
    Label15: TLabel;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Epaisseur_Visee: TEdit;
    pourcentage: TEdit;
    Texte_Station: TRadioGroup;
    Label14: TLabel;
    Label19: TLabel;
    diametre: TEdit;
    Police_Station: TButton;
    Affiche_Quadri: TCheckBox;
    Label18: TLabel;
    Epaisseur_Quadri: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Cylindre: TCheckBox;
    N_Face: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Largeur_3D: TEdit;
    Label25: TLabel;
    Button4: TButton;
    Button5: TButton;
    Couleur_Cadre: TBitBtn;
    Button1: TBitBtn;
    Button2: TBitBtn;
    Button3: TBitBtn;
    Filaire: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Affiche_NordClick(Sender: TObject);
    procedure Affiche_EchelleClick(Sender: TObject);
    procedure Affiche_QuadriClick(Sender: TObject);
    procedure Police_NordClick(Sender: TObject);
    procedure Police_EchelleClick(Sender: TObject);
    procedure Police_StationClick(Sender: TObject);
    procedure X_NordKeyPress(Sender: TObject; var Key: Char);
    procedure Epaisseur_NordKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Couleur_CadreClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Font_Nord, Font_Repere, Font_Station : TFont;
    La_Couleur, Couleur_Galerie, Couleur_Fond, Couleur_Cylindre : TColor;
    procedure Rempli(Une_Option : TOptions_Relief);
  end;

var
  Opti_Relief: TOpti_Relief;

implementation

{$R *.DFM}


procedure TOpti_Relief.Rempli(Une_Option : TOptions_Relief);
begin
  Font_Nord.Assign(Une_Option.Nord_Police);
  Font_Repere.Assign(Une_Option.Repere_Police);
  Font_Station.Assign(Une_Option.Station_Police);
  Affiche_Nord.Checked:=Une_Option.Nord_Affiche;
  Affiche_Echelle.Checked:=Une_Option.Repere_Affiche;
  Affiche_Quadri.Checked:=Une_Option.Rectangle_Affiche;
  if Une_Option.NG then Representation.ItemIndex:=1
                   else Representation.ItemIndex:=0;
  Texte_Nord.Text:=Une_Option.Texte_Nord;
  X_Nord.Text:=FloatTostrF(Une_Option.Nord_X,ffGeneral,6,3);
  Y_Nord.Text:=FloatTostrF(Une_Option.Nord_Y,ffGeneral,6,3);
  Z_Nord.Text:=FloatTostrF(Une_Option.Nord_Z,ffGeneral,6,3);
  X_Echelle.Text:=FloatTostrF(Une_Option.Repere_X,ffGeneral,6,3);
  Y_Echelle.Text:=FloatTostrF(Une_Option.Repere_Y,ffGeneral,6,3);
  Z_Echelle.Text:=FloatTostrF(Une_Option.Repere_Z,ffGeneral,6,3);
  Epaisseur_Nord.Text:=IntTostr(Une_Option.Nord_Epaisseur);

  Epaisseur_Echelle.Text:=IntTostr(Une_Option.Repere_Epaisseur);
  Long_Echelle.Text:=IntTostr(Une_Option.Repere_Longueur);
  Long_Nord.Text:=IntTostr(Une_Option.Nord_Longueur);
  Largeur_Echelle.Text:=IntTostr(Une_Option.Repere_Largeur);
  Subdivision.Text:=IntTostr(Une_Option.Repere_Sub);

  X_Inverse.Checked:=Une_Option.Inverse_X;
  Y_Inverse.Checked:=Une_Option.Inverse_Y;
  Z_Inverse.Checked:=Une_Option.Inverse_Z;
  Epaisseur_Visee.Text:=IntTostr(Une_Option.Visee_Epaisseur);
  Pourcentage.Text:=IntTostr(Une_Option.Pourcent);
  Diametre.Text:=IntTostr(Une_Option.Diametre);
  Texte_Station.ItemIndex:=Une_Option.Carrefour;
  Epaisseur_Quadri.Text:=IntTostr(Une_Option.Rectangle_Epaisseur);
  Angle_Horizontal.Text:=FloatTostrF(Une_Option.Rotation_Horizontale,ffGeneral,4,1);
  Angle_Vertical.Text:=FloatTostrF(Une_Option.Rotation_Verticale,ffGeneral,4,1);
  La_Couleur:=Une_Option.Rectangle_Couleur;
  Colorier(Couleur_Cadre,La_Couleur);

  Largeur_3D.Text:=FloatTostrF(Une_Option.Diametre_Mini,ffGeneral,3,2);
  N_Face.Text:=IntTostr(Une_Option.Nb_Faces); 
  Couleur_Galerie:=Une_Option.Galerie_Couleur;
  Couleur_Fond:=Une_Option.Fond_Couleur;
  Couleur_Cylindre:=Une_Option.Cylindre_Couleur;
  Cylindre.Checked:=Une_Option.Les_Cylindres;
  Filaire.Checked:=Une_Option.Squelette;
  Colorier(Button1,Couleur_Galerie);
  Colorier(Button2,Couleur_Fond);
  Colorier(Button3,Couleur_Cylindre);


  Affiche_NordClick(Self);
  Affiche_EchelleClick(Self);
  Affiche_QuadriClick(Self);
end;


procedure TOpti_Relief.FormCreate(Sender: TObject);
begin
  Font_Nord:=TFont.Create;
  Font_Repere:=TFont.Create;
  Font_Station:=TFont.Create;
end;

procedure TOpti_Relief.FormDestroy(Sender: TObject);
begin
  Font_Nord.Free;
  Font_Repere.Free;
  Font_Station.Free;
end;

procedure TOpti_Relief.Affiche_NordClick(Sender: TObject);
begin
  X_Nord.Enabled:=Affiche_Nord.Checked;
  Y_Nord.Enabled:=Affiche_Nord.Checked;
  Z_Nord.Enabled:=Affiche_Nord.Checked;
  Representation.Enabled:=Affiche_Nord.Checked;
  Epaisseur_Nord.Enabled:=Affiche_Nord.Checked;
  Long_Nord.Enabled:=Affiche_Nord.Checked;
  Texte_Nord.Enabled:=Affiche_Nord.Checked;
  Police_Nord.Enabled:=Affiche_Nord.Checked;
end;

procedure TOpti_Relief.Affiche_EchelleClick(Sender: TObject);
begin
  Epaisseur_Echelle.Enabled:=Affiche_Echelle.Checked;
  X_Echelle.Enabled:=Affiche_Echelle.Checked;
  Y_Echelle.Enabled:=Affiche_Echelle.Checked;
  Z_Echelle.Enabled:=Affiche_Echelle.Checked;
  X_Inverse.Enabled:=Affiche_Echelle.Checked;
  Y_Inverse.Enabled:=Affiche_Echelle.Checked;
  Z_Inverse.Enabled:=Affiche_Echelle.Checked;
  Long_Echelle.Enabled:=Affiche_Echelle.Checked;
  Largeur_Echelle.Enabled:=Affiche_Echelle.Checked;
  Subdivision.Enabled:=Affiche_Echelle.Checked;
  Police_Echelle.Enabled:=Affiche_Echelle.Checked;
end;

procedure TOpti_Relief.Affiche_QuadriClick(Sender: TObject);
begin
  Epaisseur_Quadri.Enabled:=Affiche_Quadri.Checked;
  Couleur_Cadre.Enabled:=Affiche_Quadri.Checked;
end;

procedure TOpti_Relief.Police_NordClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Nord);
  if FontDialog1.Execute then Font_Nord.Assign(FontDialog1.Font);
end;

procedure TOpti_Relief.Police_EchelleClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Repere);
  if FontDialog1.Execute then Font_Repere.Assign(FontDialog1.Font);
end;

procedure TOpti_Relief.Police_StationClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Station);
  if FontDialog1.Execute then Font_Station.Assign(FontDialog1.Font);
end;

procedure TOpti_Relief.X_NordKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') and (Key<>'-')
      then Key := #0;
end;

procedure TOpti_Relief.Epaisseur_NordKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TOpti_Relief.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color:=Couleur_Galerie;
  if ColorDialog1.Execute then begin
    Couleur_Galerie:=ColorDialog1.Color;
    Colorier(Button1,Couleur_Galerie);
  end;
end;

procedure TOpti_Relief.Button2Click(Sender: TObject);
begin
  ColorDialog1.Color:=Couleur_Fond;
  if ColorDialog1.Execute then begin
    Couleur_Fond:=ColorDialog1.Color;
    Colorier(Button2,Couleur_Fond);
  end;
end;

procedure TOpti_Relief.Button3Click(Sender: TObject);
begin
  ColorDialog1.Color:=Couleur_Cylindre;
  if ColorDialog1.Execute then begin
    Couleur_Cylindre:=ColorDialog1.Color;
    Colorier(Button3,Couleur_Cylindre);
  end;
end;

procedure TOpti_Relief.Couleur_CadreClick(Sender: TObject);
begin
  ColorDialog1.Color:=La_Couleur;
  if ColorDialog1.Execute then begin
    La_Couleur:=ColorDialog1.Color;
    Colorier(Couleur_Cadre,La_Couleur);
  end; 
end;

end.
