unit OpenGLPerso;

interface

uses UrickGL, GL, GLU, U3DPolys;

type

    TMaScene = class(TsceneGL)
      procedure Rotate(rx,ry,rz : single);
      procedure Move(X,Y,Z:single);
      procedure Sphere(CX,CY,CZ, Rayon : single; Nb_Facette : integer; Red, Green, blue : byte);
    end; {TsceneGL}


implementation

procedure TMaScene.Rotate(rx,ry,rz : single);
var
  I : integer;
begin
  for I:=0 to Entities.Count-1 do
    Tentity(Entities.Items[I]).Rotate(rx,ry,rz);
end;

procedure TMaScene.Move(x,y,z : single);
var
  I : integer;
begin
  for I:=0 to Entities.Count-1 do
    Tentity(Entities.Items[I]).Move(x,y,z);
end;

procedure TMaScene.Sphere(CX,CY,CZ, Rayon : single; Nb_Facette : integer; Red, Green, blue : byte);
const
  C63=0.4472;
  S63=0.8944;
  C72=0.3090;
  S72=0.9511;
  C144=-0.8090;
  S144=0.5878;
var
  N : integer;
  Boule : TEntity;

  procedure Un_Triangle(X1, Y1, Z1,
                        X2, Y2, Z2,
                        X3, Y3, Z3 : single);
  var
    I, J : integer;
    XA, XB, XC, YA, YB, YC, ZA, ZB, ZC, D : single;
  begin
    for I:=1 to N do for J:=1 to I do begin

      XA:=X1+((X2-X1)*(i-1)+(X3-X2)*(j-1))/N;
      YA:=Y1+((Y2-Y1)*(i-1)+(Y3-Y2)*(j-1))/N;
      ZA:=Z1+((Z2-Z1)*(i-1)+(Z3-Z2)*(j-1))/N;
      D:=sqrt(sqr(XA-CX)+sqr(YA-CY)+sqr(ZA-CZ));
      XA:=CX+(XA-CX)*Rayon/D;
      YA:=CY+(YA-CY)*Rayon/D;
      ZA:=CZ+(ZA-CZ)*Rayon/D;
      XB:=X1+((X2-X1)*i+(X3-X2)*(j-1))/N;
      YB:=Y1+((Y2-Y1)*i+(Y3-Y2)*(j-1))/N;
      ZB:=Z1+((Z2-Z1)*i+(Z3-Z2)*(j-1))/N;
      D:=sqrt(sqr(XB-CX)+sqr(YB-CY)+sqr(ZB-CZ));
      XB:=CX+(XB-CX)*Rayon/D;
      YB:=CY+(YB-CY)*Rayon/D;
      ZB:=CZ+(ZB-CZ)*Rayon/D;
      XC:=X1+((X2-X1)*i+(X3-X2)*j)/N;
      YC:=Y1+((Y2-Y1)*i+(Y3-Y2)*j)/N;
      ZC:=Z1+((Z2-Z1)*i+(Z3-Z2)*j)/N;
      D:=sqrt(sqr(XC-CX)+sqr(YC-CY)+sqr(ZC-CZ));
      XC:=CX+(XC-CX)*Rayon/D;
      YC:=CY+(YC-CY)*Rayon/D;
      ZC:=CZ+(ZC-CZ)*Rayon/D;
      with Boule.addFace do begin
        AddVertex(XA,YA,ZA,(XA-CX)/Rayon,(YA-CY)/Rayon, (ZA-CZ)/Rayon);
        AddVertex(XB,YB,ZB,(XB-CX)/Rayon,(YB-CY)/Rayon , (ZB-CZ)/Rayon);
        AddVertex(XC,YC,ZC,(XC-CX)/Rayon,(YC-CY)/Rayon , (ZC-CZ)/Rayon);
      end;
      if I<N then begin
        XA:=X1+((X2-X1)*(i+1)+(X3-X2)*j)/N;
        YA:=Y1+((Y2-Y1)*(i+1)+(Y3-Y2)*j)/N;
        ZA:=Z1+((Z2-Z1)*(i+1)+(Z3-Z2)*j)/N;
        D:=sqrt(sqr(XA-CX)+sqr(YA-CY)+sqr(ZA-CZ));
        XA:=CX+(XA-CX)*Rayon/D;
        YA:=CY+(YA-CY)*Rayon/D;
        ZA:=CZ+(ZA-CZ)*Rayon/D;
        with Boule.addFace do begin
          AddVertex(XB,YB,ZB,(XB-CX)/Rayon,(YB-CY)/Rayon , (ZB-CZ)/Rayon);
          AddVertex(XA,YA,ZA,(XA-CX)/Rayon,(YA-CY)/Rayon, (ZA-CZ)/Rayon);
          AddVertex(XC,YC,ZC,(XC-CX)/Rayon,(YC-CY)/Rayon , (ZC-CZ)/Rayon);
        end;
      end;
    end;
  end;

begin
  N:=round(sqrt(Nb_Facette/20));
  if N<1 then N:=1;

  Boule:=Tentity.create;           {create a new, empty entity}
  Boule.SetColor(Red,Green,Blue);      {assign an initial color, Red, Green, blue}


  Un_Triangle(CX, CY, CZ+Rayon,
              CX+Rayon*S63, CY, CZ+Rayon*C63,
              CX+Rayon*S63*C72, CY+Rayon*S63*S72, CZ+Rayon*C63);

  Un_Triangle(CX, CY, CZ+Rayon,
              CX+Rayon*S63*C72, CY+Rayon*S63*S72, CZ+Rayon*C63,
              CX+Rayon*S63*C144, CY+Rayon*S63*S144, CZ+Rayon*C63);

  Un_Triangle(CX, CY, CZ+Rayon,
              CX+Rayon*S63*C144, CY+Rayon*S63*S144, CZ+Rayon*C63,
              CX+Rayon*S63*C144, CY-Rayon*S63*S144, CZ+Rayon*C63);

  Un_Triangle(CX, CY, CZ+Rayon,
              CX+Rayon*S63*C144, CY-Rayon*S63*S144, CZ+Rayon*C63,
              CX+Rayon*S63*C72, CY-Rayon*S63*S72, CZ+Rayon*C63);

  Un_Triangle(CX, CY, CZ+Rayon,
              CX+Rayon*S63*C72, CY-Rayon*S63*S72, CZ+Rayon*C63,
              CX+Rayon*S63, CY, CZ+Rayon*C63);

  Un_Triangle(CX+Rayon*S63, CY, CZ+Rayon*C63,
              CX-Rayon*S63*C144, CY+Rayon*S63*S144, CZ-Rayon*C63,
              CX+Rayon*S63*C72, CY+Rayon*S63*S72, CZ+Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C72, CY+Rayon*S63*S72, CZ+Rayon*C63,
              CX-Rayon*S63*C72, CY+Rayon*S63*S72, CZ-Rayon*C63,
              CX+Rayon*S63*C144, CY+Rayon*S63*S144, CZ+Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C144, CY+Rayon*S63*S144, CZ+Rayon*C63,
              CX-Rayon*S63, CY, CZ-Rayon*C63,
              CX+Rayon*S63*C144, CY-Rayon*S63*S144, CZ+Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C144, CY-Rayon*S63*S144, CZ+Rayon*C63,
              CX-Rayon*S63*C72, CY-Rayon*S63*S72, CZ-Rayon*C63,
              CX+Rayon*S63*C72, CY-Rayon*S63*S72, CZ+Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C72, CY-Rayon*S63*S72, CZ+Rayon*C63,
              CX-Rayon*S63*C144, CY-Rayon*S63*S144, CZ-Rayon*C63,
              CX+Rayon*S63, CY, CZ+Rayon*C63);
//
  Un_Triangle(CX+Rayon*S63*C72, CY+Rayon*S63*S72, CZ+Rayon*C63,
              CX-Rayon*S63*C144, CY+Rayon*S63*S144, CZ-Rayon*C63,
              CX-Rayon*S63*C72, CY+Rayon*S63*S72, CZ-Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C144, CY+Rayon*S63*S144, CZ+Rayon*C63,
              CX-Rayon*S63*C72, CY+Rayon*S63*S72, CZ-Rayon*C63,
              CX-Rayon*S63, CY, CZ-Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C144, CY-Rayon*S63*S144, CZ+Rayon*C63,
              CX-Rayon*S63, CY, CZ-Rayon*C63,
              CX-Rayon*S63*C72, CY-Rayon*S63*S72, CZ-Rayon*C63);

  Un_Triangle(CX+Rayon*S63*C72, CY-Rayon*S63*S72, CZ+Rayon*C63,
              CX-Rayon*S63*C72, CY-Rayon*S63*S72, CZ-Rayon*C63,
              CX-Rayon*S63*C144, CY-Rayon*S63*S144, CZ-Rayon*C63);

  Un_Triangle(CX+Rayon*S63, CY, CZ+Rayon*C63,
              CX-Rayon*S63*C144, CY-Rayon*S63*S144, CZ-Rayon*C63,
              CX-Rayon*S63*C144, CY+Rayon*S63*S144, CZ-Rayon*C63);

  Un_Triangle(CX-Rayon*S63, CY, CZ-Rayon*C63,
              CX, CY, CZ-Rayon,
              CX-Rayon*S63*C72, CY-Rayon*S63*S72, CZ-Rayon*C63);

  Un_Triangle(CX-Rayon*S63*C72, CY-Rayon*S63*S72, CZ-Rayon*C63,
              CX, CY, CZ-Rayon,
              CX-Rayon*S63*C144, CY-Rayon*S63*S144, CZ-Rayon*C63);

  Un_Triangle(CX-Rayon*S63*C144, CY-Rayon*S63*S144, CZ-Rayon*C63,
              CX, CY, CZ-Rayon,
              CX-Rayon*S63*C144, CY+Rayon*S63*S144, CZ-Rayon*C63);

  Un_Triangle(CX-Rayon*S63*C144, CY+Rayon*S63*S144, CZ-Rayon*C63,
              CX, CY, CZ-Rayon,
              CX-Rayon*S63*C72, CY+Rayon*S63*S72, CZ-Rayon*C63);

  Un_Triangle(CX-Rayon*S63*C72, CY+Rayon*S63*S72, CZ-Rayon*C63,
              CX, CY, CZ-Rayon,
              CX-Rayon*S63, CY, CZ-Rayon*C63);

  N:=Boule.Points.Count;

  Entities.add(Boule);
end;

end.
 