{$N-}
unit Pt_topo;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, FicheTpo, Dialogs, Simple, Recherch, SysUtils;

const
  Pt_Depart = 0;
  Pt_Arrivee = 1;
  Reduit = 0;
  Complique = 2;

type
  TPoint_Topo = class(TForm)
    Bevel1: TBevel;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Indice: TGroupBox;
    Ind: TEdit;
    Button1: TButton;
    Button2: TButton;
    Nom: TComboBox;
    Timer1: TTimer;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NomChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure IndKeyPress(Sender: TObject; var Key: Char);
    procedure IndChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Etat : smallInt;
    Le_Massif : TMassif;
    Attente : string;
    Modifie : boolean;
    procedure Definit_Etat(L_etat : smallInt; Ensemble : TMassif; Nettoie :boolean);
    procedure Charger(Le_Point : TPointTopo);
    procedure Decharge(var Le_Point : TPointTopo);
    procedure Retour;
  end;

var
  Point_Topo: TPoint_Topo;

implementation

{$R *.DFM}
uses Unit2;

procedure TPoint_Topo.Definit_Etat(L_etat : smallInt;Ensemble : TMassif; Nettoie :boolean);
begin
  Le_Massif:=Ensemble;
  if Nettoie then  begin
    Nom.Text:='';
    Ind.Text:='';
    Radiogroup1.ItemIndex:=1;
    Nom.Enabled:=true;
    Ind.Enabled:=true;
    Button1.Enabled:=true;
    Button2.Enabled:=true;
  end;
  Etat:=(L_Etat mod 2);
  case Etat of
    Pt_Depart : Caption:='Point de dpart';
    Pt_Arrivee: Caption:='Point d''arrive';
  end;
  case (L_Etat div 2)*2 of
    Reduit : begin
      Button4.Visible:=false;
    end;
    Complique : begin
      Button4.Visible:=true;
    end;
  end;
  Retour;
end;

procedure TPoint_Topo.RadioGroup1Click(Sender: TObject);
begin
  Modifie:=true;
  if RadioGroup1.ItemIndex=1 then begin
    Nom.Enabled:=true;
    Ind.Enabled:=true;
    Button1.Enabled:=true;
    Button2.Enabled:=true;
  end
  else begin
    Nom.Enabled:=false;
    Ind.Enabled:=false;
    Button1.Enabled:=false;
    Button2.Enabled:=false;
  end;
end;

procedure TPoint_Topo.Button2Click(Sender: TObject);
var
  Le_Nom, S : String;
  L_Indice, L0, I : smallInt;
  Un_Point : TPointTopo;
  Continuer : boolean;
  Un_Noeud : TNoeud;
begin
  Le_Nom:=UpperCase(Nom.Text);
  L0:=0;
  repeat
    L_Indice:=Le_Massif.Nouveau_Point(Le_Nom,L0);
    Continuer:=false;
    Un_Point:=MultPageDlg.Premier;
    if not Un_Point.Terminus then begin
      Un_Point.Nom.UpString(S);
      if (S=Le_Nom) and (L_Indice=Un_Point.Indice) then Continuer:=true;
    end;
    for I:=0 to MultPageDlg.List_Noeud.Count-1 do begin
      Un_Noeud:=MultPageDlg.List_Noeud[I];
      Un_Point:=Un_Noeud.Precedent;
      if not Un_Point.Terminus then begin
        Un_Point.Nom.UpString(S);
        if (S=Le_Nom) and (L_Indice=Un_Point.Indice) then Continuer:=true;
      end;
      Un_Point:=Un_Noeud.Suivant;
      if not Un_Point.Terminus then begin
        Un_Point.Nom.UpString(S);
        if (S=Le_Nom) and (L_Indice=Un_Point.Indice) then Continuer:=true;
      end;
    end;
    if MultPageDlg.DernierExiste then begin
      Un_Point:=MultPageDlg.Dernier;
      if not Un_Point.Terminus then begin
        Un_Point.Nom.UpString(S);
        if (S=Le_Nom) and (L_Indice=Un_Point.Indice) then Continuer:=true;
      end;
    end;
    L0:=L_Indice;
  until not Continuer;
  Ind.Text:=IntTostr(L_Indice);
end;

procedure TPoint_Topo.OKBtnClick(Sender: TObject);
begin
  if RadioGroup1.ItemIndex=1 then try
    if StrToInt(Ind.Text)<=0 then Abort;
  except
    MessageDlg('L''indice doit tre numrique et positif.',mtWarning,[mbOk],0);
    ModalResult:=mrNone;
    Ind.SetFocus;
  end;
end;

procedure TPoint_Topo.Charger(Le_Point : TPointTopo);
var
  S : string;
begin
  if Le_Point.Terminus then RadioGroup1.ItemIndex:=0
  else begin
    RadioGroup1.ItemIndex:=1;
    Le_Point.Nom.lit(S);
    Nom.Text:=S;
    Ind.Text:=IntToStr(Le_Point.Indice);
  end;
end;


procedure TPoint_Topo.Decharge(var Le_Point : TPointTopo);
var
  S : string;
begin
  Le_Point.Terminus:=RadioGroup1.ItemIndex=0;
  if not Le_Point.Terminus then begin
    S:=Nom.Text;
    Le_Point.Nom.Ecrit(S);
    Le_Point.Indice:=StrToInt(Ind.Text);
  end;
end;

procedure TPoint_Topo.FormCreate(Sender: TObject);
begin
  PixelsPerInch:=Screen.PixelsPerInch;
end;

procedure TPoint_Topo.Retour;
var
  Intermediaire : TList;
  I, J, K : SmallInt;
  Une_Fiche, Source : TFiche;
  Un_Point, Deux_Point : TPointTopo;
  Ptt_Text : String;
  Inconnu : boolean;
  Topog : TEco;
  Une_Galerie : TGalerie;
  Un_Noeud : TNoeud;
begin
  Intermediaire:=TList.Create;
  Source:=TFiche.Create;
  Source.Date:=MultPageDlg.Date.Text;
  for I:=1 to MultPageDlg.Topographe.Lines.Count do begin
    Ptt_Text:=MultPageDlg.Topographe.Lines[I-1];
    Topog:=TEco.Create; Topog.Ecrit(Ptt_Text);
    Source.Topographes.Add(Topog);
  end;
  for I:=MultPageDlg.List_Noeud.Count-1 downto 0 do begin
    Un_Noeud:=MultPageDlg.List_Noeud[I];
    Inconnu:=true;
    Un_Point:=Un_Noeud.Precedent;
    if not Un_Point.Terminus then begin
      for J:=0 to Intermediaire.Count-1 do begin
        Deux_Point:=Intermediaire[J];
        if Un_Point.Identique(Deux_Point) then Inconnu:=false;
      end;
      if Inconnu then Intermediaire.Add(Un_Point);
    end;
    Inconnu:=true;
    Un_Point:=Un_Noeud.Suivant;
    if not Un_Point.Terminus then begin
      for J:=0 to Intermediaire.Count-1 do begin
        Deux_Point:=Intermediaire[J];
        if Un_Point.Identique(Deux_Point) then Inconnu:=false;
      end;
      if Inconnu then Intermediaire.Add(Un_Point);
    end;
  end;
  Inconnu:=true;
  Un_Point:=MultPageDlg.Premier;
  if not Un_Point.Terminus and (Un_Point.Indice<>0) then begin
    for J:=0 to Intermediaire.Count-1 do begin
      Deux_Point:=Intermediaire[J];
      if Un_Point.Identique(Deux_Point) then Inconnu:=false;
    end;
    if Inconnu then Intermediaire.Add(Un_Point);
  end;
  if MultPageDlg.DernierExiste then begin
    Inconnu:=true;
    Un_Point:=MultPageDlg.Dernier;
    if not Un_Point.Terminus then begin
      for J:=0 to Intermediaire.Count-1 do begin
        Deux_Point:=Intermediaire[J];
        if Un_Point.Identique(Deux_Point) then Inconnu:=false;
      end;
      if Inconnu then Intermediaire.Add(Un_Point);
    end;
  end;
  for I:=Le_Massif.Liste_Fiche.Count-1 downto 0 do begin
    Une_Fiche:=Le_Massif.Liste_Fiche[I];
    if Source.Meme_Equipe(Une_Fiche) then begin
      Inconnu:=true;
      for K:=Une_Fiche.liste_Galerie.Count-1 downto 0 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[K];
        Un_Point:=Une_Galerie.Depart;
        if not Un_Point.Terminus then begin
          for J:=0 to Intermediaire.Count-1 do begin
            Deux_Point:=Intermediaire[J];
            if Un_Point.Identique(Deux_Point) then Inconnu:=false;
          end;
          if Inconnu then Intermediaire.Add(Un_Point);
        end;
        Inconnu:=true;
        Un_Point:=Une_Galerie.Arrivee;
        if not Un_Point.Terminus then begin
          for J:=0 to Intermediaire.Count-1 do begin
            Deux_Point:=Intermediaire[J];
            if Un_Point.Identique(Deux_Point) then Inconnu:=false;
          end;
          if Inconnu then Intermediaire.Add(Un_Point);
        end;
      end;
    end;
  end;
  Nom.Items.Clear;
  for I:=0 to Intermediaire.Count-1 do begin
    Un_Point:=Intermediaire[I];
    Un_Point.Nom.Lit(Ptt_Text);
    Ptt_Text:=Ptt_Text+'('+IntTostr(Un_Point.Indice)+')';
    Nom.Items.Add(Ptt_Text);
  end;
  Source.Free;
end;

procedure TPoint_Topo.Button1Click(Sender: TObject);
var
  Quelle_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Position : integer;
  Grand_Nom, Ptt_Text : string;
  Choix : smallInt;
begin
  Grand_Nom:=UpperCase(Nom.Text);
  Position:=0;
  if Recherche_Simple(MultPageDlg.Le_Massif.Liste_Fiche,MultPageDlg.Le_Massif,Quelle_Fiche,Position,Grand_Nom,'','','','')
  then begin
    if Position=-1 then begin
      ShowMessage('Il faut obligatoirement passer par la visualisation avec cette mthode');
{      Position:=-1; }
    end
    else begin
      Une_Galerie:=Quelle_Fiche.Liste_Galerie[Position];
      Choix:=0;
      if not Une_Galerie.Depart.Terminus then Choix:=1;
      if not Une_Galerie.Arrivee.Terminus then Choix:=Choix+1;
      case Choix of
        0 : MessageDlg('La galerie slectionne n''a que des terminus',mtWarning,[mbOk],0);
        1 : if not Une_Galerie.Depart.Terminus then begin
          Une_Galerie.Depart.Nom.Lit(Ptt_Text);
          Nom.Text:=Ptt_Text;
          Ind.Text:=IntToStr(Une_Galerie.Depart.Indice);
        end
        else begin
          Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
          Nom.Text:=Ptt_Text;
          Ind.Text:=IntToStr(Une_Galerie.Arrivee.Indice);
        end;
        2 : begin
          Choix:=0;
          Une_Galerie.Depart.Nom.UpString(Ptt_Text);
          if Ptt_text=Grand_Nom then Choix:=1;
          Une_Galerie.Arrivee.Nom.UpString(Ptt_Text);
          if Ptt_text=Grand_Nom then Choix:=Choix+1;
          if Choix=1 then begin
            if (Ptt_Text=Grand_Nom) then begin
              Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
              Nom.Text:=Ptt_Text;
              Ind.Text:=IntToStr(Une_Galerie.Arrivee.Indice);
            end
            else begin
              Une_Galerie.Depart.Nom.Lit(Ptt_Text);
              Nom.Text:=Ptt_Text;
              Ind.Text:=IntToStr(Une_Galerie.Depart.Indice);
            end;
          end
          else begin
            Une_Galerie.Depart.Nom.Lit(Ptt_Text);
            Ptt_Text:=Ptt_Text+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
            Une_Galerie.Arrivee.Nom.Lit(Grand_Nom);
            Grand_Nom:=Grand_Nom+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
            if MessageDlg('Deux points possibles : '+Grand_Nom+' (Oui) et '+Ptt_Text+' (Ok)',
               mtConfirmation,[mbOk,mbYes],0)=mrOk then begin
              Une_Galerie.Depart.Nom.Lit(Ptt_Text);
              Nom.Text:=Ptt_Text;
              Ind.Text:=IntToStr(Une_Galerie.Depart.Indice);
            end
            else begin
              Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
              Nom.Text:=Ptt_Text;
              Ind.Text:=IntToStr(Une_Galerie.Arrivee.Indice);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TPoint_Topo.NomChange(Sender: TObject);
var
  S : string;
  I : smallInt;
begin
  Modifie:=true;
  if (length(Nom.Text)>0) and (Nom.Text[length(Nom.Text)]=')') then begin
    S:='';
    I:=length(Nom.Text)-1;
    while (I>0) and (Nom.Text[I]<>'(') do begin
      S:=Nom.Text[I]+S;
      dec(I);
    end;
    if I<>0 then begin
      Ind.Text:=S;
      Attente:=copy(Nom.Text,1,I-1);
      Timer1.Enabled:=true;
    end;
  end;
end;

procedure TPoint_Topo.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  Nom.Text:=Attente;
  Nom.SelStart :=length(Attente); // renvoie du curseur  la fin
end;

procedure TPoint_Topo.FormActivate(Sender: TObject);
begin
  if Nom.Enabled then Nom.SetFocus;
  Modifie:=false;
end;

procedure TPoint_Topo.IndKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TPoint_Topo.IndChange(Sender: TObject);
begin
  Modifie:=true;
end;

end.
