{$N-}
unit Simple;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Grids, Fichetpo, Visuel, UAjuste;

const

  RVisee = 1;
  RPoint = 2;
  RGalerie = 3;
  RFiche = 4;


type
  TRechSimp = class(TForm)
    GroupBox1: TGroupBox;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
    La_Quelle, Quel_Lieu, Nature : SmallInt;
    Ligne, Colonne : integer;
    Contenu : TList;
    Source : TMassif;
    Point_Propose : string;
    procedure Preparation(La_Nature : SmallInt; Le_Contenu : TList; La_Source : TMassif; Ancien_Point : string);
  end;

var
  RechSimp: TRechSimp;

implementation

{$R *.DFM}

procedure TRechSimp.BitBtn1Click(Sender: TObject);
begin
  if StringGrid1.Row=0 then La_Quelle:=0
                       else La_Quelle:=StringGrid1.Row-1;
  Quel_Lieu:=-1;
end;

procedure TRechSimp.FormResize(Sender: TObject);
begin
  Button1.Top:=ClientHeight-33;
  Button2.Top:=ClientHeight-33;
  Button3.Top:=ClientHeight-33;
  GroupBox1.Height:=ClientHeight-40;
  StringGrid1.Height:=ClientHeight-64;
  StringGrid1.Width:=ClientWidth-19;
end;

procedure TRechSimp.Preparation(La_Nature : SmallInt; Le_Contenu : TList; La_Source : TMassif; Ancien_Point : string);
var
  I, J : integer;
  Ptt_Text, S : string;
  SRect: TGridRect;
  Largeur : array[0..5] of integer;
begin
  Point_Propose:=Ancien_Point;
  Nature:=La_Nature;
  Contenu:=Le_Contenu;
  Source:=La_Source;
  StringGrid1.RowCount:=Contenu.Count+1;
  case Nature of
    RVisee, RGalerie, RFiche : with StringGrid1 do begin
      if (Nature=RVisee) or (Nature=RGalerie) then begin
        Button1.Visible:=true;
        Button2.Enabled:=false;
        Button1.Hint:='Visualise la fiche choisie';
        Button2.Hint:='';
      end
      else begin
        Button1.Visible:=true;
        Button2.Enabled:=true;
        Button2.Hint:='Utilise la fiche choisie';
        Button1.Hint:='Visualise les fiches';
      end;
      ColCount:=6;
      Cells[0,0]:='Systme'; Largeur[0]:=Canvas.TextWidth('Systme');
      Cells[1,0]:='Cavit'; Largeur[1]:=Canvas.TextWidth('Cavit');
      Cells[2,0]:='Rseau'; Largeur[2]:=Canvas.TextWidth('Rseau');
      Cells[3,0]:='Lieu'; Largeur[3]:=Canvas.TextWidth('Lieu');
      Cells[4,0]:='Date'; Largeur[4]:=Canvas.TextWidth('Date');
      Cells[5,0]:='Topographes'; Largeur[5]:=Canvas.TextWidth('Topographes');
      for I:=0 to Contenu.Count-1 do with TFiche(Contenu[I]) do begin
        Systeme.Lit(Ptt_Text); Cells[0,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[0] then Largeur[0]:=Canvas.TextWidth(Ptt_Text);
        Cavite.Lit(Ptt_Text);  Cells[1,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[1] then Largeur[1]:=Canvas.TextWidth(Ptt_Text);
        Reseau.Lit(Ptt_Text);  Cells[2,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[2] then Largeur[2]:=Canvas.TextWidth(Ptt_Text);
        Lieu.Lit(Ptt_Text);    Cells[3,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[3] then Largeur[3]:=Canvas.TextWidth(Ptt_Text);
        Ptt_Text:=Date;        Cells[4,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[4] then Largeur[4]:=Canvas.TextWidth(Ptt_Text);
        Ptt_Text:='';
        for J:=0 to Topographes.Count-1 do with TEco(Topographes[J]) do begin
          Lit(S);
          Ptt_Text:=Ptt_Text+S+' ';
        end;
        Cells[5,I+1]:=Ptt_Text;
        if Canvas.TextWidth(Ptt_Text)>Largeur[5] then Largeur[5]:=Canvas.TextWidth(Ptt_Text);
      end;
      for J:=0 to 5 do ColWidths[J]:=Largeur[J]+10;
    end;
    RPoint : with StringGrid1 do begin
      Button1.Visible:=false;
      Button2.Enabled:=true;
      Button2.Hint:='Utilise la galerie allant au point';
      ColCount:=2;
      Cells[0,0]:='Point'; Cells[1,0]:='Indice';
      for I:=0 to Contenu.Count-1 do with TPointTopo(Contenu[I]) do begin
        if Terminus then Ptt_Text:='Terminus'
                    else Nom.Lit(Ptt_Text);
        Cells[0,I+1]:=Ptt_Text;
        if Ptt_Text='Terminus' then Ptt_Text:=''
                               else Ptt_Text:=IntToStr(Indice);
        Cells[1,I+1]:=Ptt_Text;
      end;
    end;
  end;
  if Contenu.Count=0 then begin
    Button1.Enabled:=false;
    Button2.Enabled:=false;
  end;
  SRect.Top := 0;
  SRect.Left := 0;
  SRect.Bottom := 0;
  SRect.Right := 0;
  StringGrid1.Selection := SRect;
end;

procedure TRechSimp.StringGrid1DblClick(Sender: TObject);
var
  Liste_Intermediaire : TList;
begin
  if Ligne=0 then Ajuste(StringGrid1,Colonne);
  if StringGrid1.Row>0 then begin
    if Button2.Enabled then begin
      La_Quelle:=StringGrid1.Row-1;
      Quel_Lieu:=-1;
      ModalResult:=mrOk;
    end
    else begin
      if not Source.Finition then Source.Detailler;
      Liste_Intermediaire:=TList.Create;
      Liste_Intermediaire.Add(Contenu[StringGrid1.Row-1]);
      if not Apercu.Remplissage(Liste_Intermediaire) then
                          MessageDlg('Pas de fiches calcules.',mtWarning,[mbOk],0)
      else begin
        Apercu.Coupe:=(Nature=RGalerie);
        Apercu.Dessine;
        if Apercu.ShowModal=mrOk then begin
          La_Quelle:=Apercu.Numero_Fiche+StringGrid1.Selection.Top-1;
          Quel_Lieu:=Apercu.Numero_Galerie;
          ModalResult:=mrOk;
        end;
      end;
      Liste_Intermediaire.Free;
    end;
  end;
end;

procedure TRechSimp.BitBtn2Click(Sender: TObject);
var
  Liste_Intermediaire : TList;
  I : integer;
  SRect: TGridRect;
begin
  if not Source.Finition then Source.Detailler;
  SRect:=StringGrid1.Selection;
  if SRect.Bottom=0 then SRect.Bottom:=Contenu.Count;
  if SRect.Top=0 then SRect.Top:=1;
  StringGrid1.Selection:=SRect;
  Liste_Intermediaire:=TList.Create;
  for I:=StringGrid1.Selection.Top to StringGrid1.Selection.Bottom do Liste_Intermediaire.Add(Contenu[I-1]);
  if not Apercu.Remplissage(Liste_Intermediaire) then
                      MessageDlg('Pas de fiches calcules.',mtWarning,[mbOk],0)
  else begin
    Apercu.Coupe:=(Nature=RGalerie);
    Apercu.Dessine;
    if Apercu.ShowModal=mrOk then begin
      La_Quelle:=Apercu.Numero_Fiche+StringGrid1.Selection.Top-1;
      Quel_Lieu:=Apercu.Numero_Galerie;
      ModalResult:=mrOk;
    end;
  end;
  Liste_Intermediaire.Free;
end;

procedure TRechSimp.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  StringGrid1.MouseToCell(X,Y,Colonne, Ligne);
end;

end.
