unit UExpert;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TExpert = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Nom_Depart: TEdit;
    Label2: TLabel;
    Indice_depart: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Nom_Arrivee: TEdit;
    Indice_Arrivee: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    GroupBox3: TGroupBox;
    Nouvelle: TCheckBox;
    Label5: TLabel;
    Horizontal: TEdit;
    Label6: TLabel;
    Vertical: TEdit;
    Gauche: TCheckBox;
    Lateral: TCheckBox;
    procedure Indice_departKeyPress(Sender: TObject; var Key: Char);
    procedure Button5Click(Sender: TObject);
    procedure NouvelleClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure A_Fond(profond : boolean);
    procedure Cherche(var Le_Nom, L_indice : string);
  end;

var
  Expert: TExpert;

implementation

uses Unit1, Calcul, FicheTpo, Affiche, Recherch;

{$R *.DFM}

procedure TExpert.Indice_departKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TExpert.Button5Click(Sender: TObject);
var
  Debut, Un_Point : TPointTopo;
  Le_Point : TPointCoupe;
  N, I, J, K, Precedente_Fiche, Precedente_Galerie, Raproche_Fiche,
  Raproche_Galerie, Erreur : integer;
  Les_Points : TList;
  S : string;
  Jonction, Precedent, Direct, Changement : boolean;
  Distance_Min : double;

begin
  Precedent:=false;
  if not Nouvelle.Checked then with Form1.Massif do begin
    with (Form1.ActiveMDIChild as TAfficheur) do begin
      if Clicke then begin
        with TFiche(Form1.Massif.Liste_Courante[Click_Fiche]) do begin
          with TGalerie(Liste_Galerie[Click_Galerie]) do if En_Coupe then begin
            if Accrochage_Debut then begin
              if not Arrivee.Terminus then begin
                Arrivee.Nom.Lit(S);
                if (Nom_Depart.Text=S) and (Indice_Depart.Text=IntToStr(Arrivee.Indice)) then begin
                  Precedent:=true; Precedente_Fiche:=Click_Fiche; Precedente_Galerie:=Click_Galerie;
                end;
              end;
            end
            else begin
              if not Depart.Terminus then begin
                Depart.Nom.Lit(S);
                if (Nom_Depart.Text=S) and (Indice_Depart.Text=IntToStr(Depart.Indice)) then begin
                  Precedent:=true; Precedente_Fiche:=Click_Fiche; Precedente_Galerie:=Click_Galerie;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
    if not Precedent then begin
      for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
        for J:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[J]) do if (not Precedent) and En_Coupe then begin
          if Accrochage_Debut then begin
            if not Arrivee.Terminus then begin
              Arrivee.Nom.Lit(S);
              if (Nom_Depart.Text=S) and (Indice_Depart.Text=IntToStr(Arrivee.Indice)) then begin
                Precedent:=true; Precedente_Fiche:=I; Precedente_Galerie:=J;
              end;
            end;
          end
          else begin
            if not Depart.Terminus then begin
              Depart.Nom.Lit(S);
              if (Nom_Depart.Text=S) and (Indice_Depart.Text=IntToStr(Depart.Indice)) then begin
                Precedent:=true; Precedente_Fiche:=I; Precedente_Galerie:=J;
              end;
            end;
          end;
        end;
      end;
    end;
    if not Precedent then begin
      ShowMessage('Impossible de raccrocher le dpart  une branche connue');
      ModalResult:=mrNone;
    end;
  end;
  if ModalResult=mrOk then begin
    try
      N:=StrToInt(Indice_Arrivee.Text);
      if N<=0 then Abort;
    except
      MessageDlg('L''indice doit tre numrique et positif.',mtWarning,[mbOk],0);
      Indice_Arrivee.SetFocus;
      ModalResult:=mrNone;
      Abort;
    end;
    Debut:=TPointTopo.Create;
    Debut.Indice:=N; Debut.Nom.Ecrit(Nom_Arrivee.Text);
    Les_Points:=TList.Create;
    Les_Points.Add(Debut);
    with TCalculateur.Create do begin
      Initialise(Form1.Massif.Liste_Courante,Les_Points,moExpert);
      if Atteint(Silencieux) then begin
        GetMem(Vue,sizeOf(boolean)*Noeud.Count);
        GetMem(Distance,sizeOf(double)*Noeud.Count);
        GetMem(Numero,sizeOf(longint)*Noeud.Count);
        Approxime;
        Jonction:=false;
        for I:=0 to Noeud.Count-1 do begin
          Un_Point:=Noeud[I];
          Un_Point.Nom.UpString(S);
          if Vue^[I+1] and (IntToStr(Un_Point.Indice)=Indice_Depart.Text) and (S=UpperCase(Nom_Depart.Text)) then begin
            Jonction:=true;
            N:=I;
          end;
        end;
        if not Jonction then begin
          ShowMessage('Impossible de rejoindre les deux points. Vrifiez le point de dpart.');
          ModalResult:=mrNone;
        end
        else with Form1.Massif do begin
          if Form1.LaCoupe<>nil then with Form1.LaCoupe do begin
            if Clicke then begin
              Status:=Contenu.Met_En_Relief(false,Click_Fiche,Click_Galerie,Click_Visee,Etat);
              if Active then Form1.StatusBar.Panels[1].Text:=Status;
            end;
            Clicke:=false;
          end;
          TPointTopo(Noeud[0]).Nom.Lit(S);
          repeat
            Changement:=false;
            Distance_Min:=Distance^[N+1];
            Un_Point:=Noeud[N];
            for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
              for J:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[J]) do if not En_Coupe then begin
                if Depart.Identique(Un_Point) then begin
                  for K:=0 to Noeud.Count-1 do begin
                    if TPointTopo(Noeud[K]).Identique(Arrivee) and
                      (Distance_Min>Distance^[K+1]) then begin
                      Distance_Min:=Distance^[K+1];
                      N:=K;
                      Raproche_Fiche:=I; Raproche_Galerie:=J;
                      Direct:=true;
                      Changement:=true;
                    end;
                  end;
                end;
                if Arrivee.Identique(Un_Point) then begin
                  for K:=0 to Noeud.Count-1 do begin
                    if TPointTopo(Noeud[K]).Identique(Depart) and
                     (Distance_Min>Distance^[K+1]) then begin
                      Distance_Min:=Distance^[K+1];
                      N:=K;
                      Raproche_Fiche:=I; Raproche_Galerie:=J;
                      Direct:=false;
                      Changement:=true;
                    end;
                  end;
                end;
              end;
            end;

            if Changement then begin
            if Precedent then with TGalerie(TFiche(Form1.Massif.Liste_Courante[Precedente_Fiche]).Liste_Galerie[Precedente_Galerie]) do begin
              inc(Nb_Suite);
              Ordre_Suite[Nb_Suite]:=TFiche(Form1.Massif.Liste_Courante[Raproche_Fiche]).Ordre;
              Galerie_Suite[Nb_Suite]:=Raproche_Galerie;
            end
            else with TGalerie(TFiche(Form1.Massif.Liste_Courante[Raproche_Fiche]).Liste_Galerie[Raproche_Galerie]) do begin
              Precedent:=true;
              Le_Point:=TPointCoupe.Create;
              Le_Point.Decal_Hori:=StrToFloatE(Horizontal.Text);
              Le_Point.Decal_Z:=StrToFloatE(Vertical.Text);
              Le_Point.Nom.Create;
              if Direct then begin
                Le_Point.Nom.Duplique(Depart.Nom);
                Le_Point.Indice:=Depart.Indice;
              end
              else begin
                Le_Point.Nom.Duplique(Arrivee.Nom);
                Le_Point.Indice:=Arrivee.Indice;
              end;
              Le_Point.Ordre_Suite:=TFiche(Form1.Massif.Liste_Courante[Raproche_Fiche]).Ordre;
              Le_Point.Galerie_Suite:=Raproche_Galerie;
              Form1.Massif.Germe_Coupe.Add(Le_Point);
            end;
            Precedente_Fiche:=Raproche_Fiche; Precedente_Galerie:=Raproche_Galerie;
            with TGalerie(TFiche(Form1.Massif.Liste_Courante[Precedente_Fiche]).Liste_Galerie[Precedente_Galerie]) do begin
              Nb_Suite:=0;
              Accrochage_Debut:=direct;
              Gauche_Droite:=Gauche.Checked;
              En_Coupe:=true;
              if Lateral.Checked then begin
                for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
                  for J:=0 to Liste_Galerie.Count-1 do if not TGalerie(Liste_Galerie[J]).En_Coupe then begin
                    if direct and Arrivee.Identique(TGalerie(Liste_Galerie[J]).Depart)
                              and TGalerie(Liste_Galerie[J]).Arrivee.Terminus then begin
                      inc(Nb_Suite);
                      Ordre_Suite[Nb_Suite]:=Ordre;
                      Galerie_Suite[Nb_Suite]:=J;
                      TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                      TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                      TGalerie(Liste_Galerie[J]).Accrochage_Debut:=true;
                      TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                    end;
                    if direct and Arrivee.Identique(TGalerie(Liste_Galerie[J]).Arrivee)
                              and TGalerie(Liste_Galerie[J]).Depart.Terminus then begin
                      inc(Nb_Suite);
                      Ordre_Suite[Nb_Suite]:=Ordre;
                      Galerie_Suite[Nb_Suite]:=J;
                      TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                      TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                      TGalerie(Liste_Galerie[J]).Accrochage_Debut:=false;
                      TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                    end;
                    if not direct and Depart.Identique(TGalerie(Liste_Galerie[J]).Depart)
                              and TGalerie(Liste_Galerie[J]).Arrivee.Terminus then begin
                      inc(Nb_Suite);
                      Ordre_Suite[Nb_Suite]:=Ordre;
                      Galerie_Suite[Nb_Suite]:=J;
                      TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                      TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                      TGalerie(Liste_Galerie[J]).Accrochage_Debut:=true;
                      TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                    end;
                    if not direct and Depart.Identique(TGalerie(Liste_Galerie[J]).Arrivee)
                              and TGalerie(Liste_Galerie[J]).Depart.Terminus then begin
                      inc(Nb_Suite);
                      Ordre_Suite[Nb_Suite]:=Ordre;
                      Galerie_Suite[Nb_Suite]:=J;
                      TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                      TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                      TGalerie(Liste_Galerie[J]).Accrochage_Debut:=false;
                      TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                    end;
                  end;
                end;
              end;

            end;
            end;
          until not Changement;
          for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
            for J:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[J]) do if not En_Coupe then begin
              if Depart.Identique(Debut) and Arrivee.Identique(TPointTopo(Noeud[0])) then begin
                Raproche_Fiche:=I; Raproche_Galerie:=J;
                Direct:=false;
              end;
              if Arrivee.Identique(Debut) and Depart.Identique(TPointTopo(Noeud[0])) then begin
                Raproche_Fiche:=I; Raproche_Galerie:=J;
                Direct:=true;
              end;
            end;
          end;
          with TGalerie(TFiche(Form1.Massif.Liste_Courante[Precedente_Fiche]).Liste_Galerie[Precedente_Galerie]) do begin
            inc(Nb_Suite);
            Ordre_Suite[Nb_Suite]:=TFiche(Form1.Massif.Liste_Courante[Raproche_Fiche]).Ordre;
            Galerie_Suite[Nb_Suite]:=Raproche_Galerie;
          end;
          Precedente_Fiche:=Raproche_Fiche; Precedente_Galerie:=Raproche_Galerie;
          with TGalerie(TFiche(Form1.Massif.Liste_Courante[Precedente_Fiche]).Liste_Galerie[Precedente_Galerie]) do begin
            Nb_Suite:=0;
            Accrochage_Debut:=direct;
            Gauche_Droite:=Gauche.Checked;
            En_Coupe:=true;
            if Lateral.Checked then begin
              for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
                for J:=0 to Liste_Galerie.Count-1 do if not TGalerie(Liste_Galerie[J]).En_Coupe then begin
                  if direct and Arrivee.Identique(TGalerie(Liste_Galerie[J]).Depart)
                            and TGalerie(Liste_Galerie[J]).Arrivee.Terminus then begin
                    inc(Nb_Suite);
                    Ordre_Suite[Nb_Suite]:=Ordre;
                    Galerie_Suite[Nb_Suite]:=J;
                    TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                    TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                    TGalerie(Liste_Galerie[J]).Accrochage_Debut:=true;
                    TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                  end;
                  if direct and Arrivee.Identique(TGalerie(Liste_Galerie[J]).Arrivee)
                            and TGalerie(Liste_Galerie[J]).Depart.Terminus then begin
                    inc(Nb_Suite);
                    Ordre_Suite[Nb_Suite]:=Ordre;
                    Galerie_Suite[Nb_Suite]:=J;
                    TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                    TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                    TGalerie(Liste_Galerie[J]).Accrochage_Debut:=false;
                    TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                  end;
                  if not direct and Depart.Identique(TGalerie(Liste_Galerie[J]).Depart)
                            and TGalerie(Liste_Galerie[J]).Arrivee.Terminus then begin
                    inc(Nb_Suite);
                    Ordre_Suite[Nb_Suite]:=Ordre;
                    Galerie_Suite[Nb_Suite]:=J;
                    TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                    TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                    TGalerie(Liste_Galerie[J]).Accrochage_Debut:=true;
                    TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                  end;
                  if not direct and Depart.Identique(TGalerie(Liste_Galerie[J]).Arrivee)
                            and TGalerie(Liste_Galerie[J]).Depart.Terminus then begin
                    inc(Nb_Suite);
                    Ordre_Suite[Nb_Suite]:=Ordre;
                    Galerie_Suite[Nb_Suite]:=J;
                    TGalerie(Liste_Galerie[J]).En_Coupe:=true;
                    TGalerie(Liste_Galerie[J]).Nb_Suite:=0;
                    TGalerie(Liste_Galerie[J]).Accrochage_Debut:=false;
                    TGalerie(Liste_Galerie[J]).Gauche_Droite:=Gauche.Checked;
                  end;
                end;
              end;
            end;
          end;
          Form1.Massif.Calculer_Coupe;
          Form1.Massif.Detecteur_Erreur_Coupe;
          Form1.Massif.Sauvegarde:=false;
          if Form1.LaCoupe<>nil then Form1.LaCoupe.Mise_A_Jour;
        end;
        FreeMem(Numero,sizeOf(longint)*Noeud.Count);
        FreeMem(Distance,sizeOf(double)*Noeud.Count);
        FreeMem(Vue,sizeOf(boolean)*Noeud.Count);
        Utilise:=false;
      end
      else begin
        ShowMessage('Il n''y a rien  mettre en coupe. Vrifiez le point d''arrive.');
        ModalResult:=mrNone;
      end;
      Free;
    end;
    Les_Points.Free;
    Debut.Free;
  end;
  if ModalResult=mrOk then begin
    Horizontal.Text:='0'; Vertical.Text:='0';
    Nom_Depart.Text:=''; Indice_Depart.Text:='';
    Nom_Arrivee.Text:=''; Indice_Arrivee.Text:='';
  end;
end;

procedure TExpert.NouvelleClick(Sender: TObject);
begin
  Horizontal.Enabled:=Nouvelle.Checked;
  Vertical.Enabled:=Nouvelle.Checked;
end;

procedure TExpert.FormShow(Sender: TObject);
var
  S : string;
begin
  Nouvelle.Checked:=true;
  with (Form1.ActiveMDIChild as TAfficheur) do begin
    if Clicke then begin
      with TFiche(Form1.Massif.Liste_Courante[Click_Fiche]) do begin
        with TGalerie(Liste_Galerie[Click_Galerie]) do begin
          if En_Coupe then begin
            if Accrochage_Debut then begin
              if not Arrivee.Terminus then begin
                Nouvelle.Checked:=false;
                Gauche.Checked:=Gauche_Droite;
                Horizontal.Text:=FloatTostrF(Fin_Hori,ffGeneral,6,2);
                Vertical.Text:=FloatTostrF(Decal_Z,ffGeneral,4,1);
                Arrivee.Nom.Lit(S); Nom_Depart.Text:=S;
                Indice_Depart.Text:=IntToStr(Arrivee.Indice);
              end;
            end
            else begin
              if not Depart.Terminus then begin
                Nouvelle.Checked:=false;
                Gauche.Checked:=Gauche_Droite;
                Horizontal.Text:=FloatTostrF(Fin_Hori,ffGeneral,6,2);
                Vertical.Text:=FloatTostrF(Decal_Z,ffGeneral,4,1);
                Depart.Nom.Lit(S); Nom_Depart.Text:=S;
                Indice_Depart.Text:=IntToStr(Depart.Indice);
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TExpert.A_Fond(profond : boolean);
var
  N, I : integer;
  Debut : TPointTopo;
  Les_Points : TList;
  DMax : double;
  S : string;
begin
  try
    N:=StrToInt(Indice_Depart.Text);
    if N<=0 then Abort;
  except
    MessageDlg('L''indice doit tre numrique et positif.',mtWarning,[mbOk],0);
    Indice_Depart.SetFocus;
    Abort;
  end;

  Debut:=TPointTopo.Create;
  Debut.Indice:=N; Debut.Nom.Ecrit(Nom_Depart.Text);
  Les_Points:=TList.Create;
  Les_Points.Add(Debut);
  with TCalculateur.Create do begin
    Initialise(Form1.Massif.Liste_Courante,Les_Points,moExpert);
    if Atteint(Silencieux) then begin
      GetMem(Vue,sizeOf(boolean)*Noeud.Count);
      GetMem(Distance,sizeOf(double)*Noeud.Count);
      GetMem(Numero,sizeOf(longint)*Noeud.Count);
      Approxime;
      if Profond then DMax:=10000 else DMax:=0;
      for I:=0 to Noeud.Count-1 do with TPointTopo(Noeud[I]) do begin
        Nom.UpString(S);
        if not Profond and Vue^[I+1] and (Distance^[I+1]>DMax) then begin
          DMax:=Distance^[I+1];
          Nom_Arrivee.Text:=S;
          Indice_Arrivee.Text:=IntToStr(Indice);
        end;
        if Profond and Vue^[I+1] and (Z<DMax) then begin
          DMax:=Z;
          Nom_Arrivee.Text:=S;
          Indice_Arrivee.Text:=IntToStr(Indice);
        end;
      end;
      FreeMem(Numero,sizeOf(longint)*Noeud.Count);
      FreeMem(Distance,sizeOf(double)*Noeud.Count);
      FreeMem(Vue,sizeOf(boolean)*Noeud.Count);
      Utilise:=false;
    end
    else begin
      ShowMessage('Point de dpart inconnu ou dj en coupe.');
      ModalResult:=mrNone;
    end;
    Free;
  end;
  Les_Points.Free;
  Debut.Free;
end;


procedure TExpert.Button3Click(Sender: TObject);
begin
  A_Fond(false);
end;

procedure TExpert.Button4Click(Sender: TObject);
begin
  A_Fond(true);
end;

procedure TExpert.Button2Click(Sender: TObject);
var
  Nom, Indice : string;
begin
  Nom:=Nom_Arrivee.Text;
  Cherche(Nom,Indice);
  Nom_Arrivee.Text:=Nom;
  Indice_Arrivee.Text:=Indice;
end;

procedure TExpert.Cherche(var Le_Nom, L_indice : string);
var
  Quelle_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Position : integer;
  Grand_Nom, Ptt_Text : string;
  Choix : smallInt;
begin
  Grand_Nom:=UpperCase(Le_Nom);
  Position:=0;
  if Recherche_Simple(Form1.Massif.Liste_Courante,Form1.Massif,Quelle_Fiche,Position,Grand_Nom,'','','','')
  then begin
    if Position=-1 then begin
      ShowMessage('Il faut obligatoirement passer par la visualisation avec cette mthode');
{      Position:=-1; }
    end
    else begin
      Une_Galerie:=Quelle_Fiche.Liste_Galerie[Position];
      Choix:=0;
      if not Une_Galerie.Depart.Terminus then Choix:=1;
      if not Une_Galerie.Arrivee.Terminus then Choix:=Choix+1;
      case Choix of
        0 : MessageDlg('La galerie slectionne n''a que des terminus',mtWarning,[mbOk],0);
        1 : if not Une_Galerie.Depart.Terminus then begin
          Une_Galerie.Depart.Nom.Lit(Ptt_Text);
          Le_Nom:=Ptt_Text;
          L_Indice:=IntToStr(Une_Galerie.Depart.Indice);
        end
        else begin
          Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
          Le_Nom:=Ptt_Text;
          L_Indice:=IntToStr(Une_Galerie.Arrivee.Indice);
        end;
        2 : begin
          Choix:=0;
          Une_Galerie.Depart.Nom.UpString(Ptt_Text);
          if Ptt_text=Grand_Nom then Choix:=1;
          Une_Galerie.Arrivee.Nom.UpString(Ptt_Text);
          if Ptt_text=Grand_Nom then Choix:=Choix+1;
          if Choix=1 then begin
            if (Ptt_Text=Grand_Nom) then begin
              Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
              Le_Nom:=Ptt_Text;
              L_Indice:=IntToStr(Une_Galerie.Arrivee.Indice);
            end
            else begin
              Une_Galerie.Depart.Nom.Lit(Ptt_Text);
              Le_Nom:=Ptt_Text;
              L_Indice:=IntToStr(Une_Galerie.Depart.Indice);
            end;
          end
          else begin
            Une_Galerie.Depart.Nom.Lit(Ptt_Text);
            Ptt_Text:=Ptt_Text+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
            Une_Galerie.Arrivee.Nom.Lit(Grand_Nom);
            Grand_Nom:=Grand_Nom+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
            if MessageDlg('Deux points possibles : '+Grand_Nom+' (Oui) et '+Ptt_Text+' (Ok)',
               mtConfirmation,[mbOk,mbYes],0)=mrOk then begin
              Une_Galerie.Depart.Nom.Lit(Ptt_Text);
              Le_Nom:=Ptt_Text;
              L_Indice:=IntToStr(Une_Galerie.Depart.Indice);
            end
            else begin
              Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
              Le_Nom:=Ptt_Text;
              L_Indice:=IntToStr(Une_Galerie.Arrivee.Indice);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TExpert.Button1Click(Sender: TObject);
var
  Nom, Indice : string;
begin
  Nom:=Nom_Depart.Text;
  Cherche(Nom,Indice);
  Nom_Depart.Text:=Nom;
  Indice_Depart.Text:=Indice;
end;

end.
