unit explorer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, FicheTpo, Menus, ImgList;

type
  TExploreur = class(TForm)
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    ListView1: TListView;
    ImageArbre: TImageList;
    ImageListe: TImageList;
    GrandeImageListe: TImageList;
    PopupMenu1: TPopupMenu;
    Ouvrir1: TMenuItem;
    Restaurer1: TMenuItem;
    Timer1: TTimer;
    Zone_web: TImage;
    Rechercher1: TMenuItem;
    N1: TMenuItem;
    Couper1: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    N2: TMenuItem;
    Supprimer1: TMenuItem;
    Renommer1: TMenuItem;
    N3: TMenuItem;
    Proprits1: TMenuItem;
    Nouvellefiche1: TMenuItem;
    Vider1: TMenuItem;
    Timer2: TTimer;
    Isoler1: TMenuItem;
    Exclure1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyPress(Sender: TObject; var Key: Char);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Restaurer2Click(Sender: TObject);
    procedure Restaurer1Click(Sender: TObject);
    procedure TreeView1Editing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure ListView1Editing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure ListView1Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure Couper1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure Supprimer1Click(Sender: TObject);
    procedure Renommer1Click(Sender: TObject);
    procedure Nouvellefiche1Click(Sender: TObject);
    procedure Rechercher1Click(Sender: TObject);
    procedure Proprits1Click(Sender: TObject);
    procedure Vider1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Zone_webMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Timer2Timer(Sender: TObject);
    procedure Isoler1Click(Sender: TObject);
    procedure Zone_webDblClick(Sender: TObject);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure Exclure1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Numero_Fiche, Colonne_Classement : integer;
    Avant, Arriere, Mouvement : TList;
    Le_Noeud : TTreeNode;
    Evolution, Ordre_Classement, En_mise_a_jour : boolean;
    Presse_Systeme, Presse_Cavite, Presse_Reseau, Presse_Lieu : string;
    Presse_Fiche, Presse_Niveau : integer;
    Presse_Actif, Presse_Arbre, Coupage_en_cours : boolean;
    Xmin,XMax,YMin, YMax : double;

    procedure Construction;
    procedure Recul;
    procedure Avance;
    procedure Parent;
    procedure Supprimer;
    procedure Couper;
    procedure Copier;
    procedure Coller;
    procedure Rafraichir;
    procedure Frais;
    procedure Annuler;
    function Premiere_Fiche(Sys, Cav, Res, Lie : string; Niveau : integer) : TFiche;
    function Fiche_Suivante(Sys, Cav, Res, Lie : string; Niveau : integer) : TFiche;
    function Noeud_Equivalent : TTreeNode;
    procedure Localisation_Noeud(Node : TTreeNode;var S1, S2, S3, S4 : string);
    procedure Volet_Web;
    procedure Completer_TreeView(Node : TTreeNode);
  end;

  TAdresse = class
    Systeme, Cavite, Reseau, Lieu : string;
    Corbeille : boolean;
    Niveau : integer;
  end;

  TOrigine = class(TObject)
    Numero_Fiche : longint;
    Systeme, Cavite, Reseau, Lieu : string;
    Corbeille, Nouveau : boolean;
  end;

  TDeplacement = class(TObject)
    Groupe : TList;
    constructor Create;
    destructor Destroy; override;
  end;

var
  Exploreur: TExploreur;

implementation

{$R *.DFM}

uses Unit1, Unit2, Calcul, Recherch, Stats;

constructor TDeplacement.Create;
begin
  inherited Create;
  Groupe:=TList.Create;
end;

destructor TDeplacement.Destroy;
var
  I : integer;
begin
  for I:=0 to Groupe.Count-1 do TOrigine(Groupe[I]).Free;
  Groupe.Free;
  inherited Free;
end;


function TExploreur.Premiere_Fiche(Sys, Cav, Res, Lie : string; Niveau : integer) : TFiche;
begin
  Numero_Fiche:=0;
  Premiere_Fiche:=Fiche_Suivante(Sys, Cav, Res, Lie, Niveau);
end;

function TExploreur.Fiche_Suivante(Sys, Cav, Res, Lie : string; Niveau : integer) : TFiche;
var
  Trouve : boolean;
  S : string;
begin
  Trouve:=false;
  while (Numero_Fiche<Form1.Massif.Liste_Courante.Count) and not Trouve do with TFiche(Form1.Massif.Liste_Courante[Numero_Fiche]) do begin
    Systeme.Lit(S);
    if (UpperCase(S)=UpperCase(Sys)) or (Niveau<1) then begin
      Cavite.Lit(S);
      if (UpperCase(S)=UpperCase(Cav)) or (Niveau<2) then begin
        Reseau.Lit(S);
        if (UpperCase(S)=UpperCase(Res)) or (Niveau<3) then begin
          Lieu.Lit(S);
          if (UpperCase(S)=UpperCase(Lie)) or (Niveau<4) then begin
            Trouve:=true;
            Fiche_Suivante:=TFiche(Form1.Massif.Liste_Courante[Numero_Fiche]);
          end;
        end;
      end;
    end;
    inc(Numero_Fiche);
  end;
  if not Trouve then Fiche_Suivante:=nil;
end;


procedure TExploreur.Construction;
var
  I : integer;
  Node, Nouveau, Base : TTreeNode;
  Existe : boolean;
  S : string;
begin
  En_mise_a_jour:=true;
  TreeView1.Items.BeginUpdate;
  for I:=0 to Form1.Massif.Liste_Courante.Count-1 do with TFiche(Form1.Massif.Liste_Courante[I]) do begin
    with TreeView1.Items do
    begin
      S:=ExtractFileName(Form1.Massif.Fichier);
      S:=Copy(S,1,pos('.',S)-1);
      GetFirstNode.Text:=S;

      Node:= GetFirstNode.GetFirstChild;
      Systeme.Lit(S);
      if node=nil then begin
        Nouveau:=AddChild(GetFirstNode,S);
      end
      else begin
        Base:=Node;
        Existe:=false;
        while Node <> nil do
        begin
          if UpperCase(Node.Text)=UpperCase(S) then begin
            Existe:=true;
            Nouveau:=Node;
          end;
          Node := Node.GetNextSibling;
        end;
        if not Existe then begin
          Nouveau:=Add(Base,S);
          Nouveau.HasChildren:=true;
        end;
      end;
      Nouveau.SelectedIndex:=1;

    end;
  end;
  TreeView1.Items.EndUpdate;
  TreeView1.AlphaSort;
  En_mise_a_jour:=false;
  TreeView1Change(self,TreeView1.Items.GetFirstNode);
  S:=TreeView1.Items.GetFirstNode.Text;
end;

procedure TExploreur.FormCreate(Sender: TObject);
var
  I : integer;
  BitMap : TBitMap;
begin
  BitMap:=TBitMap.Create;
  BitMap.Width:=Zone_Web.Width; BitMap.Height:=Zone_Web.Height;
  Zone_Web.Picture.Graphic := Bitmap;
  if (csDisplayDragImage in ControlStyle) then ControlStyle:=ControlStyle - [csDisplayDragImage];
  for I:=0 to ComponentCount-1 do begin
    if Components[I] is TControl then begin
      if (csDisplayDragImage in (Components[I] as TControl).ControlStyle) then
      (Components[I] as TControl).ControlStyle:=(Components[I] as TControl).ControlStyle - [csDisplayDragImage];
    end;
  end;
  En_mise_a_jour:=true;
  TreeView1.Items.BeginUpdate;
  with TreeView1.Items.GetFirstNode do begin
    Expanded:=true;
    TreeView1.Selected:=TreeView1.Items.GetFirstNode;
  end;
  TreeView1.Items.EndUpdate;
  Avant:=TList.Create;
  Arriere:=TList.Create;
  Mouvement:=TList.Create;
  Evolution:=false;
  Ordre_Classement:=true;
  Colonne_Classement:=0;
  Presse_Actif:=false;
  if Form1.Grandesicnes1.Checked then ListView1.ViewStyle:=vsIcon;
  if Form1.Petitesicnes1.Checked then ListView1.ViewStyle:=vsSmallIcon;
  if Form1.Liste1.Checked then ListView1.ViewStyle:=vsList;
  if Form1.Dtail1.Checked then ListView1.ViewStyle:=vsReport;
  WindowState:=wsMaximized;
  BringToFront;
  FormResize(Sender);
end;

procedure TExploreur.Volet_Web;
var
  I, J, Largeur : integer;
  Ratio, Delta : Double;
  Le_Point : TColor;
  Debut : boolean;
  La_Zone : TList;
  Une_Fiche : TFiche;
  S1, S2, S3, S4 : string;
  PMin, PMax : TPoint3D;
  Image : TBitMap;
  Node : TTreeNode;

  procedure MoveToRel(X, Y : double);
  begin
    Zone_Web.Canvas.MoveTo(round((X-Pmin.X)/(PMax.X-Pmin.X)*Largeur),
                                      round((Pmax.Y-Y)/(PMax.Y-Pmin.Y)*(Zone_Web.Height-100))+100);
  end;

  procedure LineToRel(X, Y : double);
  begin
    Zone_Web.Canvas.LineTo(round((X-Pmin.X)/(PMax.X-Pmin.X)*Largeur),
                                      round((PMax.Y-Y)/(PMax.Y-Pmin.Y)*(Zone_Web.Height-100))+100);
  end;

  procedure Dessine_Une_Fiche(La_Fiche : TFiche);
  var
    J, K : integer;
    Une_Galerie : TGalerie;
    ContrainteX, ContrainteY, L, X0, Y0, X1, Y1 : double;
  begin
    for J:=0 to La_Fiche.Liste_Galerie.Count-1 do begin
      Une_Galerie:=La_Fiche.Liste_Galerie[J];
      if not Une_Galerie.Approximation then ContrainteX:=0;
      if Une_Galerie.Approximation then with Une_Galerie do begin
        if Depart.Terminus or Arrivee.Terminus then begin
          ContrainteX:=0;
          ContrainteY:=0;
        end
        else begin
          ContrainteX:=((Arrivee.X-Depart.X)-DeltaX)/SigmaL;
          ContrainteY:=((Arrivee.Y-Depart.Y)-DeltaY)/SigmaL;
        end;
        L:=0;
        if Depart.Terminus then begin
          X0:=Arrivee.X-DeltaX; Y0:=Arrivee.Y-DeltaY;
        end
        else begin
          X0:=Depart.X; Y0:=Depart.Y;
        end;
        MoveToRel(X0,Y0);
        for K:=1 to Nb_Visee do begin
          if Visees[K].ULong=cm then L:=L+Visees[K].Longueur/100 else L:=L+Visees[K].Longueur;
          X1:=X0+Visees[K].X+ContrainteX*L;
          Y1:=Y0+Visees[K].Y+ContrainteY*L;
          LineToRel(X1, Y1);
        end;
      end;
    end;
  end;

begin
  if Form1.Web1.Checked and (TreeView1.Selected<>nil) then begin
    with Zone_Web.Canvas do begin
      Pen.Color:=clWhite; Pen.Style:=psSolid; Pen.Mode:=pmCopy;
      Brush.Color:=clWhite; Brush.Style:=bsSolid;
      Rectangle(0,0,Zone_Web.Width,Zone_Web.Height);
      Pen.Color:= 16750848; Brush.Color:= 16750848;
      Ellipse(2,2,100,100);
      Image:=TBitMap.Create; Image.Width:=35; Image.Height:=35;
      if TreeView1.Selected.Text='Corbeille' then GrandeImageListe.GetBitMap(2,Image)
                                             else GrandeImageListe.GetBitMap(1,Image);
      for J:=0 to 34 do begin
        Debut:=true;
        for I:=0 to 15 do begin
          Le_Point:=Image.Canvas.Pixels[I,J];
          if Debut and (Le_Point<>clWhite) then Debut:=false;
          if not Debut then begin
            Pixels[2*I+15,2*J+15]:=Le_Point;
            Pixels[2*I+16,2*J+15]:=Le_Point;
            Pixels[2*I+15,2*J+16]:=Le_Point;
            Pixels[2*I+16,2*J+16]:=Le_Point;
          end;
        end;
        Debut:=true;
        for I:=34 downto 16 do begin
          Le_Point:=Image.Canvas.Pixels[I,J];
          if Debut and (Le_Point<>clWhite) then Debut:=false;
          if not Debut then begin
            Pixels[2*I+15,2*J+15]:=Le_Point;
            Pixels[2*I+16,2*J+15]:=Le_Point;
            Pixels[2*I+15,2*J+16]:=Le_Point;
            Pixels[2*I+16,2*J+16]:=Le_Point;
          end;
        end;
      end;
      Pen.Color:=clBlack;
      MoveTo(100,51); LineTo(Width,51);
      Brush.Color:=clWhite;
      with Font do begin
        Color:=16750848; Name:='Arial';
        Height:=30;  Style:=[fsBold];
      end;
      TextOut(120,20,TreeView1.Selected.Text);
      La_Zone:=TList.Create;
      Localisation_Noeud(TreeView1.Selected,S1,S2,S3,S4);
      Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, TreeView1.Selected.Level);
      while Une_Fiche<>nil do begin
        La_Zone.Add(Une_Fiche);
        Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, TreeView1.Selected.Level);
      end;
      if not Form1.Massif.Finition then Form1.Massif.Detailler;
      try
        if Calibre(PMin, PMax,La_Zone) then begin
          Largeur:=(Width-Splitter1.Left-11) div 3;
          Ratio:=(PMax.X-PMin.X)/(PMax.Y-PMin.Y)/Largeur*(Zone_Web.Height-100);
          if Ratio>1 then begin
            Delta:=PMax.Y-PMin.Y; Delta:=Delta*(Ratio-1)/2;
            PMin.Y:=PMin.Y-Delta; PMax.Y:=PMax.Y+Delta;
          end
          else begin
            Delta:=PMax.X-PMin.X; Delta:=Delta*(1/Ratio-1)/2;
            PMin.X:=PMin.X-Delta; PMax.X:=PMax.X+Delta;
          end;
          Delta:=PMax.Y-PMin.Y; Delta:=Delta*0.05;
          PMin.Y:=PMin.Y-Delta; PMax.Y:=PMax.Y+Delta;
          Delta:=PMax.X-PMin.X; Delta:=Delta*0.05;
          PMin.X:=PMin.X-Delta; PMax.X:=PMax.X+Delta;

          XMin:=PMin.X; XMax:=PMax.X;
          YMin:=PMin.Y; YMax:=PMax.Y;

          Pen.Color:=clBlack;
          for I:=0 to La_Zone.Count-1 do begin
            Une_Fiche:=La_Zone[I];
            Dessine_Une_Fiche(Une_Fiche);
          end;
          if ListView1.Selected<>nil then begin
            Pen.Color:=clRed;
            if TreeView1.Selected.Level<4 then begin
              Node:=Noeud_Equivalent;
              Localisation_Noeud(Node,S1,S2,S3,S4);
              Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, Node.Level);
              while Une_Fiche<>nil do begin
                Dessine_Une_Fiche(Une_Fiche);
                Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, Node.Level);
              end;
            end
            else begin
              Une_Fiche:=ListView1.Selected.Data;
              Dessine_Une_Fiche(Une_Fiche);
            end;
          end;
        end;
      finally
        La_Zone.Free;
      end;
    end;
  end;
end;

procedure TExploreur.Completer_TreeView(Node : TTreeNode);
var
  Fils : TTreeNode;
  S, S1, S2, S3, S4 : string;
  Existe : boolean;
  Une_Fiche : TFiche;
begin
  TreeView1.Items.BeginUpdate;
  Localisation_Noeud(Node,S1,S2,S3,S4);
  Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, Node.Level);
  while Une_Fiche<>nil do begin
    case Node.Level of
      0 : Une_Fiche.Systeme.Lit(S);
      1 : Une_Fiche.Cavite.Lit(S);
      2 : Une_Fiche.Reseau.Lit(S);
      3 : Une_Fiche.Lieu.Lit(S);
    end;
    Fils:=Node.GetFirstChild;
    Existe:=false;
    while Fils<>nil do begin
      if UpperCase(Fils.Text)=UpperCase(S) then Existe:=true;
      Fils := Fils.GetNextSibling;
    end;
    if not Existe then begin
      Fils:=TreeView1.Items.AddChild(Node,S);
      Fils.SelectedIndex:=1;
      if Node.Level<>3 then Fils.HasChildren:=true;
    end;
    Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, Node.Level);
  end;
  TreeView1.Items.EndUpdate;
  TreeView1.AlphaSort;
end;

procedure TExploreur.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  Fils : TTreeNode;
  ListItem : TListItem;
  I : integer;
  Une_Fiche : TFiche;
  S, T : string;
  Topog : TEco;
  Adresse : TAdresse;
begin
  if not En_mise_a_jour and (Node<>nil) then begin
    if not Evolution and (Avant<>nil) and (Avant.Count<>0) then begin
      for I:=Avant.Count-1 downto 0 do begin
        Adresse:=Avant[I];
        Adresse.free; Adresse:=nil;
      end;
      Avant.Free;
      Avant:=TList.Create;
    end;
    Evolution:=false;

    if Arriere<>nil then begin
      Adresse:=TAdresse.Create;
      if Node.text='Corbeille' then Adresse.Corbeille:=true
      else begin
        Adresse.Corbeille:=false;
        Adresse.Niveau:=Node.Level;
        case Node.Level of
          1 : begin
            Adresse.Systeme:=Node.Text;
          end;
          2 : begin
            Adresse.Systeme:=Node.Parent.Text;
            Adresse.Cavite:=Node.Text;
          end;
          3 : begin
            Adresse.Systeme:=Node.Parent.Parent.Text;
            Adresse.Cavite:=Node.Parent.Text;
            Adresse.Reseau:=Node.Text;
          end;
          4 : begin
            Adresse.Systeme:=Node.Parent.Parent.Parent.Text;
            Adresse.Cavite:=Node.Parent.Parent.Text;
            Adresse.Reseau:=Node.Parent.Text;
            Adresse.Lieu:=Node.Text;
          end;
        end;
      end;
      Arriere.Add(Adresse);
    end;
    with TreeView1.Items do
    begin
      ListView1.Selected:=nil;
      ListView1.Items.Clear;
      if Node.Level=4 then begin
        ListView1.Columns[2].Caption:='Topographes';
        Une_Fiche:=Premiere_Fiche(Node.Parent.Parent.Parent.Text,
                                  Node.Parent.Parent.Text,
                                  Node.Parent.Text,
                                  Node.Text,4);
        while Une_Fiche<>nil do begin
          ListItem := ListView1.Items.Add;
          ListItem.Caption := Une_Fiche.Date;
          ListItem.ImageIndex:=0;
          ListItem.SubItems.Add('Fiche');
          ListItem.Data:=Une_Fiche;
          S:='';
          for I:=0 to Une_Fiche.Topographes.Count-1 do begin
            Topog:=Une_Fiche.Topographes[I];
            Topog.Lit(T);
            S:=S+T+'/';
          end;
          S:=copy(S,1,length(S)-1);
          ListItem.SubItems.Add(S);
          Une_Fiche:=Fiche_Suivante(Node.Parent.Parent.Parent.Text,
                                    Node.Parent.Parent.Text,
                                    Node.Parent.Text,
                                    Node.Text,4);
        end;
      end
      else begin
        if TreeView1.Selected.Text<>'Corbeille' then begin

          if Node.GetFirstChild=nil then Completer_TreeView(Node);

          ListView1.Columns[2].Caption:='Topographes';
          Fils:=Node.GetFirstChild;
          while Fils<>nil do begin
            ListItem := ListView1.Items.Add;
            ListItem.Caption := Fils.Text;
            if Fils.Text<>'Corbeille' then begin
              ListItem.ImageIndex:=1;
              case Node.Level of
                0 : S:='Systme';
                1 : S:='Cavit';
                2 : S:='Rseau';
                3 : S:='Lieu';
              end;
              ListItem.SubItems.Add(S);
              ListItem.SubItems.Add('');
            end
            else begin
              ListItem.ImageIndex:=2;
              ListItem.SubItems.Add('');
              ListItem.SubItems.Add('');
            end;
            Fils:=Fils.GetNextSibling;
          end;
        end
        else begin
          ListView1.Columns[2].Caption:='Emplacement d''origine';
          for I:=0 to Form1.Massif.Corbeille.Count-1 do begin
            Une_Fiche:=Form1.Massif.Corbeille[I];
            ListItem := ListView1.Items.Add;
            ListItem.Caption := Une_Fiche.Date;
            ListItem.SubItems.Add('Fiche');
            Une_Fiche.Systeme.Lit(S);
            Une_Fiche.Cavite.Lit(T); S:=S+'/'+T;
            Une_Fiche.Reseau.Lit(T); S:=S+'/'+T;
            Une_Fiche.Lieu.Lit(T); S:=S+'/'+T;
            ListItem.SubItems.Add(S);
            ListItem.ImageIndex:=0;
            ListItem.Data:=Une_Fiche;
          end;
        end;
      end;
    end;
  end;
  ListView1.AlphaSort;
end;

procedure TExploreur.ListView1DblClick(Sender: TObject);
var
  ListItem : TListItem;
  Une_Fiche : TFiche;
begin
  ListItem:=ListView1.Selected;
  if (TreeView1.Selected.Text<>'Corbeille') and (ListItem<>nil) then begin
    if TreeView1.Selected.Level<4 then TreeView1.Selected:=Noeud_Equivalent
    else begin
      Une_Fiche:=ListItem.Data;
      MultPageDlg.Contenu(Une_Fiche,Form1.Massif,Form1.Preference,-1);
      ListView1.Selected:=nil;
      Form1.Ouvre_Fiche;
    end;
  end;
end;

procedure TExploreur.ListView1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then ListView1DblClick(Sender);
end;

procedure TExploreur.Recul;
var
  I : integer;
  Adresse : TAdresse;
  Node : TTreeNode;
begin
  I:=Arriere.Count-2;
  if I>=0 then begin
    Adresse:=Arriere[Arriere.Count-1];
    Avant.Add(Adresse);
    Arriere.delete(Arriere.Count-1);
  end;
  while I>=0 do begin
    Evolution:=true;
    Adresse:=Arriere[I];
    Arriere.delete(I);
    if Adresse.Corbeille then begin
      with TreeView1.Items do
      begin
        Node:=GetFirstNode.GetFirstChild;
        while Node.Text<>'Corbeille' do Node:=Node.GetNextSibling;
        TreeView1.Selected:=Node;
      end;
      I:=0;
    end
    else begin
      if Adresse.Niveau=0 then begin
        TreeView1.Selected:=TreeView1.Items.GetFirstNode;
        I:=0;
      end
      else with TreeView1.Items do begin
        Node:=TreeView1.Items.GetFirstNode.GetFirstChild;
        while (Node<>nil) and (Node.Text<>Adresse.Systeme) do Node:=Node.GetNextSibling;
        if (Adresse.Niveau>=2) and (Node<>nil) then begin
          Node:=Node.GetFirstChild;
          while (Node<>nil) and (Node.Text<>Adresse.Cavite) do Node:=Node.GetNextSibling;
          if (Adresse.Niveau>=3) and (Node<>nil) then begin
            Node:=Node.GetFirstChild;
            while (Node<>nil) and (Node.Text<>Adresse.Reseau) do Node:=Node.GetNextSibling;
            if (Adresse.Niveau>=4) and (Node<>nil) then begin
              Node:=Node.GetFirstChild;
              while (Node<>nil) and (Node.Text<>Adresse.Lieu) do Node:=Node.GetNextSibling;
            end;
          end;
        end;
        if Node<>nil then begin
          TreeView1.Selected:=Node;
          I:=0;
        end;
      end;
    end;
    dec(I);
    Adresse.Free;
  end;
end;

procedure TExploreur.Avance;
var
  I : integer;
  Adresse : TAdresse;
  Node : TTreeNode;
begin
  I:=Avant.Count-1;
  while I>=0 do begin
    Evolution:=true;
    Adresse:=Avant[I];
    Avant.delete(I);
    if Adresse.Corbeille then begin
      with TreeView1.Items do
      begin
        Node:=GetFirstNode.GetFirstChild;
        while Node.Text<>'Corbeille' do Node:=Node.GetNextSibling;
        TreeView1.Selected:=Node;
      end;
      I:=0;
    end
    else begin
      if Adresse.Niveau=0 then begin
        TreeView1.Selected:=TreeView1.Items.GetFirstNode;
        I:=0;
      end
      else with TreeView1.Items do begin
        Node:=TreeView1.Items.GetFirstNode.GetFirstChild;
        while (Node<>nil) and (Node.Text<>Adresse.Systeme) do Node:=Node.GetNextSibling;
        if (Adresse.Niveau>=2) and (Node<>nil) then begin
          Node:=Node.GetFirstChild;
          while (Node<>nil) and (Node.Text<>Adresse.Cavite) do Node:=Node.GetNextSibling;
          if (Adresse.Niveau>=3) and (Node<>nil) then begin
            Node:=Node.GetFirstChild;
            while (Node<>nil) and (Node.Text<>Adresse.Reseau) do Node:=Node.GetNextSibling;
            if (Adresse.Niveau>=4) and (Node<>nil) then begin
              Node:=Node.GetFirstChild;
              while (Node<>nil) and (Node.Text<>Adresse.Lieu) do Node:=Node.GetNextSibling;
            end;
          end;
        end;
        if Node<>nil then begin
          TreeView1.Selected:=Node;
          I:=0;
        end;
      end;
    end;
    dec(I);
    Adresse.Free;
  end;
end;

procedure TExploreur.Parent;
begin
  TreeView1.Selected:=TreeView1.Selected.Parent;
end;

procedure TExploreur.Supprimer;
var
  Node : TTreeNode;
  Une_Fiche : TFiche;
  S1, S2, S3, S4 : string;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
begin
  if ActiveControl <> nil then begin
    if ActiveControl is TTreeView then begin
      if TreeView1.Selected.Text='Corbeille' then begin
        ShowMessage('Impossible de supprimer la corbeille');
        Node:=nil;
      end
      else if TreeView1.Selected.Level=0 then begin
        ShowMessage('Impossible de supprimer tout le massif');
        Node:=nil;
      end
      else begin
        Node:=TreeView1.Selected;
      end;
    end;
    if ActiveControl is TListView then begin
      if ListView1.Selected<>nil then begin
        if ListView1.Selected.Caption='Corbeille' then begin
          ShowMessage('Impossible de supprimer dans la corbeille');
          Node:=nil;
        end
        else begin
          if TreeView1.Selected.level<4 then begin
            Node:=Noeud_Equivalent;
          end
          else begin
            Node:=nil;
            Une_Fiche:=ListView1.Selected.Data;
{            if En_Coupe(Une_Fiche) then MessageDlg('La fiche comporte des coupes, suppression impossible'+#13+
                    'vous devez supprimer les coupes avant de supprimer la fiche',mtWarning,[mbYes],0); }
            if {not En_Coupe(Une_Fiche) and }(MessageDlg('Mettre la fiche dans la corbeille ?',
                        mtWarning,[mbCancel,mbYes],0)=mrYes) then begin
              Tuer_les_Coupe(Une_Fiche);
              if Calcul_En_Cours then Calcul_Arrete:=true;
              Deplacement:=TDeplacement.Create;
              Une_Origine:=TOrigine.Create;
              with Une_Origine do begin
                Numero_Fiche:=Une_Fiche.ordre;
                Une_Fiche.Systeme.Lit(Systeme);
                Une_Fiche.Cavite.Lit(Cavite);
                Une_Fiche.Reseau.Lit(Reseau);
                Une_Fiche.Lieu.Lit(Lieu);
                Corbeille:=false;
                Nouveau:=false;
              end;
              Deplacement.Groupe.Add(Une_Origine);
              Mouvement.Add(Deplacement);
              Form1.Massif.Retirer(Une_Fiche);
              Form1.Massif.Sauvegarde:=false;
              if Form1.Automatique1.Checked then begin
                if Calcul_en_cours then Calcul_Arrete:=true;
                Form1.Depart_Calcul_Rapide.Enabled:=true;
              end;
              Rafraichir;
            end;
          end;
        end;
      end
      else Node:=nil;
    end;
    if (Node<>nil) and (MessageDlg(Format('Mettre le dossier %s dans la corbeille ?',[Node.Text]),
                        mtWarning,[mbCancel,mbYes],0)=mrYes)
                        then begin
      Localisation_Noeud(Node,S1,S2,S3,S4);
      if Calcul_En_Cours then Calcul_Arrete:=true;
      Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, Node.Level);
      Deplacement:=TDeplacement.Create;
      while Une_Fiche<>nil do begin
        Tuer_les_coupe(Une_Fiche);
        Form1.Massif.Retirer(Une_Fiche);
        Une_Origine:=TOrigine.Create;
        with Une_Origine do begin
          Numero_Fiche:=Une_Fiche.ordre;
          Une_Fiche.Systeme.Lit(Systeme);
          Une_Fiche.Cavite.Lit(Cavite);
          Une_Fiche.Reseau.Lit(Reseau);
          Une_Fiche.Lieu.Lit(Lieu);
          Corbeille:=false;
          Nouveau:=false;
        end;
        Deplacement.Groupe.Add(Une_Origine);
        dec(Numero_Fiche);
        Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, Node.Level);
      end;
      Mouvement.Add(Deplacement);
      Form1.Massif.Sauvegarde:=false;
      if Form1.Automatique1.Checked then begin
        if Calcul_en_cours then Calcul_Arrete:=true;
        Form1.Depart_Calcul_Rapide.Enabled:=true;
      end;
      Rafraichir;
    end;
  end;
end;

procedure TExploreur.Rafraichir;
begin
  Timer1.Enabled:=true;
end;

procedure TExploreur.Frais;
// le rafraichissement lui-mme
var
  Racine : array[1..4] of string;
  S : string;
  Profondeur, I, J : integer;
  Node : TTreeNode;
  Les_Noeud : TList;
  Un_Noeud : TOrigine;
begin
  Les_Noeud:=TList.Create;
  for I:=0 to TreeView1.Items.Count-1 do begin
    Un_Noeud:=TOrigine.Create;
    Node:=TreeView1.Items[I];
    with Un_Noeud do begin
      Numero_Fiche:=Node.Level;
      Localisation_Noeud(Node,Systeme,Cavite,Reseau,Lieu);
      Nouveau:=Node.Expanded;
    end;
    Les_Noeud.Add(Un_Noeud);
  end;

  Node:=TreeView1.Selected;
  Profondeur:=Node.Level;
  for I:=1 to Profondeur do begin
    Racine[I]:=Node.Text;
    Node:=Node.parent;
  end;
  TreeView1.Selected:=nil;
  En_mise_a_jour:=true;
  TreeView1.Items.BeginUpdate;
  TreeView1.Items.Clear;
  Node:=TreeView1.Items.Add(nil,'Massif');
  TreeView1.Selected:=TreeView1.Items.GetFirstNode;
  Node:=TreeView1.Items.AddChild(Node,'Corbeille');
  Node.SelectedIndex:=2;
  Node.ImageIndex:=2;
  Construction;

  for I:=Les_Noeud.Count-1 downto 0 do begin
    Un_Noeud:=Les_Noeud[I];
    with Un_Noeud do begin
      if Nouveau then begin  // c'tait un noeud dtaill
        Node:=TreeView1.Items.GetFirstNode;
        for J:=1 to Numero_Fiche do if Node<>nil then begin // numro fiche = level
          if Node.GetFirstChild=nil then Completer_TreeView(Node);
          Node:=Node.GetFirstChild;
          case J of
            1 : S:=Systeme;
            2 : S:=Cavite;
            3 : S:=Reseau;
            4 : S:=Lieu;
          end;
          while (Node<>nil) and (Node.Text<>S) do Node:=Node.GetNextSibling;
        end;
        if Node<>nil then Node.Expanded:=true;
      end;
    end;
    Les_Noeud.Remove(Un_Noeud);
    Un_Noeud.Free;
  end;
  Les_Noeud.Free;
  TreeView1.Items.EndUpdate;
  En_mise_a_jour:=false;

  Node:=TreeView1.Items.GetFirstNode;
  for I:=Profondeur downto 1 do if Node<>nil then begin
    TreeView1.Selected:=Node;
    Node:=Node.GetFirstChild;
    while (Node<>nil) and (Node.Text<>Racine[I]) do Node:=Node.GetNextSibling;
  end;
  if Node<>nil then Node.Selected:=true;
end;

procedure TExploreur.PopupMenu1Popup(Sender: TObject);
begin
  if ActiveControl is TTreeView then begin
    Ouvrir1.Visible:=true;
    Restaurer1.Visible:=false;
    Vider1.Visible:=(TreeView1.Selected.Text='Corbeille');
    Rechercher1.Visible:=(TreeView1.Selected.Text<>'Corbeille');
    Coller1.Visible:=Presse_Actif;
    Supprimer1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and (TreeView1.Selected.Level<>0);
    Renommer1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and (TreeView1.Selected.Level<>0);
    Nouvellefiche1.Visible:=(TreeView1.Selected.Text<>'Corbeille');
    Proprits1.Visible:=true;
    Isoler1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and (TreeView1.Selected.Level<>0);
    Exclure1.Visible:=Isoler1.Visible;
    N1.Visible:=true;
    N3.Visible:=(TreeView1.Selected.Text<>'Corbeille');
  end;
  if ActiveControl is TListView then begin
    Vider1.Visible:=false;
    Ouvrir1.Visible:=(ListView1.Selected<>nil) and (TreeView1.Selected.Text<>'Corbeille');
    Restaurer1.Visible:=(TreeView1.Selected.Text='Corbeille');
    Rechercher1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and
       ((ListView1.Selected=nil) or ((ListView1.Selected.Caption<>'Corbeille') and (TreeView1.Selected.Level<4)));
    Vider1.Visible:=(ListView1.Selected<>nil) and (ListView1.Selected.Caption='Corbeille');
    Coller1.Visible:=Presse_Actif;
    Supprimer1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and (TreeView1.Selected.Level<>0);
    Renommer1.Visible:=(ListView1.Selected<>nil) and (ListView1.Selected.Caption<>'Corbeille')
    and (TreeView1.Selected.Level<4) and (TreeView1.Selected.Text<>'Corbeille');
    Nouvellefiche1.Visible:=(TreeView1.Selected.Text<>'Corbeille') and
       ((ListView1.Selected=nil) or ((ListView1.Selected.Caption<>'Corbeille') and (TreeView1.Selected.Level<4)));
    Proprits1.Visible:=(ListView1.Selected=nil) or (TreeView1.Selected.Text<>'Corbeille');
    Isoler1.Visible:=(ListView1.Selected<>nil) and (ListView1.Selected.Caption<>'Corbeille')
      and (TreeView1.Selected.Text<>'Corbeille');
    Exclure1.Visible:=Isoler1.Visible;
    N3.Visible:=Proprits1.Visible and
      ((ListView1.Selected=nil) or (ListView1.Selected.Caption<>'Corbeille'));
    N1.Visible:=Ouvrir1.Visible or Rechercher1.Visible or Vider1.Visible;
  end;
  Le_Noeud:=TreeView1.Selected;
end;

procedure TExploreur.Ouvrir1Click(Sender: TObject);
begin
  if ActiveControl is TTreeView then Le_Noeud.Selected:=true;
  if ActiveControl is TListView then ListView1DblClick(Sender);
end;

procedure TExploreur.Restaurer2Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
  J : integer;
begin
//  Une_Fiche:=Form1.Massif.Corbeille[ListView1.Selected.Index];
  Une_Fiche:=ListView1.Selected.Data;
  Form1.Massif.Corbeille.Remove(Une_Fiche);
  Form1.Massif.Corbeille.Pack;
  Form1.Massif.Ajouter(Une_Fiche,true);
  for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do TGalerie(Une_Fiche.Liste_Galerie[J]).Approximation:=false;
  Deplacement:=TDeplacement.Create;
  Une_Origine:=TOrigine.Create;
  with Une_Origine do begin
    Numero_Fiche:=Une_Fiche.ordre;
    Une_Fiche.Systeme.Lit(Systeme);
    Une_Fiche.Cavite.Lit(Cavite);
    Une_Fiche.Reseau.Lit(Reseau);
    Une_Fiche.Lieu.Lit(Lieu);
    Corbeille:=true;
    Nouveau:=false;
  end;
  Deplacement.Groupe.Add(Une_Origine);
  Form1.Massif.Sauvegarde:=false;
  Mouvement.Add(Deplacement);
  Rafraichir;
end;

procedure TExploreur.Restaurer1Click(Sender: TObject);
var
  Une_Fiche : TFiche;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
  I, J : integer;
begin
  if (ActiveControl is TListView) and (TreeView1.Selected.Text='Corbeille') then Restaurer2Click(Sender)
  else begin
    Deplacement:=TDeplacement.Create;
    for I:=Form1.Massif.Corbeille.Count-1 downto 0 do begin
      Une_Fiche:=Form1.Massif.Corbeille[I];
      Form1.Massif.Corbeille.Remove(Une_Fiche);
      Form1.Massif.Ajouter(Une_Fiche,true);
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do TGalerie(Une_Fiche.Liste_Galerie[J]).Approximation:=false;
      Une_Origine:=TOrigine.Create;
      with Une_Origine do begin
        Numero_Fiche:=Une_Fiche.ordre;
        Une_Fiche.Systeme.Lit(Systeme);
        Une_Fiche.Cavite.Lit(Cavite);
        Une_Fiche.Reseau.Lit(Reseau);
        Une_Fiche.Lieu.Lit(Lieu);
        Corbeille:=true;
        Nouveau:=false;
      end;
      Deplacement.Groupe.Add(Une_Origine);
    end;
    Mouvement.Add(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Form1.Massif.Corbeille.Pack;
    Rafraichir;
    Form1.Mise_A_Jour;
  end;
  if Form1.Automatique1.Checked then begin
    if Calcul_en_cours then Calcul_Arrete:=true;
    Form1.Depart_Calcul_Rapide.Enabled:=true;
  end;
end;

procedure TExploreur.TreeView1Editing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  AllowEdit:=(Node.Text<>'Corbeille') and (Node.Level<>0);
end;

procedure TExploreur.TreeView1Edited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
  Une_Fiche : TFiche;
  S1, S2, S3, S4 : string;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
begin
  if S='Corbeille' then S:=Node.Text
  else begin
    Localisation_Noeud(Node,S1,S2,S3,S4);
    Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, Node.Level);
    Deplacement:=TDeplacement.Create;
    while Une_Fiche<>nil do begin
      Une_Origine:=TOrigine.Create;
      with Une_Origine do begin
        Numero_Fiche:=Une_Fiche.ordre;
        Une_Fiche.Systeme.Lit(Systeme);
        Une_Fiche.Cavite.Lit(Cavite);
        Une_Fiche.Reseau.Lit(Reseau);
        Une_Fiche.Lieu.Lit(Lieu);
        Corbeille:=false;
        Nouveau:=false;
      end;
      Deplacement.Groupe.Add(Une_Origine);
      case Node.Level of
        1 : Une_Fiche.Systeme.Ecrit(S);
        2 : Une_Fiche.Cavite.Ecrit(S);
        3 : Une_Fiche.Reseau.Ecrit(S);
        4 : Une_Fiche.Lieu.Ecrit(S);
      end;
      Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, Node.Level);
    end;
    Mouvement.Add(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Rafraichir;
  end;
end;

procedure TExploreur.ListView1Editing(Sender: TObject; Item: TListItem;
  var AllowEdit: Boolean);
begin
  AllowEdit:=(TreeView1.Selected.Level<4) and (ListView1.Selected.Caption<>'Corbeille')
         and (TreeView1.Selected.Text<>'Corbeille');
end;

procedure TExploreur.ListView1Edited(Sender: TObject; Item: TListItem;
  var S: String);
var
  Node : TTreeNode;
begin
  if TreeView1.Selected.Level<4 then Node:=Noeud_Equivalent
  else ShowMessage('Changement de nom interdit');
  TreeView1Edited(Sender,Node,S);
end;

procedure TExploreur.TreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  TargetNode, SourceNode : TTreeNode;
begin
  TargetNode := TreeView1.GetNodeAt(  X,  Y  );
  SourceNode := TreeView1.Selected;

  if Source is TTreeView then begin
    Accept:=(Source is TTreeView) and (TTreeView(Source) = treeview1)
          and (TargetNode<>nil) and (SourceNode.Text<>'Corbeille')
          and (TargetNode<>SourceNode)
          and not TargetNode.HasAsParent(SourceNode)
          and not SourceNode.HasAsParent(TargetNode);
  end
  else if Source is TListView then begin
    if (SourceNode.level<4) and (SourceNode.Text<>'Corbeille') then SourceNode:=Noeud_Equivalent;
    Accept:=(Source is TListView) and (TListView(Source) = listview1)
          and (TargetNode<>nil) and (SourceNode.Text<>'Corbeille')
          and (TargetNode<>SourceNode)
          and not TargetNode.HasAsParent(SourceNode)
          and not SourceNode.HasAsParent(TargetNode);

  end
  else Accept:=false;
end;

procedure TExploreur.TreeView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  TargetNode, SourceNode : TTreeNode;
  S1,S2, S3, S4, D1, D2, D3, D4 : string;
  Une_Fiche : TFiche;
  Une_Origine : TOrigine;
  Deplacement : TDeplacement;
  ListItem : TListItem;
begin
  TargetNode := TreeView1.GetNodeAt(  X,  Y  );
  if TargetNode.Text<>'Corbeille' then begin
    SourceNode := TreeView1.Selected;
    Deplacement:=TDeplacement.Create;
    Localisation_Noeud(TargetNode,D1,D2,D3,D4);
    if (Source is TTreeView) or ((Source is TListView) and (SourceNode.Level<4)) then begin
      if Source is TListView then SourceNode:=Noeud_Equivalent;
      Localisation_Noeud(SourceNode,S1,S2,S3,S4);
      Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, SourceNode.Level);
      while Une_Fiche<>nil do begin
        Une_Origine:=TOrigine.Create;
        with Une_Origine do begin
          Numero_Fiche:=Une_Fiche.ordre;
          Une_Fiche.Systeme.Lit(Systeme);
          Une_Fiche.Cavite.Lit(Cavite);
          Une_Fiche.Reseau.Lit(Reseau);
          Une_Fiche.Lieu.Lit(Lieu);
          Corbeille:=false;
          Nouveau:=false;
        end;
        Deplacement.Groupe.Add(Une_Origine);

        Une_Fiche.Systeme.Ecrit(D1);
        if TargetNode.Level>1 then begin
          Une_Fiche.Cavite.Ecrit(D2);
          if TargetNode.Level>2 then begin
            Une_Fiche.Reseau.Ecrit(D3);
            if TargetNode.Level>3 then begin
              Une_Fiche.Lieu.Ecrit(D4);
            end;
          end;
        end;
        Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, SourceNode.Level);
      end;
    end
    else begin
    (* transfert d'une fiche*)
      ListItem:=ListView1.Selected;
      Une_Fiche:=ListItem.Data;
      Une_Origine:=TOrigine.Create;
      with Une_Origine do begin
        Numero_Fiche:=Une_Fiche.ordre;
        Une_Fiche.Systeme.Lit(Systeme);
        Une_Fiche.Cavite.Lit(Cavite);
        Une_Fiche.Reseau.Lit(Reseau);
        Une_Fiche.Lieu.Lit(Lieu);
        Corbeille:=false;
        Nouveau:=false;
      end;
      Deplacement.Groupe.Add(Une_Origine);

      Une_Fiche.Systeme.Ecrit(D1);
      if TargetNode.Level>1 then begin
        Une_Fiche.Cavite.Ecrit(D2);
        if TargetNode.Level>2 then begin
          Une_Fiche.Reseau.Ecrit(D3);
          if TargetNode.Level>3 then begin
            Une_Fiche.Lieu.Ecrit(D4);
          end;
        end;
      end;
    end;
    Mouvement.Add(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Rafraichir;
  end
  else begin
    Supprimer;
  end;
end;

function TExploreur.Noeud_Equivalent : TTreeNode;
var
  Node : TTreeNode;
begin
  Node := TreeView1.Selected;
  if Node=nil then ShowMessage('Noeud vide dans Noeud_Equivalent');
  Node:=Node.GetFirstChild;
  while (Node<>nil) and (UpperCase(Node.Text)<>UpperCase(ListView1.Selected.Caption)) do Node:=Node.GetNextSibling;
  Noeud_Equivalent:=Node;
end;


procedure TExploreur.Localisation_Noeud(Node : TTreeNode;var S1, S2, S3, S4 : string);
begin
  if Node=nil then ShowMessage('Noeud vide dans Localisation_Noeud');
  case Node.Level of
    0 : begin
      S1:='';
      S2:='';
      S3:='';
      S4:='';
    end;
    1 : begin
      S1:=Node.Text;
      S2:='';
      S3:='';
      S4:='';
    end;
    2 : begin
      S1:=Node.Parent.Text;
      S2:=Node.Text;
      S3:='';
      S4:='';
    end;
    3 : begin
      S1:=Node.Parent.Parent.Text;
      S2:=Node.Parent.Text;
      S3:=Node.Text;
      S4:='';
    end;
    4 : begin
      S1:=Node.Parent.Parent.Parent.Text;
      S2:=Node.Parent.Parent.Text;
      S3:=Node.Parent.Text;
      S4:=Node.Text;
    end;
  end;
end;

procedure TExploreur.ListView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  TargetItem, SourceItem : TListItem;
begin
  TargetItem := ListView1.GetItemAt(X,Y);
  SourceItem := ListView1.Selected;
  Accept:=(Source is TListView) and (TListView(Source) = listview1)
          and (TargetItem<>nil) and (SourceItem.Caption<>'Corbeille')
          and (TargetItem<>SourceItem) and (TreeView1.Selected.Level<4)
          and (TreeView1.Selected.Text<>'Corbeille');
end;

procedure TExploreur.ListView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  TargetItem : TListItem;
  SourceNode : TTreeNode;
  S1, S2, S3, S4 : string;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
  Une_Fiche : TFiche;
begin
  TargetItem := ListView1.GetItemAt(X,Y);
  if TargetItem.Caption='Corbeille' then Supprimer
  else begin
    SourceNode:=Noeud_Equivalent;
    Localisation_Noeud(SourceNode,S1,S2,S3,S4);
    Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, SourceNode.Level);
    Deplacement:=TDeplacement.Create;
    while Une_Fiche<>nil do begin
      Une_Origine:=TOrigine.Create;
      with Une_Origine do begin
        Numero_Fiche:=Une_Fiche.ordre;
        Une_Fiche.Systeme.Lit(Systeme);
        Une_Fiche.Cavite.Lit(Cavite);
        Une_Fiche.Reseau.Lit(Reseau);
        Une_Fiche.Lieu.Lit(Lieu);
        Corbeille:=false;
        Nouveau:=false;
      end;
      Deplacement.Groupe.Add(Une_Origine);

      case SourceNode.Level of
        1 : Une_Fiche.Systeme.Ecrit(TargetItem.Caption);
        2 : Une_Fiche.Cavite.Ecrit(TargetItem.Caption);
        3 : Une_Fiche.Reseau.Ecrit(TargetItem.Caption);
        4 : Une_Fiche.Lieu.Ecrit(TargetItem.Caption);
      end;
      Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, SourceNode.Level);
    end;
    Mouvement.Add(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Rafraichir;
  end;
end;

procedure TExploreur.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  Frais;
end;

procedure TExploreur.FormResize(Sender: TObject);
begin
  if WindowState=wsNormal then WindowState:=wsMinimized
  else begin
    if Form1.Web1.Checked then begin
      ListView1.Left:=Zone_Web.Left+(Width-Splitter1.Left-11) div 3;
      ListView1.Top:=70;
      ListView1.Height:=ClientHeight-70;
    end
    else begin
      ListView1.Left:=Zone_Web.Left+1;
      ListView1.Top:=0;
      ListView1.Height:=ClientHeight;
    end;
    Zone_Web.Picture.Graphic.Width:=Zone_Web.Width;
    Zone_Web.Picture.Graphic.Height:=Zone_Web.Height;
    ListView1.Width:=ClientWidth-ListView1.Left;
  end;
end;

procedure TExploreur.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if Column.Index=Colonne_Classement then Ordre_Classement:=not Ordre_Classement
  else begin
    Colonne_Classement:=Column.Index;
    Ordre_Classement:=true;
  end;
  ListView1.AlphaSort; 
end;

procedure TExploreur.ListView1Compare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var
  D1, D2 : integer;
begin
  if Colonne_Classement=0 then begin
    if (TreeView1.Selected=nil) or (TreeView1.Selected.Level<4) then begin
      if (UpperCase(Item1.Caption)>UpperCase(Item2.Caption)) xor not Ordre_Classement then Compare:=1
      else Compare:=-1;
    end
    else begin
      D1:=Date2Jour(Item1.Caption);
      D2:=Date2Jour(Item2.Caption);
      if (D1>D2) xor not Ordre_Classement then Compare:=1
      else Compare:=-1;
    end;
  end
  else begin
    if (UpperCase(Item1.SubItems[Colonne_Classement-1])>UpperCase(Item2.SubItems[Colonne_Classement-1])) xor not Ordre_Classement
    then Compare:=1
    else Compare:=-1;
  end;
end;

procedure TExploreur.Annuler;
var
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
  I, J, K : integer;
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
begin
  if Mouvement.Count>0 then begin
    Deplacement:=Mouvement[Mouvement.Count-1];
    for I:=Deplacement.Groupe.Count-1 downto 0 do begin
      Une_Origine:=Deplacement.Groupe[I];
      if Une_Origine.Nouveau then begin
        for J:=Form1.Massif.Liste_Fiche.Count-1 downto 0 do begin
          Une_Fiche:=Form1.Massif.Liste_Fiche[J];
          if Une_Fiche.Ordre=Une_Origine.Numero_Fiche then begin
            Form1.Massif.Retirer(Une_Fiche);
            Une_Fiche.Free;
          end;
        end;
      end
      else if Une_Origine.Corbeille then begin
        for J:=Form1.Massif.Liste_Fiche.Count-1 downto 0 do begin
          Une_Fiche:=Form1.Massif.Liste_Fiche[J];
          if Une_Fiche.Ordre=Une_Origine.Numero_Fiche then Form1.Massif.Retirer(Une_Fiche);
        end;
      end
      else begin
        for J:=0 to Form1.Massif.Liste_Fiche.Count-1 do begin
          Une_Fiche:=Form1.Massif.Liste_Fiche[J];
          if Une_Fiche.Ordre=Une_Origine.Numero_Fiche then begin
            Une_Fiche.Systeme.Ecrit(Une_Origine.Systeme);
            Une_Fiche.Cavite.Ecrit(Une_Origine.Cavite);
            Une_Fiche.Reseau.Ecrit(Une_Origine.Reseau);
            Une_Fiche.Lieu.Ecrit(Une_Origine.Lieu);
          end;
        end;
        for J:=Form1.Massif.Corbeille.Count-1 downto 0 do begin
          Une_Fiche:=Form1.Massif.Corbeille[J];
          if Une_Fiche.Ordre=Une_Origine.Numero_Fiche then begin
            Form1.Massif.Corbeille.Remove(Une_Fiche);
            Form1.Massif.Ajouter(Une_Fiche,true);
            for K:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
              Une_Galerie:=Une_Fiche.Liste_Galerie[K];
              Une_Galerie.Approximation:=false;
            end;
          end;
        end;
      end;
    end;
    Mouvement.Remove(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Deplacement.Free;
    Form1.Massif.Corbeille.Pack;
    Form1.Massif.Trier;
    Rafraichir;
    if Calcul_En_Cours then begin
      Calcul_Arrete:=true;
      Form1.Depart_Calcul_Rapide.Enabled:=true;
    end;
  end;
end;

procedure TExploreur.Couper;
var
  Node : TTreeNode;
  Une_Fiche : TFiche;
  S1, S2, S3, S4 : string;
begin
  if ActiveControl <> nil then begin
    if ActiveControl is TTreeView then begin
      if TreeView1.Selected.Text='Corbeille' then begin
        ShowMessage('Impossible de dplacer la corbeille');
        Node:=nil;
      end
      else if TreeView1.Selected.Level=0 then begin
        ShowMessage('Impossible de dplacer tout le massif');
        Node:=nil;
      end
      else begin
        Node:=TreeView1.Selected;
      end;
    end;
    if ActiveControl is TListView then begin
      if ListView1.Selected<>nil then begin
        if (ListView1.Selected.Caption='Corbeille') or (TreeView1.Selected.Text='Corbeille') then begin
          ShowMessage('Impossible de dplacer depuis la corbeille');
          Node:=nil;
        end
        else begin
          if TreeView1.Selected.level<4 then begin
            Node:=Noeud_Equivalent;
          end
          else begin
            Node:=nil;
            Une_Fiche:=ListView1.Selected.Data;
            Presse_Systeme:=TreeView1.Selected.Parent.Parent.Parent.Text;
            Presse_Cavite:=TreeView1.Selected.Parent.Parent.Text;
            Presse_Reseau:=TreeView1.Selected.Parent.Text;
            Presse_Lieu:=TreeView1.Selected.Text;
            Presse_Fiche:=Une_Fiche.Ordre;
            Presse_Arbre:=false;
            Presse_Actif:=true;
            Presse_Niveau:=4;
            Coupage_en_cours:=true;
          end;
        end;
      end
      else Node:=nil;
    end;
    if Node<>nil then begin
      Localisation_Noeud(Node,S1,S2,S3,S4);
      Presse_Systeme:=S1;
      Presse_Cavite:=S2;
      Presse_Reseau:=S3;
      Presse_Lieu:=S4;
      Presse_Fiche:=-1;
      Presse_Arbre:=ActiveControl is TTreeView;
      Presse_Niveau:=Node.Level;
      Presse_Actif:=true;
      Coupage_en_cours:=true;
    end;
  end;
end;

procedure TExploreur.Copier;
begin
  Couper;
  Coupage_en_cours:=false;
end;

procedure TExploreur.Coller;
var
  Node : TTreeNode;
  Deplacement : TDeplacement;
  Une_Origine : TOrigine;
  Une_Fiche, Nouvelle : TFiche;
  I : integer;
  S1, S2, S3, S4 : string;
begin
  Node:=nil;
  if ActiveControl <> nil then begin
    if ActiveControl is TTreeView then begin
      if TreeView1.Selected.Text='Corbeille' then begin
        if not Coupage_En_Cours then ShowMessage('Impossible de dupliquer vers la corbeille')
        else begin
(* mettre  la corbeille *)
        end;
      end
      else Node:=TreeView1.Selected;
    end;
    if ActiveControl is TListView then begin
      if ListView1.Selected<>nil then begin
        if (ListView1.Selected.Caption='Corbeille') or (TreeView1.Selected.Text='Corbeille') then begin
          if not Coupage_En_Cours then ShowMessage('Impossible de dupliquer vers la corbeille')
          else begin
  (* mettre  la corbeille *)
          end;
        end
        else begin
          if TreeView1.Selected.level<4 then Node:=Noeud_Equivalent
          else ShowMessage('Impossible de copier sur une fiche');
        end;
      end
      else Node:=TreeView1.Selected;
    end;
  end;

  if (Presse_Actif) and (Node<>nil) then begin
    Localisation_Noeud(Node,S1,S2,S3,S4);
    Deplacement:=TDeplacement.Create;
    if Presse_Fiche=-1 then begin
      Une_Fiche:=Premiere_Fiche(Presse_Systeme, Presse_Cavite, Presse_Reseau, Presse_Lieu, Presse_Niveau);
      while Une_Fiche<>nil do begin
        Une_Origine:=TOrigine.Create;
        if Coupage_en_cours then begin
          with Une_Origine do begin
            Numero_Fiche:=Une_Fiche.ordre;
            Une_Fiche.Systeme.Lit(Systeme);
            Une_Fiche.Cavite.Lit(Cavite);
            Une_Fiche.Reseau.Lit(Reseau);
            Une_Fiche.Lieu.Lit(Lieu);
            Corbeille:=false;
            Nouveau:=false;
          end;
          Une_Fiche.Systeme.Ecrit(S1);
          if Node.Level>1 then begin
            Une_Fiche.Cavite.Ecrit(S2);
            if Node.Level>2 then begin
              Une_Fiche.Reseau.Ecrit(S3);
              if Node.Level>3 then begin
                Une_Fiche.Lieu.Ecrit(S4);
              end;
            end;
          end;
        end
        else begin
          Nouvelle:=TFiche.Create; Nouvelle.Copie_de(Une_Fiche);
          Form1.Massif.Ajouter(Nouvelle,true);
          with Une_Origine do begin
            Numero_Fiche:=Nouvelle.ordre;
            Corbeille:=false;
            Nouveau:=true;
          end;
          Nouvelle.Systeme.Ecrit(S1);
          if Node.Level>1 then begin
            Nouvelle.Cavite.Ecrit(S2);
            if Node.Level>2 then begin
              Nouvelle.Reseau.Ecrit(S3);
              if Node.Level>3 then begin
                Nouvelle.Lieu.Ecrit(S4);
              end;
            end;
          end;
        end;
        Deplacement.Groupe.Add(Une_Origine);
        Une_Fiche:=Fiche_Suivante(Presse_Systeme, Presse_Cavite, Presse_Reseau, Presse_Lieu, Presse_Niveau);
      end;
    end
    else begin
      for I:=0 to Form1.Massif.Liste_Fiche.Count-1 do begin
        Une_Fiche:=Form1.Massif.Liste_Fiche[I];
        if Une_Fiche.Ordre=Presse_Fiche then begin
          Une_Origine:=TOrigine.Create;
          if Coupage_en_cours then begin
            with Une_Origine do begin
              Numero_Fiche:=Une_Fiche.ordre;
              Une_Fiche.Systeme.Lit(Systeme);
              Une_Fiche.Cavite.Lit(Cavite);
              Une_Fiche.Reseau.Lit(Reseau);
              Une_Fiche.Lieu.Lit(Lieu);
              Corbeille:=false;
              Nouveau:=false;
            end;
            Une_Fiche.Systeme.Ecrit(S1);
            if Node.Level>1 then begin
              Une_Fiche.Cavite.Ecrit(S2);
              if Node.Level>2 then begin
                Une_Fiche.Reseau.Ecrit(S3);
                if Node.Level>3 then begin
                  Une_Fiche.Lieu.Ecrit(S4);
                end;
              end;
            end;
          end
          else begin
            Nouvelle:=TFiche.Create;
            Nouvelle.Copie_de(Une_Fiche);
            Form1.Massif.Ajouter(Nouvelle,true);
            with Une_Origine do begin
              Numero_Fiche:=Nouvelle.ordre;
              Corbeille:=false;
              Nouveau:=true;
            end;
            Nouvelle.Systeme.Ecrit(S1);
            if Node.Level>1 then begin
              Nouvelle.Cavite.Ecrit(S2);
              if Node.Level>2 then begin
                Nouvelle.Reseau.Ecrit(S3);
                if Node.Level>3 then begin
                  Nouvelle.Lieu.Ecrit(S4);
                end;
              end;
            end;
          end;
          Deplacement.Groupe.Add(Une_Origine);
        end;
      end;
    end;
    Mouvement.Add(Deplacement);
    Form1.Massif.Sauvegarde:=false;
    Presse_Actif:=not Coupage_en_cours;
    Rafraichir;
  end;
end;

procedure TExploreur.Couper1Click(Sender: TObject);
begin
  Couper;
end;

procedure TExploreur.Copier1Click(Sender: TObject);
begin
  Copier;
end;

procedure TExploreur.Coller1Click(Sender: TObject);
begin
  Coller;
end;

procedure TExploreur.Supprimer1Click(Sender: TObject);
begin
  Supprimer;
end;

procedure TExploreur.Renommer1Click(Sender: TObject);
begin
  if ActiveControl is TTreeView then TreeView1.Selected.EditText;
  if ActiveControl is TListView then ListView1.Selected.EditCaption;
end;

procedure TExploreur.Nouvellefiche1Click(Sender: TObject);
var
  S1, S2, S3, S4 : string;
  Node : TTreeNode;
begin
  MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
  if ActiveControl is TTreeview then Node:=TreeView1.Selected;
  if ActiveControl is TListView then begin
    if ListView1.Selected=nil then Node:=TreeView1.Selected
    else Node:=Noeud_Equivalent;
  end;
  Localisation_Noeud(Node,S1,S2,S3,S4);
  if Node.Level>=1 then MultPageDlg.Systeme.Text:=S1;
  if Node.Level>=2 then MultPageDlg.Cavite.Text:=S2;
  if Node.Level>=3 then MultPageDlg.Reseau.Text:=S3;
  if Node.Level>=1 then MultPageDlg.Lieu.Text:=S4;
  Form1.Ouvre_Fiche;
end;

procedure TExploreur.Rechercher1Click(Sender: TObject);
var
  S1, S2, S3, S4 : string;
  Node : TTreeNode;
  Quelle_Fiche : TFiche;
  Position : integer;
begin
  if ActiveControl is TTreeview then Node:=TreeView1.Selected;
  if ActiveControl is TListView then begin
    if ListView1.Selected=nil then Node:=TreeView1.Selected
    else Node:=Noeud_Equivalent;
  end;
  Localisation_Noeud(Node,S1,S2,S3,S4);
  if Form1.Massif.Liste_Courante.Count>0 then begin
    Form1.Massif.Trier;
    if Form1.Massif.Existe_Selection then Form1.Massif.Trier_Selection;
    Position:=-1;
    if Recherche_Simple(Form1.Massif.Liste_Courante,Form1.Massif,Quelle_Fiche, Position,'',S1,S2,S3,S4) then begin
      MultPageDlg.Contenu(Quelle_Fiche,Form1.Massif,Form1.Preference,Position);
      ListView1.Selected:=nil;
      Form1.Ouvre_Fiche;
    end;
  end
  else MessageDlg('Il n''y a pas de fiches.',mtWarning,[mbOk],0);
end;

procedure TExploreur.Proprits1Click(Sender: TObject);
var
  Node : TTreeNode;
  Une_Fiche : TFiche;
  S1,S2,S3,S4 : string;
begin
  Node:=nil;
  if ActiveControl is TTreeview then
    Node:=TreeView1.Selected;
  if ActiveControl is TListView then begin
    if ListView1.Selected=nil then Node:=TreeView1.Selected
    else if TreeView1.Selected.Level<4 then Node:=Noeud_Equivalent;
  end;
  if (Node<>nil) and (Node.Text<>'Corbeille') then begin
    Localisation_Noeud(Node,S1,S2,S3,S4);
    Statistique:=TStatistique.Create(self);
    Statistique.Les_Fiches:=TList.Create;
    Une_Fiche:=Premiere_Fiche(S1,S2,S3,S4,Node.Level);
    while Une_Fiche<>nil do begin
      Statistique.Les_Fiches.Add(Une_Fiche);
      Une_Fiche:=Fiche_Suivante(S1,S2,S3,S4,Node.Level);
    end;
    Statistique.ShowModal;
    Statistique.Les_Fiches.Free;
    Statistique.Free;
  end;
  if (Node<>nil) and (Node.Text='Corbeille') then
    ShowMessage(Format('La corbeille comporte %d fiches.',
      [Form1.Massif.Corbeille.Count]));
  if Node=nil then begin
    Une_Fiche:=ListView1.Selected.Data;
    Statistique:=TStatistique.Create(self);
    Statistique.Les_Fiches:=TList.Create;
    Statistique.Les_Fiches.Add(Une_Fiche);
    Statistique.ShowModal;
    Statistique.Les_Fiches.Free;
    Statistique.Free;
  end;
end;

procedure TExploreur.Vider1Click(Sender: TObject);
var
  I : integer;
  Une_Fiche : TFiche;
begin
  if MessageDlg(Format('tes-vous sr de vouloir effacer ces %d fiches ?',
    [Form1.Massif.Corbeille.Count]),mtWarning,[mbYes, mbNo],0)=mrYes then begin
    for I:=0 to Form1.Massif.Corbeille.Count-1 do begin
      Une_Fiche:=Form1.Massif.Corbeille[I];
      Une_Fiche.Free; Une_Fiche:=nil;
    end;
    Form1.Massif.Corbeille.Free; Form1.Massif.Corbeille:=nil;
    Form1.Massif.Corbeille:=TList.Create;
    Form1.Massif.Sauvegarde:=false;
    Rafraichir;
  end;
end;

procedure TExploreur.FormActivate(Sender: TObject);
begin
  Form1.StatusBar.Panels[1].Text:='';
  Form1.Etat_Menu;
  Rafraichir;
end;

procedure TExploreur.Zone_webMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  I, J, K : integer;
  X0, Y0, X1, Y1, X2, Y2, DMin, Zone, RX, RY : double;
  Une_Fiche, Bonne : TFiche;
  Une_Galerie : TGalerie;
  Trouve : boolean;
  La_Zone : TList;
  S1, S2, S3, S4 : string;
  Node : TTreeNode;
begin
  if (Y>100) and (TreeView1.Selected.Text<>'Corbeille') and
      (Form1.Massif.Liste_Fiche.Count<>0) then begin
    Rx:=(X*1.0/((Width-Splitter1.Left-11) div 3))*(Xmax-XMin)+XMin;
    Ry:=((Y-100)*1.0/(Zone_Web.Height-100))*(Ymin-Ymax)+YMax;
    Trouve:=false;
    La_Zone:=TList.Create;
    Localisation_Noeud(TreeView1.Selected,S1,S2,S3,S4);
    Une_Fiche:=Premiere_Fiche(S1, S2, S3, S4, TreeView1.Selected.Level);
    while Une_Fiche<>nil do begin
      La_Zone.Add(Une_Fiche);
      Une_Fiche:=Fiche_Suivante(S1, S2, S3, S4, TreeView1.Selected.Level);
    end;
    for I:=0 to La_Zone.Count-1 do begin
      Une_Fiche:=La_Zone[I];
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        if Une_Galerie.Approximation then with Une_Galerie do begin
          X0:=Depart.X; Y0:=Depart.Y;
          if not Trouve then begin
            Trouve:=true;
            Dmin:=sqr((X0-Rx))+sqr((Y0-Ry));
            Bonne:=Une_Fiche;
          end
          else if sqr((X0-Rx))+sqr((Y0-Ry))<Dmin then begin
            Dmin:=sqr((X0-Rx))+sqr((Y0-Ry));
            Bonne:=Une_Fiche;
          end;
          X1:=X0; Y1:=Y0;
          for K:=1 to Nb_Visee do begin
            X2:=Coordonnees^[K].X;
            Y2:=Coordonnees^[K].Y;
            Zone:=(Rx-X1)*(X2-X1)+(Ry-Y1)*(Y2-Y1);
            if Zone>sqr(X2-X1)+sqr(Y2-Y1) then begin
              if sqr((X2-Rx))+sqr((Y2-Ry))<Dmin then begin
                Dmin:=sqr((X2-Rx))+sqr((Y2-Ry));
                Bonne:=Une_Fiche;
              end;
            end
            else if (Zone>0) and ((X1<>X2) or (Y1<>Y2)) then begin
              Zone:=(X2-X1)*(Ry-Y1)-(Y2-Y1)*(Rx-X1);
              Zone:=sqr(Zone)/(sqr(X2-X1)+sqr(Y2-Y1));
              if Zone<Dmin then begin
                Dmin:=Zone;
                Bonne:=Une_Fiche;
              end;
            end;
            X1:=X2; Y1:=Y2;
          end;
        end;
      end;
    end;
    La_Zone.Free;
    ListView1.SetFocus;
    if TreeView1.Selected.Level=4 then begin
      Node:=TreeView1.Selected;
      I:=0;
      while (I<ListView1.Items.Count) and (Bonne<>ListView1.Items[I].Data) do inc(I);
      if I<>ListView1.Items.Count then ListView1.Items[I].Selected:=true;
    end
    else begin
      case TreeView1.Selected.Level of
        0 : Bonne.Systeme.Lit(S1);
        1 : Bonne.Cavite.Lit(S1);
        2 : Bonne.Reseau.Lit(S1);
        3 : Bonne.Lieu.Lit(S1);
      end;
      for I:=0 to ListView1.Items.Count-1 do if UpperCase(ListView1.Items[I].Caption)=UpperCase(S1)
                            then ListView1.Items[I].Selected:=true;
    end;
  end;
end;

procedure TExploreur.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  Timer2.Enabled:=true;
end;

procedure TExploreur.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled:=false;
  Volet_Web;
end;

procedure TExploreur.Isoler1Click(Sender: TObject);
var
  Node : TTreeNode;
  Une_Fiche : TFiche;
  S1,S2,S3,S4 : string;
  Selection_Du_Jour : TList;
begin
  Node:=nil;
  if ActiveControl is TTreeview then
    Node:=TreeView1.Selected;
  if ActiveControl is TListView then begin
    if ListView1.Selected=nil then Node:=TreeView1.Selected
    else if TreeView1.Selected.Level<4 then Node:=Noeud_Equivalent;
  end;
  if Node<>nil then begin
    Localisation_Noeud(Node,S1,S2,S3,S4);
    Selection_Du_Jour:=TList.Create;
    Une_Fiche:=Premiere_Fiche(S1,S2,S3,S4,Node.Level);
    while Une_Fiche<>nil do begin
      Selection_Du_Jour.Add(Une_Fiche);
      Une_Fiche:=Fiche_Suivante(S1,S2,S3,S4,Node.Level);
    end;
  end
  else begin
    Une_Fiche:=ListView1.Selected.Data;
    Selection_Du_Jour:=TList.Create;
    Selection_Du_Jour.Add(Une_Fiche);
  end;
  Form1.Massif.Selection.Free;
  Form1.Massif.Selection:=Selection_Du_Jour;
  Form1.Massif.Existe_Selection:=true;
  Form1.Massif.Liste_Courante:=Form1.Massif.Selection;
  Form1.Massif.Trier_Selection;
  Form1.Massif.Gabarit_Tableau:=false;
  Form1.Mise_A_Jour;
  Form1.Rcuprer1.Enabled:=true;
  Form1.StatusBar.Panels[0].Text:='Slection';
  Rafraichir;
end;

procedure TExploreur.Zone_webDblClick(Sender: TObject);
begin
  if (TreeView1.Selected.Text<>'Corbeille') and
     (Form1.Massif.Liste_Fiche.Count<>0) then begin
    if ActiveControl is TTreeView then Le_Noeud.Selected:=true;
    if ActiveControl is TListView then ListView1DblClick(Sender);
  end;
end;

procedure TExploreur.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
        HT: THitTests;
begin
        HT := TreeView1.GetHitTestInfoAt(X, Y);
        if (HT - [htOnItem] <> HT) and  (button=mbRight) then
        TreeView1.selected:=TreeView1.getNodeAt(X,Y);
end;

procedure TExploreur.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
  if Node.GetFirstChild=nil then Completer_TreeView(Node);
end;

procedure TExploreur.Exclure1Click(Sender: TObject);
var
  Node : TTreeNode;
  Une_Fiche : TFiche;
  S1,S2,S3,S4 : string;
  T1,T2,T3,T4 : string;
  Selection_Du_Jour : TList;
  I : integer;
begin
  Node:=nil;
  if ActiveControl is TTreeview then
    Node:=TreeView1.Selected;
  if ActiveControl is TListView then begin
    if ListView1.Selected=nil then Node:=TreeView1.Selected
    else if TreeView1.Selected.Level<4 then Node:=Noeud_Equivalent;
  end;
  if Node<>nil then begin
    Localisation_Noeud(Node,S1,S2,S3,S4);
    S1:=UpperCase(S1); S2:=UpperCase(S2); S3:=UpperCase(S3); S4:=UpperCase(S4);
    Selection_Du_Jour:=TList.Create;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do
    begin
      Une_Fiche:=Form1.Massif.Liste_Courante[I];
      Une_Fiche.Systeme.Lit(T1);
      Une_Fiche.Cavite.Lit(T2);
      Une_Fiche.Reseau.Lit(T3);
      Une_Fiche.Lieu.Lit(T4);
      T1:=UpperCase(T1); T2:=UpperCase(T2); T3:=UpperCase(T3); T4:=UpperCase(T4);
      case Node.Level of
        1 : if S1<>T1 then
          Selection_Du_Jour.Add(Une_Fiche);
        2 : if (S1<>T1) or (S2<>T2) then
          Selection_Du_Jour.Add(Une_Fiche);
        3 : if (S1<>T1) or (S2<>T2) or (S3<>T3) then
          Selection_Du_Jour.Add(Une_Fiche);
        4 : if (S1<>T1) or (S2<>T2) or (S3<>T3) or (S4<>T4) then
          Selection_Du_Jour.Add(Une_Fiche);
      else
        assert(false,Format('Niveau %d imprvu dans Exclure',[Node.Level]));
      end;
    end;
  end
  else
  begin
    Selection_Du_Jour:=TList.Create;
    Une_Fiche:=ListView1.Selected.Data;
    for I:=0 to Form1.Massif.Liste_Courante.Count-1 do
      if Une_Fiche<>TFiche(Form1.Massif.Liste_Courante[I]) then
        Selection_Du_Jour.Add(Form1.Massif.Liste_Courante[I]);
  end;
  Form1.Massif.Selection.Free;
  Form1.Massif.Selection:=Selection_Du_Jour;
  Form1.Massif.Existe_Selection:=true;
  Form1.Massif.Liste_Courante:=Form1.Massif.Selection;
  Form1.Massif.Trier_Selection;
  Form1.Massif.Gabarit_Tableau:=false;
  Form1.Mise_A_Jour;
  Form1.Rcuprer1.Enabled:=true;
  Form1.StatusBar.Panels[0].Text:='Slection';
  Rafraichir;
end;

end.

