{$N-}
unit Base;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FicheTpo, StdCtrls, Buttons, ExtCtrls;

type

  TListeBoolean = array[0..32000] of boolean;
  PListeBoolean = ^TListeBoolean;

  TEquivalent = class
    Nom : TEco;
    Indice_Local, Indice_Ext : byte;
    constructor Create;
    destructor Destroy; override;
  end;

  TPrincipale = class(TForm)
    OpenDialog1: TOpenDialog;
    ListeLocal: TListBox;
    ListeExt: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Quitter: TButton;
    Enregistrer: TButton;
    SaveDialog1: TSaveDialog;
    Retire_Local: TButton;
    Retire_Ext: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Retire_LocalClick(Sender: TObject);
    procedure Retire_ExtClick(Sender: TObject);
    procedure EnregistrerClick(Sender: TObject);
    procedure ListeLocalMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListeExtMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    Local, Exterieur : TMassif;
    Echec_Creation : boolean;
    Trouve_Local, Trouve_Ext : PListeBoolean;
    Liste_Equivalent, Retrait_Local : TList;
    procedure Premiere_Approche;
    procedure Retirer_Coupe(N_Ordre : longint; N_Galerie : smallInt; Racine : boolean);
  end;

var
  Principale: TPrincipale;

implementation

{$R *.DFM}

procedure TPrincipale.FormCreate(Sender: TObject);
begin
  Liste_Equivalent:=TList.Create;
  Retrait_Local:=TList.Create;
  Echec_Creation:=false;
  OpenDialog1.Title:='Massif local';
  if OpenDialog1.Execute then begin
    Screen.Cursor:=crHourGlass;
    Local:=TMassif.Create;
    Local.Fichier:=OpenDialog1.FileName;
    Label3.Caption:=ExtractFilePath(Local.Fichier);
    Label5.Caption:=ExtractFileName(Local.Fichier);
    if Local.Recuperer then begin
      OpenDialog1.Title:='Massif extrieur';
      Screen.Cursor:=crDefault;
      if OpenDialog1.Execute then begin
        Screen.Cursor:=crHourGlass;
        Exterieur:=TMassif.Create;
        Exterieur.Fichier:=OpenDialog1.FileName;
        Label4.Caption:=ExtractFilePath(Exterieur.Fichier);
        Label6.Caption:=ExtractFileName(Exterieur.Fichier);
        if not Exterieur.Recuperer then begin
          Echec_Creation:=true;
          Screen.Cursor:=crDefault;
          ShowMessage('Il faut refermer la fiche en cours d''dition du massif extrieur');
        end;
      end
      else Echec_Creation:=true;
    end
    else begin
      Echec_Creation:=true;
      ShowMessage('Il faut refermer la fiche en cours d''dition du massif local');
      Screen.Cursor:=crDefault;
    end;
  end
  else Echec_Creation:=true;
  if not Echec_Creation then Premiere_Approche
  else Timer1.Enabled:=true;
end;

procedure TPrincipale.Premiere_Approche;
var
  I, J, K, L : longint;
  Une_Fiche, L_Autre : TFiche;
  S, Totale : string;
  Topog : TEco;
  Un_Equivalent : TEquivalent;
  Une_Galerie, L_Autre_Galerie : TGalerie;
  Existe_Deja : boolean;
begin
  GetMem(Trouve_Local,Local.Liste_Fiche.Count*sizeOf(boolean));
  GetMem(Trouve_Ext,Exterieur.Liste_Fiche.Count*sizeOf(boolean));
  for I:=0 to Local.Liste_Fiche.Count-1 do Trouve_Local^[I]:=false;
  for I:=0 to Exterieur.Liste_Fiche.Count-1 do Trouve_Ext^[I]:=false;
  for I:=0 to Local.Liste_Fiche.Count-1 do begin
    Une_Fiche:=Local.Liste_Fiche[I];
    for J:=0 to Exterieur.Liste_Fiche.Count-1 do if not Trouve_Ext^[J] then begin
      L_Autre:=Exterieur.Liste_Fiche[J];
      if Une_Fiche.Identique(L_Autre) then begin
        Trouve_Local^[I]:=true;
        Trouve_Ext^[J]:=true;
        for K:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
          Une_Galerie:=Une_Fiche.Liste_Galerie[K];
          L_Autre_Galerie:=L_Autre.Liste_Galerie[K];
          if not Une_Galerie.Depart.Terminus then begin
            Existe_Deja:=false;
            for L:=0 to Liste_Equivalent.Count-1 do begin
              Un_Equivalent:=Liste_Equivalent[L];
              if Un_Equivalent.Nom.Identique(Une_Galerie.Depart.Nom) and
                  (Un_Equivalent.Indice_Local=Une_Galerie.Depart.Indice) then Existe_Deja:=true;
{* pour dtecter un bug de correspondance, c'est ici *}
            end;
            if not Existe_Deja then begin
              Un_Equivalent:=TEquivalent.Create;
              Un_Equivalent.Nom.Duplique(Une_Galerie.Depart.Nom);
              Un_Equivalent.Indice_Local:=Une_Galerie.Depart.Indice;
              Un_Equivalent.Indice_Ext:=L_Autre_Galerie.Depart.Indice;
              Liste_Equivalent.Add(Un_Equivalent);
            end;
          end;
          if not Une_Galerie.Arrivee.Terminus then begin
            Existe_Deja:=false;
            for L:=0 to Liste_Equivalent.Count-1 do begin
              Un_Equivalent:=Liste_Equivalent[L];
              if Un_Equivalent.Nom.Identique(Une_Galerie.Arrivee.Nom) and
                  (Un_Equivalent.Indice_Local=Une_Galerie.Arrivee.Indice) then Existe_Deja:=true;
{* pour dtecter un bug de correspondance, c'est ici aussi*}
            end;
            if not Existe_Deja then begin
              Un_Equivalent:=TEquivalent.Create;
              Un_Equivalent.Nom.Duplique(Une_Galerie.Arrivee.Nom);
              Un_Equivalent.Indice_Local:=Une_Galerie.Arrivee.Indice;
              Un_Equivalent.Indice_Ext:=L_Autre_Galerie.Arrivee.Indice;
              Liste_Equivalent.Add(Un_Equivalent);
            end;
          end;
        end;
      end;
    end;
  end;
  for I:=0 to Local.Liste_Fiche.Count-1 do if not Trouve_Local^[I] then begin
    Une_Fiche:=Local.Liste_Fiche[I];
    with Une_Fiche do begin
      Systeme.Lit(S); Totale:=S;
      Cavite.Lit(S); Totale:=Totale+'/'+S;
      Reseau.Lit(S); Totale:=Totale+'/'+S;
      Lieu.Lit(S); Totale:=Totale+'/'+S;
      Totale:=Totale+'/ '+Date;
      for J:=0 to Topographes.Count-1 do begin
        Topog:=Topographes[J];
        Topog.Lit(S); Totale:=Totale+'  '+S;
      end;
    end;
    ListeLocal.Items.AddObject(Totale,Une_Fiche);
  end;
  for I:=0 to Exterieur.Liste_Fiche.Count-1 do if not Trouve_Ext^[I] then begin
    Une_Fiche:=Exterieur.Liste_Fiche[I];
    with Une_Fiche do begin
      Systeme.Lit(S); Totale:=S;
      Cavite.Lit(S); Totale:=Totale+'/'+S;
      Reseau.Lit(S); Totale:=Totale+'/'+S;
      Lieu.Lit(S); Totale:=Totale+'/'+S;
      Totale:=Totale+'/ '+Date;
      for J:=0 to Topographes.Count-1 do begin
        Topog:=Topographes[J];
        Topog.Lit(S); Totale:=Totale+'  '+S;
      end;
    end;
    ListeExt.Items.AddObject(Totale,Une_Fiche);
  end;
  Screen.Cursor:=crDefault;
end;

procedure TPrincipale.FormResize(Sender: TObject);
begin
  ListeLocal.Height:=ClientHeight-152;
  ListeExt.Height:=ClientHeight-152;
  Enregistrer.Top:=ClientHeight-56;
  Quitter.Top:=ClientHeight-56;
  Retire_Local.Top:=ClientHeight-97;
  Retire_Ext.Top:=ClientHeight-97;
  ListeLocal.Width:=ClientWidth div 2 -44;
  ListeExt.Width:=ClientWidth div 2 -44;
  ListeExt.Left:=ClientWidth div 2 +3;
  Label2.Left:=ClientWidth div 2 +19;
  Label4.Left:=ClientWidth div 2 +11;
  Label6.Left:=ClientWidth div 2 +19;
  Retire_Ext.Left:=ClientWidth div 2 +11;
end;

procedure TPrincipale.QuitterClick(Sender: TObject);
begin
  Close;
end;

procedure TPrincipale.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I : integer;
  Un_Equivalent : TEquivalent;
begin
  if not Echec_Creation then begin
    FreeMem(Trouve_Local,Local.Liste_Fiche.Count*sizeOf(boolean));
    FreeMem(Trouve_Ext,Exterieur.Liste_Fiche.Count*sizeOf(boolean));
  end;
  Local.Free;
  Exterieur.Free;
  for I:=0 to Liste_Equivalent.Count-1 do begin
    Un_Equivalent:=Liste_Equivalent[I];
    Un_Equivalent.Free; Un_Equivalent:=nil;
  end;
  Liste_Equivalent.Free;
  Retrait_Local.Free;
end;


constructor TEquivalent.Create;
begin
  Nom:=TEco.Create;
end;

destructor TEquivalent.Destroy;
begin
  Nom.Free;
end;

procedure TPrincipale.Retire_LocalClick(Sender: TObject);
var
  Position : integer;
  Une_Fiche : TObject;
begin
  Position:=ListeLocal.ItemIndex;
  if Position<>-1 then begin
    Une_Fiche:=ListeLocal.Items.Objects[Position];
    Retrait_Local.Add(Une_Fiche);
    ListeLocal.Items.Delete(Position);
  end;
end;

procedure TPrincipale.Retire_ExtClick(Sender: TObject);
begin
  if ListeExt.ItemIndex<>-1 then ListeExt.Items.Delete(ListeExt.ItemIndex);
end;

procedure TPrincipale.EnregistrerClick(Sender: TObject);
var
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
  I, J : integer;
  Concordance : boolean;
  Un_Equivalent : TEquivalent;
  S : string;

  procedure Trouve_Indice(Station : TPointTopo; Fin: boolean);
  { //dtermine le nouvel indice d'un point appartenant au massif extrieur
  // essaie dabord de conserver le mme indice
  // sinon commence  partir de 1 }
  var
    K, L_Indice : integer;

    function Valable : boolean; {//regarde si l'indice n'est pas dj utilis dans la mme fiche}
    var
      L : integer;
    begin
      result:=true;
      for L:=0 to J-1 do with TGalerie(Une_Fiche.Liste_Galerie[L]) do begin
        if Depart.Nom.Identique(Station.Nom) and (Depart.Indice=L_Indice) then result:=false;
        if Arrivee.Nom.Identique(Station.Nom) and (Arrivee.Indice=L_Indice) then result:=false;
      end;
      if Fin then with TGalerie(Une_Fiche.Liste_Galerie[J]) do begin
        if Depart.Nom.Identique(Station.Nom) and (Depart.Indice=L_Indice) then result:=false;
      end;
    end;

  begin
    if not Station.Terminus then begin
      Concordance:=false;
      for K:=0 to Liste_Equivalent.Count-1 do begin
        Un_Equivalent:=Liste_Equivalent[K];
        if Un_Equivalent.Nom.Identique(Station.Nom) and
          (Un_Equivalent.Indice_Ext=Station.Indice) then begin
          Concordance:=true;
          L_Indice:=Un_Equivalent.Indice_Local;
        end;
      end;
      if Concordance then Station.Indice:=L_Indice
      else begin
        Station.Nom.Lit(S);
        L_Indice:=Local.Nouveau_Point(S,Station.Indice-1);
        if L_Indice<>Station.Indice then begin
          L_Indice:=0;
          repeat
            L_Indice:=Local.Nouveau_Point(S,L_Indice);
          until Valable;
        end;
        Un_Equivalent:=TEquivalent.Create;
        Un_Equivalent.Nom.Duplique(Station.Nom);
        Un_Equivalent.Indice_Local:=L_Indice;
        Un_Equivalent.Indice_Ext:=Station.Indice;
        Station.Indice:=L_Indice;
        Liste_Equivalent.Add(Un_Equivalent);
      end;
    end;
  end;

begin
  SaveDialog1.FileName:=Local.Fichier;
  if SaveDialog1.execute then begin
    Cursor:=crHourGlass;
    Retire_Local.Enabled:=false;
    Retire_Ext.Enabled:=false;
    Quitter.Enabled:=false;
    Enregistrer.Enabled:=false;
    for I:=0 to Retrait_Local.Count-1 do begin
      Une_Fiche:=Retrait_Local[I];
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        if Une_Galerie.En_Coupe then Retirer_Coupe(Une_Fiche.Ordre,J,true);
      end;
      Local.Retirer(Une_Fiche);
    end;
    for I:=0 to ListeExt.Items.Count-1 do begin
      Une_Fiche:=TFiche(ListeExt.Items.Objects[I]);
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie[J];
        with Une_Galerie do begin
          En_Coupe:=false; Nb_Suite:=0;
          Trouve_Indice(Depart,false);
          Trouve_Indice(Arrivee,true);
        end;
      end;
      Local.Ajouter(Une_Fiche,false);
      Exterieur.Retirer(Une_Fiche);
    end;
    Local.Enregistrer(SaveDialog1.FileName);
    for I:=0 to Retrait_Local.Count-1 do begin
      Une_Fiche:=Retrait_Local[I];
      Une_Fiche.Free; Une_Fiche:=nil;
    end;
    Close;
  end;
end;

procedure TPrincipale.Retirer_Coupe(N_Ordre : longint; N_Galerie : smallInt; Racine : boolean);
var
  I, J, K : integer;
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Un_Germe : TPointCoupe;
  Detecte : boolean;
begin
  I:=0;
  repeat
    Une_Fiche:=Local.Liste_Fiche.Items[I];
    inc(I);
  until Une_Fiche.Ordre=N_Ordre;
  Une_Galerie:=Une_Fiche.Liste_Galerie.Items[N_Galerie];
  Une_Galerie.En_Coupe:=false;
  for I:=1 to Une_Galerie.Nb_Suite do
     Retirer_Coupe(Une_Galerie.Ordre_Suite[I],Une_Galerie.Galerie_Suite[I],false);
  if Racine then begin
    Detecte:=false;
    for I:=0 to Local.Germe_Coupe.Count-1 do begin
      if Detecte then Un_Germe:=Local.Germe_Coupe[I-1]
                 else Un_Germe:=Local.Germe_Coupe[I];
      if (Un_Germe.Ordre_Suite=N_Ordre) and (Un_Germe.Galerie_Suite=N_Galerie) then begin
        Local.Germe_Coupe.Remove(Un_Germe);
        Local.Germe_Coupe.Pack;
        Un_Germe.Free; Un_Germe:=nil;
        Detecte:=true;
      end;
    end;
    for I:=0 to Local.Liste_Fiche.Count-1 do begin
      Une_Fiche:=Local.Liste_Fiche.Items[I];
      for J:=0 to Une_Fiche.Liste_Galerie.Count-1 do begin
        Une_Galerie:=Une_Fiche.Liste_Galerie.Items[J];
        Detecte:=false;
        if Une_Galerie.En_Coupe then begin
          for K:=1 to Une_Galerie.Nb_Suite do begin
            if not Detecte and (Une_Galerie.Ordre_Suite[K]=N_Ordre)
                           and (Une_Galerie.Galerie_Suite[K]=N_Galerie) then Detecte:=true;
            if Detecte then begin
              if K<Une_Galerie.Nb_Suite then begin
                Une_Galerie.Ordre_Suite[K]:=Une_Galerie.Ordre_Suite[K+1];
                Une_Galerie.Galerie_Suite[K]:=Une_Galerie.Galerie_Suite[K+1];
              end;
            end;
          end;
          if Detecte then dec(Une_Galerie.Nb_Suite);
        end;
      end;
    end;
  end;
end;

procedure TPrincipale.ListeLocalMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Value: Integer;
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  Value := ListeLocal.ItemAtPos(APoint, true);
  if Value>=0 then Panel1.Caption:=ListeLocal.Items[Value];
end;

procedure TPrincipale.ListeExtMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Value: Integer;
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  Value := ListeExt.ItemAtPos(APoint, true);
  if Value>=0 then Panel1.Caption:=ListeExt.Items[Value];
end;

procedure TPrincipale.Timer1Timer(Sender: TObject);
begin
  Close;
end;

procedure TPrincipale.FormShow(Sender: TObject);
var
  ScrollWidth, Largeur : SmallInt;
  I : integer;
begin
  ScrollWidth:=0;
  ListeLocal.Canvas.Font:=ListeLocal.Font;
  for I:=0 to ListeLocal.Items.Count-1 do begin
    Largeur:=ListeLocal.Canvas.TextWidth(ListeLocal.Items[I]);
    if Largeur>ScrollWidth then ScrollWidth:=Largeur;
  end;
  inc(ScrollWidth,3);
  PostMessage( ListeLocal.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);

  ScrollWidth:=0;
  ListeExt.Canvas.Font:=ListeExt.Font;
  for I:=0 to ListeExt.Items.Count-1 do begin
    Largeur:=ListeExt.Canvas.TextWidth(ListeExt.Items[I]);
    if Largeur>ScrollWidth then ScrollWidth:=Largeur;
  end;
  inc(ScrollWidth,3);
  PostMessage( ListeExt.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);
end;

end.
