unit keydefs;

{$X+,D-}

interface

uses WinTypes;

const
  MaxKeys = 38;
  ControlKey = '^';
  AltKey = '@';
  ShiftKey = '~';
  KeyGroupOpen = '{';
  KeyGroupClose = '}';

type
  TKeyString = String[9];

  TKeyDef = record
    Key: TKeyString;
    vkCode: Byte;
  end;

const
  KeyDefArray : array[1..MaxKeys] of TKeyDef = (
    (Key: 'LBUTTON';   vkCode: VK_LBUTTON),
    (Key: 'RBUTTON';   vkCode: VK_RBUTTON),
    (Key: 'CTRLBREAK'; vkCode: VK_CANCEL),
    (Key: 'MBUTTON';   vkCode: VK_MBUTTON),
    (Key: 'F1';        vkCode: vk_F1),
    (Key: 'F2';        vkCode: vk_F2),
    (Key: 'F3';        vkCode: vk_F3),
    (Key: 'F4';        vkCode: vk_F4),
    (Key: 'F5';        vkCode: vk_F5),
    (Key: 'F6';        vkCode: vk_F6),
    (Key: 'F7';        vkCode: vk_F7),
    (Key: 'F8';        vkCode: vk_F8),
    (Key: 'F9';        vkCode: vk_F9),
    (Key: 'F10';       vkCode: vk_F10),
    (Key: 'F11';       vkCode: vk_F11),
    (Key: 'F12';       vkCode: vk_F12),
    (Key: 'INSERT';    vkCode: vk_Insert),
    (Key: 'DELETE';    vkCode: vk_Delete),
    (Key: 'HOME';      vkCode: vk_Home),
    (Key: 'END';       vkCode: vk_End),
    (Key: 'PGUP';      vkCode: vk_Prior),
    (Key: 'PGDN';      vkCode: vk_Next),
    (Key: 'LEFT';      vkCode: VK_LEFT),
    (Key: 'UP';        vkCode: VK_UP),
    (Key: 'RIGHT';     vkCode: VK_RIGHT),
    (Key: 'DOWN';      vkCode: VK_DOWN),
    (Key: 'SELECT';    vkCode: VK_SELECT),
    (Key: 'TAB';       vkCode: vk_Tab),
    (Key: 'ENTER';     vkCode: vk_Return),
    (Key: 'BACK';      vkCode: vk_Back),
    (Key: 'PRTSCR';    vkCode: vk_SnapShot),  // Tout l'cran
    (Key: '@PRTSCR';   vkCode: vk_SnapShot),  // Fentre active
    (Key: 'SHIFT';     vkCode: vk_Shift),
    (Key: 'ESCAPE';    vkCode: vk_Escape),
    (Key: 'PAUSE';     vkCode: VK_PAUSE),
    (Key: 'CAPITAL';   vkCode: VK_CAPITAL),
    (Key: 'SCROLL';    vkCode: VK_SCROLL),
    (Key: 'WAIT';      vkCode: 0));           // Process Messages

function FindKeyInArray(Key: TKeyString; var Code: Byte): Boolean;

implementation

uses SysUtils;

function FindKeyInArray(Key: TKeyString; var Code: Byte): Boolean;
{ function searches array for token passed in Key, and returns the }

{ virtual key code in Code. }
var
  i: word;
begin
  Result := False;
  for i := Low(KeyDefArray) to High(KeyDefArray) do
    if UpperCase(Key) = KeyDefArray[i].Key then
    begin
      Code := KeyDefArray[i].vkCode;
      Result := True;
      Break;
    end;
end;

end.

