unit nouveau;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, checklst;

type
  TNouveaute = class(TForm)
    Arriere: TButton;
    Avant: TButton;
    Button3: TButton;
    Panneau: TNotebook;
    Label1: TLabel;
    Niveau: TRadioGroup;
    Label2: TLabel;
    Label3: TLabel;
    Nom_Massif: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Declinaisons: TButton;
    References: TButton;
    Label7: TLabel;
    Nom_Cavite: TEdit;
    Label8: TLabel;
    Isole: TRadioButton;
    jonctionne: TRadioButton;
    Label9: TLabel;
    systeme_connu: TRadioButton;
    Label10: TLabel;
    nouveau_systeme: TRadioButton;
    Label11: TLabel;
    Nom_systeme: TComboBox;
    Check_Systeme: TCheckListBox;
    Label12: TLabel;
    Saisie_systeme: TEdit;
    Check_cavite: TCheckListBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Combo_systeme: TComboBox;
    Label17: TLabel;
    Combo_cavite: TComboBox;
    Label18: TLabel;
    Combo_reseau: TComboBox;
    Label19: TLabel;
    Combo_lieu: TComboBox;
    Courant: TRadioButton;
    Connu: TRadioButton;
    Nouveau: TRadioButton;
    procedure NiveauClick(Sender: TObject);
    procedure AvantClick(Sender: TObject);
    procedure ArriereClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Nom_MassifClick(Sender: TObject);
    procedure DeclinaisonsClick(Sender: TObject);
    procedure ReferencesClick(Sender: TObject);
    procedure ConnuClick(Sender: TObject);
    procedure IsoleClick(Sender: TObject);
    procedure Nom_CaviteChange(Sender: TObject);
    procedure Saisie_systemeChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Etape : integer;
    Sens_Unique : boolean;
    procedure Rempli_les_noms(les_items : Tstrings; Les_Quels : Integer);
    procedure Taille_CheckBox;
  end;

var
  Nouveaute: TNouveaute;

implementation

uses Unit1, Unit2, FicheTpo;

const
  niSysteme = 0;
  niCavite = 1;
  niReseau = 2;
  niLieu = 3;

{$R *.DFM}

procedure TNouveaute.NiveauClick(Sender: TObject);
begin
  Avant.Enabled:=(Niveau.ItemIndex<>-1);
end;

procedure TNouveaute.Rempli_les_noms(les_items : Tstrings; Les_Quels : Integer);
var
  I, J : integer;
  S : string;
begin
  les_items.Clear;
  for I:=0 to Form1.Massif.Liste_Fiche.Count-1 do with TFiche(Form1.Massif.Liste_Fiche[I]) do begin
    case Les_Quels of
      niSysteme : Systeme.Lit(S);
      niCavite : Cavite.Lit(S);
      niReseau : Reseau.Lit(S);
      niLieu : Lieu.Lit(S);
    end;
    if (S<>'') and (UpperCase(S)<>UpperCase('Surface')) and (UpperCase(S)<>UpperCase('Isol')) then begin
      J:=Les_Items.Count-1;
      while (J>=0) and (UpperCase(Les_Items[J])<>UpperCase(S)) do dec(J);
      if J<0 then Les_Items.Add(S);
    end;
  end;
end;

procedure TNouveaute.AvantClick(Sender: TObject);
var
  Echec : boolean;
  I, J : integer;
  S : string;
begin
  Panneau.SetFocus;
  case Etape of
    0 : begin
      if Niveau.ItemIndex=0 then begin
        Caption:='Nouveau massif';
        if not Sens_Unique or Form1.Fermeture_Precedent(true,sender) then begin
          Caption:='Nouveau massif';
          if Sens_Unique then Form1.FermerMassif;
          Form1.OuvreMassif('');
          Etape:=2;
          Panneau.PageIndex:=2;
          Avant.Enabled:=true;
          Avant.Caption:='&Terminer';
          Arriere.Visible:=not Sens_Unique;
        end;
      end
      else begin
        case Niveau.ItemIndex of
          1 : Caption:='Nouveau systme';
          2 : Caption:='Nouvelle cavit';
          3 : Caption:='Nouvelle exploration';
          4 : Caption:='Nouveau cheminement de surface';
        end;
        Etape:=1;
        Panneau.PageIndex:=1;
        Avant.Enabled:=(Form1.Massif<>nil);
        Arriere.Visible:=true;
        Courant.Checked:=true;
        Connu.Checked:=false;
        Nouveau.Checked:=false;
        Courant.Visible:=(Form1.Massif<>nil);
      end;
    end;
    1 : begin
      if Nouveau.Checked then begin
        if not Sens_Unique or Form1.Fermeture_Precedent(true,sender) then begin
          if Sens_Unique then Form1.FermerMassif;
          Form1.OuvreMassif('');
          Etape:=8;
          Panneau.PageIndex:=2;
          Avant.Enabled:=true;
          Arriere.Visible:=not Sens_Unique;
        end;
      end
      else begin
        Echec:=false;
        if Connu.Checked then begin
          Echec:=true;
          if not Sens_Unique or Form1.Fermeture_Precedent(true,sender) then begin
            if Form1.Opendialog1.Execute then begin
              if Sens_Unique then Form1.FermerMassif;
              Form1.OuvreMassif(Form1.OpenDialog1.FileName);
              Echec:=false;
            end;
          end;
        end;
        if not Echec then begin
          case Niveau.ItemIndex of
            1 : begin
              Etape:=6;
              Panneau.PageIndex:=6;
              Avant.Caption:='&Terminer';
              Avant.Enabled:=false;
              if Connu.Checked then Arriere.Visible:=not Sens_Unique
              else Arriere.Visible:=true;
              Rempli_les_noms(Check_Systeme.Items,niSysteme);
              Rempli_les_noms(Check_Cavite.Items,niCavite);
              Taille_CheckBox;
            end;
            2 : begin
              Etape:=3;
              Panneau.PageIndex:=3;
              Avant.Enabled:=false;
              if Connu.Checked then Arriere.Visible:=not Sens_Unique
              else Arriere.Visible:=true;
              Avant.Caption:='&Suivant >';
              Label8.Visible:=true;
              Isole.Visible:=true;
              Jonctionne.Visible:=true;
              Isole.checked:=false;
              Jonctionne.checked:=false;
            end;
            3 : begin
              Etape:=7;
              Panneau.PageIndex:=7;
              Rempli_les_noms(Combo_Systeme.Items,niSysteme);
              Rempli_les_noms(Combo_Cavite.Items,niCavite);
              Rempli_les_noms(Combo_Reseau.Items,niReseau);
              Rempli_les_noms(Combo_Lieu.Items,niLieu);
              Avant.Caption:='&Terminer';
              Avant.Enabled:=true;
              if Connu.Checked then Arriere.Visible:=not Sens_Unique
              else Arriere.Visible:=true;
            end;
            4 : begin
              MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
              MultPageDlg.Systeme.Text:='Surface';
              Close;
              Form1.Ouvre_Fiche;
            end;
          end;
        end;
      end;
    end;
    2 : begin
      ModalResult:=mrOk;
    end;
    3 : begin
      if not Label8.Visible or Isole.Checked then begin
        MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
        MultPageDlg.Systeme.Text:='Isol';
        MultPageDlg.Cavite.Text:=Nom_Cavite.Text;
        Close;
        Form1.Ouvre_Fiche;
      end
      else begin
        Etape:=4;
        Panneau.pageIndex:=4;
        Systeme_Connu.Checked:=false;
        Nouveau_Systeme.Checked:=false;
        Avant.Enabled:=false;
        Arriere.Visible:=true;
      end;
    end;
    4 : begin
      if Systeme_Connu.Checked then begin
        Etape:=5;
        Panneau.PageIndex:=5;
        Avant.Caption:='&Terminer';
        Avant.Enabled:=false;
        Rempli_les_noms(Nom_Systeme.Items,niSysteme);
      end
      else begin
        Etape:=6;
        Panneau.PageIndex:=6;
        Avant.Caption:='&Terminer';
        Avant.Enabled:=false;
        Rempli_les_noms(Check_Systeme.Items,niSysteme);
        Rempli_les_noms(Check_Cavite.Items,niCavite);
        Taille_CheckBox;
      end;
    end;
    5 : begin
      MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
      MultPageDlg.Systeme.Text:=Nom_Systeme.Text;
      MultPageDlg.Cavite.Text:=Nom_Cavite.Text;
      Close;
      Form1.Ouvre_Fiche;
    end;
    6 : begin
      if MessageDlg('Appliquer le nouveau nom aux lments choisis ?',mtConfirmation,
         [mbOk,mbCancel],0)=mrOk then begin
        for I:=0 to Form1.Massif.Liste_Fiche.Count-1 do with TFiche(Form1.Massif.Liste_Fiche[I]) do begin
          Systeme.UpString(S);
          J:=Check_Systeme.Items.Count-1;
          while (J>=0) and (not Check_Systeme.Checked[J] or (S<>UpperCase(Check_Systeme.Items[J]))) do dec(J);
          if J>=0 then Systeme.Ecrit(Saisie_Systeme.Text);
          Cavite.UpString(S);
          J:=Check_Cavite.Items.Count-1;
          while (J>=0) and (not Check_Cavite.Checked[J] or (S<>UpperCase(Check_Cavite.Items[J]))) do dec(J);
          if J>=0 then Systeme.Ecrit(Saisie_Systeme.Text);
          Form1.Exploreur.Rafraichir;
          Form1.Massif.Sauvegarde:=false;
        end;
        if Niveau.ItemIndex=2 then begin
          MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
          MultPageDlg.Systeme.Text:=Saisie_Systeme.Text;
          MultPageDlg.Cavite.Text:=Nom_Cavite.Text;
          Close;
          Form1.Ouvre_Fiche;
        end
        else Close;
      end;
    end;
    7 : begin
      MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
      MultPageDlg.Systeme.Text:=Combo_Systeme.Text;
      MultPageDlg.Cavite.Text:=Combo_Cavite.Text;
      MultPageDlg.Reseau.Text:=Combo_Reseau.Text;
      MultPageDlg.Lieu.Text:=Combo_Lieu.Text;
      Close;
      Form1.Ouvre_Fiche;
    end;
    8 : begin
      case Niveau.ItemIndex of
        1 : begin
          Etape:=6;
          Panneau.PageIndex:=6;
          Avant.Caption:='&Terminer';
          Avant.Enabled:=false;
          Arriere.Visible:=true;
          Rempli_les_noms(Check_Systeme.Items,niSysteme);
          Rempli_les_noms(Check_Cavite.Items,niCavite);
          Taille_CheckBox;
        end;
        2 : begin
          Etape:=3;
          Panneau.PageIndex:=3;
          Avant.Enabled:=false;
          Arriere.Visible:=true;
          Avant.Caption:='&Suivant >';
          Label8.Visible:=true;
          Isole.Visible:=true;
          Jonctionne.Visible:=true;
          Isole.checked:=false;
          Jonctionne.checked:=false;
        end;
        3 : begin
          Etape:=7;
          Panneau.PageIndex:=7;
          Rempli_les_noms(Combo_Systeme.Items,niSysteme);
          Rempli_les_noms(Combo_Cavite.Items,niCavite);
          Rempli_les_noms(Combo_Reseau.Items,niReseau);
          Rempli_les_noms(Combo_Lieu.Items,niLieu);
          Avant.Caption:='&Terminer';
          Avant.Enabled:=true;
          Arriere.Visible:=true;
        end;
        4 : begin
          MultPageDlg.Contenu(nil,Form1.Massif,Form1.Preference,0);
          MultPageDlg.Systeme.Text:='Surface';
          Close;
          Form1.Ouvre_Fiche;
        end;
      end;
    end;
  end;
end;

procedure TNouveaute.ArriereClick(Sender: TObject);
begin
  Panneau.SetFocus;
  Avant.Caption:='&Suivant >';
  Avant.Enabled:=true;
  case Etape of
    0 : begin
    end;
    1 : begin
      Caption:='Nouvel lment';
      Etape:=0;
      Panneau.PageIndex:=0;
      Arriere.Visible:=false;
    end;
    2 : begin
      Form1.FermerMassif;
      Caption:='Nouvel lment';
      Etape:=0;
      Panneau.PageIndex:=0;
      Arriere.Visible:=false;
    end;
    3, 7 : begin
      if Courant.Checked or Connu.Checked then begin
        Etape:=1;
        Panneau.PageIndex:=1;
        Arriere.Visible:=true;
      end;
      if Connu.Checked then Form1.FermerMassif;
      if Nouveau.Checked then begin
        Etape:=8;
        Panneau.PageIndex:=2;
        Arriere.Visible:=not Sens_Unique;
      end;
    end;
    4 : begin
      Etape:=3;
      Panneau.PageIndex:=3;
      if Connu.Checked then Arriere.Visible:=not Sens_Unique;
    end;
    5 : begin
      Etape:=4;
      Panneau.PageIndex:=4;
    end;
    6 : begin
      if Niveau.ItemIndex=1 then begin
        if Courant.Checked or Connu.Checked then begin
          Etape:=1;
          Panneau.PageIndex:=1;
          Arriere.Visible:=true;
        end;
        if Connu.Checked then Form1.FermerMassif;
        if Nouveau.Checked then begin
          Etape:=8;
          Panneau.PageIndex:=2;
          Arriere.Visible:=not Sens_Unique;
        end;
      end
      else begin
        Etape:=4;
        Panneau.PageIndex:=4;
      end;
    end;
    8 : begin
      Form1.FermerMassif;
      Etape:=1;
      Panneau.PageIndex:=1;
    end;
  end;
end;

procedure TNouveaute.FormShow(Sender: TObject);
// il faut tout remettre  zro quand on rouvre l'assistant
begin
  Caption:='Nouvel lment';
  Etape:=0;
  Panneau.PageIndex:=0;
  Avant.Caption:='&Suivant >';
  Avant.Enabled:=false;
  Sens_Unique:=(Form1.Massif<>nil);
  Niveau.ItemIndex:=-1;
  Nom_Cavite.Text:='';
  Isole.Checked:=false;
  Jonctionne.Checked:=false;
  Systeme_connu.Checked:=false;
  Nouveau_Systeme.Checked:=false;
  Nom_Systeme.Text:='';
  Saisie_Systeme.Text:='';
  Combo_Systeme.Text:='';
  Combo_Cavite.Text:='';
  Combo_Reseau.Text:='';
  Combo_Lieu.Text:='';
  Arriere.Visible:=false;
end;

procedure TNouveaute.Nom_MassifClick(Sender: TObject);
begin
  if Form1.Opendialog1.Execute then begin
    Form1.FermerMassif;
    Form1.OuvreMassif(Form1.OpenDialog1.FileName);
  end;
end;

procedure TNouveaute.DeclinaisonsClick(Sender: TObject);
begin
  Form1.Dclinaison1Click(Sender);
end;

procedure TNouveaute.ReferencesClick(Sender: TObject);
begin
  Form1.Pointsderfrence1Click(Sender);
end;

procedure TNouveaute.ConnuClick(Sender: TObject);
begin
  Avant.Enabled:=true;
end;

procedure TNouveaute.IsoleClick(Sender: TObject);
begin
  Avant.Enabled:=Nom_Cavite.Text<>'';
end;

procedure TNouveaute.Nom_CaviteChange(Sender: TObject);
begin
  Avant.Enabled:=(Nom_Cavite.Text<>'') and
     ((not Label8.Visible) or Isole.Checked or Jonctionne.Checked);
end;

procedure TNouveaute.Saisie_systemeChange(Sender: TObject);
begin
  Avant.Enabled:=Saisie_Systeme.Text<>'';
end;

procedure TNouveaute.Taille_CheckBox;
var
  ScrollWidth, Largeur : SmallInt;
  I : integer;
begin
  ScrollWidth:=0;
  Check_Systeme.Canvas.Font:=Check_Systeme.Font;
  for I:=0 to Check_Systeme.Items.Count-1 do begin
    Largeur:=Check_Systeme.Canvas.TextWidth(Check_Systeme.Items[I]);
    if Largeur>ScrollWidth then ScrollWidth:=Largeur;
  end;
  inc(ScrollWidth,Check_Systeme.ItemHeight*2);
  PostMessage( Check_Systeme.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);

  ScrollWidth:=0;
  Check_Cavite.Canvas.Font:=Check_Cavite.Font;
  for I:=0 to Check_Cavite.Items.Count-1 do begin
    Largeur:=Check_Cavite.Canvas.TextWidth(Check_Cavite.Items[I]);
    if Largeur>ScrollWidth then ScrollWidth:=Largeur;
  end;
  inc(ScrollWidth,Check_Cavite.ItemHeight*2);
  PostMessage(Check_Cavite.Handle, lb_SetHorizontalExtent, ScrollWidth, 0);
end;  

end.
