unit Opt_coup;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons, SysUtils,
  StdCtrls, Dialogs, ExtCtrls, Options, TabNotBk, ComCtrls;

type
  TOpti_Coupe = class(TForm)
    FontDialog1: TFontDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label4: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label5: TLabel;
    Label3: TLabel;
    Affiche_Horizontale: TCheckBox;
    Epaisseur_Horizontale: TEdit;
    X_Horizontale: TEdit;
    Z_Horizontale: TEdit;
    Police_Horizontale: TButton;
    Pas_Horizontale: TEdit;
    Largeur_Horizontale: TEdit;
    Long_Horizontale: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Epaisseur_Verticale: TEdit;
    Largeur_Verticale: TEdit;
    Pas_Verticale: TEdit;
    Police_Verticale: TButton;
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    GroupBox6: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    X_Verticale: TEdit;
    ZMin_Verticale: TEdit;
    ZMax_Verticale: TEdit;
    Decal_Verticale: TEdit;
    Gauche_Verticale: TCheckBox;
    Nom_Verticale: TEdit;
    Indice_Verticale: TEdit;
    GroupBox5: TGroupBox;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Epaisseur_Visee: TEdit;
    pourcentage: TEdit;
    Label14: TLabel;
    Label19: TLabel;
    Texte_Station: TRadioGroup;
    diametre: TEdit;
    Police_Station: TButton;
    Label21: TLabel;
    Label22: TLabel;
    X_Origine: TEdit;
    Z_Origine: TEdit;
    Origine: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    GroupBox1: TGroupBox;
    Afficher_Habillage: TCheckBox;
    Representation_Hauteur: TRadioGroup;
    Label15: TLabel;
    Epaisseur_Habit: TEdit;
    Label25: TLabel;
    Epaisseur_hauteur: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Police_HorizontaleClick(Sender: TObject);
    procedure Police_VerticaleClick(Sender: TObject);
    procedure Police_StationClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure X_HorizontaleKeyPress(Sender: TObject; var Key: Char);
    procedure Epaisseur_HorizontaleKeyPress(Sender: TObject;
      var Key: Char);
    procedure Representation_HauteurClick(Sender: TObject);
    procedure Afficher_HabillageClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Font_Horizontale, Font_Verticale, Font_Station : TFont;
    Les_Verticales : array[1..50] of TVerticale;
    Nb_Verticales, Precedent : smallInt;
    procedure Rempli(Une_Option : TOptions_Coupe);
  end;

var
  Opti_Coupe: TOpti_Coupe;

implementation

uses Fichetpo;

{$R *.DFM}

procedure TOpti_Coupe.Rempli(Une_Option : TOptions_Coupe);
var
  I : integer;
begin
  Font_Horizontale.Assign(Une_Option.Horizontale_Police);
  Font_Verticale.Assign(Une_Option.Verticale_Police);
  Font_Station.Assign(Une_Option.Station_Police);
  Affiche_Horizontale.Checked:=Une_Option.Horizontale_Affiche;
  Afficher_Habillage.Checked:=Une_Option.Habit_Affiche;
  Representation_Hauteur.ItemIndex:=Une_Option.Type_Hauteur;
  Epaisseur_Hauteur.Text:=IntTostr(Une_Option.Epaisseur_Hauteur);

  X_Horizontale.Text:=FloatTostrF(Une_Option.Horizontale_X,ffGeneral,6,2);
  Z_Horizontale.Text:=FloatTostrF(Une_Option.Horizontale_Z,ffGeneral,6,2);
  Epaisseur_Horizontale.Text:=IntTostr(Une_Option.Horizontale_Epaisseur);
  Largeur_Horizontale.Text:=IntTostr(Une_Option.Horizontale_Largeur);
  Long_Horizontale.Text:=IntTostr(Une_Option.Horizontale_Longueur);
  Pas_Horizontale.Text:=IntTostr(Une_Option.Horizontale_Pas);
  Epaisseur_Verticale.Text:=IntTostr(Une_Option.Verticale_Epaisseur);
  Largeur_Verticale.Text:=IntTostr(Une_Option.Verticale_Largeur);
  Pas_Verticale.Text:=IntTostr(Une_Option.Verticale_Pas);
  Epaisseur_Visee.Text:=IntTostr(Une_Option.Visee_Epaisseur);
  Pourcentage.Text:=IntTostr(Une_Option.Pourcent);
  Diametre.Text:=IntTostr(Une_Option.Diametre);
  Epaisseur_Habit.Text:=IntTostr(Une_Option.Habit_Epaisseur);

  Texte_Station.ItemIndex:=Une_Option.Carrefour;
  Origine.Checked:=Une_Option.Blocage_Origine;
  X_Origine.Text:=FloatTostrF(Une_Option.Origine_X,ffGeneral,6,3);
  Z_Origine.Text:=FloatTostrF(Une_Option.Origine_Z,ffGeneral,6,3);

  Precedent:=-1;
  ListBox1.ItemIndex:=-1;
  ListBox1.Items.Clear;
  Nb_Verticales:=Une_Option.Nb_Verticale;
  for I:=1 to Une_Option.Nb_Verticale do begin
    Les_Verticales[I]:=Une_Option.Verticale[I];
    ListBox1.Items.Add(Les_Verticales[I].Nom);
  end;
  X_Verticale.Enabled:=false;
  ZMin_Verticale.Enabled:=false;
  ZMax_Verticale.Enabled:=false;
  Decal_Verticale.Enabled:=false;
  Gauche_Verticale.Enabled:=false;
  Button2.Enabled:=false;
  Nom_Verticale.Enabled:=false;
  Indice_Verticale.Enabled:=false;
end;

procedure TOpti_Coupe.FormCreate(Sender: TObject);
begin
  Font_Horizontale:=TFont.Create;
  Font_Verticale:=TFont.Create;
  Font_Station:=TFont.Create;
end;

procedure TOpti_Coupe.FormDestroy(Sender: TObject);
begin
  Font_Horizontale.Free;
  Font_Verticale.Free;
  Font_Station.Free;
end;

procedure TOpti_Coupe.Police_HorizontaleClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Horizontale);
  if FontDialog1.Execute then Font_Horizontale.Assign(FontDialog1.Font);
end;

procedure TOpti_Coupe.Police_VerticaleClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Verticale);
  if FontDialog1.Execute then Font_Verticale.Assign(FontDialog1.Font);
end;

procedure TOpti_Coupe.Police_StationClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Station);
  if FontDialog1.Execute then Font_Station.Assign(FontDialog1.Font);
end;

procedure TOpti_Coupe.Button1Click(Sender: TObject);
var
  S : string;
begin
  S:=InputBox('Nouvelle chelle','Nom de la nouvelle chelle','');
  if S<>'' then begin
    inc(Nb_Verticales);
    ListBox1.Items.Add(S);
    ListBox1.ItemIndex:=Nb_Verticales-1;
    with Les_Verticales[Nb_Verticales] do begin
      Xdev:=0; ZMin:=0; ZMax:=0; Decal:=0; Nom:=S; Point:=''; Indice:=0;
    end;
    ListBox1Click(Sender);
  end;
end;

procedure TOpti_Coupe.ListBox1Click(Sender: TObject);
begin
  if Precedent<>-1 then with Les_Verticales[Precedent+1] do begin
    XDev:=StrToFloatE(X_Verticale.text);
    ZMin:=StrToIntE(ZMin_Verticale.text);
    ZMax:=StrToIntE(ZMax_Verticale.text);
    Decal:=StrToFloatE(Decal_Verticale.text);
    Gauche:=Gauche_Verticale.Checked;
    Point:=Nom_Verticale.text;
    Indice:=StrToIntE(Indice_Verticale.text);
  end
  else begin
    X_Verticale.Enabled:=true;
    ZMin_Verticale.Enabled:=true;
    ZMax_Verticale.Enabled:=true;
    Decal_Verticale.Enabled:=true;
    Gauche_Verticale.Enabled:=true;
    Button2.Enabled:=true;
    Nom_Verticale.Enabled:=true;
    Indice_Verticale.Enabled:=true;
  end;
  with Les_Verticales[ListBox1.ItemIndex+1] do begin
    X_Verticale.text:=FloatTostrF(XDev,ffGeneral,6,2);
    ZMin_Verticale.text:=IntTostr(ZMin);
    ZMax_Verticale.text:=IntTostr(ZMax);
    Decal_Verticale.text:=FloatTostrF(Decal,ffGeneral,6,2);
    Gauche_Verticale.Checked:=Gauche;
    Nom_Verticale.text:=Point;
    Indice_Verticale.text:=IntTostr(Indice);
  end;
  Precedent:=ListBox1.ItemIndex;
end;

procedure TOpti_Coupe.Button2Click(Sender: TObject);
var
  I : integer;
begin
  if MessageDlg('Supprimer l''chelle slectionne ?',mtWarning,[mbOk,mbCancel],0)=mrOk then begin
    if Precedent<>-1 then with Les_Verticales[Precedent+1] do begin
      XDev:=StrToFloatE(X_Verticale.text);
      ZMin:=StrToIntE(ZMin_Verticale.text);
      ZMax:=StrToIntE(ZMax_Verticale.text);
      Decal:=StrToFloatE(Decal_Verticale.text);
      Gauche:=Gauche_Verticale.Checked;
      Point:=Nom_Verticale.text;
      Indice:=StrToIntE(Indice_Verticale.text);
    end;
    for I:=ListBox1.ItemIndex+1 to Nb_Verticales-1 do Les_Verticales[I]:=Les_Verticales[I+1];
    ListBox1.Items.Delete(ListBox1.ItemIndex);
    dec(Nb_Verticales);
    Precedent:=-1;
    X_Verticale.Enabled:=false;
    ZMin_Verticale.Enabled:=false;
    ZMax_Verticale.Enabled:=false;
    Decal_Verticale.Enabled:=false;
    Gauche_Verticale.Enabled:=false;
    Button2.Enabled:=false;
    Nom_Verticale.Enabled:=false;
    Indice_Verticale.Enabled:=false;
  end;
end;

procedure TOpti_Coupe.X_HorizontaleKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') and (Key<>'-')
      then Key := #0;
end;

procedure TOpti_Coupe.Epaisseur_HorizontaleKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TOpti_Coupe.Representation_HauteurClick(Sender: TObject);
begin
  Epaisseur_Hauteur.Enabled:=Representation_Hauteur.ItemIndex<>0;
end;

procedure TOpti_Coupe.Afficher_HabillageClick(Sender: TObject);
begin
  Epaisseur_Habit.Enabled:=Afficher_Habillage.Checked;
end;

end.
