unit outils3D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls;

type
  TOutils_3D = class(TForm)
    OpenGL: TCheckBox;
    Panel1: TPanel;
    Rotation: TSpeedButton;
    Translation: TSpeedButton;
    Lateral: TSpeedButton;
    stereo: TCheckBox;
    Horizontal: TBitBtn;
    Arriere: TBitBtn;
    procedure OpenGLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure stereoClick(Sender: TObject);
    procedure HorizontalClick(Sender: TObject);
    procedure ArriereClick(Sender: TObject);
  protected
  private
{    procedure WMncLBoutonDown(var Message: TMessage); message WM_NCLBUTTONDOWN;
    procedure WMncMouseMove(var Message: TMessage); message WM_NCMOUSEMOVE;
    procedure WMncLBoutonUp(var Message: TMessage); message WM_NCLBUTTONUP; }
    { Dclarations prives }
  public
    { Dclarations publiques }
    Force_Alt, Force_Ctrl, Enfonce : boolean;
    Nouvelle, Position : integer;
  end;

var
  Outils_3D: TOutils_3D;

implementation

{$R *.DFM}

uses Unit1, GrapheRe;
{
procedure TOutils_3D.WMncLBoutonDown(var Message: TMessage);
begin
  Enfonce:=true;
  Position:=Message.LParam;
end;

procedure TOutils_3D.WMncMouseMove(var Message: TMessage);
begin
  if Enfonce then begin
    Nouvelle:=Message.LParam;
    SetBounds(Left+(Nouvelle mod 65536)-(Position mod 65536),
    Top+(Nouvelle div 65536)-(Position div 65536),Width,Height);
    Position:=Nouvelle;
    if OpenGL.Checked then
      (Form1.LaPerspective.Contenu as TPerspective).Scene.Redraw;
  end;
end;

procedure TOutils_3D.WMncLBoutonUp(var Message: TMessage);
begin
  Enfonce:=false;
end;
 }
procedure TOutils_3D.OpenGLClick(Sender: TObject);
begin
  Rotation.Enabled:=OpenGL.Checked;
  Translation.Enabled:=OpenGL.Checked;
  Lateral.Enabled:=OpenGL.Checked;
  Horizontal.Enabled:=OpenGL.Checked;
  Arriere.Enabled:=OpenGL.Checked;
  Translation.Down:=true;
  if OpenGL.Checked then Stereo.Checked:=false;
  Form1.LaPerspective.Bascule;
end;

procedure TOutils_3D.FormCreate(Sender: TObject);
begin
  Force_Alt:=false;
  Force_Ctrl:=false;
  Enfonce:=false;
end;

procedure TOutils_3D.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ssAlt in Shift then begin
    Lateral.Down:=true;
    Force_Alt:=true;
    Force_Ctrl:=false;
  end;
  if ssCtrl in Shift then begin
    Rotation.Down:=true;
    Force_Alt:=false;
    Force_Ctrl:=true;
  end;
end;

procedure TOutils_3D.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Force_Alt and not (ssAlt in Shift) then begin
    Translation.Down:=true;
    Force_Alt:=false;
  end;
  if Force_Ctrl and not (ssCtrl in Shift) then begin
    Translation.Down:=true;
    Force_Ctrl:=false;
  end;
end;

procedure TOutils_3D.stereoClick(Sender: TObject);
begin
  if Stereo.Checked then begin
    OpenGL.Checked:=false;
    Form1.LaPerspective.Color:=clBlack;
  end
  else Form1.LaPerspective.Color:=clWhite;
  (Form1.LaPerspective.Contenu as TPerspective).Relief:=Stereo.Checked;
  Form1.LaPerspective.Mise_A_Jour;
end;

procedure TOutils_3D.HorizontalClick(Sender: TObject);
begin
  with (Form1.LaPerspective.Contenu as TPerspective) do begin
    Vue_Pente:=0;
    Redessine_Scene;
  end;
end;

procedure TOutils_3D.ArriereClick(Sender: TObject);
var
  X0 : double;
begin
  with (Form1.LaPerspective.Contenu as TPerspective) do begin
    X0:=abs(PMin.X-Pmax.X)+abs(PMin.Y-Pmax.Y);
    with Vue_Position do begin
      X:=-X0*cos(Vue_Pente/180*PI)*sin(Vue_Azimuth/180*PI);
      Y:=-X0*sin(Vue_Pente/180*PI);
      Z:=X0*cos(Vue_Pente/180*PI)*cos(Vue_Azimuth/180*PI);
    end;
    Redessine_Scene;
  end;
end;

end.
