{$N-}
unit Previsu;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Affiche, StdCtrls, FicheTpo;

type
  TPreview = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Button1: TButton;
    Moins: TButton;
    Plus: TButton;
    ScrollBar1: TScrollBar;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    Page, PageX_Max, PageY_Max : integer;
    Vue : TAfficheur;
    Rapport : reel;
    procedure Numero;
  end;

  procedure gris(b:Tbitmap);

var
  Preview: TPreview;

implementation

uses Options, Unit1, Printers;

{$R *.DFM}

function Imprimante_NB : boolean;
var
  Deux : integer;
begin
  Deux:=GetDeviceCaps(Printer.Handle, PLANES);
  result:=(Deux=1);
end;

procedure TPreview.FormShow(Sender: TObject);
begin
  if Printer.PageWidth/(Width-28)>Printer.PageHeight/(Height-88) then begin
    Rapport:=(Width-28)/Printer.PageWidth;
    Image1.Width:=(Width-28);
    Image1.Height:=round(Printer.PageHeight/Printer.PageWidth*(Width-28));
  end
  else begin
    Rapport:=(Height-88)/Printer.PageHeight;
    Image1.Height:=Height-88;
    Image1.Width:=round(Printer.PageWidth/Printer.PageHeight*Image1.Height);
  end;
  Image1.Picture.Graphic.Width:=Image1.Width;
  Image1.Picture.Graphic.Height:=Image1.Height;

  Image1.Left:=(Width-8-Image1.Width) div 2;
  Image1.Top:=(Height-68-Image1.Height) div 2 +41;

  with ScrollBar1 do begin
    Max:=PageX_Max*PageY_Max;
    Enabled:=(Max<>1);
    Position:=1;
    LargeChange:=PageX_Max;
  end;

  ScrollBar1Change(Sender);
end;

procedure TPreview.FormCreate(Sender: TObject);
var
  BitMap : TBitMap;
begin
  BitMap:=TBitMap.Create;
  BitMap.Width:=Image1.Width; BitMap.Height:=Image1.Height;
  Image1.Picture.Graphic := Bitmap;
end;

procedure TPreview.ScrollBar1Change(Sender: TObject);
begin
  if Sender=Plus then ScrollBar1.Position:=ScrollBar1.Position+1
  else if Sender=Moins then ScrollBar1.Position:=ScrollBar1.Position-1;
  Page:=ScrollBar1.Position;
  Image1.Canvas.Pen.Color:=clWhite; Image1.Canvas.Brush.Color:=clWhite;
  Image1.Canvas.Brush.Style:=bsSolid; Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  screen.Cursor:=crHourGlass;
  Vue.Contenu.Imprime((Page-1) mod PageX_Max,(Page-1) div PageX_Max,Form1.Les_Marges.Gauche,Form1.Les_Marges.Haut,
  Vue.Etat,Image1.Canvas,Rapport);
  if Imprimante_NB then Gris(Image1.Picture.Bitmap);
  screen.Cursor:=crDefault;
  Moins.Enabled:=(Page<>1);
  Plus.Enabled:=(PageX_Max*PageY_Max<>Page);
  Numero;
end;

procedure TPreview.Numero;
begin
  Label1.Caption:='Page '+IntTostr(Page)+'/'+IntTostr(PageX_Max*PageY_Max);
end;

procedure gris(b:Tbitmap);
var
  q, r : pointer;
  i, j : integer;
  s : integer;
begin
  b.PixelFormat:=pf24bit;
  for i:=b.height-1 downto 0 do
  begin
    q:=b.ScanLine[i];
    r:=q;
    for j:=0 to b.width-1 do
    begin
      s:=byte(q^)*29;
      inc(Integer(q));
      s:=s+byte(q^)*150;
      inc(Integer(q));
      s:=s+byte(q^)*77;
      inc(Integer(q));
      s:=s shr 8;
      byte(r^):=s;
      inc(Integer(r));
      byte(r^):=s;
      inc(Integer(r));
      byte(r^):=s;
      inc(Integer(r));
    end;
  end;
end;

end.
