{$N-}
unit Stats;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils;

type
  TStatistique = class(TForm)
    Bevel1: TBevel;
    Fiche: TLabel;
    Galerie: TLabel;
    Visee: TLabel;
    Dev: TLabel;
    Prem: TLabel;
    Sup: TLabel;
    Inf: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    Les_Fiches : TList;
    { Public declarations }
  end;

var
  Statistique: TStatistique;

implementation

uses Unit1, Fichetpo, FRose;

{$R *.DFM}

procedure TStatistique.FormShow(Sender: TObject);
var
  Nb_Fiche, Nb_Galerie, Nb_Visees, I, J, K : integer;
  TPremiere, Dlt, ZMin, ZMax : real;
begin
  if not Form1.Massif.Finition then Form1.Massif.Detailler;
  TPremiere:=0; Dlt:=0;
  Nb_Galerie:=0; Nb_Visees:=0;
  ZMin:=+1e6; ZMax:=-1e6;

  Nb_Fiche:=Les_Fiches.Count;
  for I:=0 to les_Fiches.Count-1 do with TFiche(Les_Fiches[I]) do begin
    TPremiere:=TPremiere+Premiere;
    for J:=0 to Liste_Galerie.Count-1 do with TGalerie(Liste_Galerie[J]) do begin
      inc(Nb_Galerie);
      inc(Nb_Visees,Nb_Visee);
      if Approximation then begin
        if Depart.Z>ZMax then ZMax:=Depart.Z;
        if Depart.Z<ZMin then ZMin:=Depart.Z;
      end;
      for K:=1 to Nb_Visee do begin
        if Visees[K].Correction_Dlt then Dlt:=Dlt+Visees[K].Longueur_Dlt
        else if Visees[K].ULong=m then Dlt:=Dlt+Visees[K].Longueur
        else Dlt:=Dlt+Visees[K].Longueur/100;
        if Approximation then begin
          if Coordonnees^[K].Z>ZMax then ZMax:=Coordonnees^[K].Z;
          if Coordonnees^[K].Z<ZMin then ZMin:=Coordonnees^[K].Z;
        end;
      end;
    end;
  end;
  Fiche.Caption:='Nombre de fiches : '+IntTostr(Nb_Fiche);
  Galerie.Caption:='Nombre de galerie : '+IntTostr(Nb_Galerie);
  Visee.Caption:='Nombre de vise : '+IntTostr(Nb_Visees);
  Dev.Caption:='Dveloppement (m) : '+FloatTostrF(Dlt,ffGeneral,7,2);
  Prem.Caption:='Premire (m) : '+FloatTostrF(TPremiere,ffGeneral,7,2);
  Inf.Caption:='Altitude infrieure (m) : '+FloatTostrF(ZMin,ffGeneral,6,2);
  Sup.Caption:='Altitude suprieure (m) : '+FloatTostrF(ZMax,ffGeneral,6,2);
end;

procedure TStatistique.Button2Click(Sender: TObject);
var
  La_Rose : TfrmRose;
begin
  La_Rose:=TfrmRose.Create(self);
  La_Rose.ShowIt(Form1.Massif);
  La_Rose.Free;
end;

end.
