unit svgUtils;

interface

procedure EnteteSVG(var F : TextFile; Largeur, Hauteur : integer; Illustrator : boolean);
// criture d'un en-tte de fichier svg avec compatibilit ventuelle pour les Layers d'Illustrator
// Largeur et Hauteur reprsentent les dimensions du document en mm

implementation

uses
  SysUtils;

procedure EnteteSVG(var F : TextFile; Largeur, Hauteur : integer; Illustrator : boolean);
// criture d'un en-tte de fichier svg avec compatibilit ventuelle pour les Layers d'Illustrator
// Largeur et Hauteur reprsentent les dimensions du document en mm
begin
  if Illustrator then
  begin
    writeln(F,'<?xml version="1.0" encoding="ISO-8859-1"?>');
    writeln(F,'<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.0//EN"    "http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd" [');
    writeln(F,'         <!ENTITY ns_flows "http://ns.adobe.com/Flows/1.0/">');
    writeln(F,'        	<!ENTITY ns_extend "http://ns.adobe.com/Extensibility/1.0/">');
    writeln(F,'        	<!ENTITY ns_ai "http://ns.adobe.com/AdobeIllustrator/10.0/">');
    writeln(F,'        	<!ENTITY ns_graphs "http://ns.adobe.com/Graphs/1.0/">');
    writeln(F,'        	<!ENTITY ns_vars "http://ns.adobe.com/Variables/1.0/">');
    writeln(F,'        	<!ENTITY ns_imrep "http://ns.adobe.com/ImageReplacement/1.0/">');
    writeln(F,'        	<!ENTITY ns_sfw "http://ns.adobe.com/SaveForWeb/1.0/">');
    writeln(F,'        	<!ENTITY ns_custom "http://ns.adobe.com/GenericCustomNamespace/1.0/">');
    writeln(F,'        	<!ENTITY ns_adobe_xpath "http://ns.adobe.com/XPath/1.0/">');
    writeln(F,'        	<!ENTITY ns_svg "http://www.w3.org/2000/svg">');
    writeln(F,'        	<!ENTITY ns_xlink "http://www.w3.org/1999/xlink">');
    writeln(F,']>');
    writeln(F);
    writeln(F,'<svg');
    writeln(F,' 	 xmlns:x="&ns_extend;" xmlns:i="&ns_ai;" xmlns:graph="&ns_graphs;"');
    writeln(F,' 	 xmlns="&ns_svg;" xmlns:xlink="&ns_xlink;" xmlns:a="http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"');
    writeln(F,Format(' 	 width="%dmm" height="%dmm"',[Largeur,Hauteur]));
    writeln(F,Format(' 	 overflow="visible" enable-background="new 0 0 %dmm %dmm" xml:space="preserve">',[Largeur,Hauteur]));
  end
  else
  begin
    writeln(F,'<?xml version="1.0" encoding="ISO-8859-1"?>');
    writeln(F,'<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.0//EN"');
    writeln(F,'"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd">');
    writeln(F);
    writeln(F,Format('<svg width="%dmm" height="%dmm">',[Largeur,Hauteur]));
  end;
end;

end.
