unit uconvergence;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TConvergence = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Nom_projection: TComboBox;
    X_origine: TEdit;
    Y_origine: TEdit;
    Label4: TLabel;
    X_centre: TEdit;
    Y_centre: TEdit;
    Calculer: TButton;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Nom_projectionChange(Sender: TObject);
    procedure CalculerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Origine : TStringList;
    A : double;
  end;

var
  Convergence: TConvergence;

implementation

uses Unit1, Fichetpo;

{$R *.DFM}

procedure TConvergence.FormCreate(Sender: TObject);
var
  F : textfile;
  S : string;
begin
  Nom_Projection.Items.Clear;
  Origine:=TStringList.Create;
  if FileExists(Form1.Repertoire+'projection.txt') then begin
    assignFile(F,Form1.Repertoire+'projection.txt');
    reset(F);
    while not Eof(F) do begin
      readln(F,S);
      Nom_Projection.Items.Add(copy(S,1,pos(#9,S)-1));
      Delete(S,1,pos(#9,S));
      Origine.Add(S);
    end;
    closeFile(F);
  end;
  Nom_Projection.Items.Add('Autre');
  Nom_Projection.ItemIndex:=Nom_Projection.Items.Count-1;
end;

procedure TConvergence.FormDestroy(Sender: TObject);
begin
  Origine.Free;
end;

procedure TConvergence.Nom_projectionChange(Sender: TObject);
var
  S : string;
begin
  if Nom_Projection.ItemIndex=Nom_Projection.Items.Count-1 then begin
    X_Origine.Enabled:=true; Y_Origine.Enabled:=true;
  end
  else begin
    X_Origine.Enabled:=false; Y_Origine.Enabled:=false;
    S:=Origine.Strings[Nom_Projection.ItemIndex];
    X_Origine.Text:=copy(S,1,pos(#9,S)-1);
    Y_Origine.Text:=copy(S,pos(#9,S)+1,length(S));
  end;
end;

procedure TConvergence.CalculerClick(Sender: TObject);
var
  XC, YC, XO, YO : double;
begin
  try
    try
      XC:=StrToFloat(X_centre.Text);
    except
      X_Centre.SetFocus;
      raise;
    end;
    try
      YC:=StrToFloat(Y_centre.Text);
    except
      Y_Centre.SetFocus;
      raise;
    end;
    try
      XO:=StrToFloat(X_origine.Text);
    except
      X_Origine.SetFocus;
      raise;
    end;
    try
      YO:=StrToFloat(Y_origine.Text);
    except
      Y_Origine.SetFocus;
      raise;
    end;
  except
    ShowMessage('Les coordonnes doivent tre numriques. Exemple 880.236');
    abort;
  end;
  A:=-(XC-XO)/(YC-YO);
  A:=arctan(A)/PI*180;
  if MessageDlg(Format('La convergence est de %f .'#13#10'Conserver ?',[A]),
  mtConfirmation, [mbYes, mbNo], 0) = mrYes then ModalResult:=mrOk;
end;

end.
