unit vrml;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TExport_VRML = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    SaveDialog1: TSaveDialog;
    Couleur: TRadioGroup;
    Ambiance: TTrackBar;
    Label1: TLabel;
    Lissage: TCheckBox;
    Centre: TCheckBox;
    Modele: TOpenDialog;
    Choix_Texture: TOpenDialog;
    GroupBox1: TGroupBox;
    Texture: TCheckBox;
    Nom_texture: TEdit;
    Fichier_Texture: TBitBtn;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Nom_Modele: TEdit;
    Fichier_modele: TBitBtn;
    procedure OKBtnClick(Sender: TObject);
    procedure TextureClick(Sender: TObject);
    procedure Fichier_TextureClick(Sender: TObject);
    procedure Fichier_modeleClick(Sender: TObject);
    procedure Nom_textureChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Texture_UNIX : string;
  end;

var
  Export_VRML: TExport_VRML;

implementation

uses Unit1,Affiche,Graphere,Graphes;

{$R *.DFM}

procedure TExport_VRML.OKBtnClick(Sender: TObject);
var
  F, Source : textfile;
  S : string;
  I : integer;
begin
  if SaveDialog1.Execute then begin
    if Texture.Checked then begin
      Texture_UNIX:=ExtractRelativePath(SaveDialog1.FileName,Nom_Texture.Text);
      for I:=1 to length(Texture_UNIX) do if Texture_UNIX[I]='\' then Texture_UNIX[I]:='/';
    end;
    if not FileExists(SaveDialog1.FileName) or
      (MessageDlg(Format('Le fichier %s existe dj.'+#13+'Ecrire par dessus?',[SaveDialog1.FileName])
        ,mtWarning,[mbYes,mbNo],0)=mrYes) then begin
      AssignFile(F,SaveDialog1.FileName);
      rewrite(F);
      if Nom_Modele.Text<>'' then begin
        AssignFile(Source,Nom_Modele.Text);
        reset(Source);
        while not Eof(Source) do begin
          readln(Source,S);
          writeln(F,S);
        end;
        closeFile(Source);
      end
      else writeln(F,'#VRML V2.0 utf8');
      writeln(F);
      case Couleur.ItemIndex of
        0 : TPerspective(Form1.LaPerspective.Contenu).Construit_Scene(nil,etNoir,F);
        1 : TPerspective(Form1.LaPerspective.Contenu).Construit_Scene(nil,etContrainte,F);
        2 : TPerspective(Form1.LaPerspective.Contenu).Construit_Scene(nil,etCouleur,F);
      end;
      closeFile(F);
    end
    else ModalResult:=mrNone;
  end
  else ModalResult:=mrNone;
end;

procedure TExport_VRML.TextureClick(Sender: TObject);
begin
  Couleur.Enabled:=not Texture.Checked;
end;

procedure TExport_VRML.Fichier_TextureClick(Sender: TObject);
begin
  if Choix_Texture.Execute then Nom_Texture.Text:=Choix_Texture.FileName;
end;

procedure TExport_VRML.Fichier_modeleClick(Sender: TObject);
begin
  if Modele.Execute then Nom_Modele.Text:=Modele.FileName;
end;

procedure TExport_VRML.Nom_textureChange(Sender: TObject);
begin
  if Nom_Texture.Text<>'' then Texture.Checked:=true;
end;

end.
